"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[2],{

/***/ 9082:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ SimpleSelect)
});

// UNUSED EXPORTS: FloaterSpacer

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
;// CONCATENATED MODULE: ./src/renderer/basics/SimpleSelect/DefaultOptionComponent.tsx



const DefaultOptionDiv = styles/* default */.ZP.div `
  display: flex;
  flex-flow: row;
  align-items: center;
`;
class DefaultOptionComponent extends react.PureComponent {
    render() {
        const { option } = this.props;
        return react.createElement(DefaultOptionDiv, null, (0,t.T)(option.label));
    }
}

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/basics/Floater.tsx
var Floater = __webpack_require__(3537);
;// CONCATENATED MODULE: ./src/renderer/basics/SimpleSelect/index.tsx








const FloaterSpacer = styles/* default */.ZP.div `
  width: 8px;
  flex-shrink: 0;
`;
const SimpleSelectDiv = styles/* default */.ZP.div `
  cursor: default;
  flex-grow: 1;

  background: ${(props) => props.theme.inputBackground};
  border: 1px solid ${(props) => props.theme.inputBorder};
  border-radius: 2px;

  transition: border-color: 0.1s;

  &:hover {
    border-color: ${(props) => props.theme.inputBorderFocused};
  }

  &:focus {
    outline: none;
  }
`;
const wrapperPadding = 10;
const iconPadding = 14;
const wrapperLike = (0,styles/* css */.iv) `
  ${styles/* singleLine */.U1};
  min-width: 180px;
  min-height: 2em;
  padding: ${wrapperPadding}px;
`;
const ValueWrapper = styles/* default */.ZP.div `
  ${wrapperLike};

  display: flex;
  flex-flow: row;
  align-items: center;
`;
const OptionWrapperDiv = styles/* default */.ZP.div `
  ${wrapperLike};
  background: ${(props) => props.theme.inputBackground};

  &.focused {
    background: ${(props) => props.theme.inputFocusedBackground};
  }

  &.selected {
    background: ${(props) => props.theme.inputSelectedBackground};
  }
`;
class OptionWrapper extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.gotEl = (el) => {
            this.el = el;
            if (this.el) {
                this.updateScroll();
            }
        };
    }
    render() {
        return react.createElement(OptionWrapperDiv, Object.assign({}, this.props, { ref: this.gotEl }));
    }
    componentDidUpdate() {
        this.updateScroll();
    }
    updateScroll() {
        const { className } = this.props;
        if (/focused/.test(className)) {
            this.el.scrollIntoViewIfNeeded();
        }
    }
}
const Bar = styles/* default */.ZP.div `
  height: auto;
  width: 1px;
  background: ${(props) => props.theme.inputBorderFocused};
  align-self: stretch;
`;
const IconWrapper = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
  padding-right: ${iconPadding - wrapperPadding}px;
  padding-left: ${iconPadding}px;
`;
const OptionsAnchorDiv = styles/* default */.ZP.div `
  position: relative;
`;
const OptionsDiv = styles/* default */.ZP.div `
  position: absolute;
  top: 4px;
  left: 0;
  right: 0;
  padding: 4px 0;
  border-radius: 2px;

  border: 1px solid ${(props) => props.theme.inputBorder};

  z-index: 10;

  max-height: 400px;
  overflow-y: auto;
`;
const DummyOption = styles/* default */.ZP.div `
  display: flex;
  flex-flow: row;
  align-items: center;
  color: ${(props) => props.theme.ternaryText};
`;
const searchClearThreshold = 2000; // 2 seconds
const keyboardFocusTimeout = 250;
class SimpleSelect extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onKeyDown = (ev) => {
            if (ev.key === "ArrowUp" ||
                ev.key === "PageUp" ||
                ev.key === "ArrowDown" ||
                ev.key === "PageDown" ||
                ev.key === "Home" ||
                ev.key === "End") {
                ev.preventDefault();
                const { options } = this.props;
                let { focusedValue } = this.state;
                if (!focusedValue) {
                    focusedValue = this.props.value;
                }
                if (!focusedValue) {
                    return;
                }
                let currentIndex = options.indexOf(focusedValue);
                let newIndex = currentIndex;
                if (ev.key === "ArrowUp") {
                    newIndex -= 1;
                }
                else if (ev.key === "ArrowDown") {
                    newIndex += 1;
                }
                else if (ev.key === "PageUp") {
                    newIndex -= 5;
                }
                else if (ev.key === "PageDown") {
                    newIndex += 5;
                }
                else if (ev.key === "Home") {
                    newIndex = 0;
                }
                else if (ev.key === "End") {
                    newIndex = options.length - 1;
                }
                if (newIndex < 0) {
                    newIndex = 0;
                }
                else if (newIndex >= options.length) {
                    newIndex = options.length - 1;
                }
                let newFocusedValue = options[newIndex];
                this.setState({
                    focusedValue: newFocusedValue,
                    lastKeyboardFocusAt: Date.now(),
                });
            }
            if (ev.key === "Enter") {
                this.close();
                this.props.onChange(this.state.focusedValue);
            }
        };
        this.onKeyPress = (ev) => {
            let search;
            let state = this.state;
            let prefix = Date.now() - state.lastSearchAt > searchClearThreshold
                ? ""
                : state.search;
            search = (prefix + ev.key).toLowerCase();
            this.setState({
                search,
                lastSearchAt: Date.now(),
            });
            const focusedValue = (0,index_all/* find */.sE)(this.props.options, (x) => typeof x.label === "string" && x.label.toLowerCase().startsWith(search));
            if (focusedValue) {
                this.setState({ focusedValue, lastKeyboardFocusAt: Date.now() });
            }
        };
        this.onOptionClick = (ev) => {
            ev.stopPropagation();
            const { onChange } = this.props;
            onChange(this.getValueForWrapper(ev.currentTarget));
            this.close();
        };
        this.onOptionMouseEnter = (ev) => {
            if (Date.now() - this.state.lastKeyboardFocusAt < keyboardFocusTimeout) {
                return;
            }
            this.setState({ focusedValue: this.getValueForWrapper(ev.currentTarget) });
        };
        this.onToggle = () => {
            this.setState((state) => ({
                open: !state.open,
            }));
            if (this.state.open) {
                this.close();
            }
            else {
                this.open();
            }
        };
        this.onBlur = () => {
            this.close();
        };
        this.state = {
            open: false,
            focusedValue: (0,index_all/* first */.Ps)(props.options),
            search: "",
            lastSearchAt: Date.now(),
            lastKeyboardFocusAt: 0,
        };
    }
    render() {
        const { value, OptionComponent = DefaultOptionComponent, isLoading, className, } = this.props;
        return (react.createElement(SimpleSelectDiv, { className: className, onClick: this.onToggle, onKeyDown: this.onKeyDown, onKeyPress: this.onKeyPress, tabIndex: -1, onBlur: this.onBlur },
            react.createElement(ValueWrapper, null,
                value ? (react.createElement(OptionComponent, { option: value })) : (react.createElement(DummyOption, null, "Select...")),
                react.createElement(Filler/* default */.Z, null),
                isLoading ? (react.createElement(react.Fragment, null,
                    react.createElement(Floater/* default */.Z, null),
                    react.createElement(FloaterSpacer, null))) : null,
                react.createElement(Bar, null),
                react.createElement(IconWrapper, null,
                    react.createElement(Icon/* default */.Z, { icon: "caret-down" }))),
            react.createElement(OptionsAnchorDiv, null, this.renderOptions())));
    }
    renderOptions() {
        const { open } = this.state;
        if (!open) {
            return null;
        }
        const { focusedValue } = this.state;
        const { options, value, OptionComponent = DefaultOptionComponent, } = this.props;
        return (react.createElement(OptionsDiv, null, options.map((option, i) => {
            const focused = focusedValue === option;
            const selected = value === option;
            return (react.createElement(OptionWrapper, { key: i, className: classnames_default()({ focused, selected }), "data-value": JSON.stringify(option.value), onClick: this.onOptionClick, onMouseEnter: this.onOptionMouseEnter },
                react.createElement(OptionComponent, { key: i, option: option })));
        })));
    }
    getValueForWrapper(el) {
        let dataValue = JSON.parse(el.dataset.value);
        const { options, onChange } = this.props;
        return (0,index_all/* findWhere */._e)(options, { value: dataValue });
    }
    open() {
        this.setState({ open: true, focusedValue: this.props.value });
    }
    close() {
        this.setState({ open: false });
    }
}


/***/ }),

/***/ 6500:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);




const LabelEl = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.label `
  background: ${(props) => props.theme.explanation};
  padding: 8px 11px;
  font-size: 14px;
  display: flex;
  align-items: center;

  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .prefChunk */ .Do};

  &.active {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .prefChunkActive */ ._U};
  }

  input[type="checkbox"] {
    margin-right: 8px;
  }
`;
class Label extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { active, children, className } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_3__/* .__rest */ ._T)(_a, ["active", "children", "className"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LabelEl, Object.assign({ className: classnames__WEBPACK_IMPORTED_MODULE_2___default()(className, { active }) }, restProps), children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Label);


/***/ }),

/***/ 7002:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ pages_PreferencesPage)
});

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
;// CONCATENATED MODULE: ./src/common/format/platform.ts
const platforms = {
    linux: "Linux",
    windows: "Windows",
    osx: "macOS",
    android: "Android",
};
/**
 * Formats a platform for humans to read.
 */
function formatPlatform(p) {
    return platforms[p] || p;
}
function formatArch(arch) {
    switch (arch) {
        case "ia32":
            return "32-bit";
        case "x64":
            return "64-bit";
        default:
            return arch;
    }
}

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/basics/DownloadProgressSpan.tsx
var DownloadProgressSpan = __webpack_require__(830);
// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__(6785);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/BrothComponent.tsx






const BrothComponentDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: start;
`;
const Spacer = styles/* default */.ZP.div `
  width: 8px;
`;
class BrothComponent extends react.PureComponent {
    render() {
        const { name, pkg } = this.props;
        return (react.createElement(BrothComponentDiv, { className: "section component" },
            this.renderIcon(),
            react.createElement(Spacer, null),
            name,
            " @ ",
            this.formatPackageVersion(pkg.version),
            react.createElement(Spacer, null),
            this.renderProgress()));
    }
    renderIcon() {
        switch (this.props.pkg.stage) {
            case "idle":
                return react.createElement(Icon/* default */.Z, { icon: "checkmark" });
            case "assess":
                return react.createElement(Icon/* default */.Z, { icon: "stopwatch" });
            case "download":
                return react.createElement(Icon/* default */.Z, { icon: "download" });
            case "install":
                return react.createElement(Icon/* default */.Z, { icon: "install" });
            case "need-restart":
                return react.createElement(Icon/* default */.Z, { icon: "repeat" });
        }
        return null;
    }
    renderProgress() {
        const { pkg } = this.props;
        const { progressInfo } = pkg;
        if (progressInfo) {
            const { eta = 0, bps = 0 } = progressInfo;
            return (react.createElement(react.Fragment, null,
                react.createElement(Spacer, null),
                react.createElement(LoadingCircle/* default */.Z, { progress: progressInfo.progress }),
                react.createElement(Spacer, null),
                react.createElement(DownloadProgressSpan/* default */.Z, { eta: eta, bps: bps, downloadsPaused: false })));
        }
        if (pkg.stage === "assess" || pkg.stage === "install") {
            return (react.createElement(react.Fragment, null,
                react.createElement(Spacer, null),
                react.createElement(LoadingCircle/* default */.Z, { progress: -1 })));
        }
        return null;
    }
    formatPackageVersion(v) {
        if (!v) {
            return "∅";
        }
        if (/[a-z0-9]/.test(v)) {
            return v.substr(0, 7);
        }
        return v;
    }
}
/* harmony default export */ const PreferencesPage_BrothComponent = ((0,hook/* hookWithProps */.h)(BrothComponent)((map) => ({
    pkg: map((rs, props) => rs.broth.packages[props.name]),
}))(BrothComponent));

// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/BrothComponents.tsx






class BrothComponents extends react.Component {
    constructor() {
        super(...arguments);
        this.checkForUpdates = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.checkForComponentUpdates({}));
        };
    }
    render() {
        const { packageNames } = this.props;
        return (react.createElement("div", { className: "section" },
            react.createElement(Icon/* default */.Z, { icon: "list" }),
            " ",
            (0,t.T)(["preferences.advanced.components"]),
            react.createElement("span", { className: "button", onClick: this.checkForUpdates, style: {
                    marginLeft: "10px",
                    borderBottom: "1px solid",
                } }, (0,t.T)(["menu.help.check_for_update"])),
            packageNames.map((name) => (react.createElement(PreferencesPage_BrothComponent, { name: name })))));
    }
}
/* harmony default export */ const PreferencesPage_BrothComponents = ((0,hook/* hook */.z)((map) => ({
    packageNames: map((rs) => rs.broth.packageNames),
}))(BrothComponents));

// EXTERNAL MODULE: ./src/renderer/pages/PreferencesPage/Label.tsx
var Label = __webpack_require__(6500);
;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/Checkbox.tsx




class Checkbox extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onChange = (e) => {
            const { name, dispatch } = this.props;
            dispatch(actions/* actions */.N.updatePreferences({ [name]: e.currentTarget.checked }));
        };
    }
    render() {
        const { active, children, label } = this.props;
        return (react.createElement(Label/* default */.Z, { active: active },
            react.createElement("input", { type: "checkbox", checked: active, onChange: this.onChange }),
            react.createElement("span", null,
                " ",
                label,
                " "),
            children));
    }
}
/* harmony default export */ const PreferencesPage_Checkbox = ((0,hook/* hookWithProps */.h)(Checkbox)((map) => ({
    active: map((rs, props) => rs.preferences[props.name]),
}))(Checkbox));

// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__(541);
;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/ProxySettings.tsx






class ProxySettings extends react.PureComponent {
    render() {
        const { proxy, proxySource } = this.props;
        return (react.createElement(ProxySettingsSpan, null,
            react.createElement(Icon/* default */.Z, { icon: "earth" }),
            "\u00A0",
            (0,t.T)(["preferences.proxy_server_address"]),
            proxy ? (react.createElement("span", { className: "value", "data-rh-at": "right", "data-rh": proxySource }, proxy)) : (react.createElement("span", { className: "value" }, (0,t.T)(["preferences.proxy_server_source.direct"]))),
            " ",
            react.createElement("a", { href: urls/* default */.Z.proxyDocs }, (0,t.T)(["docs.learn_more"]))));
    }
}
const ProxySettingsSpan = styles/* default */.ZP.span `
  display: flex;
  align-items: center;

  .value {
    margin: 0 10px;
    color: ${(props) => props.theme.baseColors.ivory};
    user-select: initial;
  }
`;
/* harmony default export */ const PreferencesPage_ProxySettings = ((0,hook/* hook */.z)((map) => ({
    proxy: map((rs) => rs.system.proxy),
    proxySource: map((rs) => rs.system.proxySource),
}))(ProxySettings));

;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/AdvancedSettings.tsx










class AdvancedSettings extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.checkForGameUpdates = (e) => {
            const { dispatch } = this.props;
            e.preventDefault();
            dispatch(actions/* actions */.N.checkForGameUpdates({}));
            dispatch(actions/* actions */.N.navigate({ wind: "root", url: "itch://downloads" }));
        };
        this.openAppLog = (e) => {
            const { dispatch } = this.props;
            e.preventDefault();
            dispatch(actions/* actions */.N.navigate({ wind: "root", url: "itch://applog" }));
        };
        this.clearBrowsingData = (e) => {
            const { dispatch } = this.props;
            e.preventDefault();
            dispatch(actions/* actions */.N.clearBrowsingDataRequest({
                wind: (0,navigation/* ambientWind */.w)(),
            }));
        };
    }
    render() {
        const { system, dispatch } = this.props;
        return (react.createElement(react.Fragment, null,
            react.createElement("h2", { id: "preferences-advanced-section" }, (0,t.T)(["preferences.advanced"])),
            react.createElement("div", { className: "explanation advanced-form" },
                react.createElement(PreferencesPage_BrothComponents, null),
                react.createElement("div", { className: "section" },
                    react.createElement(Icon/* default */.Z, { icon: "security" }),
                    " ",
                    formatPlatform(system.platform),
                    " ",
                    formatArch(system.arch)),
                react.createElement("div", { className: "section" },
                    react.createElement(PreferencesPage_ProxySettings, null)),
                react.createElement("div", { className: "section" },
                    react.createElement("span", { className: "link", onClick: this.openAppLog }, (0,t.T)(["preferences.advanced.open_app_log"]))),
                react.createElement("div", { className: "section" },
                    react.createElement("span", { className: "link", onClick: this.checkForGameUpdates }, (0,t.T)(["preferences.advanced.check_game_updates"]))),
                react.createElement("div", { className: "section" },
                    react.createElement("span", { id: "clear-browsing-data-link", className: "link", onClick: this.clearBrowsingData }, (0,t.T)(["preferences.advanced.clear_browsing_data"]))),
                react.createElement(PreferencesPage_Checkbox, { name: "disableBrowser", label: (0,t.T)(["preferences.advanced.disable_browser"]) }),
                react.createElement(PreferencesPage_Checkbox, { name: "disableHardwareAcceleration", label: (0,t.T)(["preferences.advanced.disable_hardware_acceleration"]) }))));
    }
}
/* harmony default export */ const PreferencesPage_AdvancedSettings = ((0,hook/* hook */.z)((map) => ({
    system: map((rs) => rs.system),
}))(AdvancedSettings));

;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/OpenAtLoginErrorMessage.tsx





class OpenAtLoginErrorMessage extends react.PureComponent {
    render() {
        const { openAtLoginError } = this.props;
        if (!openAtLoginError) {
            return null;
        }
        let cause;
        if (openAtLoginError.cause === "no_desktop_file") {
            cause = (0,t.T)([
                "preferences.behavior.open_at_login.causes.no_desktop_file",
                {
                    linux_install_page: (react.createElement("a", { href: urls/* default */.Z.installingOnLinux }, "installing itch on Linux")),
                },
            ]);
        }
        else if (openAtLoginError.cause === "error") {
            cause = openAtLoginError.message;
        }
        if (cause) {
            return (react.createElement("p", { className: "explanation drop-down", style: { marginBottom: "15px" } },
                react.createElement(Icon/* default */.Z, { icon: "warning" }),
                " ",
                (0,t.T)([
                    "preferences.behavior.open_at_login.error",
                    {
                        cause: react.createElement("span", null, cause),
                    },
                ])));
        }
        return null;
    }
}
/* harmony default export */ const PreferencesPage_OpenAtLoginErrorMessage = ((0,hook/* hook */.z)((map) => ({
    openAtLoginError: map((rs) => rs.status.openAtLoginError),
}))(OpenAtLoginErrorMessage));

;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/BehaviorSettings.tsx





class BehaviorSettings extends react.PureComponent {
    render() {
        return (react.createElement(react.Fragment, null,
            react.createElement("h2", null, (0,t.T)(["preferences.security"])),
            react.createElement("div", { className: "security-form" },
                react.createElement(PreferencesPage_Checkbox, { name: "isolateApps", label: (0,t.T)(["preferences.security.sandbox.title"]) })),
            react.createElement("p", { className: "explanation" },
                (0,t.T)(["preferences.security.sandbox.description"]),
                " ",
                react.createElement("a", { href: urls/* default */.Z.sandboxDocs }, (0,t.T)(["docs.learn_more"]))),
            react.createElement("h2", null, (0,t.T)(["preferences.behavior"])),
            react.createElement("div", { className: "behavior-form" },
                react.createElement(PreferencesPage_Checkbox, { name: "enableTabs", label: (0,t.T)(["preferences.behavior.enable_tabs"]) }),
                react.createElement(PreferencesPage_Checkbox, { name: "openAtLogin", label: (0,t.T)(["preferences.behavior.open_at_login"]) }),
                react.createElement(PreferencesPage_OpenAtLoginErrorMessage, null),
                react.createElement(PreferencesPage_Checkbox, { name: "openAsHidden", label: (0,t.T)(["preferences.behavior.open_as_hidden"]) }),
                react.createElement(PreferencesPage_Checkbox, { name: "closeToTray", label: (0,t.T)(["preferences.behavior.close_to_tray"]) }),
                react.createElement(PreferencesPage_Checkbox, { name: "manualGameUpdates", label: (0,t.T)(["preferences.behavior.manual_game_updates"]) }),
                react.createElement(PreferencesPage_Checkbox, { name: "preventDisplaySleep", label: (0,t.T)(["preferences.behavior.prevent_display_sleep"]) })),
            react.createElement("h2", null, (0,t.T)(["preferences.notifications"])),
            react.createElement("div", { className: "behavior-form" },
                react.createElement(PreferencesPage_Checkbox, { name: "readyNotification", label: (0,t.T)(["preferences.notifications.ready_notification"]) }))));
    }
}
/* harmony default export */ const PreferencesPage_BehaviorSettings = (BehaviorSettings);

// EXTERNAL MODULE: ./src/renderer/basics/Floater.tsx
var Floater = __webpack_require__(3537);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/renderer/basics/SimpleSelect/index.tsx + 1 modules
var SimpleSelect = __webpack_require__(9082);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/LanguageSettings.tsx












const LanguageSettings_Spacer = styles/* default */.ZP.div `
  width: 8px;
  height: 2px;
`;
const LanguageSelect = (0,styles/* default */.ZP)((0,SimpleSelect/* default */.Z)) `
  flex-grow: 0;
  flex-basis: 300px;
`;
class LanguageSettings extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.queueLocaleDownload = (e) => {
            const { dispatch, lang } = this.props;
            e.preventDefault();
            dispatch(actions/* actions */.N.queueLocaleDownload({ lang }));
        };
        this.onLanguageChange = (value) => {
            const { dispatch } = this.props;
            if (!value) {
                return;
            }
            let lang = value.value;
            if (lang === "__") {
                lang = null;
            }
            dispatch(actions/* actions */.N.updatePreferences({ lang }));
        };
    }
    render() {
        const { dispatch, locales, lang, sniffedLang } = this.props;
        let autoLang = {
            label: ["preferences.language.auto", { language: sniffedLang }],
            value: "__",
        };
        const options = [autoLang, ...locales];
        let translateUrl = `${urls/* default */.Z.itchTranslationPlatform}/projects/itch/itch`;
        const english = /^en/.test(lang);
        if (!english && lang !== "__") {
            translateUrl += `/${lang}`;
        }
        const badgeLang = lang ? lang.substr(0, 2) : "en";
        const translationBadgeUrl = `${urls/* default */.Z.itchTranslationPlatform}/widgets/itchio/${badgeLang}/itch/svg-badge.svg`;
        const downloading = this.props.downloading[lang];
        return (react.createElement(react.Fragment, null,
            react.createElement("h2", null, (0,t.T)(["preferences.language"])),
            react.createElement("div", { className: "language-form" },
                react.createElement(Label/* default */.Z, { active: true },
                    react.createElement(Icon/* default */.Z, { icon: "earth" }),
                    react.createElement(LanguageSettings_Spacer, null),
                    react.createElement(LanguageSelect, { onChange: this.onLanguageChange, options: options, value: (0,index_all/* findWhere */._e)(options, { value: lang }) || autoLang }),
                    downloading ? (react.createElement(Floater/* default */.Z, null)) : (react.createElement(IconButton/* default */.Z, { icon: "repeat", onClick: this.queueLocaleDownload })))),
            react.createElement("p", { className: "explanation flex" },
                (0,t.T)(["preferences.language.get_involved", { name: "itch" }]),
                " ",
                react.createElement("a", { href: translateUrl },
                    react.createElement("img", { className: "weblate-badge", src: translationBadgeUrl })))));
    }
}
/* harmony default export */ const PreferencesPage_LanguageSettings = ((0,hook/* hook */.z)((map) => ({
    locales: map((rs) => rs.i18n.locales),
    lang: map((rs) => rs.i18n.lang),
    sniffedLang: map((rs) => rs.system.sniffedLanguage),
    downloading: map((rs) => rs.i18n.downloading),
}))(LanguageSettings));

// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__(6025);
;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/InstallLocationSettings.tsx






const ControlButtonsDiv = styles/* default */.ZP.div `
  padding: 12px;
  padding-top: 24px;
  display: flex;
  flex-direction: row;
  align-items: center;
`;
class InstallLocationSettings extends react.Component {
    constructor() {
        super(...arguments);
        this.onManage = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.navigate({
                wind: "root",
                url: "itch://locations",
            }));
        };
    }
    render() {
        return (react.createElement(react.Fragment, null,
            react.createElement("h2", null, (0,t.T)(["preferences.install_locations"])),
            react.createElement(ControlButtonsDiv, null,
                react.createElement(Button/* default */.Z, { icon: "cog", label: (0,t.T)(["install_locations.manage"]), onClick: this.onManage }))));
    }
}
/* harmony default export */ const PreferencesPage_InstallLocationSettings = ((0,hook/* hook */.z)()(InstallLocationSettings));

;// CONCATENATED MODULE: ./src/renderer/pages/PreferencesPage/index.tsx









const PreferencesDiv = styles/* default */.ZP.div `
  ${styles/* meat */.pw};
`;
const PreferencesContentDiv = styles/* default */.ZP.div `
  overflow-y: auto;
  padding: 0px 20px 30px 20px;
  font-size: 20px;

  color: ${(props) => props.theme.baseText};

  .heading,
  h2 {
    font-size: 18px;
  }

  h2 {
    padding: 10px 15px;
    margin-top: 20px;
    margin-bottom: 5px;
    flex-shrink: 0;
  }

  .icon.turner {
    display: inline-block;
    width: 15px;
    text-align: center;
    transform: rotateZ(0deg);
    transition: transform 0.2s ease-in-out;

    &.turned {
      transform: rotateZ(90deg);
    }
  }

  .preferences-form {
    z-index: 5;
  }

  .advanced-form {
    .section {
      margin: 8px 0;

      &.component {
        margin-left: 16px;
      }

      &:first-child {
        margin-top: 0;
      }
    }

    .button:hover {
      cursor: pointer;
    }
  }

  .explanation {
    padding: 0 15px;
    margin: 15px 0 0 0;

    color: #b9b9b9;
    font-size: 14px;
    max-width: 500px;
    border-radius: $explanation-border-radius;
    line-height: 1.6;

    &.drop-down {
      animation: soft-drop 0.8s;
    }

    &.flex {
      display: flex;
      flex-shrink: 0;

      a,
      .link {
        margin-left: 8px;
        display: flex;
      }
    }

    a,
    .link {
      text-decoration: underline;
      color: #ececec;

      &:hover {
        cursor: pointer;
      }
    }
  }

  .link-box {
    margin: 20px 15px;
    font-size: 80%;

    .icon {
      margin-right: 8px;
    }

    a {
      color: #87a7c3;
      text-decoration: none;
    }
  }
`;
class PreferencesPage extends react.PureComponent {
    componentDidMount() {
        (0,tab_utils/* dispatchTabPageUpdate */.pq)(this.props, {
            label: ["sidebar.preferences"],
        });
    }
    render() {
        return (react.createElement(PreferencesDiv, null,
            react.createElement(PreferencesContentDiv, null,
                react.createElement(PreferencesPage_LanguageSettings, null),
                react.createElement(PreferencesPage_InstallLocationSettings, null),
                react.createElement(PreferencesPage_BehaviorSettings, null),
                react.createElement(PreferencesPage_AdvancedSettings, null))));
    }
}
/* harmony default export */ const pages_PreferencesPage = ((0,hook/* hook */.z)()((0,withTab/* withTab */.D1)(PreferencesPage)));


/***/ })

}]);
//# sourceMappingURL=2.chunk.js.map