"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[210],{

/***/ 5379:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   j: () => (/* binding */ fileSize)
/* harmony export */ });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ 830:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (/* binding */ DownloadProgressSpan)
/* harmony export */ });
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5379);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2629);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(9080);




function DownloadProgressSpan({ bps, eta, downloadsPaused, onlyBPS, onlyETA, }) {
    if (downloadsPaused) {
        return react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_3__.T)(["grid.item.downloads_paused"]));
    }
    if (onlyBPS) {
        return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
            (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_0__/* .fileSize */ .j)(bps),
            "/s"));
    }
    if (onlyETA) {
        return react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { secs: eta });
    }
    const hasBPS = bps > 0;
    const hasETA = eta > 0;
    return (react__WEBPACK_IMPORTED_MODULE_1__.createElement("span", null,
        hasBPS ? (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
            (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_0__/* .fileSize */ .j)(bps),
            "/s")) : null,
        hasBPS && hasETA ? " — " : null,
        hasETA ? react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { secs: eta }) : null));
}


/***/ }),

/***/ 4987:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  vN: () => (/* binding */ FiltersContainerDiv),
  ZP: () => (/* binding */ basics_FiltersContainer),
  zR: () => (/* binding */ filtersContainerHeight)
});

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__(541);
// EXTERNAL MODULE: ./src/renderer/bridge.ts
var bridge = __webpack_require__(2968);
;// CONCATENATED MODULE: ./src/renderer/util/url.ts

const wellKnownProtocols = ["http:", "https:", "itch:"];
function isWellKnownProtocol(protocol) {
    return wellKnownProtocols.indexOf(protocol) !== -1;
}
function transformUrl(original) {
    if (/^about:/.test(original)) {
        return original;
    }
    let req = original;
    const searchUrl = (q) => {
        return "https://duckduckgo.com/?" + bridge/* querystring */.xO.stringify({ q, kae: "d" });
    };
    // special search URLs
    if (/^\?/.test(original)) {
        return searchUrl(original.substr(1));
    }
    // spaces and no dots ? smells like a search request
    if (original.indexOf(" ") !== -1 && original.indexOf(".") === -1) {
        return searchUrl(original);
    }
    // add http: if needed
    let parsed = bridge/* url */.HQ.parse(req);
    if (!isWellKnownProtocol(parsed.protocol)) {
        req = "http://" + original;
        parsed = bridge/* url */.HQ.parse(req);
        if (!parsed.hostname) {
            return searchUrl(original);
        }
    }
    return req;
}

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/store.ts + 4 modules
var store = __webpack_require__(5784);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/hocs/watching.tsx
var watching = __webpack_require__(7538);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
;// CONCATENATED MODULE: ./src/renderer/basics/NavigationBar.tsx















const HTTPS_RE = /^https:\/\//;
const HTTP_RE = /^http:\/\//;
const ITCH_RE = /^itch:\/\//;
const NavigationBarDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;

  padding-right: 4px;

  flex-grow: 1;
  flex-shrink: 1;
  overflow: hidden;
  position: relative;

  &.loading {
    &::after {
      position: absolute;
      bottom: -6px;
      content: " ";
      width: 100%;
      height: 2px;
      background: ${(props) => props.theme.accent};
      animation: ${styles/* animations */.sF.lineSpinner} 2s ease-in-out infinite;
    }
  }
`;
const browserAddressSizing = (0,styles/* css */.iv) `
  height: 28px;
  line-height: 28px;
  border-radius: 2px;
`;
const browserAddressStyle = (0,styles/* css */.iv) `
  ${browserAddressSizing};
  ${styles/* singleLine */.U1};
  font-size: 14px;
  text-shadow: 0 0 1px black;
  padding: 0;
  padding-left: 8px;
  padding-right: 12px;
  width: 100%;
  color: #fdfdfd;

  border: none;
  background: rgba(255, 255, 255, 0.1);
  box-shadow: none;

  &:focus {
    outline: none;
  }
`;
const AddressWrapper = styles/* default */.ZP.div `
  ${browserAddressSizing};
  margin: 0 6px;
  transition: all 0.4s;
  border: 1px solid transparent;
  flex-grow: 1;

  &.editing {
    border-color: rgba(255, 255, 255, 0.4);
  }
`;
const AddressInput = styles/* default */.ZP.input `
  ${browserAddressStyle};

  text-shadow: 0 0 1px transparent;
  color: white;
`;
const AddressDiv = styles/* default */.ZP.div `
  ${browserAddressStyle};

  .security-theater-bit {
    color: rgb(138, 175, 115);
  }

  .fluff-bit {
    color: rgb(148, 184, 218);
  }
`;
function isHTMLInput(el) {
    return el.tagName === "INPUT";
}
let NavigationBar = class NavigationBar extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.fresh = true;
        // event handlers
        this.goBack = () => {
            (0,tab_utils/* dispatchTabGoBack */.U6)(this.props);
        };
        this.showBackHistory = (ev) => {
            const { clientX, clientY } = ev;
            ev.preventDefault();
            (0,tab_utils/* dispatchOpenTabBackHistory */.gn)(this.props, { clientX, clientY });
        };
        this.goForward = () => {
            (0,tab_utils/* dispatchTabGoForward */.li)(this.props);
        };
        this.showForwardHistory = (ev) => {
            const { clientX, clientY } = ev;
            ev.preventDefault();
            (0,tab_utils/* dispatchOpenTabForwardHistory */.iC)(this.props, { clientX, clientY });
        };
        this.stop = () => {
            (0,tab_utils/* dispatchTabStop */.nP)(this.props);
        };
        this.reload = () => {
            (0,tab_utils/* dispatchTabReloaded */.hF)(this.props);
        };
        this.onBrowserAddress = (browserAddress) => {
            this.browserAddress = browserAddress;
            if (!browserAddress) {
                return;
            }
            const { internalPage } = this.props;
            if (this.fresh && internalPage === "new-tab") {
                this.fresh = false;
                this.startEditingAddress();
            }
            if (isHTMLInput(browserAddress)) {
                browserAddress.focus();
                browserAddress.select();
            }
        };
        this.addressKeyDown = (e) => {
            if (e.key === "Enter") {
                const input = e.currentTarget.value;
                const url = transformUrl(input);
                const parsedUrl = new URL(url);
                // If the supplied url is external to itch, then
                // open in a new external browser window
                if (parsedUrl.origin.endsWith(".itch.io") ||
                    parsedUrl.origin.endsWith("/itch.io") ||
                    urls/* ITCH_URL_RE */.N.test(parsedUrl.origin)) {
                    (0,tab_utils/* dispatchTabEvolve */.vV)(this.props, { url, replace: false });
                }
                else {
                    store["default"].dispatch(actions/* actions */.N.openInExternalBrowser({ url: url }));
                }
                this.setState({ editingAddress: false });
            }
            else if (e.key === "Escape") {
                e.preventDefault();
                this.setState({ editingAddress: false });
            }
        };
        this.addressBlur = () => {
            const { browserAddress } = this;
            if (browserAddress && isHTMLInput(browserAddress)) {
                browserAddress.setSelectionRange(0, 0);
            }
        };
        this.startEditingAddress = () => {
            this.setState({ editingAddress: true });
        };
        this.state = {
            editingAddress: false,
            url: null,
        };
    }
    subscribe(w) {
        w.on(actions/* actions */.N.focusLocationBar, async (store, action) => {
            const { wind, tab } = action.payload;
            if (wind !== (0,navigation/* ambientWind */.w)()) {
                return;
            }
            if (tab !== this.props.tab) {
                return;
            }
            this.setState({
                editingAddress: true,
            });
            const { browserAddress } = this;
            if (browserAddress && isHTMLInput(browserAddress)) {
                browserAddress.select();
            }
        });
        w.on(actions/* actions */.N.blurLocationBar, async (store, action) => {
            this.setState({ editingAddress: false });
        });
    }
    render() {
        const { canGoBack, canGoForward, loading } = this.props;
        return (react.createElement(NavigationBarDiv, { className: classnames_default()({ loading }) },
            react.createElement(IconButton/* default */.Z, { icon: "arrow-left", disabled: !canGoBack, onClick: this.goBack, onContextMenu: this.showBackHistory }),
            react.createElement(IconButton/* default */.Z, { icon: "arrow-right", disabled: !canGoForward, onClick: this.goForward, onContextMenu: this.showForwardHistory }),
            this.renderAddressBar()));
    }
    renderAddressBar() {
        const { loading, url } = this.props;
        if (!this.props.showAddressBar) {
            return null;
        }
        let { editingAddress } = this.state;
        return (react.createElement(react.Fragment, null,
            loading ? (react.createElement(IconButton/* default */.Z, { icon: "cross", onClick: this.stop })) : (react.createElement(IconButton/* default */.Z, { icon: "repeat", onClick: this.reload })),
            react.createElement(AddressWrapper, { className: classnames_default()({ editing: editingAddress }) }, editingAddress ? (react.createElement(AddressInput, { className: "browser-address", type: "search", ref: this.onBrowserAddress, defaultValue: url, onKeyDown: this.addressKeyDown, onBlur: this.addressBlur })) : (react.createElement(AddressDiv, { className: classnames_default()("browser-address"), ref: this.onBrowserAddress, onClick: this.startEditingAddress }, this.renderURL(url))))));
    }
    renderURL(url) {
        let isHTTP = HTTP_RE.test(url);
        let isHTTPS = HTTPS_RE.test(url);
        let isItch = ITCH_RE.test(url);
        if (isHTTPS) {
            return (react.createElement("span", null,
                react.createElement("span", { className: "security-theater-bit" }, "https://"),
                url.replace(HTTPS_RE, "")));
        }
        if (isItch) {
            return (react.createElement("span", null,
                react.createElement("span", { className: "fluff-bit" }, "itch://"),
                url.replace(ITCH_RE, "")));
        }
        if (!(isHTTP || isHTTPS || isItch)) {
            return null;
        }
        return react.createElement(react.Fragment, null, url);
    }
    static getDerivedStateFromProps(props, state) {
        if (props.url !== state.url) {
            return {
                url: props.url,
                editingAddress: false,
            };
        }
        return null;
    }
};
NavigationBar = (0,tslib_es6/* __decorate */.gn)([
    watching/* default */.Z
], NavigationBar);
/* harmony default export */ const basics_NavigationBar = ((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(NavigationBar)((map) => ({
    url: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.url),
    internalPage: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.internalPage),
    canGoBack: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).status.canGoBack),
    canGoForward: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).status.canGoForward),
}))(NavigationBar)));

;// CONCATENATED MODULE: ./src/renderer/basics/FiltersContainer.tsx




const filtersContainerHeight = 40;
const FiltersContainerDiv = styles/* default */.ZP.section `
  display: flex;
  align-items: center;
  padding-bottom: 2px;
  width: 100%;
  overflow: hidden;
  background: ${(props) => props.theme.sidebarBackground};
  box-shadow: 0 4px 8px -4px ${(props) => props.theme.sidebarBackground};
  flex-shrink: 0;
  padding-left: 10px;
  padding-right: 10px;
  height: ${filtersContainerHeight}px;

  position: relative;

  &.loading {
    &::after {
      position: absolute;
      bottom: 0px;
      content: " ";
      width: 100%;
      height: 2px;
      background: ${(props) => props.theme.accent};
      animation: ${styles/* animations */.sF.lineSpinner} 2s ease-in-out infinite;
    }
  }
`;
class FiltersContainer extends react.PureComponent {
    render() {
        const { loading, children, className } = this.props;
        return (react.createElement(FiltersContainerDiv, { className: classnames_default()(className, { loading }) },
            react.createElement(basics_NavigationBar, { loading: loading, showAddressBar: !this.props.hideAddressBar }),
            children));
    }
}
/* harmony default export */ const basics_FiltersContainer = (FiltersContainer);


/***/ }),

/***/ 2629:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1061);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4012);



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, Object.assign({}, (0,common_format_datetime__WEBPACK_IMPORTED_MODULE_0__/* .formatDurationAsMessage */ .Lb)(secs)))));


/***/ }),

/***/ 2250:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   An: () => (/* binding */ dispatchTabGotWebContents),
/* harmony export */   Iq: () => (/* binding */ urlWithParams),
/* harmony export */   U6: () => (/* binding */ dispatchTabGoBack),
/* harmony export */   Vl: () => (/* binding */ dispatchTabLosingWebContents),
/* harmony export */   _H: () => (/* binding */ dispatchTabLoadingStateChanged),
/* harmony export */   gn: () => (/* binding */ dispatchOpenTabBackHistory),
/* harmony export */   hF: () => (/* binding */ dispatchTabReloaded),
/* harmony export */   iC: () => (/* binding */ dispatchOpenTabForwardHistory),
/* harmony export */   li: () => (/* binding */ dispatchTabGoForward),
/* harmony export */   nP: () => (/* binding */ dispatchTabStop),
/* harmony export */   pq: () => (/* binding */ dispatchTabPageUpdate),
/* harmony export */   vV: () => (/* binding */ dispatchTabEvolve)
/* harmony export */ });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(9471);
/* harmony import */ var url__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(8575);
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7673);




function dispatchTabLoadingStateChanged(props, loading) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabLoadingStateChanged({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
        loading,
    }));
}
function dispatchTabGotWebContents(props, webContentsId) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabGotWebContents({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
        webContentsId,
    }));
}
function dispatchTabLosingWebContents(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabLosingWebContents({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabEvolve(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.evolveTab(Object.assign({ wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(), tab }, payload)));
}
function dispatchTabPageUpdate(props, page) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabPageUpdate({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
        page,
    }));
}
function dispatchTabReloaded(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabReloaded({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabStop(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabStop({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabGoForward(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabGoForward({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabGoBack(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabGoBack({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchOpenTabBackHistory(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openTabBackHistory(Object.assign({ wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(), tab }, payload)));
}
function dispatchOpenTabForwardHistory(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openTabForwardHistory(Object.assign({ wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(), tab }, payload)));
}
function urlWithParams(url, params) {
    const parsed = url__WEBPACK_IMPORTED_MODULE_1__.parse(url);
    let finalParams = querystring__WEBPACK_IMPORTED_MODULE_2__.parse(parsed.query);
    for (const k of Object.keys(params)) {
        const v = params[k];
        if (!v) {
            delete finalParams[k];
        }
        else {
            finalParams[k] = v;
        }
    }
    const query = querystring__WEBPACK_IMPORTED_MODULE_2__.stringify(finalParams);
    parsed.search = query ? `?${query}` : "";
    return url__WEBPACK_IMPORTED_MODULE_1__.format(parsed);
}


/***/ }),

/***/ 2521:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   D1: () => (/* binding */ withTab),
/* harmony export */   sM: () => (/* binding */ TabProvider)
/* harmony export */ });
/* unused harmony export TabConsumer */
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);

const spaceContext = react__WEBPACK_IMPORTED_MODULE_0__.createContext(undefined);
const TabProvider = spaceContext.Provider;
const TabConsumer = spaceContext.Consumer;
const withTab = (Component) => (props) => (react__WEBPACK_IMPORTED_MODULE_0__.createElement(TabConsumer, null, (tab) => react__WEBPACK_IMPORTED_MODULE_0__.createElement(Component, Object.assign({}, props, { tab: tab }))));


/***/ }),

/***/ 4210:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4713);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6785);
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5871);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(9080);
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(9050);
/* harmony import */ var renderer_basics_DownloadProgressSpan__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(830);
/* harmony import */ var renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(7128);









class PrereqsState extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
    render() {
        const { gameTitle, tasks } = this.props.modal.widgetParams;
        return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_3__/* .ModalWidgetDiv */ .U, null,
            react__WEBPACK_IMPORTED_MODULE_1__.createElement("p", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_5__.T)(["prereq.explanation", { title: gameTitle }])),
            react__WEBPACK_IMPORTED_MODULE_1__.createElement(PrereqsRows, null, (0,underscore__WEBPACK_IMPORTED_MODULE_6__/* .map */ .UI)(tasks, (v, name) => {
                let progress = v.progress;
                switch (v.status) {
                    case common_butlerd_messages__WEBPACK_IMPORTED_MODULE_0__/* .PrereqStatus */ .ln.Installing: {
                        progress = -1; // indeterminate
                        break;
                    }
                    case common_butlerd_messages__WEBPACK_IMPORTED_MODULE_0__/* .PrereqStatus */ .ln.Done: {
                        progress = 1;
                        break;
                    }
                }
                return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(PrereqsRow, { key: name, style: { order: v.order } },
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { progress: progress }),
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_8__/* .FilterSpacer */ .dz, null),
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", { className: "prereqs-info" },
                        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", { className: "task-name" }, v.fullName),
                        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", { className: "task-status" }, v.status === "downloading" && v.progress ? (react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_DownloadProgressSpan__WEBPACK_IMPORTED_MODULE_7__/* ["default"] */ .Z, { eta: v.eta, bps: v.bps, downloadsPaused: false })) : ((0,renderer_t__WEBPACK_IMPORTED_MODULE_5__.T)([`prereq.status.${v.status}`]))))));
            }))));
    }
}
const PrereqsRows = renderer_styles__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .ZP.ul `
  display: flex;
  flex: 0 1;
  flex-direction: column;
  align-content: flex-start;
`;
const PrereqsRow = renderer_styles__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .ZP.li `
  display: flex;
  flex: 0 1;
  flex-direction: row;
  align-items: center;
  margin: 14px 0;
  margin-left: 10px;

  .task-status {
    margin-top: 5px;
    font-size: 80%;
    color: ${(props) => props.theme.secondaryText};
  }
`;
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (PrereqsState);


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ }),

/***/ 7128:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Ni: () => (/* binding */ FilterOptionButton),
/* harmony export */   Zk: () => (/* binding */ FilterOptionIcon),
/* harmony export */   dz: () => (/* binding */ FilterSpacer),
/* harmony export */   e_: () => (/* binding */ FilterGroup),
/* harmony export */   gY: () => (/* binding */ SortsAndFilters),
/* harmony export */   zR: () => (/* binding */ FilterOptionLink)
/* harmony export */ });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4987);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4198);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5836);



const SortsAndFilters = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP)((0,renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__/* .FiltersContainerDiv */ .vN)) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* .css */ .iv) `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  ${optionButtonLike};
`;
const FilterOptionIcon = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP)((0,renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .Z)) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ })

}]);
//# sourceMappingURL=210.chunk.js.map