"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[235],{

/***/ 5379:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   j: () => (/* binding */ fileSize)
/* harmony export */ });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ 9235:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5379);
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2968);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6785);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2263);
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5871);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(9080);









class ClearBrowsingData extends react__WEBPACK_IMPORTED_MODULE_3__.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.toggleCache = () => {
            this.change({ clearCache: !this.state.clearCache });
        };
        this.toggleCookies = () => {
            this.change({ clearCookies: !this.state.clearCookies });
        };
        this.state = {
            fetchedCacheSize: false,
            clearCache: true,
            clearCookies: false,
        };
        this.doUpdatePayload(this.state);
    }
    componentDidMount() {
        const { userId } = this.props;
        renderer_bridge__WEBPACK_IMPORTED_MODULE_2__.electron.getUserCacheSize(userId).then((cacheSize) => {
            this.setState({
                fetchedCacheSize: true,
                cacheSize,
            });
        });
    }
    change(state) {
        const mergedState = Object.assign(Object.assign({}, this.state), state);
        this.setState(mergedState);
        this.doUpdatePayload(mergedState);
    }
    doUpdatePayload(state) {
        const payloadUpdate = {
            cache: state.clearCache,
            cookies: state.clearCookies,
        };
        this.props.updatePayload(payloadUpdate);
    }
    render() {
        const { fetchedCacheSize, cacheSize, clearCache, clearCookies, } = this.state;
        // chrome sometimes return negative values (-2 B)
        const shownCacheSize = cacheSize < 0 ? 0 : cacheSize;
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_6__/* .ModalWidgetDiv */ .U, null,
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(ClearBrowsingDataList, null,
                react__WEBPACK_IMPORTED_MODULE_3__.createElement("label", { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ active: clearCache }) },
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement("div", { className: "checkbox" },
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement("input", { type: "checkbox", id: "clear-cache-checkbox", checked: clearCache, onChange: this.toggleCache }),
                        (0,renderer_t__WEBPACK_IMPORTED_MODULE_8__.T)(["prompt.clear_browsing_data.category.cache"])),
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement("div", { className: "checkbox-info" }, fetchedCacheSize ? ((0,renderer_t__WEBPACK_IMPORTED_MODULE_8__.T)([
                        "prompt.clear_browsing_data.cache_size_used",
                        {
                            size: (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_1__/* .fileSize */ .j)(shownCacheSize),
                        },
                    ])) : (react__WEBPACK_IMPORTED_MODULE_3__.createElement("span", null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { progress: 0.1 }),
                        " ",
                        (0,renderer_t__WEBPACK_IMPORTED_MODULE_8__.T)(["prompt.clear_browsing_data.retrieving_cache_size"]),
                        ",")))),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement("label", { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ active: clearCookies }) },
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement("div", { className: "checkbox" },
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement("input", { type: "checkbox", id: "clear-cookies-checkbox", checked: clearCookies, onChange: this.toggleCookies }),
                        (0,renderer_t__WEBPACK_IMPORTED_MODULE_8__.T)(["prompt.clear_browsing_data.category.cookies"])),
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement("div", { className: "checkbox-info" }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_8__.T)(["prompt.clear_browsing_data.cookies_info"]))))));
    }
}
const ClearBrowsingDataList = renderer_styles__WEBPACK_IMPORTED_MODULE_7__/* ["default"] */ .ZP.div `
  label {
    display: block;
    border-left: 3px solid ${(props) => props.theme.prefBorder};
    padding: 5px 0;
    padding-left: 5px;
    margin: 3px 0;
    margin-bottom: 10px;
    transition: 0.2s border ease-in-out;

    &:hover {
      cursor: pointer;
    }

    &.active {
      border-color: ${(props) => props.theme.accent};
    }
  }

  .checkbox {
    margin: 0;
    display: flex;
    align-items: center;

    input[type="checkbox"] {
      margin-right: 10px;
    }
  }

  .checkbox-info {
    margin: 0;
    margin-top: 5px;
    margin-left: 5px;
    font-size: 90%;
    color: ${(props) => props.theme.secondaryText};
  }
`;
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__/* .hook */ .z)((map) => ({
    userId: map((rs) => rs.profile.profile.id),
}))(ClearBrowsingData));


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=235.chunk.js.map