"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[259],{

/***/ 105:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   z: () => (/* binding */ hasPlatforms)
/* harmony export */ });
const data = {
    windows: { icon: "windows8", platform: "windows", emoji: "🏁" },
    linux: { icon: "tux", platform: "linux", emoji: "🐧" },
    osx: { icon: "apple", platform: "osx", emoji: "🍎" },
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (data);
function hasPlatforms(target) {
    for (const key of Object.keys(data)) {
        if (target.platforms[key]) {
            return true;
        }
    }
    if (target.type === "html") {
        return true;
    }
    return false;
}


/***/ }),

/***/ 1282:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   $: () => (/* binding */ truncate)
/* harmony export */ });
/**
 * Returns a truncated version of input. The output length will not exceed
 * opts.length.
 */
function truncate(input, opts) {
    if (!input) {
        return input;
    }
    if (input.length > opts.length) {
        return input.substr(0, opts.length - 3) + "...";
    }
    return input;
}


/***/ }),

/***/ 3964:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);


const ButlerErrorDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;
  margin: 2em 0;

  .spacer {
    width: 8px;
  }
`;
const ErrorState = ({ error }) => {
    if (!error) {
        return null;
    }
    return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(ButlerErrorDiv, null,
        react__WEBPACK_IMPORTED_MODULE_0__.createElement("span", { className: "icon icon-error" }),
        react__WEBPACK_IMPORTED_MODULE_0__.createElement("div", { className: "spacer" }),
        react__WEBPACK_IMPORTED_MODULE_0__.createElement("abbr", { title: error && error.stack ? error.stack : String(error) }, String(error))));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (ErrorState);


/***/ }),

/***/ 4987:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  vN: () => (/* binding */ FiltersContainerDiv),
  ZP: () => (/* binding */ basics_FiltersContainer),
  zR: () => (/* binding */ filtersContainerHeight)
});

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__(541);
// EXTERNAL MODULE: ./src/renderer/bridge.ts
var bridge = __webpack_require__(2968);
;// CONCATENATED MODULE: ./src/renderer/util/url.ts

const wellKnownProtocols = ["http:", "https:", "itch:"];
function isWellKnownProtocol(protocol) {
    return wellKnownProtocols.indexOf(protocol) !== -1;
}
function transformUrl(original) {
    if (/^about:/.test(original)) {
        return original;
    }
    let req = original;
    const searchUrl = (q) => {
        return "https://duckduckgo.com/?" + bridge/* querystring */.xO.stringify({ q, kae: "d" });
    };
    // special search URLs
    if (/^\?/.test(original)) {
        return searchUrl(original.substr(1));
    }
    // spaces and no dots ? smells like a search request
    if (original.indexOf(" ") !== -1 && original.indexOf(".") === -1) {
        return searchUrl(original);
    }
    // add http: if needed
    let parsed = bridge/* url */.HQ.parse(req);
    if (!isWellKnownProtocol(parsed.protocol)) {
        req = "http://" + original;
        parsed = bridge/* url */.HQ.parse(req);
        if (!parsed.hostname) {
            return searchUrl(original);
        }
    }
    return req;
}

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/store.ts + 4 modules
var store = __webpack_require__(5784);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/hocs/watching.tsx
var watching = __webpack_require__(7538);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
;// CONCATENATED MODULE: ./src/renderer/basics/NavigationBar.tsx















const HTTPS_RE = /^https:\/\//;
const HTTP_RE = /^http:\/\//;
const ITCH_RE = /^itch:\/\//;
const NavigationBarDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;

  padding-right: 4px;

  flex-grow: 1;
  flex-shrink: 1;
  overflow: hidden;
  position: relative;

  &.loading {
    &::after {
      position: absolute;
      bottom: -6px;
      content: " ";
      width: 100%;
      height: 2px;
      background: ${(props) => props.theme.accent};
      animation: ${styles/* animations */.sF.lineSpinner} 2s ease-in-out infinite;
    }
  }
`;
const browserAddressSizing = (0,styles/* css */.iv) `
  height: 28px;
  line-height: 28px;
  border-radius: 2px;
`;
const browserAddressStyle = (0,styles/* css */.iv) `
  ${browserAddressSizing};
  ${styles/* singleLine */.U1};
  font-size: 14px;
  text-shadow: 0 0 1px black;
  padding: 0;
  padding-left: 8px;
  padding-right: 12px;
  width: 100%;
  color: #fdfdfd;

  border: none;
  background: rgba(255, 255, 255, 0.1);
  box-shadow: none;

  &:focus {
    outline: none;
  }
`;
const AddressWrapper = styles/* default */.ZP.div `
  ${browserAddressSizing};
  margin: 0 6px;
  transition: all 0.4s;
  border: 1px solid transparent;
  flex-grow: 1;

  &.editing {
    border-color: rgba(255, 255, 255, 0.4);
  }
`;
const AddressInput = styles/* default */.ZP.input `
  ${browserAddressStyle};

  text-shadow: 0 0 1px transparent;
  color: white;
`;
const AddressDiv = styles/* default */.ZP.div `
  ${browserAddressStyle};

  .security-theater-bit {
    color: rgb(138, 175, 115);
  }

  .fluff-bit {
    color: rgb(148, 184, 218);
  }
`;
function isHTMLInput(el) {
    return el.tagName === "INPUT";
}
let NavigationBar = class NavigationBar extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.fresh = true;
        // event handlers
        this.goBack = () => {
            (0,tab_utils/* dispatchTabGoBack */.U6)(this.props);
        };
        this.showBackHistory = (ev) => {
            const { clientX, clientY } = ev;
            ev.preventDefault();
            (0,tab_utils/* dispatchOpenTabBackHistory */.gn)(this.props, { clientX, clientY });
        };
        this.goForward = () => {
            (0,tab_utils/* dispatchTabGoForward */.li)(this.props);
        };
        this.showForwardHistory = (ev) => {
            const { clientX, clientY } = ev;
            ev.preventDefault();
            (0,tab_utils/* dispatchOpenTabForwardHistory */.iC)(this.props, { clientX, clientY });
        };
        this.stop = () => {
            (0,tab_utils/* dispatchTabStop */.nP)(this.props);
        };
        this.reload = () => {
            (0,tab_utils/* dispatchTabReloaded */.hF)(this.props);
        };
        this.onBrowserAddress = (browserAddress) => {
            this.browserAddress = browserAddress;
            if (!browserAddress) {
                return;
            }
            const { internalPage } = this.props;
            if (this.fresh && internalPage === "new-tab") {
                this.fresh = false;
                this.startEditingAddress();
            }
            if (isHTMLInput(browserAddress)) {
                browserAddress.focus();
                browserAddress.select();
            }
        };
        this.addressKeyDown = (e) => {
            if (e.key === "Enter") {
                const input = e.currentTarget.value;
                const url = transformUrl(input);
                const parsedUrl = new URL(url);
                // If the supplied url is external to itch, then
                // open in a new external browser window
                if (parsedUrl.origin.endsWith(".itch.io") ||
                    parsedUrl.origin.endsWith("/itch.io") ||
                    urls/* ITCH_URL_RE */.N.test(parsedUrl.origin)) {
                    (0,tab_utils/* dispatchTabEvolve */.vV)(this.props, { url, replace: false });
                }
                else {
                    store["default"].dispatch(actions/* actions */.N.openInExternalBrowser({ url: url }));
                }
                this.setState({ editingAddress: false });
            }
            else if (e.key === "Escape") {
                e.preventDefault();
                this.setState({ editingAddress: false });
            }
        };
        this.addressBlur = () => {
            const { browserAddress } = this;
            if (browserAddress && isHTMLInput(browserAddress)) {
                browserAddress.setSelectionRange(0, 0);
            }
        };
        this.startEditingAddress = () => {
            this.setState({ editingAddress: true });
        };
        this.state = {
            editingAddress: false,
            url: null,
        };
    }
    subscribe(w) {
        w.on(actions/* actions */.N.focusLocationBar, async (store, action) => {
            const { wind, tab } = action.payload;
            if (wind !== (0,navigation/* ambientWind */.w)()) {
                return;
            }
            if (tab !== this.props.tab) {
                return;
            }
            this.setState({
                editingAddress: true,
            });
            const { browserAddress } = this;
            if (browserAddress && isHTMLInput(browserAddress)) {
                browserAddress.select();
            }
        });
        w.on(actions/* actions */.N.blurLocationBar, async (store, action) => {
            this.setState({ editingAddress: false });
        });
    }
    render() {
        const { canGoBack, canGoForward, loading } = this.props;
        return (react.createElement(NavigationBarDiv, { className: classnames_default()({ loading }) },
            react.createElement(IconButton/* default */.Z, { icon: "arrow-left", disabled: !canGoBack, onClick: this.goBack, onContextMenu: this.showBackHistory }),
            react.createElement(IconButton/* default */.Z, { icon: "arrow-right", disabled: !canGoForward, onClick: this.goForward, onContextMenu: this.showForwardHistory }),
            this.renderAddressBar()));
    }
    renderAddressBar() {
        const { loading, url } = this.props;
        if (!this.props.showAddressBar) {
            return null;
        }
        let { editingAddress } = this.state;
        return (react.createElement(react.Fragment, null,
            loading ? (react.createElement(IconButton/* default */.Z, { icon: "cross", onClick: this.stop })) : (react.createElement(IconButton/* default */.Z, { icon: "repeat", onClick: this.reload })),
            react.createElement(AddressWrapper, { className: classnames_default()({ editing: editingAddress }) }, editingAddress ? (react.createElement(AddressInput, { className: "browser-address", type: "search", ref: this.onBrowserAddress, defaultValue: url, onKeyDown: this.addressKeyDown, onBlur: this.addressBlur })) : (react.createElement(AddressDiv, { className: classnames_default()("browser-address"), ref: this.onBrowserAddress, onClick: this.startEditingAddress }, this.renderURL(url))))));
    }
    renderURL(url) {
        let isHTTP = HTTP_RE.test(url);
        let isHTTPS = HTTPS_RE.test(url);
        let isItch = ITCH_RE.test(url);
        if (isHTTPS) {
            return (react.createElement("span", null,
                react.createElement("span", { className: "security-theater-bit" }, "https://"),
                url.replace(HTTPS_RE, "")));
        }
        if (isItch) {
            return (react.createElement("span", null,
                react.createElement("span", { className: "fluff-bit" }, "itch://"),
                url.replace(ITCH_RE, "")));
        }
        if (!(isHTTP || isHTTPS || isItch)) {
            return null;
        }
        return react.createElement(react.Fragment, null, url);
    }
    static getDerivedStateFromProps(props, state) {
        if (props.url !== state.url) {
            return {
                url: props.url,
                editingAddress: false,
            };
        }
        return null;
    }
};
NavigationBar = (0,tslib_es6/* __decorate */.gn)([
    watching/* default */.Z
], NavigationBar);
/* harmony default export */ const basics_NavigationBar = ((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(NavigationBar)((map) => ({
    url: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.url),
    internalPage: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.internalPage),
    canGoBack: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).status.canGoBack),
    canGoForward: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).status.canGoForward),
}))(NavigationBar)));

;// CONCATENATED MODULE: ./src/renderer/basics/FiltersContainer.tsx




const filtersContainerHeight = 40;
const FiltersContainerDiv = styles/* default */.ZP.section `
  display: flex;
  align-items: center;
  padding-bottom: 2px;
  width: 100%;
  overflow: hidden;
  background: ${(props) => props.theme.sidebarBackground};
  box-shadow: 0 4px 8px -4px ${(props) => props.theme.sidebarBackground};
  flex-shrink: 0;
  padding-left: 10px;
  padding-right: 10px;
  height: ${filtersContainerHeight}px;

  position: relative;

  &.loading {
    &::after {
      position: absolute;
      bottom: 0px;
      content: " ";
      width: 100%;
      height: 2px;
      background: ${(props) => props.theme.accent};
      animation: ${styles/* animations */.sF.lineSpinner} 2s ease-in-out infinite;
    }
  }
`;
class FiltersContainer extends react.PureComponent {
    render() {
        const { loading, children, className } = this.props;
        return (react.createElement(FiltersContainerDiv, { className: classnames_default()(className, { loading }) },
            react.createElement(basics_NavigationBar, { loading: loading, showAddressBar: !this.props.hideAddressBar }),
            children));
    }
}
/* harmony default export */ const basics_FiltersContainer = (FiltersContainer);


/***/ }),

/***/ 3537:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (/* binding */ Floater)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5836);



const floaterKeyframes = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* .keyframes */ .F4) `
  0% {
    transform: scale(0);
    opacity: .6;
  }

  100% {
    transform: scale(1);
    opacity: 1;
  }
`;
const numDrops = 3;
const duration = 0.5;
const offset = duration / numDrops;
const FloaterDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  width: 30px;
  height: 10px;

  display: flex;
  flex-flow: row;
  align-items: center;
  justify-content: center;

  div {
    width: 8px;
    height: 6px;
    margin: 0 2px;
    border-radius: 50%;
    background: white;
    animation: ${floaterKeyframes} ${duration}s infinite ease-in-out alternate;
  }

  &.tiny {
    width: 20px;
    height: 8px;

    div {
      width: 6px;
      height: 3px;
    }
  }

  div:nth-child(1) {
    animation-delay: -${offset * 2}s;
  }

  div:nth-child(2) {
    animation-delay: -${offset * 1}s;
  }
`;
function Floater(props) {
    const { tiny } = props;
    return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(FloaterDiv, { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ tiny }) },
        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null),
        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null),
        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null)));
}


/***/ }),

/***/ 1612:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (/* binding */ PlatformIcon)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4198);
/* harmony import */ var common_constants_platform_data__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(105);



class PlatformIcon extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const { target, field, before } = this.props;
        if (!target.platforms || !target.platforms[field]) {
            return null;
        }
        const data = common_constants_platform_data__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z[field];
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null,
            before,
            react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .Z, { hint: data.platform, icon: data.icon })));
    }
}


/***/ }),

/***/ 3043:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);
/* harmony import */ var renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(1612);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(4198);
/* harmony import */ var common_constants_platform_data__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(105);






const PlatformIconsDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.span `
  .icon {
    margin-left: 8px;

    &:first-child {
      margin-left: 0;
    }
  }
`;
class PlatformIcons extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { target, before } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_5__/* .__rest */ ._T)(_a, ["target", "before"]);
        if (!(0,common_constants_platform_data__WEBPACK_IMPORTED_MODULE_4__/* .hasPlatforms */ .z)(target)) {
            return null;
        }
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null,
            before ? before() : null,
            react__WEBPACK_IMPORTED_MODULE_0__.createElement(PlatformIconsDiv, Object.assign({}, restProps),
                react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { field: "windows", target: target }),
                react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { field: "osx", target: target }),
                react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_basics_PlatformIcons_PlatformIcon__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { field: "linux", target: target }),
                target.type === "html" ? react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { icon: "html5", hint: "web" }) : null)));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (PlatformIcons);


/***/ }),

/***/ 8472:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   v: () => (/* binding */ rcall)
/* harmony export */ });
/* harmony import */ var renderer_store__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5784);
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5258);
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2968);



const logger = renderer_logger__WEBPACK_IMPORTED_MODULE_1__/* .rendererLogger */ .X.childWithName("rcall");
/**
 * Perform a butlerd call from the renderer process
 */
async function rcall(rc, params, setups) {
    return await renderer_bridge__WEBPACK_IMPORTED_MODULE_2__/* .butlerd */ .lB.rcall(renderer_store__WEBPACK_IMPORTED_MODULE_0__["default"], logger, rc.__method, params, setups);
}


/***/ }),

/***/ 5617:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  K_: () => (/* binding */ LoadingStateDiv),
  ZP: () => (/* binding */ hocs_butlerCaller),
  a1: () => (/* binding */ renderNoop)
});

// EXTERNAL MODULE: ./src/common/logger/index.ts
var logger = __webpack_require__(8976);
// EXTERNAL MODULE: ./src/common/util/watcher.ts + 1 modules
var watcher = __webpack_require__(9434);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-fast-compare/index.js
var react_fast_compare = __webpack_require__(9590);
var react_fast_compare_default = /*#__PURE__*/__webpack_require__.n(react_fast_compare);
// EXTERNAL MODULE: ./src/renderer/basics/ErrorState.tsx
var ErrorState = __webpack_require__(3964);
// EXTERNAL MODULE: ./src/renderer/basics/Floater.tsx
var Floater = __webpack_require__(3537);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
;// CONCATENATED MODULE: ./src/renderer/butlerd/invalidators.ts


const invalidators = new Map();
invalidators.set(messages/* FetchProfileOwnedKeys */.R_, [actions/* actions */.N.commonsUpdated]);
invalidators.set(messages/* FetchCaves */.J1, [actions/* actions */.N.commonsUpdated]);
invalidators.set(messages/* FetchCave */.nD, [actions/* actions */.N.commonsUpdated]);
invalidators.set(messages/* InstallLocationsList */.kx, [
    actions/* actions */.N.commonsUpdated,
    actions/* actions */.N.installLocationsChanged,
]);

// EXTERNAL MODULE: ./src/renderer/butlerd/rcall.ts
var rcall = __webpack_require__(8472);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
// EXTERNAL MODULE: ./node_modules/react-redux/es/index.js + 20 modules
var es = __webpack_require__(5858);
;// CONCATENATED MODULE: ./src/renderer/hocs/butlerCaller/index.tsx











function renderNoop() {
    return null;
}
const LoadingStateDiv = styles/* default */.ZP.div `
  display: flex;
  align-items: center;
  justify-content: center;
  margin: 20px auto;
`;
const butlerCaller = (method) => {
    class Caller extends react.PureComponent {
        constructor(props, context) {
            super(props, context);
            this.fetchID = 0;
            this.invalidate = (0,index_all/* debounce */.Ds)(() => {
                this.queueFetch();
            }, 150);
            this.queueFetch = (additionalParams) => {
                // cf. https://github.com/Microsoft/TypeScript/pull/13288
                let fullParams = this.props.params;
                if (additionalParams) {
                    fullParams = Object.assign(Object.assign({}, fullParams), additionalParams);
                }
                this.setState({
                    loading: true,
                });
                this.fetchID++;
                let { fetchID } = this;
                (async () => {
                    try {
                        const result = await (0,rcall/* rcall */.v)(method, fullParams);
                        if (this.fetchID !== fetchID) {
                            // discard outdated result
                            return;
                        }
                        this.setResult(result);
                        if (!fullParams.fresh && result.stale) {
                            this.queueFetch({ fresh: true });
                        }
                    }
                    catch (error) {
                        if (this.fetchID !== fetchID) {
                            // discard outdated result
                            return;
                        }
                        this.setError(error);
                    }
                })();
            };
            this.setResult = (r) => {
                if (this.props.onResult) {
                    this.props.onResult(r);
                }
                this.setState({ result: r, error: null, loading: false });
            };
            this.setError = (e) => {
                this.setState({ error: e, loading: false });
            };
            this.state = {
                loading: true,
                error: undefined,
                result: undefined,
            };
            this.invalidators = invalidators.get(method);
        }
        componentDidMount() {
            this.queueFetch();
            if (this.invalidators) {
                this.watcher = new watcher/* Watcher */.C(new logger/* Logger */.Yd(logger/* devNull */.s5));
                this.props.__store.watcher.addSub(this.watcher);
                for (const invalidatingAction of this.invalidators) {
                    this.watcher.on(invalidatingAction, async (store, action) => {
                        this.invalidate();
                    });
                }
            }
        }
        componentWillUnmount() {
            if (this.watcher) {
                this.props.__store.watcher.removeSub(this.watcher);
            }
        }
        render() {
            const { error, loading, result } = this.state;
            const { render, errorsHandled, loadingHandled } = this.props;
            if (loading) {
                if (!loadingHandled) {
                    return (react.createElement(LoadingStateDiv, null,
                        react.createElement(Floater/* default */.Z, null)));
                }
            }
            if (error) {
                if (!errorsHandled) {
                    return react.createElement(ErrorState/* default */.Z, { error: error });
                }
            }
            return render({ error, loading, result });
        }
        componentDidUpdate(prevProps) {
            if (!react_fast_compare_default()(prevProps.params, this.props.params)) {
                this.queueFetch();
                return;
            }
            if (prevProps.sequence != this.props.sequence) {
                this.queueFetch({ fresh: true });
                return;
            }
        }
    }
    Caller.displayName = `ButlerCall(${method.name})`;
    class Wrapper extends react.PureComponent {
        render() {
            return (react.createElement(es/* ReactReduxContext */.ET.Consumer, null, ({ store }) => react.createElement(Caller, Object.assign({}, this.props, { __store: store }))));
        }
        static renderCallback(f) {
            return f;
        }
        static onResultCallback(f) {
            return f;
        }
    }
    return Wrapper;
};
/* harmony default export */ const hocs_butlerCaller = (butlerCaller);


/***/ }),

/***/ 2250:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   An: () => (/* binding */ dispatchTabGotWebContents),
/* harmony export */   Iq: () => (/* binding */ urlWithParams),
/* harmony export */   U6: () => (/* binding */ dispatchTabGoBack),
/* harmony export */   Vl: () => (/* binding */ dispatchTabLosingWebContents),
/* harmony export */   _H: () => (/* binding */ dispatchTabLoadingStateChanged),
/* harmony export */   gn: () => (/* binding */ dispatchOpenTabBackHistory),
/* harmony export */   hF: () => (/* binding */ dispatchTabReloaded),
/* harmony export */   iC: () => (/* binding */ dispatchOpenTabForwardHistory),
/* harmony export */   li: () => (/* binding */ dispatchTabGoForward),
/* harmony export */   nP: () => (/* binding */ dispatchTabStop),
/* harmony export */   pq: () => (/* binding */ dispatchTabPageUpdate),
/* harmony export */   vV: () => (/* binding */ dispatchTabEvolve)
/* harmony export */ });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(9471);
/* harmony import */ var url__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(8575);
/* harmony import */ var querystring__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7673);




function dispatchTabLoadingStateChanged(props, loading) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabLoadingStateChanged({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
        loading,
    }));
}
function dispatchTabGotWebContents(props, webContentsId) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabGotWebContents({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
        webContentsId,
    }));
}
function dispatchTabLosingWebContents(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabLosingWebContents({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabEvolve(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.evolveTab(Object.assign({ wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(), tab }, payload)));
}
function dispatchTabPageUpdate(props, page) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabPageUpdate({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
        page,
    }));
}
function dispatchTabReloaded(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabReloaded({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabStop(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabStop({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabGoForward(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabGoForward({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchTabGoBack(props) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.tabGoBack({
        wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(),
        tab,
    }));
}
function dispatchOpenTabBackHistory(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openTabBackHistory(Object.assign({ wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(), tab }, payload)));
}
function dispatchOpenTabForwardHistory(props, payload) {
    const { tab, dispatch } = props;
    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openTabForwardHistory(Object.assign({ wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_3__/* .ambientWind */ .w)(), tab }, payload)));
}
function urlWithParams(url, params) {
    const parsed = url__WEBPACK_IMPORTED_MODULE_1__.parse(url);
    let finalParams = querystring__WEBPACK_IMPORTED_MODULE_2__.parse(parsed.query);
    for (const k of Object.keys(params)) {
        const v = params[k];
        if (!v) {
            delete finalParams[k];
        }
        else {
            finalParams[k] = v;
        }
    }
    const query = querystring__WEBPACK_IMPORTED_MODULE_2__.stringify(finalParams);
    parsed.search = query ? `?${query}` : "";
    return url__WEBPACK_IMPORTED_MODULE_1__.format(parsed);
}


/***/ }),

/***/ 2521:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   D1: () => (/* binding */ withTab),
/* harmony export */   sM: () => (/* binding */ TabProvider)
/* harmony export */ });
/* unused harmony export TabConsumer */
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);

const spaceContext = react__WEBPACK_IMPORTED_MODULE_0__.createContext(undefined);
const TabProvider = spaceContext.Provider;
const TabConsumer = spaceContext.Consumer;
const withTab = (Component) => (props) => (react__WEBPACK_IMPORTED_MODULE_0__.createElement(TabConsumer, null, (tab) => react__WEBPACK_IMPORTED_MODULE_0__.createElement(Component, Object.assign({}, props, { tab: tab }))));


/***/ }),

/***/ 465:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Dx: () => (/* binding */ Title),
/* harmony export */   Xe: () => (/* binding */ Desc),
/* harmony export */   kS: () => (/* binding */ TitleBox),
/* harmony export */   pd: () => (/* binding */ TitleBreak)
/* harmony export */ });
/* unused harmony export TitleSpacer */
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

//-----------------------------------
// Description
//-----------------------------------
const TitleBox = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 12px 0;
  align-self: flex-start;

  display: flex;
  flex-direction: column;
  align-self: stretch;
`;
const Title = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  font-size: ${(props) => props.theme.fontSizes.huger};
  font-weight: bold;
  display: flex;
  flex-flow: row wrap;
  align-items: center;
`;
const TitleBreak = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  flex-basis: 100%;
  width: 0;
  height: 0;
  overflow: hidden;
  margin-top: 8px;
`;
const TitleSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  width: 8px;
`;
const Desc = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  color: ${(props) => props.theme.secondaryText};
`;


/***/ }),

/***/ 7792:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  ZP: () => (/* binding */ common_StandardGameCover),
  xb: () => (/* binding */ standardCoverHeight),
  C2: () => (/* binding */ standardCoverWidth)
});

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/basics/Cover/index.tsx + 2 modules
var Cover = __webpack_require__(103);
;// CONCATENATED MODULE: ./src/renderer/pages/common/StandardSaleRibbon.tsx


const SaleRibbon = styles/* default */.ZP.div `
  position: absolute;
  right: 0;
  bottom: 0;
  background-color: ${(props) => props.theme.sale};
  padding: 0.5em 1em;
  font-size: ${(props) => props.theme.fontSizes.large};
  font-weight: 700;
  border: 3px solid ${(props) => props.theme.breadBackground};
  border-right: none;
  border-bottom: none;
`;
const SaleRate = styles/* default */.ZP.div `
  opacity: 0.9;
  font-weight: 900;
`;
const SaleMiniLabel = styles/* default */.ZP.div `
  text-transform: uppercase;
  line-height: 1.1;
  opacity: 0.5;
  font-weight: bold;
`;
/* harmony default export */ const StandardSaleRibbon = (({ game }) => (react.createElement(react.Fragment, null, game.sale ? (react.createElement(SaleRibbon, null,
    react.createElement(SaleRate, null,
        game.sale.rate.toFixed(),
        "%"),
    react.createElement(SaleMiniLabel, null, "off"))) : null)));

// EXTERNAL MODULE: ./src/common/format/truncate.ts
var truncate = __webpack_require__(1282);
// EXTERNAL MODULE: ./src/renderer/pages/PageStyles/games.tsx
var games = __webpack_require__(465);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/PlatformIcons/index.tsx
var PlatformIcons = __webpack_require__(3043);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
;// CONCATENATED MODULE: ./src/renderer/pages/common/StandardGameCover.tsx













//-----------------------------------
// Cover
//-----------------------------------
const baseWidth = 215;
const baseHeight = 170;
const coverFactor = 0.9;
const standardCoverWidth = baseWidth * coverFactor;
const standardCoverHeight = baseHeight * coverFactor;
const CoverBox = styles/* default */.ZP.div `
  flex-shrink: 0;
  width: ${standardCoverWidth}px;
  height: ${standardCoverHeight}px;
  box-shadow: 0 0 20px rgba(0, 0, 0, 0.4);
  position: relative;

  &.showInfo {
    .cover-hover {
      opacity: 0;
      transition: opacity 0.4s;
    }

    img {
      transition: filter 0.4s;
    }

    &:hover {
      img {
        filter: brightness(42%) saturate(42%);
      }

      .cover-hover {
        opacity: 1;
      }
    }
  }
`;
const CoverInfo = styles/* default */.ZP.div `
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;

  display: flex;
  flex-direction: row;
  align-items: center;

  pointer-events: none;

  line-height: 1.4;
`;
const DarkBox = styles/* default */.ZP.div `
  margin: 0;
  padding: 0;
  align-self: flex-start;
  display: flex;
  flex-direction: column;
  align-self: stretch;
  width: 100%;
  padding: 0.3em 0.7em;
  background: rgba(0, 0, 0, 0.5);
`;
const DarkTitle = styles/* default */.ZP.div `
  ${styles/* singleLine */.U1};
  flex-shrink: 0;
  font-size: ${(props) => props.theme.fontSizes.huge};
  font-weight: bold;
  padding: 0.3em 0;
`;
class StandardGameCover extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onContextMenu = (ev) => {
            const { game, dispatch } = this.props;
            if (!game) {
                return;
            }
            const { clientX, clientY } = ev;
            ev.preventDefault();
            const wind = (0,navigation/* ambientWind */.w)();
            dispatch(actions/* actions */.N.openGameContextMenu({
                clientX,
                clientY,
                game,
                wind,
            }));
        };
    }
    render() {
        const _a = this.props, { game, showInfo, className, children, showGifMarker = true } = _a, restProps = (0,tslib_es6/* __rest */._T)(_a, ["game", "showInfo", "className", "children", "showGifMarker"]);
        return (react.createElement(CoverBox, Object.assign({}, restProps, { className: classnames_default()(className, { showInfo }), onContextMenu: this.onContextMenu }),
            game ? (react.createElement(react.Fragment, null,
                react.createElement("a", { href: (0,navigation/* urlForGame */.OH)(game.id) },
                    react.createElement(Cover/* GameCover */.ro, { game: game, showGifMarker: !showInfo && showGifMarker }),
                    react.createElement(StandardSaleRibbon, { game: game }),
                    showInfo ? (react.createElement(react.Fragment, null,
                        react.createElement(CoverInfo, { className: "cover-hover" },
                            react.createElement(DarkBox, null,
                                react.createElement(DarkTitle, null, game.title),
                                react.createElement(games/* Desc */.Xe, null, (0,truncate/* truncate */.$)(game.shortText, { length: 70 })),
                                react.createElement(Filler/* default */.Z, null),
                                react.createElement(PlatformIcons/* default */.Z, { target: game }))))) : null))) : null,
            children));
    }
}
/* harmony default export */ const common_StandardGameCover = ((0,hook/* hook */.z)()(StandardGameCover));


/***/ })

}]);
//# sourceMappingURL=259.chunk.js.map