"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[274],{

/***/ 274:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ modal_widgets_SwitchVersionCave)
});

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__(1061);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/polished/dist/polished.esm.js + 9 modules
var polished_esm = __webpack_require__(6538);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/modal-widgets/styles.tsx
var styles = __webpack_require__(5871);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
;// CONCATENATED MODULE: ./src/renderer/modal-widgets/SwitchVersionCave/CustomDate.tsx



class CustomDate extends react.PureComponent {
    render() {
        const { intl, date, format = datetime/* DATE_FORMAT */.zT } = this.props;
        const dateObject = new Date(date);
        if (!dateObject) {
            return null;
        }
        if (!dateObject.getTime || isNaN(dateObject.getTime())) {
            console.warn("CustomDate was passed an invalid date: ", this.props.date);
            return null;
        }
        return react.createElement(react.Fragment, null, (0,datetime/* formatDate */.p6)(dateObject, intl.locale, format));
    }
}
/* harmony default export */ const SwitchVersionCave_CustomDate = ((0,injectIntl/* default */.ZP)(CustomDate));

// EXTERNAL MODULE: ./src/renderer/styles.ts
var renderer_styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
;// CONCATENATED MODULE: ./src/renderer/modal-widgets/SwitchVersionCave/index.tsx












const BuildListDiv = renderer_styles/* default */.ZP.div `
  width: 100%;
  max-height: 400px;

  padding-right: 15px;

  overflow-y: scroll;

  .builds--month {
    width: 100%;
    border-left: 2px solid ${(props) => props.theme.accent};
    margin-top: 24px;
    padding-left: 12px;
    padding-top: 8px;
    padding-bottom: 8px;
    font-size: ${(props) => props.theme.fontSizes.larger};
    font-weight: bold;
  }

  .builds--item {
    display: flex;
    flex-direction: row;

    width: 100%;
    margin: 8px 0;
    background: ${(props) => props.theme.sidebarBackground};
    padding: 12px 16px;
    align-items: center;

    &:hover {
      cursor: pointer;
      background: ${(props) => (0,polished_esm/* lighten */.$n)(0.05, props.theme.sidebarBackground)};
    }

    .item--version {
      display: flex;
      flex-direction: column;
      flex-shrink: 0;
    }

    .filler {
      flex-grow: 1;
    }

    .spacer {
      flex-shrink: 0;
      width: 16px;
    }
  }

  .version--user {
    font-weight: bold;
    font-size: ${(props) => props.theme.fontSizes.large};
    margin-right: 16px;
  }

  .version--raw,
  .version--timeago {
    color: ${(props) => props.theme.secondaryText};
  }
`;
function monthFor(b) {
    const date = new Date(b.updatedAt);
    return date.getUTCFullYear() * 12 + date.getUTCMonth();
}
class SwitchVersionCave extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (ev) => {
            const index = parseInt(ev.currentTarget.dataset.index, 10);
            const res = { index };
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.closeModal({
                wind: (0,navigation/* ambientWind */.w)(),
                action: actions/* actions */.N.modalResponse(res),
            }));
        };
    }
    render() {
        const { builds } = this.props.modal.widgetParams;
        const buildElements = [];
        if ((0,index_all/* isEmpty */.xb)(builds)) {
            buildElements.push(react.createElement(react.Fragment, null, (0,t.T)(["prompt.revert.no_other_version"])));
        }
        else {
            let lastMonth = 0;
            for (let index = 0; index < builds.length; index++) {
                const build = builds[index];
                const month = monthFor(build);
                if (month != lastMonth) {
                    const monthDate = build.updatedAt;
                    buildElements.push(react.createElement("div", { key: `month-${month}`, className: "builds--month" },
                        react.createElement(SwitchVersionCave_CustomDate, { date: new Date(monthDate), format: datetime/* MONTH_YEAR_FORMAT */.Yj })));
                    lastMonth = month;
                }
                buildElements.push(this.renderBuild(index, build));
            }
        }
        return (react.createElement(styles/* ModalWidgetDiv */.U, null,
            react.createElement(BuildListDiv, null, buildElements)));
    }
    renderBuild(index, b) {
        const version = b.userVersion || b.version;
        const updatedAt = b.updatedAt;
        return (react.createElement("div", { className: "builds--item", key: b.id, "data-index": index, onClick: this.onClick },
            react.createElement(Icon/* default */.Z, { icon: "history" }),
            react.createElement("div", { className: "spacer" }),
            version ? (react.createElement("div", { className: "version--user" }, (0,t.T)(["prompt.revert.version", { version }]))) : null,
            react.createElement("div", { className: "version--raw" }, `#${b.id}`),
            react.createElement("div", { className: "filler" }),
            react.createElement("div", { className: "spacer" }),
            react.createElement("div", { className: "timeago", "data-rh": JSON.stringify({ date: updatedAt }) },
                react.createElement(SwitchVersionCave_CustomDate, { date: updatedAt, format: datetime/* DAY_MONTH_FORMAT */.KV }))));
    }
}
/* harmony default export */ const modal_widgets_SwitchVersionCave = ((0,hook/* hook */.z)()(SwitchVersionCave));


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=274.chunk.js.map