"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[320],{

/***/ 1608:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   F: () => (/* binding */ ModalButtonSpacer),
/* harmony export */   Z: () => (/* binding */ ModalButtons)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalButtons = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  width: 100%;
  flex-shrink: 0;
  display: flex;
  flex-direction: row;
  justify-content: flex-end;
`;
const ModalButtonSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  flex-shrink: 0;
  flex-grow: 0;
  width: 1em;
`;


/***/ }),

/***/ 5969:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   R: () => (/* binding */ doAsync)
/* harmony export */ });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ 8320:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ SendFeedback)
});

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
;// CONCATENATED MODULE: ./src/common/format/shape.ts
function fillShape(input, shape) {
    if (!input) {
        return input;
    }
    if (Array.isArray(input)) {
        const arr = input;
        return arr.map((subInput) => fillShape(subInput, shape));
    }
    const keys = Object.keys(shape);
    let output = {};
    if (keys.length === 1 && keys[0] === "*") {
        const subShape = shape[keys[0]];
        for (const k of Object.keys(input)) {
            output[k] = fillShape(input[k], subShape);
        }
        return output;
    }
    for (const k of keys) {
        const v = shape[k];
        if (v === true) {
            output[k] = input[k];
        }
        else {
            output[k] = fillShape(input[k], v);
        }
    }
    return output;
}

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/prop-types/index.js
var prop_types = __webpack_require__(5697);
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/helpers/elementTypes.js
function makeTypeChecker(tabsRole) {
  return function (element) {
    return !!element.type && element.type.tabsRole === tabsRole;
  };
}

var elementTypes_isTab = makeTypeChecker('Tab');
var elementTypes_isTabList = makeTypeChecker('TabList');
var elementTypes_isTabPanel = makeTypeChecker('TabPanel');
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/helpers/childrenDeepMap.js
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }




function isTabChild(child) {
  return elementTypes_isTab(child) || elementTypes_isTabList(child) || elementTypes_isTabPanel(child);
}

function deepMap(children, callback) {
  return react.Children.map(children, function (child) {
    // null happens when conditionally rendering TabPanel/Tab
    // see https://github.com/reactjs/react-tabs/issues/37
    if (child === null) return null;

    if (isTabChild(child)) {
      return callback(child);
    }

    if (child.props && child.props.children && typeof child.props.children === 'object') {
      // Clone the child that has children and map them too
      return (0,react.cloneElement)(child, _objectSpread(_objectSpread({}, child.props), {}, {
        children: deepMap(child.props.children, callback)
      }));
    }

    return child;
  });
}
function childrenDeepMap_deepForEach(children, callback) {
  return react.Children.forEach(children, function (child) {
    // null happens when conditionally rendering TabPanel/Tab
    // see https://github.com/reactjs/react-tabs/issues/37
    if (child === null) return;

    if (elementTypes_isTab(child) || elementTypes_isTabPanel(child)) {
      callback(child);
    } else if (child.props && child.props.children && typeof child.props.children === 'object') {
      if (elementTypes_isTabList(child)) callback(child);
      childrenDeepMap_deepForEach(child.props.children, callback);
    }
  });
}
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/helpers/propTypes.js


function childrenPropType(props, propName, componentName) {
  var error;
  var tabsCount = 0;
  var panelsCount = 0;
  var tabListFound = false;
  var listTabs = [];
  var children = props[propName];
  deepForEach(children, function (child) {
    if (isTabList(child)) {
      if (child.props && child.props.children && typeof child.props.children === 'object') {
        deepForEach(child.props.children, function (listChild) {
          return listTabs.push(listChild);
        });
      }

      if (tabListFound) {
        error = new Error("Found multiple 'TabList' components inside 'Tabs'. Only one is allowed.");
      }

      tabListFound = true;
    }

    if (isTab(child)) {
      if (!tabListFound || listTabs.indexOf(child) === -1) {
        error = new Error("Found a 'Tab' component outside of the 'TabList' component. 'Tab' components " + "have to be inside the 'TabList' component.");
      }

      tabsCount++;
    } else if (isTabPanel(child)) {
      panelsCount++;
    }
  });

  if (!error && tabsCount !== panelsCount) {
    error = new Error("There should be an equal number of 'Tab' and 'TabPanel' in `" + componentName + "`. " + ("Received " + tabsCount + " 'Tab' and " + panelsCount + " 'TabPanel'."));
  }

  return error;
}
function onSelectPropType(props, propName, componentName, location, propFullName) {
  var prop = props[propName];
  var name = propFullName || propName;
  var error = null;

  if (prop && typeof prop !== 'function') {
    error = new Error("Invalid " + location + " `" + name + "` of type `" + typeof prop + "` supplied " + ("to `" + componentName + "`, expected `function`."));
  } else if (props.selectedIndex != null && prop == null) {
    error = new Error("The " + location + " `" + name + "` is marked as required in `" + componentName + "`, but " + "its value is `undefined` or `null`.\n" + "`onSelect` is required when `selectedIndex` is also set. Not doing so will " + "make the tabs not do anything, as `selectedIndex` indicates that you want to " + "handle the selected tab yourself.\n" + "If you only want to set the inital tab replace `selectedIndex` with `defaultIndex`.");
  }

  return error;
}
function selectedIndexPropType(props, propName, componentName, location, propFullName) {
  var prop = props[propName];
  var name = propFullName || propName;
  var error = null;

  if (prop != null && typeof prop !== 'number') {
    error = new Error("Invalid " + location + " `" + name + "` of type `" + typeof prop + "` supplied to " + ("`" + componentName + "`, expected `number`."));
  } else if (props.defaultIndex != null && prop != null) {
    return new Error("The " + location + " `" + name + "` cannot be used together with `defaultIndex` " + ("in `" + componentName + "`.\n") + ("Either remove `" + name + "` to let `" + componentName + "` handle the selected ") + "tab internally or remove `defaultIndex` to handle it yourself.");
  }

  return error;
}
;// CONCATENATED MODULE: ./node_modules/clsx/dist/clsx.m.js
function toVal(mix) {
	var k, y, str='';

	if (typeof mix === 'string' || typeof mix === 'number') {
		str += mix;
	} else if (typeof mix === 'object') {
		if (Array.isArray(mix)) {
			for (k=0; k < mix.length; k++) {
				if (mix[k]) {
					if (y = toVal(mix[k])) {
						str && (str += ' ');
						str += y;
					}
				}
			}
		} else {
			for (k in mix) {
				if (mix[k]) {
					str && (str += ' ');
					str += k;
				}
			}
		}
	}

	return str;
}

/* harmony default export */ function clsx_m() {
	var i=0, tmp, x, str='';
	while (i < arguments.length) {
		if (tmp = arguments[i++]) {
			if (x = toVal(tmp)) {
				str && (str += ' ');
				str += x
			}
		}
	}
	return str;
}

;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/helpers/uuid.js
// Get a universally unique identifier
var count = 0;
function uuid() {
  return "react-tabs-" + count++;
}
function uuid_reset() {
  count = 0;
}
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/helpers/count.js


function count_getTabsCount(children) {
  var tabCount = 0;
  childrenDeepMap_deepForEach(children, function (child) {
    if (elementTypes_isTab(child)) tabCount++;
  });
  return tabCount;
}
function count_getPanelsCount(children) {
  var panelCount = 0;
  childrenDeepMap_deepForEach(children, function (child) {
    if (elementTypes_isTabPanel(child)) panelCount++;
  });
  return panelCount;
}
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/components/UncontrolledTabs.js
function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }










function isNode(node) {
  return node && 'getAttribute' in node;
} // Determine if a node from event.target is a Tab element


function isTabNode(node) {
  return isNode(node) && node.getAttribute('role') === 'tab';
} // Determine if a tab node is disabled


function isTabDisabled(node) {
  return isNode(node) && node.getAttribute('aria-disabled') === 'true';
}

var canUseActiveElement;

try {
  canUseActiveElement = !!(typeof window !== 'undefined' && window.document && window.document.activeElement);
} catch (e) {
  // Work around for IE bug when accessing document.activeElement in an iframe
  // Refer to the following resources:
  // http://stackoverflow.com/a/10982960/369687
  // https://developer.microsoft.com/en-us/microsoft-edge/platform/issues/12733599
  canUseActiveElement = false;
}

var UncontrolledTabs = /*#__PURE__*/function (_Component) {
  _inheritsLoose(UncontrolledTabs, _Component);

  function UncontrolledTabs() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.tabNodes = [];

    _this.handleKeyDown = function (e) {
      var direction = _this.props.direction;

      if (_this.isTabFromContainer(e.target)) {
        var index = _this.props.selectedIndex;
        var preventDefault = false;
        var useSelectedIndex = false;

        if (e.keyCode === 32 || e.keyCode === 13) {
          preventDefault = true;
          useSelectedIndex = false;

          _this.handleClick(e);
        }

        if (e.keyCode === 37 || e.keyCode === 38) {
          // Select next tab to the left
          if (direction === 'rtl') {
            index = _this.getNextTab(index);
          } else {
            index = _this.getPrevTab(index);
          }

          preventDefault = true;
          useSelectedIndex = true;
        } else if (e.keyCode === 39 || e.keyCode === 40) {
          // Select next tab to the right
          if (direction === 'rtl') {
            index = _this.getPrevTab(index);
          } else {
            index = _this.getNextTab(index);
          }

          preventDefault = true;
          useSelectedIndex = true;
        } else if (e.keyCode === 35) {
          // Select last tab (End key)
          index = _this.getLastTab();
          preventDefault = true;
          useSelectedIndex = true;
        } else if (e.keyCode === 36) {
          // Select first tab (Home key)
          index = _this.getFirstTab();
          preventDefault = true;
          useSelectedIndex = true;
        } // This prevents scrollbars from moving around


        if (preventDefault) {
          e.preventDefault();
        } // Only use the selected index in the state if we're not using the tabbed index


        if (useSelectedIndex) {
          _this.setSelected(index, e);
        }
      }
    };

    _this.handleClick = function (e) {
      var node = e.target;

      do {
        if (_this.isTabFromContainer(node)) {
          if (isTabDisabled(node)) {
            return;
          }

          var index = [].slice.call(node.parentNode.children).filter(isTabNode).indexOf(node);

          _this.setSelected(index, e);

          return;
        } // eslint-disable-next-line no-cond-assign

      } while ((node = node.parentNode) != null);
    };

    return _this;
  }

  var _proto = UncontrolledTabs.prototype;

  _proto.setSelected = function setSelected(index, event) {
    // Check index boundary
    if (index < 0 || index >= this.getTabsCount()) return;
    var _this$props = this.props,
        onSelect = _this$props.onSelect,
        selectedIndex = _this$props.selectedIndex; // Call change event handler

    onSelect(index, selectedIndex, event);
  };

  _proto.getNextTab = function getNextTab(index) {
    var count = this.getTabsCount(); // Look for non-disabled tab from index to the last tab on the right

    for (var i = index + 1; i < count; i++) {
      if (!isTabDisabled(this.getTab(i))) {
        return i;
      }
    } // If no tab found, continue searching from first on left to index


    for (var _i = 0; _i < index; _i++) {
      if (!isTabDisabled(this.getTab(_i))) {
        return _i;
      }
    } // No tabs are disabled, return index


    return index;
  };

  _proto.getPrevTab = function getPrevTab(index) {
    var i = index; // Look for non-disabled tab from index to first tab on the left

    while (i--) {
      if (!isTabDisabled(this.getTab(i))) {
        return i;
      }
    } // If no tab found, continue searching from last tab on right to index


    i = this.getTabsCount();

    while (i-- > index) {
      if (!isTabDisabled(this.getTab(i))) {
        return i;
      }
    } // No tabs are disabled, return index


    return index;
  };

  _proto.getFirstTab = function getFirstTab() {
    var count = this.getTabsCount(); // Look for non disabled tab from the first tab

    for (var i = 0; i < count; i++) {
      if (!isTabDisabled(this.getTab(i))) {
        return i;
      }
    }

    return null;
  };

  _proto.getLastTab = function getLastTab() {
    var i = this.getTabsCount(); // Look for non disabled tab from the last tab

    while (i--) {
      if (!isTabDisabled(this.getTab(i))) {
        return i;
      }
    }

    return null;
  };

  _proto.getTabsCount = function getTabsCount() {
    var children = this.props.children;
    return count_getTabsCount(children);
  };

  _proto.getPanelsCount = function getPanelsCount() {
    var children = this.props.children;
    return count_getPanelsCount(children);
  };

  _proto.getTab = function getTab(index) {
    return this.tabNodes["tabs-" + index];
  };

  _proto.getChildren = function getChildren() {
    var _this2 = this;

    var index = 0;
    var _this$props2 = this.props,
        children = _this$props2.children,
        disabledTabClassName = _this$props2.disabledTabClassName,
        focus = _this$props2.focus,
        forceRenderTabPanel = _this$props2.forceRenderTabPanel,
        selectedIndex = _this$props2.selectedIndex,
        selectedTabClassName = _this$props2.selectedTabClassName,
        selectedTabPanelClassName = _this$props2.selectedTabPanelClassName;
    this.tabIds = this.tabIds || [];
    this.panelIds = this.panelIds || [];
    var diff = this.tabIds.length - this.getTabsCount(); // Add ids if new tabs have been added
    // Don't bother removing ids, just keep them in case they are added again
    // This is more efficient, and keeps the uuid counter under control

    while (diff++ < 0) {
      this.tabIds.push(uuid());
      this.panelIds.push(uuid());
    } // Map children to dynamically setup refs


    return deepMap(children, function (child) {
      var result = child; // Clone TabList and Tab components to have refs

      if (elementTypes_isTabList(child)) {
        var listIndex = 0; // Figure out if the current focus in the DOM is set on a Tab
        // If it is we should keep the focus on the next selected tab

        var wasTabFocused = false;

        if (canUseActiveElement) {
          wasTabFocused = react.Children.toArray(child.props.children).filter(elementTypes_isTab).some(function (tab, i) {
            return document.activeElement === _this2.getTab(i);
          });
        }

        result = (0,react.cloneElement)(child, {
          children: deepMap(child.props.children, function (tab) {
            var key = "tabs-" + listIndex;
            var selected = selectedIndex === listIndex;
            var props = {
              tabRef: function tabRef(node) {
                _this2.tabNodes[key] = node;
              },
              id: _this2.tabIds[listIndex],
              panelId: _this2.panelIds[listIndex],
              selected: selected,
              focus: selected && (focus || wasTabFocused)
            };
            if (selectedTabClassName) props.selectedClassName = selectedTabClassName;
            if (disabledTabClassName) props.disabledClassName = disabledTabClassName;
            listIndex++;
            return (0,react.cloneElement)(tab, props);
          })
        });
      } else if (elementTypes_isTabPanel(child)) {
        var props = {
          id: _this2.panelIds[index],
          tabId: _this2.tabIds[index],
          selected: selectedIndex === index
        };
        if (forceRenderTabPanel) props.forceRender = forceRenderTabPanel;
        if (selectedTabPanelClassName) props.selectedClassName = selectedTabPanelClassName;
        index++;
        result = (0,react.cloneElement)(child, props);
      }

      return result;
    });
  };

  /**
   * Determine if a node from event.target is a Tab element for the current Tabs container.
   * If the clicked element is not a Tab, it returns false.
   * If it finds another Tabs container between the Tab and `this`, it returns false.
   */
  _proto.isTabFromContainer = function isTabFromContainer(node) {
    // return immediately if the clicked element is not a Tab.
    if (!isTabNode(node)) {
      return false;
    } // Check if the first occurrence of a Tabs container is `this` one.


    var nodeAncestor = node.parentElement;

    do {
      if (nodeAncestor === this.node) return true;
      if (nodeAncestor.getAttribute('data-tabs')) break;
      nodeAncestor = nodeAncestor.parentElement;
    } while (nodeAncestor);

    return false;
  };

  _proto.render = function render() {
    var _this3 = this;

    // Delete all known props, so they don't get added to DOM
    var _this$props3 = this.props,
        children = _this$props3.children,
        className = _this$props3.className,
        disabledTabClassName = _this$props3.disabledTabClassName,
        domRef = _this$props3.domRef,
        focus = _this$props3.focus,
        forceRenderTabPanel = _this$props3.forceRenderTabPanel,
        onSelect = _this$props3.onSelect,
        selectedIndex = _this$props3.selectedIndex,
        selectedTabClassName = _this$props3.selectedTabClassName,
        selectedTabPanelClassName = _this$props3.selectedTabPanelClassName,
        attributes = _objectWithoutPropertiesLoose(_this$props3, ["children", "className", "disabledTabClassName", "domRef", "focus", "forceRenderTabPanel", "onSelect", "selectedIndex", "selectedTabClassName", "selectedTabPanelClassName"]);

    return /*#__PURE__*/react.createElement("div", _extends({}, attributes, {
      className: clsx_m(className),
      onClick: this.handleClick,
      onKeyDown: this.handleKeyDown,
      ref: function ref(node) {
        _this3.node = node;
        if (domRef) domRef(node);
      },
      "data-tabs": true
    }), this.getChildren());
  };

  return UncontrolledTabs;
}(react.Component);

UncontrolledTabs.defaultProps = {
  className: 'react-tabs',
  focus: false
};

UncontrolledTabs.propTypes =  false ? 0 : {};
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/components/Tabs.js
function Tabs_objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Tabs_inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }






var MODE_CONTROLLED = 0;
var MODE_UNCONTROLLED = 1;

var Tabs = /*#__PURE__*/function (_Component) {
  Tabs_inheritsLoose(Tabs, _Component);

  function Tabs(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _this.handleSelected = function (index, last, event) {
      var onSelect = _this.props.onSelect;
      var mode = _this.state.mode; // Call change event handler

      if (typeof onSelect === 'function') {
        // Check if the change event handler cancels the tab change
        if (onSelect(index, last, event) === false) return;
      }

      var state = {
        // Set focus if the change was triggered from the keyboard
        focus: event.type === 'keydown'
      };

      if (mode === MODE_UNCONTROLLED) {
        // Update selected index
        state.selectedIndex = index;
      }

      _this.setState(state);
    };

    _this.state = Tabs.copyPropsToState(_this.props, {}, props.defaultFocus);
    return _this;
  }

  Tabs.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
    return Tabs.copyPropsToState(props, state);
  };

  Tabs.getModeFromProps = function getModeFromProps(props) {
    return props.selectedIndex === null ? MODE_UNCONTROLLED : MODE_CONTROLLED;
  };

  // preserve the existing selectedIndex from state.
  // If the state has not selectedIndex, default to the defaultIndex or 0
  Tabs.copyPropsToState = function copyPropsToState(props, state, focus) {
    if (focus === void 0) {
      focus = false;
    }

    if (false) {}

    var newState = {
      focus: focus,
      mode: Tabs.getModeFromProps(props)
    };

    if (newState.mode === MODE_UNCONTROLLED) {
      var maxTabIndex = count_getTabsCount(props.children) - 1;
      var selectedIndex = null;

      if (state.selectedIndex != null) {
        selectedIndex = Math.min(state.selectedIndex, maxTabIndex);
      } else {
        selectedIndex = props.defaultIndex || 0;
      }

      newState.selectedIndex = selectedIndex;
    }

    return newState;
  };

  var _proto = Tabs.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        children = _this$props.children,
        defaultIndex = _this$props.defaultIndex,
        defaultFocus = _this$props.defaultFocus,
        props = Tabs_objectWithoutPropertiesLoose(_this$props, ["children", "defaultIndex", "defaultFocus"]);

    var _this$state = this.state,
        focus = _this$state.focus,
        selectedIndex = _this$state.selectedIndex;
    props.focus = focus;
    props.onSelect = this.handleSelected;

    if (selectedIndex != null) {
      props.selectedIndex = selectedIndex;
    }

    return /*#__PURE__*/react.createElement(UncontrolledTabs, props, children);
  };

  return Tabs;
}(react.Component);

Tabs.defaultProps = {
  defaultFocus: false,
  forceRenderTabPanel: false,
  selectedIndex: null,
  defaultIndex: null
};

Tabs.propTypes =  false ? 0 : {};
Tabs.tabsRole = 'Tabs';
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/components/TabList.js
function TabList_extends() { TabList_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return TabList_extends.apply(this, arguments); }

function TabList_objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function TabList_inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }





var TabList = /*#__PURE__*/function (_Component) {
  TabList_inheritsLoose(TabList, _Component);

  function TabList() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = TabList.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        children = _this$props.children,
        className = _this$props.className,
        attributes = TabList_objectWithoutPropertiesLoose(_this$props, ["children", "className"]);

    return /*#__PURE__*/react.createElement("ul", TabList_extends({}, attributes, {
      className: clsx_m(className),
      role: "tablist"
    }), children);
  };

  return TabList;
}(react.Component);

TabList.defaultProps = {
  className: 'react-tabs__tab-list'
};

TabList.propTypes =  false ? 0 : {};
TabList.tabsRole = 'TabList';
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/components/Tab.js
function Tab_extends() { Tab_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return Tab_extends.apply(this, arguments); }

function Tab_objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Tab_inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }




var DEFAULT_CLASS = 'react-tabs__tab';

var Tab = /*#__PURE__*/function (_Component) {
  Tab_inheritsLoose(Tab, _Component);

  function Tab() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = Tab.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.checkFocus();
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.checkFocus();
  };

  _proto.checkFocus = function checkFocus() {
    var _this$props = this.props,
        selected = _this$props.selected,
        focus = _this$props.focus;

    if (selected && focus) {
      this.node.focus();
    }
  };

  _proto.render = function render() {
    var _cx,
        _this = this;

    var _this$props2 = this.props,
        children = _this$props2.children,
        className = _this$props2.className,
        disabled = _this$props2.disabled,
        disabledClassName = _this$props2.disabledClassName,
        focus = _this$props2.focus,
        id = _this$props2.id,
        panelId = _this$props2.panelId,
        selected = _this$props2.selected,
        selectedClassName = _this$props2.selectedClassName,
        tabIndex = _this$props2.tabIndex,
        tabRef = _this$props2.tabRef,
        attributes = Tab_objectWithoutPropertiesLoose(_this$props2, ["children", "className", "disabled", "disabledClassName", "focus", "id", "panelId", "selected", "selectedClassName", "tabIndex", "tabRef"]);

    return /*#__PURE__*/react.createElement("li", Tab_extends({}, attributes, {
      className: clsx_m(className, (_cx = {}, _cx[selectedClassName] = selected, _cx[disabledClassName] = disabled, _cx)),
      ref: function ref(node) {
        _this.node = node;
        if (tabRef) tabRef(node);
      },
      role: "tab",
      id: id,
      "aria-selected": selected ? 'true' : 'false',
      "aria-disabled": disabled ? 'true' : 'false',
      "aria-controls": panelId,
      tabIndex: tabIndex || (selected ? '0' : null)
    }), children);
  };

  return Tab;
}(react.Component);

Tab.defaultProps = {
  className: DEFAULT_CLASS,
  disabledClassName: DEFAULT_CLASS + "--disabled",
  focus: false,
  id: null,
  panelId: null,
  selected: false,
  selectedClassName: DEFAULT_CLASS + "--selected"
};

Tab.propTypes =  false ? 0 : {};
Tab.tabsRole = 'Tab';
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/components/TabPanel.js
function TabPanel_extends() { TabPanel_extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return TabPanel_extends.apply(this, arguments); }

function TabPanel_objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function TabPanel_inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }




var TabPanel_DEFAULT_CLASS = 'react-tabs__tab-panel';

var TabPanel = /*#__PURE__*/function (_Component) {
  TabPanel_inheritsLoose(TabPanel, _Component);

  function TabPanel() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = TabPanel.prototype;

  _proto.render = function render() {
    var _cx;

    var _this$props = this.props,
        children = _this$props.children,
        className = _this$props.className,
        forceRender = _this$props.forceRender,
        id = _this$props.id,
        selected = _this$props.selected,
        selectedClassName = _this$props.selectedClassName,
        tabId = _this$props.tabId,
        attributes = TabPanel_objectWithoutPropertiesLoose(_this$props, ["children", "className", "forceRender", "id", "selected", "selectedClassName", "tabId"]);

    return /*#__PURE__*/react.createElement("div", TabPanel_extends({}, attributes, {
      className: clsx_m(className, (_cx = {}, _cx[selectedClassName] = selected, _cx)),
      role: "tabpanel",
      id: id,
      "aria-labelledby": tabId
    }), forceRender || selected ? children : null);
  };

  return TabPanel;
}(react.Component);

TabPanel.defaultProps = {
  className: TabPanel_DEFAULT_CLASS,
  forceRender: false,
  selectedClassName: TabPanel_DEFAULT_CLASS + "--selected"
};

TabPanel.propTypes =  false ? 0 : {};
TabPanel.tabsRole = 'TabPanel';
;// CONCATENATED MODULE: ./node_modules/react-tabs/esm/index.js





// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__(6025);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__(6785);
// EXTERNAL MODULE: ./src/renderer/helpers/doAsync.tsx
var doAsync = __webpack_require__(5969);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/modal-widgets/styles.tsx
var styles = __webpack_require__(5871);
// EXTERNAL MODULE: ./src/renderer/pages/PreferencesPage/Label.tsx
var Label = __webpack_require__(6500);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var renderer_styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./src/renderer/basics/modal-styles.tsx
var modal_styles = __webpack_require__(1608);
// EXTERNAL MODULE: ./src/renderer/bridge.ts
var bridge = __webpack_require__(2968);
;// CONCATENATED MODULE: ./src/renderer/modal-widgets/SendFeedback.tsx

















var ReportStage;
(function (ReportStage) {
    ReportStage[ReportStage["Filling"] = 0] = "Filling";
    ReportStage[ReportStage["Uploading"] = 1] = "Uploading";
    ReportStage[ReportStage["Done"] = 2] = "Done";
    ReportStage[ReportStage["Failed"] = 3] = "Failed";
})(ReportStage || (ReportStage = {}));
const blockStyle = (0,renderer_styles/* css */.iv) `
  margin: 1em 0 0;
  padding: 0.5em;
  font-family: inherit;
  font-size: inherit;
  background: rgba(0, 0, 0, 0.4);
  border: 1px solid ${(props) => props.theme.inputBorder};
  color: ${(props) => props.theme.baseText};
  line-height: 1.4;

  width: 100%;
`;
const OurLabel = (0,renderer_styles/* default */.ZP)((0,Label/* default */.Z)) `
  margin: 1em 0 0;
`;
const MessageArea = renderer_styles/* default */.ZP.textarea `
  ${blockStyle};

  height: 200px;
`;
const InfoBlock = renderer_styles/* default */.ZP.div `
  ${blockStyle};
  width: 100%;
  font-family: inherit;
  font-size: inherit;

  white-space: pre-wrap;
  overflow-y: auto;

  height: 300px;
`;
const CallToAction = renderer_styles/* default */.ZP.div `
  width: 100%;
  height: 250px;
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;

  & > :first-child {
    margin-bottom: 1em;
  }
`;
const BigButton = (0,renderer_styles/* default */.ZP)((0,Button/* default */.Z)) `
  font-size: 150% !important;
`;
const SystemInfo = renderer_styles/* default */.ZP.div `
  em {
    font-weight: lighter;
    color: ${(props) => props.theme.secondaryText};
  }
`;
const SystemBlock = renderer_styles/* default */.ZP.div `
  padding-left: 1em;
`;
const SendFeedbackDiv = (0,renderer_styles/* default */.ZP)((0,styles/* ModalWidgetDiv */.U)) `
  min-width: 800px;
  max-width: 800px;
  min-height: 600px;
  max-height: 600px;
  display: flex;
  flex-direction: column;

  p {
    line-height: 1.4;
    margin: 1em 0 0;

    ul {
      list-style-type: disc;
      padding-left: 2em;
    }
  }
`;
const ExternalLink = renderer_styles/* default */.ZP.div `
  color: ${(props) => props.theme.secondaryText};
  text-decoration: underline;

  &:hover {
    cursor: pointer;
  }

  &:after {
    content: " ↗";
  }
`;
class ReportIssue extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onTabSelected = (tabIndex) => this.setState({ tabIndex });
        this.onGoBack = () => this.setState((state) => ({ tabIndex: state.tabIndex - 1 }));
        this.onGoForward = () => this.setState((state) => ({ tabIndex: state.tabIndex + 1 }));
        this.onIncludeSystemInfo = (e) => {
            this.setState({ includeSystemInfo: e.currentTarget.checked });
        };
        this.onViewReport = () => {
            const { dispatch } = this.props;
            const { reportURL } = this.state;
            dispatch(actions/* actions */.N.openInExternalBrowser({
                url: reportURL,
            }));
        };
        this.onSend = () => {
            this.setState({
                stage: ReportStage.Uploading,
            });
            (0,doAsync/* doAsync */.R)(async () => {
                const daleURL = "https://dale.itch.zone";
                const { system, includeSystemInfo, message } = this.state;
                const { log } = this.props.modal.widgetParams;
                try {
                    const params = new URLSearchParams();
                    if (includeSystemInfo) {
                        params.set("system", JSON.stringify(system, null, 2));
                    }
                    else {
                        params.set("system", "(redacted)");
                    }
                    params.set("log", `
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
> Message
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

${message}

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
> Log
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

${log}
`);
                    const body = await fetch(daleURL, {
                        method: "post",
                        // fetch *can* take a URLSearchParams, thank you very much
                        body: params,
                    });
                    if (body.status != 200) {
                        throw new Error(`Post ${daleURL}: got HTTP ${body.status}. Body: ${await body.text()}`);
                    }
                    const res = await body.json();
                    if (res.success) {
                        this.setState({
                            stage: ReportStage.Done,
                            reportURL: `${daleURL}/${res.id}`,
                        });
                        return;
                    }
                    throw new Error(`Creating report failed: ${JSON.stringify(res, null, 2)}`);
                }
                catch (e) {
                    this.setState({
                        stage: ReportStage.Failed,
                        errorMessage: e.stack,
                    });
                }
            });
        };
        this.onBailOut = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.closeModal({
                wind: (0,navigation/* ambientWind */.w)(),
                id: this.props.modal.id,
            }));
        };
        this.renderSystem = (input) => {
            if (Array.isArray(input)) {
                const arr = input;
                return (react.createElement(react.Fragment, null, arr.map((x, i) => (react.createElement(SystemBlock, { key: i },
                    react.createElement("em", null,
                        "#",
                        i + 1),
                    react.createElement(SystemBlock, null, this.renderSystem(x)))))));
            }
            if (typeof input === "object") {
                return (react.createElement(react.Fragment, null, Object.keys(input).map((k) => (react.createElement(react.Fragment, null, !Array.isArray(input[k]) && typeof input[k] !== "object" ? (react.createElement("div", null,
                    react.createElement("em", null, k),
                    " ",
                    input[k])) : (react.createElement("div", null,
                    react.createElement("em", null, k),
                    react.createElement(SystemBlock, null, this.renderSystem(input[k])))))))));
            }
            return react.createElement(react.Fragment, null, input);
        };
        this.onLearnMore = (ev) => {
            ev.preventDefault();
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.openInExternalBrowser({
                url: "https://dale.itch.zone/",
            }));
        };
        this.onMessageChange = (ev) => {
            const textArea = ev.currentTarget;
            this.setState({
                message: textArea.value,
            });
        };
        this.state = {
            stage: ReportStage.Filling,
            message: "Dear itch app team, ",
            system: { state: "Loading..." },
            includeSystemInfo: true,
            tabIndex: 0,
        };
    }
    componentDidMount() {
        (0,doAsync/* doAsync */.R)(async () => {
            try {
                let output = {
                    cpu: "",
                    graphics: "",
                    osInfo: "",
                    broth: "",
                };
                try {
                    const input = await bridge/* sysinfo */.bt.cpu();
                    output.cpu = fillShape(input, {
                        manufacturer: true,
                        brand: true,
                        vendor: true,
                        speed: true,
                        cores: true,
                    });
                }
                catch (e) {
                    output.cpu = `Could not get info: ${e}`;
                }
                try {
                    const input = await bridge/* sysinfo */.bt.graphics();
                    output.graphics = fillShape(input, {
                        controllers: {
                            model: true,
                            vendor: true,
                            vram: true,
                        },
                    });
                }
                catch (e) {
                    output.graphics = `Could not get info: ${e}`;
                }
                try {
                    const input = await bridge/* sysinfo */.bt.osInfo();
                    output.osInfo = fillShape(input, {
                        platform: true,
                        arch: true,
                        distro: true,
                        release: true,
                        codename: true,
                        logofile: true,
                    });
                }
                catch (e) {
                    output.osInfo = `Could not get info: ${e}`;
                }
                output.broth = fillShape(this.props.brothPackages, {
                    "*": {
                        stage: true,
                        version: true,
                    },
                });
                this.setState({
                    system: output,
                });
            }
            catch (e) {
                this.setState({
                    system: { state: `Could not gather system information: ${e.stack}` },
                });
            }
        });
    }
    render() {
        const { stage } = this.state;
        if (stage === ReportStage.Filling) {
            return this.renderFilling();
        }
        else if (stage === ReportStage.Uploading) {
            return this.renderUploading();
        }
        else if (stage === ReportStage.Done) {
            return this.renderDone();
        }
        else {
            return this.renderFailed();
        }
    }
    renderFilling() {
        const { message, system, includeSystemInfo, tabIndex } = this.state;
        return (react.createElement(SendFeedbackDiv, null,
            react.createElement(Tabs, { selectedIndex: tabIndex, onSelect: this.onTabSelected },
                react.createElement(TabList, null,
                    react.createElement(Tab, null, (0,t.T)(["send_feedback.steps.your_message"])),
                    react.createElement(Tab, null, (0,t.T)(["send_feedback.steps.system_info"])),
                    react.createElement(Tab, null, (0,t.T)(["send_feedback.steps.send"]))),
                react.createElement(TabPanel, null,
                    react.createElement("p", null, (0,t.T)(["send_feedback.describe_issue"])),
                    react.createElement(MessageArea, { autoFocus: true, onChange: this.onMessageChange, value: message }),
                    react.createElement("p", null, (0,t.T)(["send_feedback.reminders.header"])),
                    react.createElement("p", null,
                        react.createElement("ul", null,
                            react.createElement("li", null, (0,t.T)(["send_feedback.reminders.we_are_humans"])),
                            react.createElement("li", null, (0,t.T)(["send_feedback.reminders.be_precise"])),
                            react.createElement("li", null, (0,t.T)(["send_feedback.reminders.include_reproduce_steps"])),
                            react.createElement("li", null, (0,t.T)(["send_feedback.reminders.mention_itchio_account"])))),
                    react.createElement("p", null, (0,t.T)(["send_feedback.reminders.thanks"])),
                    react.createElement("p", null,
                        react.createElement(ExternalLink, { onClick: this.onLearnMore }, (0,t.T)(["send_feedback.questions.where_does_report_go"])))),
                react.createElement(TabPanel, null,
                    react.createElement("p", null, (0,t.T)(["send_feedback.consent.please_review"])),
                    react.createElement(InfoBlock, null, includeSystemInfo ? (react.createElement(SystemInfo, null, this.renderSystem(system))) : (react.createElement("span", null,
                        "(",
                        (0,t.T)(["send_feedback.consent.redacted"]),
                        ")"))),
                    react.createElement("p", null, (0,t.T)(["send_feedback.consent.system_info_helps_us"])),
                    react.createElement(OurLabel, { active: includeSystemInfo },
                        react.createElement("input", { type: "checkbox", checked: includeSystemInfo, onChange: this.onIncludeSystemInfo }),
                        react.createElement("span", null, (0,t.T)(["send_feedback.consent.include_in_report"])))),
                react.createElement(TabPanel, null,
                    react.createElement("p", null, (0,t.T)(["send_feedback.send.secret_url"])),
                    react.createElement("p", null, (0,t.T)(["send_feedback.send.secret_url.feature_list"])),
                    react.createElement("p", null,
                        react.createElement("ul", null,
                            react.createElement("li", null, (0,t.T)(["send_feedback.send.secret_url.feature_list.view"])),
                            react.createElement("li", null, (0,t.T)(["send_feedback.send.secret_url.feature_list.delete"])))),
                    react.createElement(CallToAction, null,
                        react.createElement(BigButton, { icon: "upload-to-cloud", fat: true, wide: true, onClick: this.onSend }, (0,t.T)(["send_feedback.send.do_send"])),
                        react.createElement(ExternalLink, { onClick: this.onBailOut }, (0,t.T)(["send_feedback.send.dont_send"]))),
                    react.createElement("p", null, (0,t.T)(["send_feedback.final_thanks"])))),
            react.createElement(Filler/* default */.Z, null),
            react.createElement(modal_styles/* ModalButtons */.Z, null,
                react.createElement(Button/* default */.Z, { onClick: this.onBailOut }, (0,t.T)(["prompt.action.cancel"])),
                react.createElement(Filler/* default */.Z, null),
                react.createElement(Button/* default */.Z, { icon: "arrow-left", disabled: tabIndex <= 0, onClick: this.onGoBack }, (0,t.T)(["send_feedback.nav.previous"])),
                react.createElement(modal_styles/* ModalButtonSpacer */.F, null),
                react.createElement(Button/* default */.Z, { icon: "arrow-right", disabled: tabIndex >= 2, onClick: this.onGoForward }, (0,t.T)(["send_feedback.nav.next"])))));
    }
    renderUploading() {
        return (react.createElement(SendFeedbackDiv, null,
            react.createElement(CallToAction, null,
                react.createElement(LoadingCircle/* default */.Z, { progress: -1 }),
                react.createElement("span", null, "Sending..."))));
    }
    renderDone() {
        return (react.createElement(SendFeedbackDiv, null,
            react.createElement("p", null, (0,t.T)(["send_feedback.success.intro"])),
            react.createElement(CallToAction, null,
                react.createElement(BigButton, { icon: "folder-open", wide: true, fat: true, onClick: this.onViewReport }, (0,t.T)(["send_feedback.success.view_report"])),
                react.createElement("span", null, (0,t.T)(["send_feedback.success.view_report.delete"]))),
            react.createElement("p", null, (0,t.T)(["send_feedback.success.thanks"])),
            react.createElement("p", null, (0,t.T)(["send_feedback.success.promise"])),
            react.createElement(Filler/* default */.Z, null),
            react.createElement(modal_styles/* ModalButtons */.Z, null,
                react.createElement(Button/* default */.Z, { icon: "cross", onClick: this.onBailOut }, (0,t.T)(["send_feedback.nav.close"])))));
    }
    renderFailed() {
        const { errorMessage } = this.state;
        return (react.createElement(SendFeedbackDiv, null,
            react.createElement("p", null, (0,t.T)(["send_feedback.error.intro"])),
            react.createElement(InfoBlock, null, errorMessage),
            react.createElement(Filler/* default */.Z, null),
            react.createElement(modal_styles/* ModalButtons */.Z, null,
                react.createElement(Button/* default */.Z, { icon: "cross", onClick: this.onBailOut }, (0,t.T)(["send_feedback.nav.close"])))));
    }
}
/* harmony default export */ const SendFeedback = ((0,injectIntl/* default */.ZP)((0,hook/* hook */.z)((map) => ({
    brothPackages: map((rs) => rs.broth.packages),
}))(ReportIssue)));


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ }),

/***/ 6500:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_2__);




const LabelEl = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.label `
  background: ${(props) => props.theme.explanation};
  padding: 8px 11px;
  font-size: 14px;
  display: flex;
  align-items: center;

  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .prefChunk */ .Do};

  &.active {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .prefChunkActive */ ._U};
  }

  input[type="checkbox"] {
    margin-right: 8px;
  }
`;
class Label extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { active, children, className } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_3__/* .__rest */ ._T)(_a, ["active", "children", "className"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LabelEl, Object.assign({ className: classnames__WEBPACK_IMPORTED_MODULE_2___default()(className, { active }) }, restProps), children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Label);


/***/ })

}]);
//# sourceMappingURL=320.chunk.js.map