"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[357],{

/***/ 2357:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ pages_NewTabPage)
});

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/pages/BrowserPage/BrowserBar.tsx
var BrowserBar = __webpack_require__(9411);
// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__(541);
;// CONCATENATED MODULE: ./src/renderer/pages/BrowserPage/newTabItems.ts

const newTabPrimaryItems = [
    {
        label: ["sidebar.explore"],
        icon: "earth",
        url: "itch://featured",
    },
    {
        label: ["sidebar.library"],
        icon: "heart-filled",
        url: "itch://library",
    },
    {
        label: ["sidebar.collections"],
        icon: "video_collection",
        url: "itch://collections",
    },
    {
        label: ["sidebar.dashboard"],
        icon: "archive",
        url: "itch://dashboard",
    },
];
const newTabSecondaryItems = [
    {
        label: ["new_tab.twitter"],
        icon: "twitter",
        url: "https://twitter.com/search?q=itch.io&src=typd",
    },
    {
        label: ["new_tab.random"],
        icon: "shuffle",
        url: urls/* default */.Z.itchio + "/randomizer",
    },
    {
        label: ["new_tab.on_sale"],
        icon: "shopping_cart",
        url: urls/* default */.Z.itchio + "/games/on-sale",
    },
    {
        label: ["new_tab.top_sellers"],
        icon: "star",
        url: urls/* default */.Z.itchio + "/games/top-sellers",
    },
    {
        label: ["new_tab.devlogs"],
        icon: "fire",
        url: urls/* default */.Z.itchio + "/devlogs",
    },
];

// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
;// CONCATENATED MODULE: ./src/renderer/pages/NewTabPage/index.tsx










const NewTabPageDiv = styles/* default */.ZP.div `
  ${styles/* meat */.pw};
`;
const NewTabMain = styles/* default */.ZP.div `
  display: flex;
  flex-direction: column;
  align-items: center;

  overflow-y: auto;
`;
const NewTabGrid = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: space-around;
  align-items: flex-start;
  align-content: flex-start;
  flex: 1;
  flex-shrink: 0;

  max-width: 960px;
  margin-top: 40px;
`;
const NewTabItem = styles/* default */.ZP.a `
  ${styles/* clickable */.Zk};

  color: ${(props) => props.theme.baseText};
  text-decoration: none;

  width: auto;
  flex-grow: 1;
  padding: 20px 10px;
  margin: 10px;
  display: flex;
  flex-direction: column;
  align-items: center;

  min-width: 160px;
  background: rgba(255, 255, 255, 0.1);
  border-radius: 4px;

  .icon {
    font-size: 70px;
    margin-bottom: 25px;
  }
`;
const Title = styles/* default */.ZP.h2 `
  flex-basis: 100%;
  text-align: center;
  padding: 20px 0;
  font-size: ${(props) => props.theme.fontSizes.huge};
`;
class NewTabPage extends react.PureComponent {
    render() {
        return (react.createElement(NewTabPageDiv, null,
            react.createElement(BrowserBar/* default */.Z, null),
            react.createElement(NewTabMain, null,
                react.createElement(NewTabGrid, null, (0,index_all/* map */.UI)(newTabPrimaryItems, (item) => {
                    const { label, icon, url } = item;
                    return (react.createElement(NewTabItem, { key: url, href: url },
                        react.createElement(Icon/* default */.Z, { icon: icon }),
                        react.createElement("span", null, (0,t.T)(label))));
                })),
                react.createElement(NewTabGrid, null,
                    react.createElement(Title, null, (0,t.T)(["new_tab.titles.buttons"])),
                    (0,index_all/* map */.UI)(newTabSecondaryItems, (item) => {
                        const { label, icon, url } = item;
                        return (react.createElement(NewTabItem, { key: url, href: url },
                            react.createElement(Icon/* default */.Z, { icon: icon }),
                            react.createElement("span", null, (0,t.T)(label))));
                    })))));
    }
    componentDidMount() {
        (0,tab_utils/* dispatchTabPageUpdate */.pq)(this.props, {
            label: ["sidebar.new_tab"],
        });
    }
}
/* harmony default export */ const pages_NewTabPage = ((0,withTab/* withTab */.D1)((0,hook/* hook */.z)()(NewTabPage)));


/***/ })

}]);
//# sourceMappingURL=357.chunk.js.map