"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[402],{

/***/ 6925:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (__webpack_require__.p + "45416ee3387c41c6a09090e575792a09.svg");

/***/ }),

/***/ 992:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Nd: () => (/* binding */ getRpcErrorData),
/* harmony export */   SS: () => (/* binding */ isInternalError),
/* harmony export */   dt: () => (/* binding */ getErrorStack),
/* harmony export */   mg: () => (/* binding */ asRequestError)
/* harmony export */ });
/* unused harmony export mergeLogAndError */
/* harmony import */ var common_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(8976);
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1061);


function asRequestError(e) {
    const re = e;
    if (re.rpcError) {
        return e;
    }
    return null;
}
function getRpcErrorData(e) {
    const re = asRequestError(e);
    if (re && re.rpcError && re.rpcError.data) {
        return re.rpcError.data;
    }
    return null;
}
function isInternalError(e) {
    const re = asRequestError(e);
    if (!re) {
        return true;
    }
    if (re.rpcError.code < 0) {
        return true;
    }
    return false;
}
function getErrorStack(e) {
    if (!e) {
        return "Unknown error";
    }
    let errorStack = e.stack;
    const re = asRequestError(e);
    if (re) {
        const ed = getRpcErrorData(e);
        if (ed && ed.stack) {
            // use golang stack if available
            errorStack = ed.stack;
        }
        else if (re.message) {
            // or just message
            errorStack = re.message;
        }
    }
    return errorStack;
}
function mergeLogAndError(log, e) {
    let formattedLog = "";
    if (log) {
        let lines = log.split("\n");
        for (let line of lines) {
            line = line.trim();
            let fallback = false;
            try {
                const obj = JSON.parse(line);
                if (obj.msg) {
                    let date = formatDate(new Date(obj.time), "en-US", DATE_FORMAT);
                    let level = levels[obj.level];
                    let { msg } = obj;
                    formattedLog += `${date} [${level}] ${msg}\n`;
                }
                else {
                    fallback = true;
                }
            }
            catch (e) {
                fallback = true;
            }
            if (fallback) {
                formattedLog += `${line}\n`;
            }
        }
    }
    return `${formattedLog}\n\nError stack:\n${getErrorStack(e)}\n`;
}


/***/ }),

/***/ 3656:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Ip: () => (/* binding */ getDownloadError),
/* harmony export */   Z: () => (/* binding */ formatError),
/* harmony export */   dK: () => (/* binding */ getInstallPlanInfoError)
/* harmony export */ });
/* unused harmony export getButlerdErrorFromTuple */
/* harmony import */ var common_butlerd_errors__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(992);
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(9050);


function formatError(e, apiErrorPrefix) {
    const re = (0,common_butlerd_errors__WEBPACK_IMPORTED_MODULE_0__/* .asRequestError */ .mg)(e);
    if (re && re.rpcError) {
        const { code, data } = re.rpcError;
        if (data && data.apiError && apiErrorPrefix) {
            const { messages } = data.apiError;
            const message = (0,underscore__WEBPACK_IMPORTED_MODULE_1__/* .first */ .Ps)(messages);
            if (message) {
                const snakeCaseMessage = message.replace(/\s/g, "_").toLowerCase();
                return [
                    `errors.api.${apiErrorPrefix}.${snakeCaseMessage}`,
                    {
                        defaultValue: `{message}`,
                        message,
                    },
                ];
            }
        }
        const { message } = re.rpcError;
        return [
            `butlerd.codes.${code}`,
            {
                defaultValue: `{message}`,
                message,
            },
        ];
    }
    return e.message;
}
function getDownloadError(item) {
    return getButlerdErrorFromTuple(item);
}
function getInstallPlanInfoError(item) {
    return getButlerdErrorFromTuple(item);
}
function getButlerdErrorFromTuple(item) {
    if (!item.errorMessage) {
        return null;
    }
    let rawError = new Error(item.errorMessage);
    rawError.stack = item.error;
    rawError.rpcError = {
        code: item.errorCode,
        message: item.errorMessage,
        data: {
            stack: item.error,
        },
    };
    return rawError;
}


/***/ }),

/***/ 5379:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   j: () => (/* binding */ fileSize)
/* harmony export */ });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ 830:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (/* binding */ DownloadProgressSpan)
/* harmony export */ });
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5379);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2629);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(9080);




function DownloadProgressSpan({ bps, eta, downloadsPaused, onlyBPS, onlyETA, }) {
    if (downloadsPaused) {
        return react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_3__.T)(["grid.item.downloads_paused"]));
    }
    if (onlyBPS) {
        return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
            (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_0__/* .fileSize */ .j)(bps),
            "/s"));
    }
    if (onlyETA) {
        return react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { secs: eta });
    }
    const hasBPS = bps > 0;
    const hasETA = eta > 0;
    return (react__WEBPACK_IMPORTED_MODULE_1__.createElement("span", null,
        hasBPS ? (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
            (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_0__/* .fileSize */ .j)(bps),
            "/s")) : null,
        hasBPS && hasETA ? " — " : null,
        hasETA ? react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { secs: eta }) : null));
}


/***/ }),

/***/ 2629:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1061);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4012);



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, Object.assign({}, (0,common_format_datetime__WEBPACK_IMPORTED_MODULE_0__/* .formatDurationAsMessage */ .Lb)(secs)))));


/***/ }),

/***/ 7703:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .secondaryLink */ .CF};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_2__/* .__rest */ ._T)(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Link);
class Props {
}


/***/ }),

/***/ 4844:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ basics_TitleBar)
});

// UNUSED EXPORTS: titleBarHeight

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/renderer/env.ts
var env = __webpack_require__(1113);
// EXTERNAL MODULE: ./src/common/helpers/space.ts
var space = __webpack_require__(2001);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
;// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/NewVersionAvailable.tsx






const Container = styles/* default */.ZP.div `
  align-self: stretch;
  font-weight: bold;
  padding: 0 0.5em;
  margin-right: 1em;

  display: flex;
  flex-direction: row;
  align-items: center;
  border-radius: 2px;

  &:hover {
    background: ${(props) => props.theme.baseBackground};
    cursor: pointer;
  }
`;
const Spacer = styles/* default */.ZP.div `
  height: 1px;
  width: 0.4em;
`;
class NewVersionAvailable extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.relaunchRequest({}));
        };
    }
    render() {
        const { available } = this.props;
        if (!available) {
            return null;
        }
        return (react.createElement(Container, { onClick: this.onClick },
            react.createElement(Icon/* default */.Z, { icon: "install" }),
            react.createElement(Spacer, null),
            (0,t.T)(["prompt.self_update_ready.short"])));
    }
}
/* harmony default export */ const TitleBar_NewVersionAvailable = ((0,hook/* hook */.z)((map) => ({
    available: map((rs) => {
        const pkg = rs.broth.packages[rs.system.appName];
        return pkg && pkg.stage === "need-restart";
    }),
}))(NewVersionAvailable));

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/util/get-user-cover-url.ts
var get_user_cover_url = __webpack_require__(3720);
;// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/UserMenu.tsx







const UserMenuDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;

  padding: 8px;
  margin-right: 8px;

  transition: background 0.2s;
  &:hover {
    background: rgba(0, 0, 0, 0.2);
    cursor: pointer;
  }

  animation: ${styles/* animations */.sF.enterTop} 0.2s;

  .icon {
    margin: 0;
    transition: all 0.2s;
  }

  img {
    height: 24px;
    width: 24px;
    margin-right: 8px;
    border-radius: 2px;
    flex-shrink: 0;
  }

  span {
    flex-shrink: 1;
    ${styles/* singleLine */.U1};
  }
`;
class UserMenu extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.openMenu = (e) => {
            if (e.button === 0) {
                const { dispatch } = this.props;
                dispatch(actions/* actions */.N.openUserMenu({
                    wind: (0,navigation/* ambientWind */.w)(),
                    clientX: e.clientX,
                    clientY: e.clientY,
                }));
            }
        };
    }
    render() {
        if (!this.props.me) {
            return null; // cf. #1405
        }
        return this.me();
    }
    me() {
        const { me } = this.props;
        const { username, displayName } = me;
        const coverUrl = (0,get_user_cover_url/* getUserCoverURL */.n)(me);
        return (react.createElement(UserMenuDiv, { className: "user-menu", onMouseDown: this.openMenu },
            react.createElement("img", { src: coverUrl }),
            react.createElement("span", null, displayName || username),
            react.createElement(Filler/* default */.Z, null)));
    }
}
/* harmony default export */ const TitleBar_UserMenu = ((0,hook/* hook */.z)((map) => ({
    me: map((rs) => rs.profile.profile.user),
}))(UserMenu));

// EXTERNAL MODULE: ./src/renderer/modals.ts + 3 modules
var modals = __webpack_require__(9088);
// EXTERNAL MODULE: ./src/common/helpers/secret-click.ts
var secret_click = __webpack_require__(4843);
;// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/index.tsx













const DraggableDiv = styles/* default */.ZP.div `
  ${styles/* singleLine */.U1};
  -webkit-app-region: drag;

  flex: 1 1;
  display: flex;
  align-self: stretch;
`;
const TitleBar_Spacer = styles/* default */.ZP.div `
  width: 8px;
  flex-shrink: 0;
`;
const titleBarHeight = 40;
const WindowButton = (0,styles/* default */.ZP)((0,IconButton/* default */.Z)) `
  align-self: flex-start;
  flex-shrink: 0;
  width: ${titleBarHeight * 1.1}px;
  height: ${titleBarHeight * 0.8}px;
  opacity: 0.7;

  &:hover {
    opacity: 1;
    background: rgba(255, 255, 255, 0.1);
  }

  &.exit:hover {
    background: rgba(174, 8, 7, 1);
  }
`;
const DraggableDivInner = styles/* default */.ZP.div `
  flex: 1 1;
  display: flex;
  align-self: center;
  align-items: center;
  max-width: 100%;
`;
const TitleBar_Filler = styles/* default */.ZP.div `
  flex: 1 1;
`;
const TitleBarDiv = styles/* default */.ZP.div `
  display: flex;
  align-items: center;
  width: 100%;
  background: ${(props) => props.theme.sidebarBackground};
  padding-left: 10px;
  height: ${titleBarHeight}px;
`;
const TitleDiv = styles/* default */.ZP.div `
  ${styles/* singleLine */.U1};

  font-size: ${(props) => props.theme.fontSizes.large};
`;
const emptyObj = {};
class TitleBar extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if ((0,secret_click/* isSecretClick */.C)(e)) {
                const { dispatch } = this.props;
                dispatch(actions/* actions */.N.openModal(modals/* default */.Z.secretSettings.make({
                    wind: (0,navigation/* ambientWind */.w)(),
                    title: "Secret settings",
                    message: "",
                    widgetParams: {},
                })));
                return;
            }
        };
        this.preferencesClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.navigate({ wind: "root", url: "itch://preferences" }));
        };
        this.minimizeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.minimizeWind({ wind: (0,navigation/* ambientWind */.w)() }));
        };
        this.maximizeRestoreClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.toggleMaximizeWind({ wind: (0,navigation/* ambientWind */.w)() }));
        };
        this.closeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.hideWind({ wind: (0,navigation/* ambientWind */.w)() }));
        };
    }
    render() {
        const { tab, macos, tabInstance } = this.props;
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        const sp = space/* Space */.T.fromInstance(tab, tabInstance);
        let label = sp.lazyLabel();
        const loggedIn = tab !== "login";
        if (!loggedIn) {
            if (macos) {
                label = "";
            }
            else {
                label = env/* default */.Z.appName;
            }
        }
        return (react.createElement(TitleBarDiv, { className: "title-bar" },
            react.createElement(DraggableDiv, { id: "title-draggable", onClick: this.onClick },
                react.createElement(DraggableDivInner, null,
                    secondary ? react.createElement(TitleBar_Filler, null) : null,
                    react.createElement(TitleDiv, { className: "title-bar-text" }, (0,t.T)(label)),
                    react.createElement(TitleBar_Filler, null))),
            secondary ? null : (react.createElement(react.Fragment, null,
                loggedIn ? react.createElement(TitleBar_UserMenu, null) : null,
                react.createElement(TitleBar_NewVersionAvailable, null))),
            react.createElement(TitleBar_Spacer, null),
            this.renderIcons()));
    }
    renderIcons() {
        const { macos, maximized } = this.props;
        if (macos) {
            return null;
        }
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        return (react.createElement(react.Fragment, null,
            secondary ? null : (react.createElement(react.Fragment, null,
                react.createElement(WindowButton, { icon: "minus", onClick: this.minimizeClick }),
                react.createElement(WindowButton, { icon: maximized ? "window-restore" : "window-maximize", onClick: this.maximizeRestoreClick }))),
            react.createElement(WindowButton, { className: "exit", icon: "cross", onClick: this.closeClick })));
    }
}
/* harmony default export */ const basics_TitleBar = ((0,hook/* hookWithProps */.h)(TitleBar)((map) => ({
    tabInstance: map((rs, props) => (0,navigation/* ambientWindState */.cq)(rs).tabInstances[props.tab] || emptyObj),
    maximized: map((rs, props) => rs.winds[(0,navigation/* ambientWind */.w)()].native.maximized),
    focused: map((rs, props) => rs.winds[(0,navigation/* ambientWind */.w)()].native.focused),
    macos: map((rs, props) => rs.system.macos),
}))(TitleBar));


/***/ }),

/***/ 8472:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   v: () => (/* binding */ rcall)
/* harmony export */ });
/* harmony import */ var renderer_store__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5784);
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5258);
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2968);



const logger = renderer_logger__WEBPACK_IMPORTED_MODULE_1__/* .rendererLogger */ .X.childWithName("rcall");
/**
 * Perform a butlerd call from the renderer process
 */
async function rcall(rc, params, setups) {
    return await renderer_bridge__WEBPACK_IMPORTED_MODULE_2__/* .butlerd */ .lB.rcall(renderer_store__WEBPACK_IMPORTED_MODULE_0__["default"], logger, rc.__method, params, setups);
}


/***/ }),

/***/ 5969:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   R: () => (/* binding */ doAsync)
/* harmony export */ });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ 402:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ scenes_GateScene)
});

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/TitleBar/index.tsx + 2 modules
var TitleBar = __webpack_require__(4844);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__(541);
// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__(5379);
// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__(6025);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/basics/Link.tsx
var Link = __webpack_require__(7703);
// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__(6785);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./src/renderer/basics/DownloadProgressSpan.tsx
var DownloadProgressSpan = __webpack_require__(830);
// EXTERNAL MODULE: ./src/renderer/modals.ts + 3 modules
var modals = __webpack_require__(9088);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/BlockingOperation.tsx














const BlockingOperationDiv = styles/* default */.ZP.div `
  font-size: ${(props) => props.theme.fontSizes.large};

  .message {
    padding: 1em;
    display: flex;
    flex-direction: row;
    justify-content: center;
    white-space: pre-wrap;
    max-height: 150px;
    overflow-y: auto;
    user-select: initial;
  }

  .antivirus-message {
    background: rgba(0, 0, 0, 0.3);
    margin: 1em 0;
    padding: 1em;
  }

  .progress {
    padding: 1em;
    font-size: ${(props) => props.theme.fontSizes.smaller};
    color: ${(props) => props.theme.secondaryText};
    text-align: center;
  }

  .error-actions {
    padding: 1em;
    display: flex;
    flex-direction: row;
    justify-content: center;
  }
`;
const Spacer = styles/* default */.ZP.div `
  display: inline-block;
  height: 1px;
  min-width: 8px;
`;
class BlockingOperation extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.viewBlockingOperationLog = () => {
            const { dispatch, blockingOperation } = this.props;
            dispatch(actions/* actions */.N.openModal(modals/* default */.Z.showError.make({
                wind: (0,navigation/* ambientWind */.w)(),
                title: "Setup",
                message: ["login.status.setup_failure", { error: "" }],
                widgetParams: {
                    rawError: blockingOperation.rawError,
                    log: blockingOperation.log,
                    forceDetails: true,
                    showSendReport: true,
                },
                buttons: ["ok"],
            })));
        };
        this.onRetrySetup = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.retrySetup({}));
        };
        this.learnAboutAntivirus = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.openInExternalBrowser({ url: urls/* default */.Z.windowsAntivirus }));
        };
    }
    render() {
        const { dispatch, blockingOperation, windows } = this.props;
        const { message, icon, progressInfo } = blockingOperation;
        const hasError = icon === "error";
        let iconElement;
        if (hasError) {
            iconElement = react.createElement(Icon/* default */.Z, { icon: icon });
        }
        else {
            iconElement = (react.createElement(LoadingCircle/* default */.Z, { wide: true, progress: progressInfo ? progressInfo.progress : -1 }));
        }
        const { bps = 0, eta = 0 } = progressInfo ? progressInfo : {};
        return (react.createElement(BlockingOperationDiv, null,
            react.createElement("div", { className: "message" },
                iconElement ? (react.createElement(react.Fragment, null,
                    iconElement,
                    react.createElement(Spacer, null))) : null,
                (0,t.T)(message)),
            !!progressInfo && progressInfo.doneBytes > 0 ? (react.createElement("div", { className: "progress" },
                (0,filesize/* fileSize */.j)(progressInfo.doneBytes),
                " /",
                " ",
                (0,filesize/* fileSize */.j)(progressInfo.totalBytes),
                bps !== 0 || eta !== 0 ? (react.createElement(react.Fragment, null,
                    " @ ",
                    react.createElement(DownloadProgressSpan/* default */.Z, { eta: eta, bps: bps, downloadsPaused: false }))) : null)) : null,
            hasError ? (react.createElement(react.Fragment, null,
                react.createElement("div", { className: "error-actions" },
                    react.createElement(Button/* default */.Z, { icon: "repeat", label: (0,t.T)(["login.action.retry_setup"]), onClick: this.onRetrySetup }),
                    react.createElement(Spacer, null),
                    react.createElement(Button/* default */.Z, { icon: "bug", label: (0,t.T)(["grid.item.open_debug_log"]), onClick: this.viewBlockingOperationLog })),
                windows ? (react.createElement("p", { className: "antivirus-message" },
                    react.createElement(Icon/* default */.Z, { icon: "lifebuoy" }),
                    react.createElement(Spacer, null),
                    (0,t.T)(["login.status.antivirus_warning"]),
                    react.createElement(Spacer, null),
                    react.createElement(Link/* default */.Z, { label: (0,t.T)(["toast.actions.learn_more"]), onClick: this.learnAboutAntivirus }))) : null)) : null));
    }
}
/* harmony default export */ const GateScene_BlockingOperation = ((0,hook/* hook */.z)((map) => ({
    windows: map((rs) => rs.system.windows),
}))(BlockingOperation));

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
// EXTERNAL MODULE: ./src/renderer/butlerd/rcall.ts
var rcall = __webpack_require__(8472);
// EXTERNAL MODULE: ./src/renderer/helpers/doAsync.tsx
var doAsync = __webpack_require__(5969);
// EXTERNAL MODULE: ./src/renderer/hocs/watching.tsx
var watching = __webpack_require__(7538);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);
// EXTERNAL MODULE: ./src/common/format/errors.ts
var errors = __webpack_require__(3656);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/styles.tsx

const Links = styles/* default */.ZP.div `
  margin: 1em 0;
  text-align: center;
`;

;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/LoginForm/index.tsx













const ErrorDiv = styles/* default */.ZP.div `
  min-width: 500px;
  margin: 1.4em 0;

  .header {
    text-align: center;
  }

  .icon {
    margin-right: 8px;
  }

  color: ${(props) => props.theme.error};
`;
const PasswordContainer = styles/* default */.ZP.div `
  position: relative;
`;
const RevealButton = (0,styles/* default */.ZP)((0,IconButton/* default */.Z)) `
  position: absolute;
  right: 8px;
  top: 0;
  height: 100%;
  font-size: 20px;

  .icon {
    color: ${(props) => props.theme.ternaryText} !important;
  }

  &.passwordShown {
    .icon {
      color: ${(props) => props.theme.accent} !important;
    }
  }
`;
class LoginForm extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.openRegisterPage = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.openInExternalBrowser({ url: urls/* default */.Z.accountRegister }));
        };
        this.openPasswordResetPage = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.openInExternalBrowser({
                url: urls/* default */.Z.accountForgotPassword,
            }));
        };
        this.togglePasswordReveal = (ev) => {
            ev.preventDefault();
            this.setState({
                passwordShown: !this.state.passwordShown,
            });
        };
        this.username = null;
        this.gotUsernameField = (el) => (this.username = el);
        this.password = null;
        this.gotPasswordField = (el) => (this.password = el);
        this.handleSubmit = () => {
            const { username, password } = this;
            if (!username || !password) {
                return;
            }
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.loginWithPassword({
                username: username.value,
                password: password.value,
            }));
        };
        this.handleKeyDown = (e) => {
            if (e.key === "Enter") {
                this.handleSubmit();
            }
        };
        this.state = {
            passwordShown: false,
        };
    }
    render() {
        const { dispatch, showSaved, lastUsername } = this.props;
        const { passwordShown } = this.state;
        return (react.createElement(LoginFormDiv, null,
            react.createElement(Form, { onSubmit: this.handleSubmit },
                this.renderError(),
                react.createElement("label", null,
                    (0,t.T)(["login.field.username"]),
                    react.createElement("input", { id: "login-username", ref: this.gotUsernameField, type: "text", defaultValue: lastUsername, autoFocus: !lastUsername, onKeyDown: this.handleKeyDown })),
                react.createElement("label", null,
                    (0,t.T)(["login.field.password"]),
                    react.createElement(PasswordContainer, null,
                        react.createElement(RevealButton, { onMouseDown: this.togglePasswordReveal, icon: passwordShown ? "visibility" : "visibility_off", hint: passwordShown
                                ? ["login.action.hide_password"]
                                : ["login.action.reveal_password"], className: classnames_default()({ passwordShown }), hintPosition: "top" }),
                        react.createElement("input", { id: "login-password", ref: this.gotPasswordField, type: passwordShown ? "text" : "password", autoFocus: !!lastUsername, onKeyDown: this.handleKeyDown }))),
                react.createElement(Button/* default */.Z, { id: "login-button", className: "login-button", fat: true, primary: true, label: (0,t.T)(["login.action.login"]), onClick: this.handleSubmit })),
            react.createElement(Links, null,
                react.createElement(Link/* default */.Z, { label: (0,t.T)(["login.action.register"]), onClick: this.openRegisterPage }),
                react.createElement("span", null, " · "),
                react.createElement(Link/* default */.Z, { label: (0,t.T)(["login.action.reset_password"]), onClick: this.openPasswordResetPage }),
                react.createElement("span", { key: "separator" }, " · "),
                react.createElement(Link/* default */.Z, { key: "show-saved-logins", label: (0,t.T)(["login.action.show_saved_logins"]), onClick: showSaved }))));
    }
    renderError() {
        const err = this.props.error;
        if (!err) {
            return null;
        }
        return (react.createElement(ErrorDiv, null,
            react.createElement("div", { className: "header" },
                react.createElement(Icon/* default */.Z, { icon: "error" }),
                (0,t.T)((0,errors/* formatError */.Z)(err, "login")))));
    }
}
const Form = styles/* default */.ZP.form `
  display: flex;
  flex-direction: column;
  align-items: center;

  label {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    margin: 0.5em 1em;

    span {
      margin: 0 4px;
      color: ${(props) => props.theme.secondaryText};
      font-size: 90%;
    }
  }

  #login-password {
    padding-right: 35px;
  }

  input {
    ${styles/* heavyInput */.C1};
    font-size: ${(props) => props.theme.fontSizes.large};
    width: 380px;
  }

  .login-button {
    margin: 1em 0;
  }
`;
const LoginFormDiv = styles/* default */.ZP.div ``;
/* harmony default export */ const GateScene_LoginForm = ((0,hook/* hook */.z)((map) => ({
    lastUsername: map((rs) => rs.profile.login.lastUsername),
    error: map((rs) => rs.profile.login.error),
}))(LoginForm));

// EXTERNAL MODULE: ./src/renderer/basics/TimeAgo.tsx + 2 modules
var TimeAgo = __webpack_require__(8923);
// EXTERNAL MODULE: ./src/renderer/util/get-user-cover-url.ts
var get_user_cover_url = __webpack_require__(3720);
;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/RememberedProfiles/RememberedProfile.tsx









class RememberedProfile extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.useThisProfile = () => {
            const { dispatch, profile } = this.props;
            dispatch(actions/* actions */.N.useSavedLogin({ profile }));
        };
        this.onForget = (e) => {
            e.stopPropagation();
            const { profile, dispatch } = this.props;
            const { username } = profile.user;
            dispatch(actions/* actions */.N.openModal(modals/* default */.Z.naked.make({
                wind: "root",
                title: ["prompt.forget_session.title"],
                message: ["prompt.forget_session.message", { username }],
                detail: ["prompt.forget_session.detail"],
                buttons: [
                    {
                        id: "modal-forget-profile",
                        label: ["prompt.forget_session.action"],
                        action: actions/* actions */.N.forgetProfile({ profile }),
                        icon: "cross",
                    },
                    "cancel",
                ],
                widgetParams: null,
            })));
        };
    }
    render() {
        const { profile } = this.props;
        const { user } = profile;
        const { username, displayName } = user;
        const coverUrl = (0,get_user_cover_url/* getUserCoverURL */.n)(user);
        return (react.createElement(RememberedProfileDiv, { className: "remembered-profile", onClick: this.useThisProfile },
            react.createElement("img", { className: "avatar", src: coverUrl }),
            react.createElement("div", { className: "rest" },
                react.createElement("p", { className: "username" }, displayName || username),
                react.createElement("p", { className: "last-connected" },
                    (0,t.T)(["login.remembered_session.last_connected"]),
                    " ",
                    react.createElement(TimeAgo/* default */.Z, { date: profile.lastConnected }))),
            react.createElement("div", { className: "filler" }),
            react.createElement("span", { "data-rh-at": "left", "data-rh": JSON.stringify(["prompt.forget_session.action"]) },
                react.createElement(IconButton/* default */.Z, { icon: "cross", className: "forget-profile", onClick: this.onForget }))));
    }
}
/* harmony default export */ const RememberedProfiles_RememberedProfile = ((0,hook/* hook */.z)()(RememberedProfile));
const RememberedProfileDiv = styles/* default */.ZP.div `
  ${styles/* boxy */.wN};
  flex-shrink: 0;
  min-width: 380px;
  border-radius: 2px;
  display: flex;
  flex-direction: row;
  align-items: center;
  margin: 8px 4px;

  .avatar {
    filter: grayscale(100%);

    width: 64px;
    height: 64px;
    border-radius: 2px;
    margin-right: 4px;
  }

  &:hover .avatar {
    filter: grayscale(0%);
  }

  p {
    padding: 2px 0;
  }

  .rest {
    padding: 6px 8px;
  }

  .filler {
    flex-grow: 8;
  }

  .username {
    color: ${(props) => props.theme.baseText};
    font-size: ${(props) => props.theme.fontSizes.huge};
    font-weight: bold;
    padding: 4px 0;
  }

  .last-connected {
    color: ${(props) => props.theme.secondaryText};
    font-size: 14px;
  }

  box-shadow: 0 0 4px ${(props) => props.theme.sidebarBackground};

  &:hover {
    box-shadow: 0 0 8px ${(props) => props.theme.sidebarBackground};
    cursor: pointer;
  }

  &:active {
    -webkit-filter: brightness(70%);
  }
`;

;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/RememberedProfiles/index.tsx












const RememberedProfilesDiv = styles/* default */.ZP.div `
  animation: fade-in 0.2s;

  display: flex;
  flex-direction: column;
  align-items: center;
  overflow-y: auto;
`;
let RememberedProfiles = class RememberedProfiles extends react.PureComponent {
    render() {
        const { profiles, showForm } = this.props;
        return (react.createElement(RememberedProfilesDiv, null,
            (0,index_all/* map */.UI)(profiles, (profile) => (react.createElement(RememberedProfiles_RememberedProfile, { key: profile.user.id, profile: profile }))),
            react.createElement(Links, null,
                react.createElement(Link/* default */.Z, { label: (0,t.T)(["login.action.show_form"]), onClick: showForm }))));
    }
    subscribe(watcher) {
        watcher.on(actions/* actions */.N.forgetProfile, async (store, action) => {
            const { profile } = action.payload;
            await (0,rcall/* rcall */.v)(messages/* ProfileForget */.zE, { profileId: profile.id });
            store.dispatch(actions/* actions */.N.profilesUpdated({}));
        });
    }
};
RememberedProfiles = (0,tslib_es6/* __decorate */.gn)([
    watching/* default */.Z
], RememberedProfiles);
/* harmony default export */ const GateScene_RememberedProfiles = (RememberedProfiles);

;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/LoginScreen.tsx












let LoginScreen = class LoginScreen extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.showForm = () => {
            this.setState({ showingSaved: false });
        };
        this.showSaved = () => {
            this.setState({ showingSaved: true });
        };
        this.state = {
            loading: true,
            showingSaved: true,
            profiles: [],
        };
    }
    componentDidMount() {
        this.refresh();
    }
    subscribe(watcher) {
        watcher.on(actions/* actions */.N.profilesUpdated, async (store, action) => {
            this.refresh();
        });
        watcher.on(actions/* actions */.N.loginFailed, async (store, action) => {
            this.showForm();
        });
    }
    refresh() {
        (0,doAsync/* doAsync */.R)(async () => {
            const { profiles } = await (0,rcall/* rcall */.v)(messages/* ProfileList */.q1, {});
            this.setState({ loading: false, profiles });
            if ((0,index_all/* isEmpty */.xb)(profiles)) {
                this.setState({ showingSaved: false });
            }
        });
    }
    render() {
        const { loading, showingSaved, profiles } = this.state;
        if (loading) {
            return react.createElement(LoadingCircle/* default */.Z, { progress: -1, wide: true });
        }
        if (showingSaved) {
            return (react.createElement(GateScene_RememberedProfiles, { profiles: profiles, showForm: this.showForm }));
        }
        else {
            return react.createElement(GateScene_LoginForm, { showSaved: this.showSaved });
        }
    }
};
LoginScreen = (0,tslib_es6/* __decorate */.gn)([
    watching/* default */.Z
], LoginScreen);
/* harmony default export */ const GateScene_LoginScreen = ((0,hook/* hook */.z)()(LoginScreen));

// EXTERNAL MODULE: ./node_modules/vivus/dist/vivus.js
var vivus = __webpack_require__(9752);
var vivus_default = /*#__PURE__*/__webpack_require__.n(vivus);
;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/LogoIndicator.tsx




const appWhiteContour = (__webpack_require__(6925)/* ["default"] */ .Z);
const LogoIndicatorDiv = styles/* default */.ZP.div `
  pointer-events: none;

  margin-top: 50px;

  &,
  svg {
    height: 170px;
    width: 430px;
  }

  svg {
    display: block;
    overflow: hidden;

    path {
      transition: stroke-dashoffset 2s ease-out;
    }
  }
`;
class LogoIndicator extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.gotEl = (el) => {
            if (el) {
                new (vivus_default())(el.id, {
                    file: appWhiteContour,
                    type: "delayed",
                    start: "manual",
                    animTimingFunction: (vivus_default()).EASE_OUT,
                    onReady: (vivus) => {
                        this.vivus = vivus;
                        this.update();
                    },
                });
            }
        };
        this.update = () => {
            if (this.vivus) {
                this.vivus.setFrameProgress(this.props.progress);
            }
        };
    }
    render() {
        return react.createElement(LogoIndicatorDiv, { id: "logo-indicator-div", ref: this.gotEl });
    }
    componentDidUpdate() {
        this.update();
    }
}
/* harmony default export */ const GateScene_LogoIndicator = ((0,hook/* hook */.z)((map) => ({
    progress: map((rs) => {
        const { blockingOperation, done } = rs.setup;
        if (done) {
            return 1.0;
        }
        else {
            if (blockingOperation && blockingOperation.progressInfo) {
                return blockingOperation.progressInfo.progress;
            }
            else {
                return 0.0;
            }
        }
    }),
}))(LogoIndicator));

;// CONCATENATED MODULE: ./src/renderer/scenes/GateScene/index.tsx








const GateSceneDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  align-items: center;
  height: 100%;

  .crux {
    flex-grow: 1;
    display: flex;
    flex-direction: column;
    align-self: stretch;
    align-items: center;
  }
`;
class GateScene extends react.PureComponent {
    render() {
        return (react.createElement(GateSceneDiv, null,
            react.createElement(TitleBar/* default */.Z, { tab: "login" }),
            react.createElement(GateScene_LogoIndicator, null),
            react.createElement(Filler/* default */.Z, null),
            react.createElement("section", { className: "crux" }, this.renderChild()),
            react.createElement(Filler/* default */.Z, null)));
    }
    renderChild() {
        const { blockingOperation } = this.props;
        if (blockingOperation) {
            return react.createElement(GateScene_BlockingOperation, { blockingOperation: blockingOperation });
        }
        return react.createElement(GateScene_LoginScreen, null);
    }
}
/* harmony default export */ const scenes_GateScene = ((0,hook/* hook */.z)((map) => ({
    stage: map((rs) => (rs.setup.done ? "login" : "setup")),
    errors: map((rs) => (rs.setup.done ? null : rs.setup.errors)),
    blockingOperation: map((rs) => rs.setup.done
        ? rs.profile.login.blockingOperation
        : rs.setup.blockingOperation),
}))(GateScene));


/***/ }),

/***/ 3720:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   n: () => (/* binding */ getUserCoverURL)
/* harmony export */ });
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2968);

function getUserCoverURL(user) {
    const { coverUrl, stillCoverUrl } = user;
    return stillCoverUrl || coverUrl || getFrogCoverURL(user.id);
}
const frogs = [
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-cyan.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-red.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-gold.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-blue.svg"),
];
function getFrogCoverURL(userId) {
    return frogs[userId % frogs.length];
}


/***/ })

}]);
//# sourceMappingURL=402.chunk.js.map