"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[522],{

/***/ 2325:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CH: () => (/* binding */ getCaveSummary)
/* harmony export */ });
/* unused harmony exports hookProgress, hookLogging, getErrorMessage */
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4713);

function hookProgress(convo, ctx) {
    convo.onNotification(messages.Progress, (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages.Log, async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}


/***/ }),

/***/ 105:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   z: () => (/* binding */ hasPlatforms)
/* harmony export */ });
const data = {
    windows: { icon: "windows8", platform: "windows", emoji: "🏁" },
    linux: { icon: "tux", platform: "linux", emoji: "🐧" },
    osx: { icon: "apple", platform: "osx", emoji: "🍎" },
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (data);
function hasPlatforms(target) {
    for (const key of Object.keys(data)) {
        if (target.platforms[key]) {
            return true;
        }
    }
    if (target.type === "html") {
        return true;
    }
    return false;
}


/***/ }),

/***/ 5379:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   j: () => (/* binding */ fileSize)
/* harmony export */ });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ 6817:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   b: () => (/* binding */ showInExplorerString)
/* harmony export */ });
/* provided dependency */ var process = __webpack_require__(4155);
function showInExplorerString() {
    switch (process.platform) {
        case "linux": {
            return ["grid.item.open_file_location.linux"];
        }
        case "darwin": {
            return ["grid.item.open_file_location.osx"];
        }
        case "win32":
        default: {
            return ["grid.item.open_file_location.windows"];
        }
    }
}


/***/ }),

/***/ 5346:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   $O: () => (/* binding */ formatUploadTitle),
/* harmony export */   A6: () => (/* binding */ formatBuildVersionInfo),
/* harmony export */   Pn: () => (/* binding */ formatUploadTitleFancy)
/* harmony export */ });
function formatUploadTitle(u) {
    return u ? u.displayName || u.filename : "?";
}
function clean(s) {
    return s
        .replace(/\.[a-zA-Z0-9]+$/, "")
        .replace(/[_-]/g, " ")
        .replace(/\s+/, " ");
}
function formatUploadTitleFancy(u) {
    if (u.displayName) {
        return u.displayName;
    }
    if (u.filename) {
        return clean(u.filename);
    }
    return "?";
}
function formatBuildVersionInfo(b) {
    if (!b) {
        return null;
    }
    if (b.userVersion) {
        return `v${b.userVersion}`;
    }
    return `#${b.version}`;
}


/***/ }),

/***/ 1829:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  x: () => (/* binding */ actionForGame)
});

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
;// CONCATENATED MODULE: ./src/common/constants/classification-actions.ts

const classificationActions = {
    [messages/* GameClassification */.Ai.Game]: "launch",
    [messages/* GameClassification */.Ai.Tool]: "launch",
    [messages/* GameClassification */.Ai.Assets]: "open",
    [messages/* GameClassification */.Ai.GameMod]: "open",
    [messages/* GameClassification */.Ai.PhysicalGame]: "open",
    [messages/* GameClassification */.Ai.Soundtrack]: "open",
    [messages/* GameClassification */.Ai.Other]: "open",
    [messages/* GameClassification */.Ai.Comic]: "open",
    [messages/* GameClassification */.Ai.Book]: "open",
};

;// CONCATENATED MODULE: ./src/common/util/action-for-game.ts

/**
 * Returns whether a game can be "launched" or "opened", where "launching" means
 * starting an executable, serving a web game, etc., and "opening" means showing files
 * in a file explorer.
 */
function actionForGame(game, cave) {
    // FIXME: we're not using the cave at all here - we probably should.
    return classificationActions[game.classification] || "launch";
}


/***/ }),

/***/ 2629:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1061);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4012);



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, Object.assign({}, (0,common_format_datetime__WEBPACK_IMPORTED_MODULE_0__/* .formatDurationAsMessage */ .Lb)(secs)))));


/***/ }),

/***/ 2985:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(8923);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(9080);





class LastPlayed extends react__WEBPACK_IMPORTED_MODULE_2__.PureComponent {
    render() {
        const { game, cave, short = false, className } = this.props;
        const { lastTouchedAt = null } = cave || {};
        const classification = game.classification || "game";
        const classAction = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__/* .actionForGame */ .x)(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        return (react__WEBPACK_IMPORTED_MODULE_2__.createElement("div", { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()("last-playthrough", className) }, lastTouchedAt ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement("label", null, short ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { date: lastTouchedAt })) : ((0,renderer_t__WEBPACK_IMPORTED_MODULE_4__.T)([
            `usage_stats.last_${xed}_time_ago`,
            {
                time_ago: react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { date: lastTouchedAt }),
            },
        ])))) : ((0,renderer_t__WEBPACK_IMPORTED_MODULE_4__.T)([`usage_stats.never_${xed}`]))));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (LastPlayed);


/***/ }),

/***/ 6055:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(9080);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2629);




class TotalPlaytime extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
    render() {
        const { game, cave, short = false } = this.props;
        let { secondsRun = 0 } = (cave || {});
        const classification = game.classification || "game";
        const classAction = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__/* .actionForGame */ .x)(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        if (secondsRun > 0 && classAction === "launch") {
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null,
                short ? null : (react__WEBPACK_IMPORTED_MODULE_1__.createElement("label", null,
                    (0,renderer_t__WEBPACK_IMPORTED_MODULE_2__.T)([`usage_stats.has_${xed}_for_duration`]),
                    " ")),
                react__WEBPACK_IMPORTED_MODULE_1__.createElement("span", { className: "total-playtime" },
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { secs: secondsRun }))));
        }
        return null;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (TotalPlaytime);


/***/ }),

/***/ 326:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ basics_UploadIcon)
});

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__(5379);
// EXTERNAL MODULE: ./src/common/constants/platform-data.ts
var platform_data = __webpack_require__(105);
// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
;// CONCATENATED MODULE: ./src/main/reactors/make-upload-button.ts



function makeUploadButton(upload, opts = { showSize: true }) {
    let label = `${upload.displayName || upload.filename}`;
    let tags = [];
    if (upload.size > 0 && opts.showSize) {
        tags.push({
            label: `${fileSize(upload.size)}`,
        });
    }
    if (upload.demo) {
        tags.push({
            label: ["pick_update_upload.tags.demo"],
        });
    }
    for (const prop of Object.keys(platformData)) {
        if (upload[prop]) {
            tags.push({
                icon: platformData[prop].icon,
            });
        }
    }
    const timeAgo = {
        date: upload.updatedAt,
    };
    const icon = uploadIcon(upload) || "download";
    return { label, tags, icon, timeAgo };
}
const uploadIcons = {
    [messages/* UploadType */.AJ.Default]: "gamepad",
    [messages/* UploadType */.AJ.Flash]: "neutral",
    [messages/* UploadType */.AJ.Unity]: "neutral",
    [messages/* UploadType */.AJ.Java]: "neutral",
    [messages/* UploadType */.AJ.HTML]: "html5",
    [messages/* UploadType */.AJ.Soundtrack]: "music",
    [messages/* UploadType */.AJ.Book]: "book",
    [messages/* UploadType */.AJ.Video]: "video",
    [messages/* UploadType */.AJ.Documentation]: "book",
    [messages/* UploadType */.AJ.Mod]: "shirt",
    [messages/* UploadType */.AJ.AudioAssets]: "file-music",
    [messages/* UploadType */.AJ.GraphicalAssets]: "images",
    [messages/* UploadType */.AJ.Sourcecode]: "code",
    [messages/* UploadType */.AJ.Other]: "zip",
};
function uploadIcon(upload) {
    return uploadIcons[upload.type];
}
// TODO: i18n that stuff
const uploadTypeHints = {
    [messages/* UploadType */.AJ.Default]: "File",
    [messages/* UploadType */.AJ.Flash]: "Flash embed",
    [messages/* UploadType */.AJ.Unity]: "Unity embed (legacy)",
    [messages/* UploadType */.AJ.Java]: "Java applet",
    [messages/* UploadType */.AJ.HTML]: "HTML5 app",
    [messages/* UploadType */.AJ.Soundtrack]: "Soundtrack",
    [messages/* UploadType */.AJ.Book]: "Book",
    [messages/* UploadType */.AJ.Video]: "Video",
    [messages/* UploadType */.AJ.Documentation]: "Documentation",
    [messages/* UploadType */.AJ.Mod]: "Mod",
    [messages/* UploadType */.AJ.AudioAssets]: "Audio assets",
    [messages/* UploadType */.AJ.GraphicalAssets]: "Graphical assets",
    [messages/* UploadType */.AJ.Sourcecode]: "Source code",
    [messages/* UploadType */.AJ.Other]: "Other",
};
function uploadTypeHint(upload) {
    return uploadTypeHints[upload.type];
}

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
;// CONCATENATED MODULE: ./src/renderer/basics/UploadIcon.tsx



class UploadIcon extends react.PureComponent {
    render() {
        const { upload } = this.props;
        if (!upload) {
            return null;
        }
        return react.createElement(Icon/* default */.Z, { icon: uploadIcon(upload), hint: uploadTypeHint(upload) });
    }
}
/* harmony default export */ const basics_UploadIcon = (UploadIcon);


/***/ }),

/***/ 1608:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   F: () => (/* binding */ ModalButtonSpacer),
/* harmony export */   Z: () => (/* binding */ ModalButtons)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalButtons = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  width: 100%;
  flex-shrink: 0;
  display: flex;
  flex-direction: row;
  justify-content: flex-end;
`;
const ModalButtonSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  flex-shrink: 0;
  flex-grow: 0;
  width: 1em;
`;


/***/ }),

/***/ 1522:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5379);
/* harmony import */ var common_format_show_in_explorer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6817);
/* harmony import */ var common_format_upload__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(5346);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(9471);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6025);
/* harmony import */ var renderer_basics_Cover__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(103);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(4198);
/* harmony import */ var renderer_basics_LastPlayed__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2985);
/* harmony import */ var renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(446);
/* harmony import */ var renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(8923);
/* harmony import */ var renderer_basics_TotalPlaytime__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(6055);
/* harmony import */ var renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(326);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(2263);
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(5871);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(9080);
/* harmony import */ var renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(1608);
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(4333);
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(2325);





















const CaveItem = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  padding: 4px;

  display: flex;
  flex-direction: column;
  align-items: flex-start;

  .time-ago,
  .total-playtime {
    color: ${(props) => props.theme.secondaryText} !important;
  }
`;
const CaveDetails = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  display: flex;
  flex-direction: column;
`;
const CaveDetailsRow = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  padding: 8px 0;

  display: flex;
  flex-direction: row;
  align-items: center;

  &.smaller {
    font-size: 90%;
  }
`;
const Spacer = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  height: 1px;
  width: 8px;
`;
const SpacerLarge = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  height: 1px;
  width: 16px;
`;
const CaveItemBigActions = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  display: flex;
  flex-direction: column;
  margin-top: 20px;
  margin-bottom: 20px;

  & > * {
    margin-right: 4px;
  }
`;
const Title = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  font-weight: bold;

  display: flex;
  flex-direction: row;
  align-items: center;
`;
const FileSize = renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP.div `
  font-weight: normal;
`;
const ManageCaveDiv = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .ZP)((0,renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_13__/* .ModalWidgetDiv */ .U)) `
  min-width: 600px;
`;
class ManageCave extends react__WEBPACK_IMPORTED_MODULE_3__.PureComponent {
    constructor() {
        super(...arguments);
        this.onSwitchVersion = (ev) => {
            const cave = this.props.modal.widgetParams.cave;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_19__/* .ambientWind */ .w)(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.switchVersionCaveRequest({ cave }),
            }));
        };
        this.onBack = () => {
            const { dispatch } = this.props;
            const { wind, id } = this.props.modal;
            const { game } = this.props.modal.widgetParams.cave;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({
                wind,
                id,
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.manageGame({ game }),
            }));
        };
        this.onUninstall = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_19__/* .ambientWind */ .w)(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.queueCaveUninstall({ caveId }),
            }));
        };
        this.onReinstall = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_19__/* .ambientWind */ .w)(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.queueCaveReinstall({ caveId }),
            }));
        };
        this.onUpdateCheck = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_19__/* .ambientWind */ .w)(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.checkForGameUpdate({ caveId }),
            }));
        };
        this.onExplore = (ev) => {
            const caveId = this.props.modal.widgetParams.cave.id;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.exploreCave({ caveId }));
        };
    }
    render() {
        return react__WEBPACK_IMPORTED_MODULE_3__.createElement(ManageCaveDiv, null, this.renderCave());
    }
    renderCave() {
        const { cave } = this.props.modal.widgetParams;
        const { game } = cave;
        const u = cave.upload;
        const caveSummary = (0,common_butlerd_utils__WEBPACK_IMPORTED_MODULE_18__/* .getCaveSummary */ .CH)(cave);
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(CaveItem, { key: cave.id },
            react__WEBPACK_IMPORTED_MODULE_3__.createElement("div", { style: {
                    width: "100%",
                    display: "flex",
                    flexDirection: "row",
                    justifyContent: "space-between",
                    alignItems: "center",
                } },
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(CaveDetails, null,
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement(CaveDetailsRow, null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Title, null, formatUpload(u))),
                    cave.build ? (react__WEBPACK_IMPORTED_MODULE_3__.createElement(react__WEBPACK_IMPORTED_MODULE_3__.Fragment, null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(CaveDetailsRow, { className: "smaller" },
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "pin" }),
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                            (0,common_format_upload__WEBPACK_IMPORTED_MODULE_20__/* .formatBuildVersionInfo */ .A6)(cave.build),
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_9__/* ["default"] */ .Z, { date: cave.build.createdAt }),
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(SpacerLarge, null),
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "checkmark" }),
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                            (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["table.column.powered_by"]),
                            "\u00A0",
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement("a", { target: "_popout", href: "https://itch.io/docs/butler/" }, "butler")))) : null,
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement(CaveDetailsRow, { className: "smaller" },
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "tag" }),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                        (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["table.column.published"]),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                        u ? react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_9__/* ["default"] */ .Z, { date: u.createdAt }) : null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(SpacerLarge, null),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "install" }),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                        (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["table.column.installed"]),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_9__/* ["default"] */ .Z, { date: cave.stats.installedAt })),
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement(CaveDetailsRow, { className: "smaller" },
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "history" }),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_LastPlayed__WEBPACK_IMPORTED_MODULE_7__/* ["default"] */ .Z, { game: game, cave: caveSummary }),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(SpacerLarge, null),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "stopwatch" }),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_TotalPlaytime__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .Z, { game: game, cave: caveSummary }))),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement("div", { style: { width: "60px" } },
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Cover__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .ZP, { hover: false, gameId: game.id, coverUrl: game.coverUrl, stillCoverUrl: game.stillCoverUrl }))),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(CaveItemBigActions, null,
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP, { icon: "folder-open", onClick: this.onExplore },
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* .BigButtonContent */ .wo, null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* .BigButtonRow */ .t9, null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)((0,common_format_show_in_explorer__WEBPACK_IMPORTED_MODULE_2__/* .showInExplorerString */ .b)())),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* .BigButtonRow */ .t9, null,
                            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* .Tag */ .Vp, null, cave.installInfo.installFolder),
                            cave.installInfo.installedSize ? (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* .Tag */ .Vp, null,
                                react__WEBPACK_IMPORTED_MODULE_3__.createElement(FileSize, null, (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_1__/* .fileSize */ .j)(cave.installInfo.installedSize)))) : null))),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP, { icon: "repeat", onClick: this.onUpdateCheck },
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* .BigButtonContent */ .wo, null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* .BigButtonRow */ .t9, null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["grid.item.check_for_update"])))),
                u ? (react__WEBPACK_IMPORTED_MODULE_3__.createElement(react__WEBPACK_IMPORTED_MODULE_3__.Fragment, null, u.channelName == "" ? ("") : (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_RowButton__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP, { icon: "shuffle", onClick: this.onSwitchVersion }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["grid.item.revert_to_version"]))))) : null),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_16__/* .ModalButtons */ .Z, null,
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { icon: "arrow-left", onClick: this.onBack }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["prompt.action.back"])),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_17__/* ["default"] */ .Z, null),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { icon: "repeat", onClick: this.onReinstall, className: "manage-reinstall" }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["prompt.uninstall.reinstall"])),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_16__/* .ModalButtonSpacer */ .F, null),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { icon: "uninstall", onClick: this.onUninstall, className: "manage-uninstall" }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_15__.T)(["prompt.uninstall.uninstall"])))));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_12__/* .hook */ .z)()(ManageCave));
function formatUpload(upload) {
    return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(react__WEBPACK_IMPORTED_MODULE_3__.Fragment, null,
        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_11__/* ["default"] */ .Z, { upload: upload }),
        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Spacer, null),
        (0,common_format_upload__WEBPACK_IMPORTED_MODULE_20__/* .formatUploadTitle */ .$O)(upload)));
}


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=522.chunk.js.map