"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[533],{

/***/ 992:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Nd: () => (/* binding */ getRpcErrorData),
/* harmony export */   SS: () => (/* binding */ isInternalError),
/* harmony export */   dt: () => (/* binding */ getErrorStack),
/* harmony export */   mg: () => (/* binding */ asRequestError)
/* harmony export */ });
/* unused harmony export mergeLogAndError */
/* harmony import */ var common_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(8976);
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1061);


function asRequestError(e) {
    const re = e;
    if (re.rpcError) {
        return e;
    }
    return null;
}
function getRpcErrorData(e) {
    const re = asRequestError(e);
    if (re && re.rpcError && re.rpcError.data) {
        return re.rpcError.data;
    }
    return null;
}
function isInternalError(e) {
    const re = asRequestError(e);
    if (!re) {
        return true;
    }
    if (re.rpcError.code < 0) {
        return true;
    }
    return false;
}
function getErrorStack(e) {
    if (!e) {
        return "Unknown error";
    }
    let errorStack = e.stack;
    const re = asRequestError(e);
    if (re) {
        const ed = getRpcErrorData(e);
        if (ed && ed.stack) {
            // use golang stack if available
            errorStack = ed.stack;
        }
        else if (re.message) {
            // or just message
            errorStack = re.message;
        }
    }
    return errorStack;
}
function mergeLogAndError(log, e) {
    let formattedLog = "";
    if (log) {
        let lines = log.split("\n");
        for (let line of lines) {
            line = line.trim();
            let fallback = false;
            try {
                const obj = JSON.parse(line);
                if (obj.msg) {
                    let date = formatDate(new Date(obj.time), "en-US", DATE_FORMAT);
                    let level = levels[obj.level];
                    let { msg } = obj;
                    formattedLog += `${date} [${level}] ${msg}\n`;
                }
                else {
                    fallback = true;
                }
            }
            catch (e) {
                fallback = true;
            }
            if (fallback) {
                formattedLog += `${line}\n`;
            }
        }
    }
    return `${formattedLog}\n\nError stack:\n${getErrorStack(e)}\n`;
}


/***/ }),

/***/ 8383:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   eE: () => (/* binding */ isNetworkError)
/* harmony export */ });
/* unused harmony exports RequestError, RequestTimeout, RequestAborted, RequestFormattingFailure, RequestParsingFailure */
/* harmony import */ var common_butlerd_errors__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(992);
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4713);


/**
 * Returns true if this is a network error
 */
function isNetworkError(e) {
    // this operates under the assumption that:
    //   * all our internal network errors should start with "err::"
    //   * all of chrome's already do
    //   * we transform fetch's into err:: variants.
    // we coerce e.message into a string on the off chance that it's not defined
    // or not a string.
    const isJavaScriptNetworkError = e && ("" + e.message).indexOf("net::") === 0;
    if (isJavaScriptNetworkError) {
        return true;
    }
    const re = (0,common_butlerd_errors__WEBPACK_IMPORTED_MODULE_0__/* .asRequestError */ .mg)(e);
    if (re) {
        if (re.rpcError.code === common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .Code */ .EK.NetworkDisconnected) {
            return true;
        }
    }
    return false;
}
class RequestError extends (/* unused pure expression or super */ null && (Error)) {
    constructor(message) {
        super(message.indexOf("net::") == 0 ? message : "net::REQUEST_ERROR::");
    }
}
class RequestTimeout extends (/* unused pure expression or super */ null && (RequestError)) {
    constructor() {
        super("TIMED_OUT");
    }
}
class RequestAborted extends (/* unused pure expression or super */ null && (RequestError)) {
    constructor() {
        super("ABORTED");
    }
}
class RequestFormattingFailure extends (/* unused pure expression or super */ null && (RequestError)) {
    constructor(message) {
        super("FORMATTING_FAILURE: " + message);
    }
}
class RequestParsingFailure extends (/* unused pure expression or super */ null && (RequestError)) {
    constructor(message) {
        super("PARSING_FAILURE: " + message);
    }
}


/***/ }),

/***/ 8533:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ pages_LocationsPage)
});

// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/FiltersContainer.tsx + 2 modules
var FiltersContainer = __webpack_require__(4987);
// EXTERNAL MODULE: ./src/renderer/hocs/butlerCaller/index.tsx + 1 modules
var butlerCaller = __webpack_require__(5617);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/pages/common/ItemList.tsx
var ItemList = __webpack_require__(6797);
// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__(9954);
// EXTERNAL MODULE: ./src/renderer/pages/common/SortsAndFilters.tsx
var SortsAndFilters = __webpack_require__(7128);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/renderer/pages/common/GameStripe.tsx
var GameStripe = __webpack_require__(7840);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__(5379);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
;// CONCATENATED MODULE: ./src/renderer/pages/LocationsPage/LocationSizeBar.tsx




const LocationSizeDiv = styles/* default */.ZP.div `
  width: 400px;

  .progress-wrapper {
    font-size: ${(props) => props.theme.fontSizes.smaller};
    &:hover {
      cursor: pointer;
    }
  }

  .progress {
    background: #555;
    padding: 2px 8px;
    position: relative;
    ${styles/* singleLine */.U1};

    &,
    .progress-inner {
      border-radius: 2px;
    }

    .progress-inner {
      background: white;
      position: absolute;
      left: 0;
      top: 0;
      bottom: 0;
    }

    .progress-label {
      color: white;
      mix-blend-mode: difference;
    }
  }
`;
class LocationSizeBar extends react.PureComponent {
    render() {
        const { location } = this.props;
        if (!location) {
            return null;
        }
        const { sizeInfo } = location;
        if (!sizeInfo || sizeInfo.totalSize < 0) {
            return "Not available";
        }
        const { totalSize, freeSize, installedSize } = sizeInfo;
        return (react.createElement(LocationSizeDiv, null,
            react.createElement("div", { className: "progress-wrapper", "data-rh": JSON.stringify([
                    "preferences.install_location.size_used_by_games",
                    { installedSize: (0,filesize/* fileSize */.j)(installedSize) },
                ]) },
                react.createElement("div", { className: "progress" },
                    react.createElement("div", { className: "progress-inner", style: {
                            right: `${(freeSize / totalSize) * 100}%`,
                        } }),
                    react.createElement("span", { className: "progress-label" }, (0,t.T)([
                        "preferences.install_location.free_of_total",
                        {
                            freeSize: (0,filesize/* fileSize */.j)(freeSize),
                            totalSize: (0,filesize/* fileSize */.j)(totalSize),
                        },
                    ]))))));
    }
}

// EXTERNAL MODULE: ./src/renderer/pages/PageStyles/games.tsx
var games = __webpack_require__(465);
;// CONCATENATED MODULE: ./src/renderer/pages/LocationsPage/LocationSummary.tsx













const LocationStripe = (0,GameStripe/* makeGameStripe */.k)(messages/* FetchCaves */.J1);
const SizeTag = styles/* default */.ZP.div `
  margin-left: 1em;
  font-size: ${(props) => props.theme.fontSizes.baseText};
`;
class LocationSummary extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.getGame = LocationStripe.getGameCallback((cave) => cave.game);
        this.renderTitleExtras = () => {
            const { location } = this.props;
            let installedSize;
            if (location && location.sizeInfo && location.sizeInfo.installedSize > 0) {
                installedSize = (0,filesize/* fileSize */.j)(location.sizeInfo.installedSize);
            }
            return (react.createElement(react.Fragment, null,
                react.createElement(SizeTag, null, installedSize
                    ? (0,t.T)((0,t._)("preferences.install_location.size_used_by_games", {
                        installedSize,
                    }))
                    : (0,t.T)((0,t._)("preferences.install_location.empty"))),
                react.createElement(Filler/* default */.Z, null),
                react.createElement(games/* TitleBreak */.pd, null),
                react.createElement(LocationSizeBar, { location: location }),
                react.createElement(IconButton/* default */.Z, { icon: "more_vert", onClick: this.onMoreActions })));
        };
        this.onMoreActions = (e) => {
            e.preventDefault();
            const { location, numLocations } = this.props;
            const mayDelete = numLocations > 1;
            let template = [];
            template.push({
                localizedLabel: ["preferences.install_location.navigate"],
                action: actions/* actions */.N.navigate({
                    wind: "root",
                    url: (0,navigation/* urlForInstallLocation */.yd)(location.id),
                }),
                id: "context--install-location-navigate",
            });
            if (mayDelete) {
                template.push({
                    localizedLabel: ["preferences.install_location.delete"],
                    action: actions/* actions */.N.removeInstallLocation({ id: location.id }),
                    id: "context--install-location-delete",
                });
            }
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.popupContextMenu({
                wind: (0,navigation/* ambientWind */.w)(),
                clientX: e.clientX,
                clientY: e.clientY,
                template,
            }));
        };
    }
    render() {
        const { location } = this.props;
        return (react.createElement(LocationStripe, { title: `${location.path}`, renderTitleExtras: this.renderTitleExtras, params: {
                filters: {
                    installLocationId: location.id,
                },
            }, href: `itch://locations/${location.id}`, getGame: this.getGame }));
    }
}
/* harmony default export */ const LocationsPage_LocationSummary = ((0,hook/* hook */.z)()(LocationSummary));

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__(6785);
;// CONCATENATED MODULE: ./src/renderer/pages/LocationsPage/index.tsx


















const ListInstallLocations = (0,butlerCaller/* default */.ZP)(messages/* InstallLocationsList */.kx);
const Spacer = styles/* default */.ZP.div `
  width: 8px;
`;
class LocationsPage extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.renderCallContents = ListInstallLocations.renderCallback(({ loading, result }) => {
            const { scanningLocations, locationScanProgress } = this.props;
            return (react.createElement(react.Fragment, null,
                react.createElement(FiltersContainer/* default */.ZP, { loading: loading }),
                react.createElement(SortsAndFilters/* SortsAndFilters */.gY, null,
                    react.createElement(SortsAndFilters/* FilterGroup */.e_, null,
                        react.createElement(SortsAndFilters/* FilterOptionLink */.zR, { href: "itch://scan-install-locations", className: classnames_default()({ disabled: scanningLocations }) },
                            react.createElement(SortsAndFilters/* FilterOptionIcon */.Zk, { icon: "search" }),
                            (0,t.T)(["preferences.scan_install_locations"]),
                            scanningLocations ? (react.createElement(react.Fragment, null,
                                react.createElement(Spacer, null),
                                react.createElement(LoadingCircle/* default */.Z, { progress: locationScanProgress }))) : null)),
                    react.createElement(SortsAndFilters/* FilterSpacer */.dz, null),
                    react.createElement(SortsAndFilters/* FilterGroup */.e_, null,
                        react.createElement(SortsAndFilters/* FilterOptionButton */.Ni, { onClick: this.onAddLocation },
                            react.createElement(SortsAndFilters/* FilterOptionIcon */.Zk, { icon: "plus" }),
                            (0,t.T)(["preferences.install_location.add"])))),
                this.renderList(result)));
        });
        this.renderList = (result) => {
            if (!result || (0,index_all/* isEmpty */.xb)(result.installLocations)) {
                return null;
            }
            const locations = result.installLocations;
            const numLocations = (0,index_all/* size */.dp)(locations);
            return (react.createElement(ItemList/* default */.Z, null, (0,index_all/* sortBy */.MR)(result.installLocations, (location) => -location.sizeInfo.installedSize).map((location) => (react.createElement(LocationsPage_LocationSummary, { key: location.id, location: location, numLocations: numLocations })))));
        };
        this.onAddLocation = (ev) => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.addInstallLocation({ wind: (0,navigation/* ambientWind */.w)() }));
        };
    }
    render() {
        return (react.createElement(Page/* default */.Z, null,
            react.createElement(ListInstallLocations, { params: { sequence: this.props.sequence }, loadingHandled: true, render: this.renderCallContents })));
    }
    componentDidMount() {
        (0,tab_utils/* dispatchTabPageUpdate */.pq)(this.props, { label: ["install_locations.manage"] });
    }
}
/* harmony default export */ const pages_LocationsPage = ((0,withTab/* withTab */.D1)((0,hook/* hook */.z)((map) => ({
    scanningLocations: map((rs) => rs.system.locationScanProgress !== null),
    locationScanProgress: map((rs) => rs.system.locationScanProgress),
}))(LocationsPage)));


/***/ }),

/***/ 7840:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   k: () => (/* binding */ makeGameStripe)
/* harmony export */ });
/* unused harmony export makeStripeCallbacks */
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(655);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(9471);
/* harmony import */ var main_net_errors__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(8383);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3964);
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3537);
/* harmony import */ var renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5617);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2263);
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2521);
/* harmony import */ var renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(465);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(9080);
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(9050);
/* harmony import */ var renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(7792);














const StripeDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;
  width: 100%;
  overflow: hidden;
  position: relative;

  height: ${renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_11__/* .standardCoverHeight */ .xb + 2}px;

  padding: 1.2em 0;
  margin-bottom: 32px;
`;
const FloaterContainer = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.div `
  background: ${(props) => props.theme.breadBackground};
  opacity: 0.7;
  padding: 4px;

  position: absolute;
  left: 5px;
  top: 5px;
  z-index: 20;
`;
const ViewAll = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.a `
  position: absolute;
  background: ${(props) => props.theme.breadBackground};
  box-shadow: 0 0 30px ${(props) => props.theme.breadBackground};
  padding: 0 4em;
  top: 0;
  bottom: 0;
  right: 0;
  display: flex;
  flex-direction: row;
  align-items: center;
  overflow: hidden;

  z-index: 4;
`;
const StripeItemDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* .boxy */ .wN};
  flex-shrink: 0;
  margin-right: 0.8em;
`;
const stripeLimit = 12;
function makeGameStripe(rc) {
    const Call = (0,renderer_hocs_butlerCaller__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .ZP)(rc);
    const hasItems = (result) => {
        if (!result) {
            return false;
        }
        return !(0,underscore__WEBPACK_IMPORTED_MODULE_10__/* .isEmpty */ .xb)(result.items);
    };
    class Stripe extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
        constructor() {
            super(...arguments);
            this.renderCallContents = Call.renderCallback(({ result, error, loading }) => (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
                this.renderTitle(loading, result, error),
                react__WEBPACK_IMPORTED_MODULE_1__.createElement(StripeDiv, null,
                    loading ? (react__WEBPACK_IMPORTED_MODULE_1__.createElement(FloaterContainer, null,
                        react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, null))) : null,
                    this.renderViewAll(),
                    this.renderItems(result),
                    this.renderEmpty()))));
        }
        render() {
            const { params, sequence } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(Call, { params: Object.assign(Object.assign({}, params), { limit: stripeLimit }), sequence: sequence, loadingHandled: true, errorsHandled: true, render: this.renderCallContents }));
        }
        renderTitle(loading, result, error) {
            const { linkId, href, title, renderTitleExtras = renderNoop, } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
                react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_7__/* .TitleBox */ .kS, null,
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_7__/* .Title */ .Dx, null,
                        react__WEBPACK_IMPORTED_MODULE_1__.createElement("a", { id: linkId, href: href }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_9__.T)(title)),
                        renderTitleExtras())),
                this.renderError(result, error)));
        }
        renderError(result, error) {
            if (!error) {
                return null;
            }
            if (hasItems(result) && (0,main_net_errors__WEBPACK_IMPORTED_MODULE_0__/* .isNetworkError */ .eE)(error)) {
                return null;
            }
            return react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { error: error });
        }
        renderItems(result) {
            if (!result) {
                return null;
            }
            if ((0,underscore__WEBPACK_IMPORTED_MODULE_10__/* .isEmpty */ .xb)(result.items)) {
                return null;
            }
            const doneSet = new Set();
            const { getGame } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null, result.items.map((item) => {
                const game = getGame(item);
                if (!game || doneSet.has(game.id)) {
                    return null;
                }
                doneSet.add(game.id);
                return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(StripeItem, { key: game.id, className: "stripe--item", "data-game-id": game.id, game: game }));
            })));
        }
        renderEmpty() {
            const { dispatch } = this.props;
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null, [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12].map((id) => (react__WEBPACK_IMPORTED_MODULE_1__.createElement(StripeItem, { key: `empty-${id}` })))));
        }
        renderViewAll() {
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(ViewAll, { href: this.props.href }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_9__.T)(["game_stripe.view_all"])));
        }
    }
    let result = (0,renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_6__/* .withTab */ .D1)((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__/* .hookWithProps */ .h)(Stripe)((map) => ({
        sequence: map((rs, props) => (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_12__/* .ambientTab */ .mB)(rs, props).sequence),
    }))(Stripe));
    function identity(t) {
        return t;
    }
    let augmentedResult = result;
    augmentedResult.getGameCallback = identity;
    return augmentedResult;
}
function makeStripeCallbacks(rc) {
    return {
        getGame(f) {
            return f;
        },
    };
}
function renderNoop() {
    return null;
}
class StripeItem extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
    render() {
        const _a = this.props, { game } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_13__/* .__rest */ ._T)(_a, ["game"]);
        return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(StripeItemDiv, Object.assign({}, restProps),
            react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_11__/* ["default"] */ .ZP, { game: game, showInfo: true })));
    }
}


/***/ }),

/***/ 6797:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  flex-grow: 1;
  overflow-y: auto;
  padding: 0 12px;

  user-select: none;

  /* this scrolls, so we want it to have its own layer */
  will-change: transform;
`);


/***/ }),

/***/ 7128:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Ni: () => (/* binding */ FilterOptionButton),
/* harmony export */   Zk: () => (/* binding */ FilterOptionIcon),
/* harmony export */   dz: () => (/* binding */ FilterSpacer),
/* harmony export */   e_: () => (/* binding */ FilterGroup),
/* harmony export */   gY: () => (/* binding */ SortsAndFilters),
/* harmony export */   zR: () => (/* binding */ FilterOptionLink)
/* harmony export */ });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4987);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4198);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5836);



const SortsAndFilters = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP)((0,renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__/* .FiltersContainerDiv */ .vN)) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* .css */ .iv) `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  ${optionButtonLike};
`;
const FilterOptionIcon = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP)((0,renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .Z)) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ })

}]);
//# sourceMappingURL=533.chunk.js.map