"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[551],{

/***/ 3961:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   kr: () => (/* binding */ onNotification),
/* harmony export */   mK: () => (/* binding */ hookLogging),
/* harmony export */   rN: () => (/* binding */ onRequest)
/* harmony export */ });
/* unused harmony export convertMessage */
/* harmony import */ var common_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(8976);
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2325);
/* harmony import */ var butlerd_lib_support__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(8240);



const hookLogging = (logger) => {
    return { type: "HOOK_LOGGING", logger: logger };
};
const onNotification = (messageName, callback) => {
    return {
        type: "ON_NOTIFICATION",
        messageName: messageName,
        callback: callback,
    };
};
const onRequest = (messageName, callback) => {
    return { type: "ON_REQUEST", messageName: messageName, callback: callback };
};
const convertMessage = (message) => {
    if (message.type === "HOOK_LOGGING") {
        const logger = new Logger(message.logger.sink, message.logger.name);
        return (convo) => utils.hookLogging(convo, logger);
    }
    else if (message.type === "ON_NOTIFICATION") {
        const notification = createNotification(message.messageName);
        return (convo) => convo.onNotification(notification, message.callback);
    }
    else if (message.type === "ON_REQUEST") {
        const request = createRequest(message.messageName);
        return (convo) => convo.onRequest(request, message.callback);
    }
    else {
        return (convo) => null;
    }
};


/***/ }),

/***/ 7703:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .secondaryLink */ .CF};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_2__/* .__rest */ ._T)(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Link);
class Props {
}


/***/ }),

/***/ 1608:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   F: () => (/* binding */ ModalButtonSpacer),
/* harmony export */   Z: () => (/* binding */ ModalButtons)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalButtons = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  width: 100%;
  flex-shrink: 0;
  display: flex;
  flex-direction: row;
  justify-content: flex-end;
`;
const ModalButtonSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  flex-shrink: 0;
  flex-grow: 0;
  width: 1em;
`;


/***/ }),

/***/ 7426:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ AppLogPage_Log)
});

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/index.js + 1 modules
var lib = __webpack_require__(49);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
;// CONCATENATED MODULE: ./src/renderer/basics/SelectRow.tsx





const SelectRowDiv = styles/* default */.ZP.div `
  display: inline-block;
`;
const Select = styles/* default */.ZP.select `
  border: none;
  padding: 6px 8px;
  margin-left: 2px;
  background: ${(props) => props.theme.itemBackground};
  border: 1px solid rgba(255, 255, 255, 0.1);
  border-radius: 2px;
  color: ${(props) => props.theme.baseText};
  cursor: pointer;
  font-family: inherit;
  font-size: inherit;
`;
/**
 * A drop-down you can select from
 */
class SelectRow extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onChange = (event) => {
            const { onChange } = this.props;
            if (onChange) {
                onChange(event.currentTarget.value);
            }
        };
        this.gotElement = (element) => {
            this.element = element;
        };
    }
    render() {
        const { options, value, intl } = this.props;
        const optionTags = (0,index_all/* map */.UI)(options, (option, index) => (react.createElement("option", { key: index, value: option.value }, (0,t/* TString */.m)(intl, option.label))));
        return (react.createElement(SelectRowDiv, null,
            react.createElement(Select, { ref: this.gotElement, value: value, onChange: this.onChange }, optionTags)));
    }
    value() {
        if (this.element) {
            return this.element.value;
        }
        else {
            return null;
        }
    }
}
/* harmony default export */ const basics_SelectRow = ((0,injectIntl/* default */.ZP)(SelectRow));

// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__(6025);
;// CONCATENATED MODULE: ./src/renderer/pages/AppLogPage/Log.tsx









// time, module, message
const numColumns = 3;
const levels = {
    default: "user",
    "60": "fatal",
    "50": "error",
    "40": "warn",
    "30": "info",
    "20": "debug",
    "10": "trace",
};
const reverseLevels = {
    fatal: "60",
    error: "50",
    warn: "40",
    info: "30",
    debug: "20",
    trace: "10",
};
const LogContainer = styles/* default */.ZP.div `
  width: 100%;
  height: 100%;
`;
const LogControls = styles/* default */.ZP.div `
  padding-bottom: 1em;
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const LogTable = styles/* default */.ZP.table `
  background: ${(props) => props.theme.sidebarBackground};
  width: 100%;
  height: 100%;

  tbody {
    overflow-y: scroll;
    height: 100%;

    display: block;
    tr {
      display: table;
    }
  }

  td {
    padding: 0 0.5em;
    padding-left: 0;
    line-height: 1.4;
    color: ${(props) => props.theme.secondaryText};
    font-size: ${(props) => props.theme.fontSizes.smaller};

    &.fatal {
      background: #cd3131;
      color: white;
    }

    &.error {
      color: #c53030;
    }

    &.warn {
      color: #d3d310;
    }

    &.info {
      color: #138ba8;
    }

    &.debug {
      color: #357ac6;
    }

    &.timecol,
    &.modcol {
      white-space: nowrap;
    }

    &.msgcol {
      white-space: pre-wrap;
    }

    &.timecol {
      color: ${(props) => props.theme.ternaryText};
    }
  }
`;
const levelOptions = [
    { label: ["log.level.debug"], value: reverseLevels["debug"] },
    { label: ["log.level.info"], value: reverseLevels["info"] },
    { label: ["log.level.warning"], value: reverseLevels["warn"] },
    { label: ["log.level.error"], value: reverseLevels["error"] },
];
const linesPerPage = 250;
class Log extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onLoadMore = () => {
            this.setState((state) => ({
                maxLines: state.maxLines + linesPerPage,
            }));
        };
        this.gotBody = (tbody) => {
            this.tbody = tbody;
            this.scrollDown();
        };
        this.onChangeLevel = (value) => {
            this.setState({ level: value });
        };
        this.onJumpDown = () => {
            this.scrollDown();
        };
        this.state = {
            level: reverseLevels["info"],
            maxLines: linesPerPage,
        };
    }
    render() {
        const { maxLines } = this.state;
        let level = parseInt(this.state.level, 10);
        const { log, className, extraControls } = this.props;
        let lines = log.split("\n");
        let entries = lines.map((x) => {
            // TODO: use fast-json-parse instead ?
            try {
                const entry = JSON.parse(x);
                return entry.hasOwnProperty("msg") ? entry : x;
            }
            catch (e) {
                return x;
            }
        });
        entries = index_all/* default.filter */.ZP.filter(entries, (x) => (x.level ? x.level >= level : false));
        let hasMore = index_all/* default.size */.ZP.size(entries) > maxLines;
        entries = index_all/* default.last */.ZP.last(entries, maxLines);
        return (react.createElement(LogContainer, { className: className },
            react.createElement(LogControls, null,
                react.createElement("label", null,
                    (0,t.T)(["log.level"]),
                    ": ",
                    react.createElement(basics_SelectRow, { options: levelOptions, value: this.state.level, onChange: this.onChangeLevel })),
                extraControls,
                react.createElement(Filler/* default */.Z, null),
                react.createElement(IconButton/* default */.Z, { icon: "caret-down", onClick: this.onJumpDown })),
            react.createElement(LogTable, null,
                react.createElement("tbody", { ref: this.gotBody },
                    hasMore ? (react.createElement("div", { style: { margin: "20px" } },
                        react.createElement(Button/* default */.Z, { onClick: this.onLoadMore, label: "Load more..." }))) : null,
                    entries.map((x, i) => {
                        if (x.hasOwnProperty("msg")) {
                            let jumpElement;
                            let previousEntry = entries[i - 1];
                            if (x.time) {
                                const currDate = new Date(x.time);
                                const prevDate = previousEntry
                                    ? new Date(previousEntry.time)
                                    : null;
                                if (!previousEntry ||
                                    !previousEntry.time ||
                                    currDate.getUTCDate() != prevDate.getUTCDate() ||
                                    currDate.getUTCMonth() != prevDate.getUTCMonth() ||
                                    currDate.getUTCFullYear() != currDate.getUTCFullYear()) {
                                    jumpElement = (react.createElement("tr", { key: `${i}-jump` },
                                        react.createElement("td", { colSpan: 3 },
                                            react.createElement(lib/* FormattedDate */.Ji, { month: "long", year: "numeric", day: "numeric", value: x.time }))));
                                }
                            }
                            return (react.createElement(react.Fragment, null,
                                jumpElement,
                                react.createElement("tr", { key: i },
                                    react.createElement("td", { className: "timecol" },
                                        react.createElement(lib/* FormattedTime */.qN, { value: x.time })),
                                    react.createElement("td", { className: "modcol" }, x.name ? react.createElement("span", null, x.name) : null),
                                    react.createElement("td", { className: levels[x.level] + " msgcol" }, x.msg))));
                        }
                        else {
                            return (react.createElement("tr", { key: i },
                                react.createElement("td", { colSpan: numColumns }, x)));
                        }
                    })))));
    }
    scrollDown() {
        if (!this.tbody) {
            return;
        }
        this.tbody.scrollTop = this.tbody.scrollHeight;
    }
    scrollTop() {
        if (!this.tbody) {
            return;
        }
        this.tbody.scrollTop = 0;
    }
}
/* harmony default export */ const AppLogPage_Log = (Log);


/***/ }),

/***/ 1625:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   BV: () => (/* binding */ BoxInner),
/* harmony export */   xu: () => (/* binding */ Box)
/* harmony export */ });
/* unused harmony exports BaseBox, BoxSingle */
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const BaseBox = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  margin: 1em auto;
  line-height: 1.6;
`;
const Box = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .boxy */ .wN};
  max-width: 1200px;

  margin: 1em auto;
  line-height: 1.6;
`;
const BoxSingle = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .boxy */ .wN};

  margin: 1em auto;
  line-height: 1.6;
`;
const BoxInner = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  width: 100%;
  display: flex;
  flex-direction: row;
  align-items: center;
`;


/***/ }),

/***/ 6551:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

var __filename = "src/renderer/pages/ScanInstallLocationsPage/index.tsx";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4713);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(9471);
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2968);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6025);
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(4333);
/* harmony import */ var renderer_basics_Link__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(7703);
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(6785);
/* harmony import */ var renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(1608);
/* harmony import */ var renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(8472);
/* harmony import */ var renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(5969);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2263);
/* harmony import */ var renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(2250);
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(2521);
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(5258);
/* harmony import */ var renderer_pages_AppLogPage_Log__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(7426);
/* harmony import */ var renderer_pages_common_Page__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(9954);
/* harmony import */ var renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(7128);
/* harmony import */ var renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(7792);
/* harmony import */ var renderer_pages_common_StandardGameDesc__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(5231);
/* harmony import */ var renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(1625);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(9080);
/* harmony import */ var common_logger__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(8976);
/* harmony import */ var common_helpers_bridge__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(3961);


























var Stage;
(function (Stage) {
    Stage[Stage["Scanning"] = 0] = "Scanning";
    Stage[Stage["NeedConfirm"] = 1] = "NeedConfirm";
    Stage[Stage["Done"] = 2] = "Done";
})(Stage || (Stage = {}));
const coverHeight = 20;
const coverWidth = (coverHeight / renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_17__/* .standardCoverHeight */ .xb) * renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_17__/* .standardCoverWidth */ .C2;
const StyledLog = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP)((0,renderer_pages_AppLogPage_Log__WEBPACK_IMPORTED_MODULE_14__/* ["default"] */ .Z)) `
  tbody {
    min-height: 240px;
  }

  padding-bottom: 1em;
`;
const TinyCover = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP)((0,renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_17__/* ["default"] */ .ZP)) `
  width: ${coverWidth}px;
  height: ${coverHeight}px;
  overflow: hidden;

  margin-right: 8px;
`;
const PageScan = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP)((0,renderer_pages_common_Page__WEBPACK_IMPORTED_MODULE_15__/* ["default"] */ .Z)) `
  user-select: none;
  height: 100%;
  padding: 20px;
`;
const WideBox = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP)((0,renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_19__/* .Box */ .xu)) `
  width: 100%;
`;
const ListDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP.div `
  flex-grow: 1000; /* Filler is 100 */
  flex-shrink: 0;
`;
const ListDivSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP.div `
  flex-shrink: 0;
  height: 24px;
`;
const List = renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP.ul `
  overflow-y: auto;
  max-height: 300px;
  min-width: 120px;
  margin-top: 1em;
  flex-grow: 1;

  li {
    display: flex;
    flex-direction: row;
    align-items: center;
    margin: 6px 0;
  }
`;
const SectionDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_20__/* ["default"] */ .ZP.div `
  padding: 8px;
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
`;
const parentLogger = renderer_logger__WEBPACK_IMPORTED_MODULE_13__/* .rendererLogger */ .X.child(__filename);
class ScanInstallLocations extends react__WEBPACK_IMPORTED_MODULE_3__.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onConfirm = () => {
            this.resolve();
        };
        this.onClose = () => {
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeWind({ wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_24__/* .ambientWind */ .w)() }));
        };
        this.onShowLog = () => {
            this.setState({ showLog: true });
        };
        this.state = {
            stage: Stage.Scanning,
            progress: 0,
            game: null,
            games: [],
            numItems: 0,
            didImport: false,
            log: "",
            showLog: false,
        };
    }
    componentDidMount() {
        (0,renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_11__/* .dispatchTabPageUpdate */ .pq)(this.props, {
            label: ["preferences.scan_install_locations"],
        });
        (0,renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_25__/* .doAsync */ .R)(async () => {
            let didImport = false;
            const logger = (0,common_logger__WEBPACK_IMPORTED_MODULE_22__/* .recordingLogger */ .CI)(renderer_logger__WEBPACK_IMPORTED_MODULE_13__/* .rendererLogger */ .X);
            try {
                // investigate
                const { numImportedItems } = await (0,renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_9__/* .rcall */ .v)(common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .InstallLocationsScan */ .Ex, { legacyMarketPath: renderer_bridge__WEBPACK_IMPORTED_MODULE_2__/* .paths */ .Hb.legacyMarketPath() }, [
                    (0,common_helpers_bridge__WEBPACK_IMPORTED_MODULE_23__/* .hookLogging */ .mK)(logger),
                    (0,common_helpers_bridge__WEBPACK_IMPORTED_MODULE_23__/* .onNotification */ .kr)(common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .Progress */ .Y7.__method, async ({ progress }) => {
                        this.setState({ progress });
                    }),
                    (0,common_helpers_bridge__WEBPACK_IMPORTED_MODULE_23__/* .onNotification */ .kr)(common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .InstallLocationsScanYield */ .Pq.__method, async ({ game }) => {
                        this.setState((state) => ({
                            game,
                            games: [...state.games, game],
                        }));
                    }),
                    (0,common_helpers_bridge__WEBPACK_IMPORTED_MODULE_23__/* .onRequest */ .rN)(common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .InstallLocationsScanConfirmImport */ .tM.__method, async ({ numItems }) => {
                        this.setState({ stage: Stage.NeedConfirm, numItems });
                        let confirmPromise = new Promise((resolve, reject) => {
                            this.resolve = resolve;
                            this.reject = reject;
                        });
                        try {
                            await confirmPromise;
                            didImport = true;
                            this.setState({ didImport: true });
                            return { confirm: true };
                        }
                        catch (e) {
                            logger.warn(`While importing games: ${e.stack}`);
                        }
                        return { confirm: false };
                    }),
                ]);
                this.setState({ numItems: numImportedItems });
            }
            finally {
                this.setState({ stage: Stage.Done, log: logger.getLog() });
                const { dispatch } = this.props;
                dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.newItemsImported({}));
                if (didImport) {
                    this.onClose();
                }
            }
        });
    }
    render() {
        const { progress, game } = this.state;
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(PageScan, null,
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, null),
            this.renderStatus(),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, null),
            this.renderButtons()));
    }
    renderButtons() {
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_modal_styles__WEBPACK_IMPORTED_MODULE_8__/* .ModalButtons */ .Z, null,
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { label: (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("prompt.action.cancel")), onClick: this.onClose }),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, null),
            this.renderMainButton()));
    }
    renderMainButton() {
        const { stage } = this.state;
        switch (stage) {
            case Stage.Scanning:
                return react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { label: (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("prompt.action.continue")), disabled: true });
            case Stage.NeedConfirm:
                const { numItems } = this.state;
                return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { icon: "plus", label: (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("preferences.scan_install_locations.import_items", { numItems })), onClick: this.onConfirm }));
            case Stage.Done:
                return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { label: (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("prompt.action.close")), onClick: this.onClose }));
        }
        return null;
    }
    renderStatus() {
        const { stage } = this.state;
        switch (stage) {
            case Stage.Scanning:
                return this.renderScanning();
            case Stage.NeedConfirm:
                return this.renderNeedConfirm();
            case Stage.Done:
                return this.renderDone();
        }
    }
    renderScanning() {
        const { progress, game } = this.state;
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(react__WEBPACK_IMPORTED_MODULE_3__.Fragment, null,
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(SectionDiv, null,
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(WideBox, null,
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_pages_PageStyles_boxes__WEBPACK_IMPORTED_MODULE_19__/* .BoxInner */ .BV, null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_pages_common_StandardGameCover__WEBPACK_IMPORTED_MODULE_17__/* ["default"] */ .ZP, { game: game }),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_16__/* .FilterSpacer */ .dz, null),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_pages_common_StandardGameDesc__WEBPACK_IMPORTED_MODULE_18__/* ["default"] */ .Z, { game: game }),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_16__/* .FilterSpacer */ .dz, null)))),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, null),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(SectionDiv, null,
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_7__/* ["default"] */ .Z, { wide: true, progress: progress }),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_16__/* .FilterSpacer */ .dz, null),
                (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("preferences.scan_install_locations.looking_for_games")))));
    }
    renderNeedConfirm() {
        const { games } = this.state;
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(ListDiv, null,
            react__WEBPACK_IMPORTED_MODULE_3__.createElement("p", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("preferences.scan_install_locations.message"))),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(List, null, games.map((g) => (react__WEBPACK_IMPORTED_MODULE_3__.createElement("li", { key: g.id },
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(TinyCover, { game: g, showGifMarker: false }),
                react__WEBPACK_IMPORTED_MODULE_3__.createElement("span", null, g.title))))),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, null)));
    }
    renderDone() {
        const { didImport, numItems, showLog, log } = this.state;
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(ListDiv, null,
            didImport ? (react__WEBPACK_IMPORTED_MODULE_3__.createElement("p", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("preferences.scan_install_locations.items_imported", {
                numImportedItems: numItems,
            })))) : (react__WEBPACK_IMPORTED_MODULE_3__.createElement("p", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("preferences.scan_install_locations.no_items_found")))),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(ListDivSpacer, null),
            showLog ? (react__WEBPACK_IMPORTED_MODULE_3__.createElement(StyledLog, { log: log })) : (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Link__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { label: (0,renderer_t__WEBPACK_IMPORTED_MODULE_21__.T)((0,renderer_t__WEBPACK_IMPORTED_MODULE_21__._)("grid.item.view_details")), onClick: this.onShowLog }))));
    }
    componentWillUnmount() {
        if (this.reject) {
            this.reject(new Error("closed!"));
        }
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_12__/* .withTab */ .D1)((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__/* .hook */ .z)()(ScanInstallLocations)));


/***/ }),

/***/ 7128:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Ni: () => (/* binding */ FilterOptionButton),
/* harmony export */   Zk: () => (/* binding */ FilterOptionIcon),
/* harmony export */   dz: () => (/* binding */ FilterSpacer),
/* harmony export */   e_: () => (/* binding */ FilterGroup),
/* harmony export */   gY: () => (/* binding */ SortsAndFilters),
/* harmony export */   zR: () => (/* binding */ FilterOptionLink)
/* harmony export */ });
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4987);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4198);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5836);



const SortsAndFilters = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP)((0,renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_0__/* .FiltersContainerDiv */ .vN)) `
  display: flex;
  justify-content: center;
  flex-flow: row wrap;
  height: auto;

  padding: 0.4em 0.6em;
  font-weight: normal;
`;
const FilterGroup = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  margin: 0.5em 0;
  display: flex;
  flex-flow: row wrap;
`;
// const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 25%, 1),hsla(355, 43%, 17%, 1))`;
// const activeBg = `linear-gradient(to top, hsla(355, 43%, 50%, 1), hsla(355, 43%, 37%, 1));`;
const inactiveBg = `linear-gradient(to top,hsla(355, 43%, 17%, 1),hsla(355, 43%, 11%, 1))`;
const activeBg = `linear-gradient(to top, hsla(355, 43%, 33%, 1), hsla(355, 43%, 22%, 1));`;
const borderColor = `#843442`;
const borderRadius = `4px`;
const optionButtonLike = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* .css */ .iv) `
  display: flex;
  flex-flow: row;
  align-items: center;

  background: ${inactiveBg};
  padding: 0.5em 1em;
  margin: 0;
  border: 1px solid ${borderColor};
  border-left: none;
  color: ${(props) => props.theme.baseText};
  transition: all 0.4s;

  &:first-child {
    border-radius: ${borderRadius} 0 0 ${borderRadius};
    border-left: 1px solid ${borderColor};
  }

  &:last-child {
    border-radius: 0 ${borderRadius} ${borderRadius} 0;
  }

  &:first-child:last-child {
    border-radius: ${borderRadius};
  }

  &.active {
    background: ${activeBg};
    color: ${(props) => props.theme.baseText};
  }

  &:hover {
    cursor: pointer;
  }
`;
const FilterOptionLink = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.a `
  ${optionButtonLike};

  &.disabled {
    pointer-events: none;
    opacity: 0.4;
  }
`;
const FilterOptionButton = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  ${optionButtonLike};
`;
const FilterOptionIcon = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP)((0,renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .Z)) `
  margin-right: 0.5em;
  font-size: 80%;

  opacity: 1;
  &.inactive {
    opacity: 0.2;
  }
`;
const FilterSpacer = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  width: 24px;
  flex-shrink: 0;
`;


/***/ }),

/***/ 5231:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(9471);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4333);
/* harmony import */ var renderer_basics_PlatformIcons__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(3043);
/* harmony import */ var renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(465);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(9080);






const StandardGameDesc = ({ game, children, }) => {
    if (!game) {
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_3__/* .TitleBox */ .kS, null,
            react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_3__/* .Title */ .Dx, null)));
    }
    return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_3__/* .TitleBox */ .kS, null,
        react__WEBPACK_IMPORTED_MODULE_0__.createElement("a", { href: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_5__/* .urlForGame */ .OH)(game.id), className: "gamedesc--titlelink" },
            react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_pages_PageStyles_games__WEBPACK_IMPORTED_MODULE_3__/* .Title */ .Dx, null,
                react__WEBPACK_IMPORTED_MODULE_0__.createElement("div", { className: "gamedesc--title" }, game.title),
                children)),
        react__WEBPACK_IMPORTED_MODULE_0__.createElement("div", null, game.shortText),
        react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .Z, null),
        react__WEBPACK_IMPORTED_MODULE_0__.createElement("div", null,
            renderClassification(game.classification),
            react__WEBPACK_IMPORTED_MODULE_0__.createElement(renderer_basics_PlatformIcons__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { target: game, before: () => react__WEBPACK_IMPORTED_MODULE_0__.createElement(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, "\u00A0\u00A0") }))));
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (StandardGameDesc);
function renderClassification(classification) {
    let label = [`usage_stats.description.${classification}`];
    return react__WEBPACK_IMPORTED_MODULE_0__.createElement(react__WEBPACK_IMPORTED_MODULE_0__.Fragment, null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_4__.T)(label));
}


/***/ }),

/***/ 49:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Ji: () => (/* binding */ FormattedDate),
  BK: () => (/* binding */ FormattedNumber),
  qN: () => (/* binding */ FormattedTime)
});

// UNUSED EXPORTS: FormattedDateParts, FormattedDateTimeRange, FormattedDisplayName, FormattedList, FormattedMessage, FormattedNumberParts, FormattedPlural, FormattedRelativeTime, FormattedTimeParts, IntlContext, IntlProvider, InvalidConfigError, MessageFormatError, MissingDataError, MissingTranslationError, RawIntlProvider, ReactIntlError, ReactIntlErrorCode, UnsupportedFormatterError, createIntl, createIntlCache, defineMessage, defineMessages, injectIntl, useIntl

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/utils.js
var utils = __webpack_require__(680);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
;// CONCATENATED MODULE: ./node_modules/react-intl/lib/src/components/createFormattedComponent.js




var DisplayName;
(function (DisplayName) {
    DisplayName["formatDate"] = "FormattedDate";
    DisplayName["formatTime"] = "FormattedTime";
    DisplayName["formatNumber"] = "FormattedNumber";
    DisplayName["formatList"] = "FormattedList";
    // Note that this DisplayName is the locale display name, not to be confused with
    // the name of the enum, which is for React component display name in dev tools.
    DisplayName["formatDisplayName"] = "FormattedDisplayName";
})(DisplayName || (DisplayName = {}));
var DisplayNameParts;
(function (DisplayNameParts) {
    DisplayNameParts["formatDate"] = "FormattedDateParts";
    DisplayNameParts["formatTime"] = "FormattedTimeParts";
    DisplayNameParts["formatNumber"] = "FormattedNumberParts";
    DisplayNameParts["formatList"] = "FormattedListParts";
})(DisplayNameParts || (DisplayNameParts = {}));
var FormattedNumberParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
    (0,utils/* invariantIntlContext */.lq)(intl);
    var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
    return children(intl.formatNumberToParts(value, formatProps));
})); };
FormattedNumberParts.displayName = 'FormattedNumberParts';
function createFormattedDateTimePartsComponent(name) {
    var ComponentParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        var date = typeof value === 'string' ? new Date(value || 0) : value;
        var formattedParts = name === 'formatDate'
            ? intl.formatDateToParts(date, formatProps)
            : intl.formatTimeToParts(date, formatProps);
        return children(formattedParts);
    })); };
    ComponentParts.displayName = DisplayNameParts[name];
    return ComponentParts;
}
function createFormattedComponent(name) {
    var Component = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        // TODO: fix TS type definition for localeMatcher upstream
        var formattedValue = intl[name](value, formatProps);
        if (typeof children === 'function') {
            return children(formattedValue);
        }
        var Text = intl.textComponent || react.Fragment;
        return react.createElement(Text, null, formattedValue);
    })); };
    Component.displayName = DisplayName[name];
    return Component;
}

;// CONCATENATED MODULE: ./node_modules/react-intl/lib/index.js


function defineMessages(msgs) {
    return msgs;
}
function defineMessage(msg) {
    return msg;
}



// IMPORTANT: Explicit here to prevent api-extractor from outputing `import('./src/types').CustomFormatConfig`
var FormattedDate = createFormattedComponent('formatDate');
var FormattedTime = createFormattedComponent('formatTime');
var FormattedNumber = createFormattedComponent('formatNumber');
var FormattedList = createFormattedComponent('formatList');
var FormattedDisplayName = createFormattedComponent('formatDisplayName');
var FormattedDateParts = createFormattedDateTimePartsComponent('formatDate');
var FormattedTimeParts = createFormattedDateTimePartsComponent('formatTime');







/***/ })

}]);
//# sourceMappingURL=551.chunk.js.map