"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[581],{

/***/ 2325:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CH: () => (/* binding */ getCaveSummary)
/* harmony export */ });
/* unused harmony exports hookProgress, hookLogging, getErrorMessage */
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4713);

function hookProgress(convo, ctx) {
    convo.onNotification(messages.Progress, (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages.Log, async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}


/***/ }),

/***/ 105:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__),
/* harmony export */   z: () => (/* binding */ hasPlatforms)
/* harmony export */ });
const data = {
    windows: { icon: "windows8", platform: "windows", emoji: "🏁" },
    linux: { icon: "tux", platform: "linux", emoji: "🐧" },
    osx: { icon: "apple", platform: "osx", emoji: "🍎" },
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (data);
function hasPlatforms(target) {
    for (const key of Object.keys(data)) {
        if (target.platforms[key]) {
            return true;
        }
    }
    if (target.type === "html") {
        return true;
    }
    return false;
}


/***/ }),

/***/ 5379:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   j: () => (/* binding */ fileSize)
/* harmony export */ });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ 5346:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   $O: () => (/* binding */ formatUploadTitle),
/* harmony export */   A6: () => (/* binding */ formatBuildVersionInfo),
/* harmony export */   Pn: () => (/* binding */ formatUploadTitleFancy)
/* harmony export */ });
function formatUploadTitle(u) {
    return u ? u.displayName || u.filename : "?";
}
function clean(s) {
    return s
        .replace(/\.[a-zA-Z0-9]+$/, "")
        .replace(/[_-]/g, " ")
        .replace(/\s+/, " ");
}
function formatUploadTitleFancy(u) {
    if (u.displayName) {
        return u.displayName;
    }
    if (u.filename) {
        return clean(u.filename);
    }
    return "?";
}
function formatBuildVersionInfo(b) {
    if (!b) {
        return null;
    }
    if (b.userVersion) {
        return `v${b.userVersion}`;
    }
    return `#${b.version}`;
}


/***/ }),

/***/ 1829:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  x: () => (/* binding */ actionForGame)
});

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
;// CONCATENATED MODULE: ./src/common/constants/classification-actions.ts

const classificationActions = {
    [messages/* GameClassification */.Ai.Game]: "launch",
    [messages/* GameClassification */.Ai.Tool]: "launch",
    [messages/* GameClassification */.Ai.Assets]: "open",
    [messages/* GameClassification */.Ai.GameMod]: "open",
    [messages/* GameClassification */.Ai.PhysicalGame]: "open",
    [messages/* GameClassification */.Ai.Soundtrack]: "open",
    [messages/* GameClassification */.Ai.Other]: "open",
    [messages/* GameClassification */.Ai.Comic]: "open",
    [messages/* GameClassification */.Ai.Book]: "open",
};

;// CONCATENATED MODULE: ./src/common/util/action-for-game.ts

/**
 * Returns whether a game can be "launched" or "opened", where "launching" means
 * starting an executable, serving a web game, etc., and "opening" means showing files
 * in a file explorer.
 */
function actionForGame(game, cave) {
    // FIXME: we're not using the cave at all here - we probably should.
    return classificationActions[game.classification] || "launch";
}


/***/ }),

/***/ 3537:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (/* binding */ Floater)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5836);



const floaterKeyframes = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* .keyframes */ .F4) `
  0% {
    transform: scale(0);
    opacity: .6;
  }

  100% {
    transform: scale(1);
    opacity: 1;
  }
`;
const numDrops = 3;
const duration = 0.5;
const offset = duration / numDrops;
const FloaterDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP.div `
  width: 30px;
  height: 10px;

  display: flex;
  flex-flow: row;
  align-items: center;
  justify-content: center;

  div {
    width: 8px;
    height: 6px;
    margin: 0 2px;
    border-radius: 50%;
    background: white;
    animation: ${floaterKeyframes} ${duration}s infinite ease-in-out alternate;
  }

  &.tiny {
    width: 20px;
    height: 8px;

    div {
      width: 6px;
      height: 3px;
    }
  }

  div:nth-child(1) {
    animation-delay: -${offset * 2}s;
  }

  div:nth-child(2) {
    animation-delay: -${offset * 1}s;
  }
`;
function Floater(props) {
    const { tiny } = props;
    return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(FloaterDiv, { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ tiny }) },
        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null),
        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null),
        react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null)));
}


/***/ }),

/***/ 2629:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1061);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4012);



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, Object.assign({}, (0,common_format_datetime__WEBPACK_IMPORTED_MODULE_0__/* .formatDurationAsMessage */ .Lb)(secs)))));


/***/ }),

/***/ 2985:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(8923);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(9080);





class LastPlayed extends react__WEBPACK_IMPORTED_MODULE_2__.PureComponent {
    render() {
        const { game, cave, short = false, className } = this.props;
        const { lastTouchedAt = null } = cave || {};
        const classification = game.classification || "game";
        const classAction = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__/* .actionForGame */ .x)(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        return (react__WEBPACK_IMPORTED_MODULE_2__.createElement("div", { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()("last-playthrough", className) }, lastTouchedAt ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement("label", null, short ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { date: lastTouchedAt })) : ((0,renderer_t__WEBPACK_IMPORTED_MODULE_4__.T)([
            `usage_stats.last_${xed}_time_ago`,
            {
                time_ago: react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { date: lastTouchedAt }),
            },
        ])))) : ((0,renderer_t__WEBPACK_IMPORTED_MODULE_4__.T)([`usage_stats.never_${xed}`]))));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (LastPlayed);


/***/ }),

/***/ 6055:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(9080);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2629);




class TotalPlaytime extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
    render() {
        const { game, cave, short = false } = this.props;
        let { secondsRun = 0 } = (cave || {});
        const classification = game.classification || "game";
        const classAction = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__/* .actionForGame */ .x)(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        if (secondsRun > 0 && classAction === "launch") {
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null,
                short ? null : (react__WEBPACK_IMPORTED_MODULE_1__.createElement("label", null,
                    (0,renderer_t__WEBPACK_IMPORTED_MODULE_2__.T)([`usage_stats.has_${xed}_for_duration`]),
                    " ")),
                react__WEBPACK_IMPORTED_MODULE_1__.createElement("span", { className: "total-playtime" },
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { secs: secondsRun }))));
        }
        return null;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (TotalPlaytime);


/***/ }),

/***/ 326:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ basics_UploadIcon)
});

// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__(5379);
// EXTERNAL MODULE: ./src/common/constants/platform-data.ts
var platform_data = __webpack_require__(105);
// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
;// CONCATENATED MODULE: ./src/main/reactors/make-upload-button.ts



function makeUploadButton(upload, opts = { showSize: true }) {
    let label = `${upload.displayName || upload.filename}`;
    let tags = [];
    if (upload.size > 0 && opts.showSize) {
        tags.push({
            label: `${fileSize(upload.size)}`,
        });
    }
    if (upload.demo) {
        tags.push({
            label: ["pick_update_upload.tags.demo"],
        });
    }
    for (const prop of Object.keys(platformData)) {
        if (upload[prop]) {
            tags.push({
                icon: platformData[prop].icon,
            });
        }
    }
    const timeAgo = {
        date: upload.updatedAt,
    };
    const icon = uploadIcon(upload) || "download";
    return { label, tags, icon, timeAgo };
}
const uploadIcons = {
    [messages/* UploadType */.AJ.Default]: "gamepad",
    [messages/* UploadType */.AJ.Flash]: "neutral",
    [messages/* UploadType */.AJ.Unity]: "neutral",
    [messages/* UploadType */.AJ.Java]: "neutral",
    [messages/* UploadType */.AJ.HTML]: "html5",
    [messages/* UploadType */.AJ.Soundtrack]: "music",
    [messages/* UploadType */.AJ.Book]: "book",
    [messages/* UploadType */.AJ.Video]: "video",
    [messages/* UploadType */.AJ.Documentation]: "book",
    [messages/* UploadType */.AJ.Mod]: "shirt",
    [messages/* UploadType */.AJ.AudioAssets]: "file-music",
    [messages/* UploadType */.AJ.GraphicalAssets]: "images",
    [messages/* UploadType */.AJ.Sourcecode]: "code",
    [messages/* UploadType */.AJ.Other]: "zip",
};
function uploadIcon(upload) {
    return uploadIcons[upload.type];
}
// TODO: i18n that stuff
const uploadTypeHints = {
    [messages/* UploadType */.AJ.Default]: "File",
    [messages/* UploadType */.AJ.Flash]: "Flash embed",
    [messages/* UploadType */.AJ.Unity]: "Unity embed (legacy)",
    [messages/* UploadType */.AJ.Java]: "Java applet",
    [messages/* UploadType */.AJ.HTML]: "HTML5 app",
    [messages/* UploadType */.AJ.Soundtrack]: "Soundtrack",
    [messages/* UploadType */.AJ.Book]: "Book",
    [messages/* UploadType */.AJ.Video]: "Video",
    [messages/* UploadType */.AJ.Documentation]: "Documentation",
    [messages/* UploadType */.AJ.Mod]: "Mod",
    [messages/* UploadType */.AJ.AudioAssets]: "Audio assets",
    [messages/* UploadType */.AJ.GraphicalAssets]: "Graphical assets",
    [messages/* UploadType */.AJ.Sourcecode]: "Source code",
    [messages/* UploadType */.AJ.Other]: "Other",
};
function uploadTypeHint(upload) {
    return uploadTypeHints[upload.type];
}

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
;// CONCATENATED MODULE: ./src/renderer/basics/UploadIcon.tsx



class UploadIcon extends react.PureComponent {
    render() {
        const { upload } = this.props;
        if (!upload) {
            return null;
        }
        return react.createElement(Icon/* default */.Z, { icon: uploadIcon(upload), hint: uploadTypeHint(upload) });
    }
}
/* harmony default export */ const basics_UploadIcon = (UploadIcon);


/***/ }),

/***/ 4581:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5379);
/* harmony import */ var common_format_upload__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(5346);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(9471);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6025);
/* harmony import */ var renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(4333);
/* harmony import */ var renderer_basics_LastPlayed__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2985);
/* harmony import */ var renderer_basics_TotalPlaytime__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6055);
/* harmony import */ var renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(326);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2263);
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(5871);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(9080);
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(9050);
/* harmony import */ var renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(3537);
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(2325);

















const CaveItemList = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  margin: 8px 0;
`;
const CaveItem = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  margin: 12px 4px;
  padding: 4px;
  border: 1px solid rgba(255, 255, 255, 0.1);
  background: ${(props) => props.theme.itemBackground};
  border-radius: 2px;

  display: flex;
  flex-direction: row;
  align-items: center;
`;
const CaveDetails = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  display: flex;
  flex-direction: column;
`;
const CaveDetailsRow = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  padding: 6px 0;

  display: flex;
  flex-direction: row;
  align-items: center;

  .platform-icons {
    margin-left: 8px;
  }

  &.smaller {
    font-size: 90%;
  }
`;
const Spacer = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  height: 1px;
  width: 8px;
`;
const CaveItemActions = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  display: flex;
  flex-direction: row;
  margin-right: 8px;
`;
const Title = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  margin-left: 8px;
  font-weight: bold;

  display: flex;
  flex-direction: row;
  align-items: center;
`;
const FileSize = renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP.div `
  color: ${(props) => props.theme.secondaryText};
  margin-left: 8px;
`;
const ManageGameDiv = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .ZP)((0,renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_9__/* .ModalWidgetDiv */ .U)) `
  min-width: 600px;
  min-height: 300px;
`;
class ManageGame extends react__WEBPACK_IMPORTED_MODULE_2__.PureComponent {
    constructor() {
        super(...arguments);
        this.onInstall = (ev) => {
            const uploadId = parseInt(ev.currentTarget.dataset.uploadId, 10);
            const params = this.props.modal.widgetParams;
            const { game } = params;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_15__/* .ambientWind */ .w)(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.queueGameInstall({ game, uploadId }),
            }));
        };
        this.onManage = (ev) => {
            const caveId = ev.currentTarget.dataset.caveId;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_15__/* .ambientWind */ .w)(),
                action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.manageCave({ caveId }),
            }));
        };
    }
    render() {
        const params = this.props.modal.widgetParams;
        const { game, caves, allUploads, loadingUploads } = params;
        const installedUploadIds = {};
        (0,underscore__WEBPACK_IMPORTED_MODULE_12__/* .each */ .S6)(caves, (cave) => {
            if (cave.upload) {
                installedUploadIds[cave.upload.id] = true;
            }
        });
        const uninstalledUploads = (0,underscore__WEBPACK_IMPORTED_MODULE_12__/* .filter */ .hX)(allUploads, (u) => !installedUploadIds[u.id]);
        return (react__WEBPACK_IMPORTED_MODULE_2__.createElement(ManageGameDiv, null,
            (0,underscore__WEBPACK_IMPORTED_MODULE_12__/* .size */ .dp)(caves) > 0 ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(react__WEBPACK_IMPORTED_MODULE_2__.Fragment, null,
                react__WEBPACK_IMPORTED_MODULE_2__.createElement("p", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_11__.T)(["prompt.manage_game.installed_uploads"])),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveItemList, null, (0,underscore__WEBPACK_IMPORTED_MODULE_12__/* .map */ .UI)(caves, (cave, i) => {
                    const u = cave.upload;
                    const caveSummary = (0,common_butlerd_utils__WEBPACK_IMPORTED_MODULE_14__/* .getCaveSummary */ .CH)(cave);
                    return (react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveItem, { key: cave.id },
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveDetails, null,
                            react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveDetailsRow, null,
                                react__WEBPACK_IMPORTED_MODULE_2__.createElement(Title, null, formatUpload(u))),
                            react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveDetailsRow, { className: "smaller" },
                                cave.installInfo.installedSize ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(FileSize, null, (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_1__/* .fileSize */ .j)(cave.installInfo.installedSize))) : null,
                                react__WEBPACK_IMPORTED_MODULE_2__.createElement(Spacer, null),
                                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_LastPlayed__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, { game: game, cave: caveSummary }),
                                react__WEBPACK_IMPORTED_MODULE_2__.createElement(Spacer, null),
                                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_TotalPlaytime__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { game: game, cave: caveSummary }))),
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, null),
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveItemActions, null,
                            react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "manage-cave", "data-cave-id": cave.id, icon: "cog", primary: true, onClick: this.onManage }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_11__.T)(["grid.item.manage"])))));
                })))) : null,
            uninstalledUploads.length > 0 ? ((0,underscore__WEBPACK_IMPORTED_MODULE_12__/* .size */ .dp)(caves) > 0 ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement("p", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_11__.T)(["prompt.manage_game.available_uploads"]))) : null) : (react__WEBPACK_IMPORTED_MODULE_2__.createElement(react__WEBPACK_IMPORTED_MODULE_2__.Fragment, null,
                " ",
                loadingUploads ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Floater__WEBPACK_IMPORTED_MODULE_13__/* ["default"] */ .Z, null)) : (react__WEBPACK_IMPORTED_MODULE_2__.createElement("p", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_11__.T)(["prompt.manage_game.no_other_uploads"]))))),
            uninstalledUploads.length > 0 ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveItemList, null, (0,underscore__WEBPACK_IMPORTED_MODULE_12__/* .map */ .UI)(uninstalledUploads, (u) => {
                return (react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveItem, { key: u.id },
                    react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveDetails, null,
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveDetailsRow, null,
                            react__WEBPACK_IMPORTED_MODULE_2__.createElement(Title, null, formatUpload(u))),
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveDetailsRow, { className: "smaller" }, u.size > 0 ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(FileSize, null, (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_1__/* .fileSize */ .j)(u.size))) : null)),
                    react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Filler__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, null),
                    react__WEBPACK_IMPORTED_MODULE_2__.createElement(CaveItemActions, null,
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { "data-upload-id": u.id, icon: "install", primary: true, onClick: this.onInstall }, (0,renderer_t__WEBPACK_IMPORTED_MODULE_11__.T)(["grid.item.install"])))));
            }))) : null));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_8__/* .hook */ .z)()(ManageGame));
function formatUpload(upload) {
    return (react__WEBPACK_IMPORTED_MODULE_2__.createElement(react__WEBPACK_IMPORTED_MODULE_2__.Fragment, null,
        react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_UploadIcon__WEBPACK_IMPORTED_MODULE_7__/* ["default"] */ .Z, { upload: upload }),
        react__WEBPACK_IMPORTED_MODULE_2__.createElement(Spacer, null),
        (0,common_format_upload__WEBPACK_IMPORTED_MODULE_16__/* .formatUploadTitle */ .$O)(upload)));
}


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=581.chunk.js.map