"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[63],{

/***/ 7871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (__webpack_require__.p + "c143903d0c758898b2428036ce9061e6.svg");

/***/ }),

/***/ 2325:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CH: () => (/* binding */ getCaveSummary)
/* harmony export */ });
/* unused harmony exports hookProgress, hookLogging, getErrorMessage */
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4713);

function hookProgress(convo, ctx) {
    convo.onNotification(messages.Progress, (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages.Log, async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}


/***/ }),

/***/ 5379:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   j: () => (/* binding */ fileSize)
/* harmony export */ });
// ported from https://github.com/dustin/go-humanize
// Si vis pacem, para bellum
const sizes = ["B", "KiB", "MiB", "GiB", "TiB", "PiB", "EiB"];
const base = 1024;
const logE1024 = Math.log(base);
function fileSize(s) {
    if (s < 10) {
        return `${s} B`;
    }
    const e = Math.floor(Math.log(s) / logE1024);
    const suffix = sizes[Math.trunc(e)];
    const val = Math.floor((s / Math.pow(base, e)) * 10 + 0.5) / 10;
    if (val < 10) {
        return `${val.toFixed(1)} ${suffix}`;
    }
    else {
        return `${val.toFixed(0)} ${suffix}`;
    }
}


/***/ }),

/***/ 5414:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   DY: () => (/* binding */ formatReason),
/* harmony export */   bU: () => (/* binding */ formatTask),
/* harmony export */   de: () => (/* binding */ formatOperation),
/* harmony export */   vm: () => (/* binding */ formatOutcome),
/* harmony export */   yt: () => (/* binding */ taskIcon)
/* harmony export */ });
/* harmony import */ var common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(945);

function formatOperation(op) {
    if (op.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_0__/* .OperationType */ .C8.Task) {
        return formatTask(op.name, op.stage);
    }
    else if (op.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_0__/* .OperationType */ .C8.Download) {
        return ["grid.item.downloading"];
    }
    else {
        return null;
    }
}
function taskIcon(name) {
    if (name === "launch") {
        return "stop";
    }
    else if (name === "uninstall") {
        return "uninstall";
    }
    else {
        return "install";
    }
}
function formatTask(name, stage) {
    if (name === "launch") {
        switch (stage) {
            case "prepare":
                return ["grid.item.running.prepare"];
            case "clean":
                return ["grid.item.running.clean"];
        }
        return ["grid.item.running"];
    }
    else if (name === "uninstall") {
        return ["grid.item.uninstalling"];
    }
    else {
        return ["grid.item.installing"];
    }
}
function formatReason(reason) {
    switch (reason) {
        case "install":
            return ["download.reason.install"];
        case "update":
            return ["download.reason.update"];
        case "reinstall":
            return ["download.reason.reinstall"];
        default:
            return null;
    }
}
function formatOutcome(reason) {
    switch (reason) {
        case "install":
            return ["download.outcome.installed"];
        case "update":
            return ["download.outcome.updated"];
        case "reinstall":
            return ["download.outcome.reinstalled"];
        default:
            return null;
    }
}


/***/ }),

/***/ 945:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Nv: () => (/* binding */ Access),
  C8: () => (/* binding */ OperationType),
  ZP: () => (/* binding */ get_game_status)
});

// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
;// CONCATENATED MODULE: ./src/common/helpers/get-by-ids.ts

const emptyArr = [];
function getByIds(records, ids) {
    if ((0,index_all/* size */.dp)(ids) === 0) {
        return emptyArr;
    }
    if (!records) {
        return emptyArr;
    }
    const result = [];
    for (const id of ids) {
        const record = records[id];
        if (record) {
            result.push(record);
        }
    }
    return result;
}
/* harmony default export */ const get_by_ids = (getByIds);

// EXTERNAL MODULE: ./src/main/reactors/downloads/getters.ts
var getters = __webpack_require__(9027);
// EXTERNAL MODULE: ./src/common/util/lru-memoize.ts
var lru_memoize = __webpack_require__(2476);
;// CONCATENATED MODULE: ./src/common/helpers/get-game-status.ts




/**
 * What type of access we have to the game - do we own it,
 * have we created it, have we bought it, etc.
 */
var Access;
(function (Access) {
    /**
     * Game cannot be bought
     */
    Access[Access["Free"] = 0] = "Free";
    /**
     * Game is pay-what-you-want
     */
    Access[Access["Pwyw"] = 1] = "Pwyw";
    /**
     * Game has a demo that can be downloaded for free
     */
    Access[Access["Demo"] = 2] = "Demo";
    /**
     * Game is in press system and so are we
     */
    Access[Access["Press"] = 3] = "Press";
    /**
     * We have a download key for the game
     */
    Access[Access["Key"] = 4] = "Key";
    /**
     * We have edit rights on the game page
     */
    Access[Access["Edit"] = 5] = "Edit";
    /**
     * We have no access to the game whatsoever
     */
    Access[Access["None"] = 6] = "None";
})(Access || (Access = {}));
var OperationType;
(function (OperationType) {
    /** The current operation is a download */
    OperationType[OperationType["Download"] = 0] = "Download";
    /** The current operation is a task */
    OperationType[OperationType["Task"] = 1] = "Task";
})(OperationType || (OperationType = {}));
function getGameStatus(rs, game, caveId) {
    const { commons, tasks, downloads } = rs;
    const { profile } = rs.profile;
    let downloadKeys = get_by_ids(commons.downloadKeys, commons.downloadKeyIdsByGameId[game.id]);
    let cave;
    let numCaves = 0;
    if (!cave) {
        if (caveId) {
            cave = commons.caves[caveId];
        }
        else {
            let caves = get_by_ids(commons.caves, commons.caveIdsByGameId[game.id]);
            numCaves = (0,index_all/* size */.dp)(caves);
            cave = (0,index_all/* first */.Ps)(caves);
        }
    }
    const downloadKey = (0,index_all/* first */.Ps)(downloadKeys);
    const pressUser = profile.user.pressUser;
    const task = (0,index_all/* first */.Ps)(tasks.tasksByGameId[game.id]);
    const pendingDownloads = (0,getters/* getPendingForGame */.qh)(downloads, game.id);
    let download;
    if (caveId) {
        download = (0,index_all/* findWhere */._e)(pendingDownloads, { caveId });
    }
    else {
        download = (0,index_all/* first */.Ps)(pendingDownloads);
    }
    let isActiveDownload = false;
    let areDownloadsPaused = false;
    let downloadProgress;
    if (download) {
        const activeDownload = (0,getters/* getActiveDownload */.tp)(downloads);
        isActiveDownload = download.id === activeDownload.id;
        areDownloadsPaused = downloads.paused;
        downloadProgress = downloads.progresses[download.id];
    }
    let update;
    if (cave) {
        update = rs.gameUpdates.updates[cave.id];
    }
    const profileId = profile.id;
    return realGetGameStatus(game, cave, numCaves, downloadKey, pressUser, task, download, downloadProgress, update, isActiveDownload, areDownloadsPaused, profileId);
}
/* harmony default export */ const get_game_status = (getGameStatus);
function rawGetGameStatus(game, cave, numCaves, downloadKey, pressUser, task, download, downloadProgress, update, isDownloadActive, areDownloadsPaused, profileId) {
    let access = Access.None;
    if (game.userId == profileId) {
        access = Access.Edit;
    }
    else {
        const hasPrice = game.minPrice > 0;
        if (!hasPrice) {
            if (game.canBeBought) {
                access = Access.Pwyw;
            }
            else {
                access = Access.Free;
            }
        }
        else {
            // game has minimum price
            if (downloadKey) {
                // we have download keys
                access = Access.Key;
            }
            else {
                // we have no download keys
                if (game.inPressSystem && pressUser) {
                    access = Access.Press;
                }
                else {
                    // we have.. nothing
                }
            }
        }
    }
    let operation = null;
    if (task) {
        operation = {
            type: OperationType.Task,
            name: task.name,
            active: true,
            paused: false,
            progress: task.progress,
            eta: task.eta,
            bps: task.bps,
        };
    }
    else if (download) {
        let p = downloadProgress || {
            progress: null,
            eta: null,
            bps: null,
            stage: null,
        };
        operation = {
            type: OperationType.Download,
            id: download.id,
            reason: download.reason,
            active: isDownloadActive,
            paused: areDownloadsPaused,
            progress: p.progress,
            eta: p.eta,
            bps: p.bps,
            stage: p.stage,
        };
    }
    return {
        cave,
        numCaves,
        downloadKey,
        access,
        operation,
        update,
    };
}
const realGetGameStatus = (0,lru_memoize/* memoize */.H)(300, rawGetGameStatus);


/***/ }),

/***/ 1829:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  x: () => (/* binding */ actionForGame)
});

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
;// CONCATENATED MODULE: ./src/common/constants/classification-actions.ts

const classificationActions = {
    [messages/* GameClassification */.Ai.Game]: "launch",
    [messages/* GameClassification */.Ai.Tool]: "launch",
    [messages/* GameClassification */.Ai.Assets]: "open",
    [messages/* GameClassification */.Ai.GameMod]: "open",
    [messages/* GameClassification */.Ai.PhysicalGame]: "open",
    [messages/* GameClassification */.Ai.Soundtrack]: "open",
    [messages/* GameClassification */.Ai.Other]: "open",
    [messages/* GameClassification */.Ai.Comic]: "open",
    [messages/* GameClassification */.Ai.Book]: "open",
};

;// CONCATENATED MODULE: ./src/common/util/action-for-game.ts

/**
 * Returns whether a game can be "launched" or "opened", where "launching" means
 * starting an executable, serving a web game, etc., and "opening" means showing files
 * in a file explorer.
 */
function actionForGame(game, cave) {
    // FIXME: we're not using the cave at all here - we probably should.
    return classificationActions[game.classification] || "launch";
}


/***/ }),

/***/ 9027:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   g2: () => (/* binding */ getPendingDownloads),
/* harmony export */   po: () => (/* binding */ getFinishedDownloads),
/* harmony export */   qh: () => (/* binding */ getPendingForGame),
/* harmony export */   tp: () => (/* binding */ getActiveDownload)
/* harmony export */ });
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(9050);
/* harmony import */ var common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2476);


const getActiveDownload = (0,common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__/* .memoize */ .H)(1, function (downloads) {
    return (0,underscore__WEBPACK_IMPORTED_MODULE_0__/* .first */ .Ps)(getPendingDownloads(downloads));
});
const getPendingDownloads = (0,common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__/* .memoize */ .H)(1, function (downloads) {
    const pending = (0,underscore__WEBPACK_IMPORTED_MODULE_0__/* .filter */ .hX)(downloads.items, (i) => !i.finishedAt);
    return (0,underscore__WEBPACK_IMPORTED_MODULE_0__/* .sortBy */ .MR)(pending, "position");
});
const getFinishedDownloads = (0,common_util_lru_memoize__WEBPACK_IMPORTED_MODULE_1__/* .memoize */ .H)(1, function (downloads) {
    const pending = (0,underscore__WEBPACK_IMPORTED_MODULE_0__/* .filter */ .hX)(downloads.items, (i) => !!i.finishedAt);
    return (0,underscore__WEBPACK_IMPORTED_MODULE_0__/* .sortBy */ .MR)(pending, "finishedAt").reverse();
});
function getPendingForGame(downloads, gameId) {
    return (0,underscore__WEBPACK_IMPORTED_MODULE_0__/* .filter */ .hX)(getPendingDownloads(downloads), (i) => i.game && +i.game.id === +gameId);
}


/***/ }),

/***/ 830:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (/* binding */ DownloadProgressSpan)
/* harmony export */ });
/* harmony import */ var common_format_filesize__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5379);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2629);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(9080);




function DownloadProgressSpan({ bps, eta, downloadsPaused, onlyBPS, onlyETA, }) {
    if (downloadsPaused) {
        return react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_3__.T)(["grid.item.downloads_paused"]));
    }
    if (onlyBPS) {
        return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
            (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_0__/* .fileSize */ .j)(bps),
            "/s"));
    }
    if (onlyETA) {
        return react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { secs: eta });
    }
    const hasBPS = bps > 0;
    const hasETA = eta > 0;
    return (react__WEBPACK_IMPORTED_MODULE_1__.createElement("span", null,
        hasBPS ? (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react__WEBPACK_IMPORTED_MODULE_1__.Fragment, null,
            (0,common_format_filesize__WEBPACK_IMPORTED_MODULE_0__/* .fileSize */ .j)(bps),
            "/s")) : null,
        hasBPS && hasETA ? " — " : null,
        hasETA ? react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, { secs: eta }) : null));
}


/***/ }),

/***/ 2629:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1061);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var react_intl__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4012);



/**
 * Renders a human-friendly (and localized) duration
 */
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (({ secs }) => (react__WEBPACK_IMPORTED_MODULE_1__.createElement(react_intl__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z, Object.assign({}, (0,common_format_datetime__WEBPACK_IMPORTED_MODULE_0__/* .formatDurationAsMessage */ .Lb)(secs)))));


/***/ }),

/***/ 2985:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(8923);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(9080);





class LastPlayed extends react__WEBPACK_IMPORTED_MODULE_2__.PureComponent {
    render() {
        const { game, cave, short = false, className } = this.props;
        const { lastTouchedAt = null } = cave || {};
        const classification = game.classification || "game";
        const classAction = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_1__/* .actionForGame */ .x)(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        return (react__WEBPACK_IMPORTED_MODULE_2__.createElement("div", { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()("last-playthrough", className) }, lastTouchedAt ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement("label", null, short ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { date: lastTouchedAt })) : ((0,renderer_t__WEBPACK_IMPORTED_MODULE_4__.T)([
            `usage_stats.last_${xed}_time_ago`,
            {
                time_ago: react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_TimeAgo__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { date: lastTouchedAt }),
            },
        ])))) : ((0,renderer_t__WEBPACK_IMPORTED_MODULE_4__.T)([`usage_stats.never_${xed}`]))));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (LastPlayed);


/***/ }),

/***/ 4844:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ basics_TitleBar)
});

// UNUSED EXPORTS: titleBarHeight

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/renderer/env.ts
var env = __webpack_require__(1113);
// EXTERNAL MODULE: ./src/common/helpers/space.ts
var space = __webpack_require__(2001);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
;// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/NewVersionAvailable.tsx






const Container = styles/* default */.ZP.div `
  align-self: stretch;
  font-weight: bold;
  padding: 0 0.5em;
  margin-right: 1em;

  display: flex;
  flex-direction: row;
  align-items: center;
  border-radius: 2px;

  &:hover {
    background: ${(props) => props.theme.baseBackground};
    cursor: pointer;
  }
`;
const Spacer = styles/* default */.ZP.div `
  height: 1px;
  width: 0.4em;
`;
class NewVersionAvailable extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.relaunchRequest({}));
        };
    }
    render() {
        const { available } = this.props;
        if (!available) {
            return null;
        }
        return (react.createElement(Container, { onClick: this.onClick },
            react.createElement(Icon/* default */.Z, { icon: "install" }),
            react.createElement(Spacer, null),
            (0,t.T)(["prompt.self_update_ready.short"])));
    }
}
/* harmony default export */ const TitleBar_NewVersionAvailable = ((0,hook/* hook */.z)((map) => ({
    available: map((rs) => {
        const pkg = rs.broth.packages[rs.system.appName];
        return pkg && pkg.stage === "need-restart";
    }),
}))(NewVersionAvailable));

// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/util/get-user-cover-url.ts
var get_user_cover_url = __webpack_require__(3720);
;// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/UserMenu.tsx







const UserMenuDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;

  padding: 8px;
  margin-right: 8px;

  transition: background 0.2s;
  &:hover {
    background: rgba(0, 0, 0, 0.2);
    cursor: pointer;
  }

  animation: ${styles/* animations */.sF.enterTop} 0.2s;

  .icon {
    margin: 0;
    transition: all 0.2s;
  }

  img {
    height: 24px;
    width: 24px;
    margin-right: 8px;
    border-radius: 2px;
    flex-shrink: 0;
  }

  span {
    flex-shrink: 1;
    ${styles/* singleLine */.U1};
  }
`;
class UserMenu extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.openMenu = (e) => {
            if (e.button === 0) {
                const { dispatch } = this.props;
                dispatch(actions/* actions */.N.openUserMenu({
                    wind: (0,navigation/* ambientWind */.w)(),
                    clientX: e.clientX,
                    clientY: e.clientY,
                }));
            }
        };
    }
    render() {
        if (!this.props.me) {
            return null; // cf. #1405
        }
        return this.me();
    }
    me() {
        const { me } = this.props;
        const { username, displayName } = me;
        const coverUrl = (0,get_user_cover_url/* getUserCoverURL */.n)(me);
        return (react.createElement(UserMenuDiv, { className: "user-menu", onMouseDown: this.openMenu },
            react.createElement("img", { src: coverUrl }),
            react.createElement("span", null, displayName || username),
            react.createElement(Filler/* default */.Z, null)));
    }
}
/* harmony default export */ const TitleBar_UserMenu = ((0,hook/* hook */.z)((map) => ({
    me: map((rs) => rs.profile.profile.user),
}))(UserMenu));

// EXTERNAL MODULE: ./src/renderer/modals.ts + 3 modules
var modals = __webpack_require__(9088);
// EXTERNAL MODULE: ./src/common/helpers/secret-click.ts
var secret_click = __webpack_require__(4843);
;// CONCATENATED MODULE: ./src/renderer/basics/TitleBar/index.tsx













const DraggableDiv = styles/* default */.ZP.div `
  ${styles/* singleLine */.U1};
  -webkit-app-region: drag;

  flex: 1 1;
  display: flex;
  align-self: stretch;
`;
const TitleBar_Spacer = styles/* default */.ZP.div `
  width: 8px;
  flex-shrink: 0;
`;
const titleBarHeight = 40;
const WindowButton = (0,styles/* default */.ZP)((0,IconButton/* default */.Z)) `
  align-self: flex-start;
  flex-shrink: 0;
  width: ${titleBarHeight * 1.1}px;
  height: ${titleBarHeight * 0.8}px;
  opacity: 0.7;

  &:hover {
    opacity: 1;
    background: rgba(255, 255, 255, 0.1);
  }

  &.exit:hover {
    background: rgba(174, 8, 7, 1);
  }
`;
const DraggableDivInner = styles/* default */.ZP.div `
  flex: 1 1;
  display: flex;
  align-self: center;
  align-items: center;
  max-width: 100%;
`;
const TitleBar_Filler = styles/* default */.ZP.div `
  flex: 1 1;
`;
const TitleBarDiv = styles/* default */.ZP.div `
  display: flex;
  align-items: center;
  width: 100%;
  background: ${(props) => props.theme.sidebarBackground};
  padding-left: 10px;
  height: ${titleBarHeight}px;
`;
const TitleDiv = styles/* default */.ZP.div `
  ${styles/* singleLine */.U1};

  font-size: ${(props) => props.theme.fontSizes.large};
`;
const emptyObj = {};
class TitleBar extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if ((0,secret_click/* isSecretClick */.C)(e)) {
                const { dispatch } = this.props;
                dispatch(actions/* actions */.N.openModal(modals/* default */.Z.secretSettings.make({
                    wind: (0,navigation/* ambientWind */.w)(),
                    title: "Secret settings",
                    message: "",
                    widgetParams: {},
                })));
                return;
            }
        };
        this.preferencesClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.navigate({ wind: "root", url: "itch://preferences" }));
        };
        this.minimizeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.minimizeWind({ wind: (0,navigation/* ambientWind */.w)() }));
        };
        this.maximizeRestoreClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.toggleMaximizeWind({ wind: (0,navigation/* ambientWind */.w)() }));
        };
        this.closeClick = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.hideWind({ wind: (0,navigation/* ambientWind */.w)() }));
        };
    }
    render() {
        const { tab, macos, tabInstance } = this.props;
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        const sp = space/* Space */.T.fromInstance(tab, tabInstance);
        let label = sp.lazyLabel();
        const loggedIn = tab !== "login";
        if (!loggedIn) {
            if (macos) {
                label = "";
            }
            else {
                label = env/* default */.Z.appName;
            }
        }
        return (react.createElement(TitleBarDiv, { className: "title-bar" },
            react.createElement(DraggableDiv, { id: "title-draggable", onClick: this.onClick },
                react.createElement(DraggableDivInner, null,
                    secondary ? react.createElement(TitleBar_Filler, null) : null,
                    react.createElement(TitleDiv, { className: "title-bar-text" }, (0,t.T)(label)),
                    react.createElement(TitleBar_Filler, null))),
            secondary ? null : (react.createElement(react.Fragment, null,
                loggedIn ? react.createElement(TitleBar_UserMenu, null) : null,
                react.createElement(TitleBar_NewVersionAvailable, null))),
            react.createElement(TitleBar_Spacer, null),
            this.renderIcons()));
    }
    renderIcons() {
        const { macos, maximized } = this.props;
        if (macos) {
            return null;
        }
        const iw = window.windSpec;
        const secondary = iw.role == "secondary";
        return (react.createElement(react.Fragment, null,
            secondary ? null : (react.createElement(react.Fragment, null,
                react.createElement(WindowButton, { icon: "minus", onClick: this.minimizeClick }),
                react.createElement(WindowButton, { icon: maximized ? "window-restore" : "window-maximize", onClick: this.maximizeRestoreClick }))),
            react.createElement(WindowButton, { className: "exit", icon: "cross", onClick: this.closeClick })));
    }
}
/* harmony default export */ const basics_TitleBar = ((0,hook/* hookWithProps */.h)(TitleBar)((map) => ({
    tabInstance: map((rs, props) => (0,navigation/* ambientWindState */.cq)(rs).tabInstances[props.tab] || emptyObj),
    maximized: map((rs, props) => rs.winds[(0,navigation/* ambientWind */.w)()].native.maximized),
    focused: map((rs, props) => rs.winds[(0,navigation/* ambientWind */.w)()].native.focused),
    macos: map((rs, props) => rs.system.macos),
}))(TitleBar));


/***/ }),

/***/ 5969:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   R: () => (/* binding */ doAsync)
/* harmony export */ });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ 9411:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(9471);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(4987);
/* harmony import */ var renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5391);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2263);
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2521);







class BrowserBar extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
    constructor() {
        super(...arguments);
        this.onMore = (ev) => {
            const { dispatch, tab, url } = this.props;
            const { clientX, clientY } = ev;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.popupContextMenu({
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_6__/* .ambientWind */ .w)(),
                clientX,
                clientY,
                template: [
                    {
                        localizedLabel: ["browser.popout"],
                        action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openInExternalBrowser({
                            url,
                        }),
                    },
                    {
                        type: "separator",
                    },
                    {
                        localizedLabel: ["browser.open_devtools"],
                        action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openDevTools({
                            wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_6__/* .ambientWind */ .w)(),
                            tab,
                        }),
                    },
                ],
            }));
        };
    }
    render() {
        const { loading } = this.props;
        return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FiltersContainer__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .ZP, { loading: loading },
            react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { icon: "more_vert", onClick: this.onMore })));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_5__/* .withTab */ .D1)((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_4__/* .hookWithProps */ .h)(BrowserBar)((map) => ({
    url: map((rs, props) => (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_6__/* .ambientTab */ .mB)(rs, props).location.url),
    loading: map((rs, props) => (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_6__/* .ambientTab */ .mB)(rs, props).loading),
}))(BrowserBar)));


/***/ }),

/***/ 9954:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .meat */ .pw};
`);


/***/ }),

/***/ 4063:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ scenes_HubScene)
});

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./node_modules/classnames/index.js
var classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(classnames);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./src/renderer/basics/FiltersContainer.tsx + 2 modules
var FiltersContainer = __webpack_require__(4987);
// EXTERNAL MODULE: ./src/renderer/basics/TitleBar/index.tsx + 2 modules
var TitleBar = __webpack_require__(4844);
// EXTERNAL MODULE: ./src/renderer/modals.ts + 3 modules
var modals = __webpack_require__(9088);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
// EXTERNAL MODULE: ./node_modules/react-loadable/lib/index.js
var lib = __webpack_require__(8356);
var lib_default = /*#__PURE__*/__webpack_require__.n(lib);
// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__(6025);
// EXTERNAL MODULE: ./src/renderer/basics/LoadingCircle/index.tsx + 1 modules
var LoadingCircle = __webpack_require__(6785);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./src/renderer/pages/BrowserPage/BrowserBar.tsx
var BrowserBar = __webpack_require__(9411);
// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__(9954);
;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Meats/Meat.tsx













const CrashyPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 225).then(__webpack_require__.bind(__webpack_require__, 4225)),
    loading: () => null,
});
const CavePage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 775).then(__webpack_require__.bind(__webpack_require__, 4775)),
    loading: () => null,
});
const GamePage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 708).then(__webpack_require__.bind(__webpack_require__, 3708)),
    loading: () => null,
});
const InstallPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 116).then(__webpack_require__.bind(__webpack_require__, 4116)),
    loading: () => null,
});
const FeaturedPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 299).then(__webpack_require__.bind(__webpack_require__, 299)),
    loading: () => null,
});
const LibraryPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 407).then(__webpack_require__.bind(__webpack_require__, 1407)),
    loading: () => null,
});
const OwnedPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(301), __webpack_require__.e(742)]).then(__webpack_require__.bind(__webpack_require__, 8963)),
    loading: () => null,
});
const InstalledPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(301), __webpack_require__.e(224)]).then(__webpack_require__.bind(__webpack_require__, 5224)),
    loading: () => null,
});
const LocationsPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 533).then(__webpack_require__.bind(__webpack_require__, 8533)),
    loading: () => null,
});
const LocationPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(301), __webpack_require__.e(949)]).then(__webpack_require__.bind(__webpack_require__, 1650)),
    loading: () => null,
});
const BrowserPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 695).then(__webpack_require__.bind(__webpack_require__, 4695)),
    loading: () => null,
});
const NewTabPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 357).then(__webpack_require__.bind(__webpack_require__, 2357)),
    loading: () => null,
});
const CollectionPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(301), __webpack_require__.e(793)]).then(__webpack_require__.bind(__webpack_require__, 1793)),
    loading: () => null,
});
const CollectionsPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 645).then(__webpack_require__.bind(__webpack_require__, 6645)),
    loading: () => null,
});
const AppLogPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 810).then(__webpack_require__.bind(__webpack_require__, 8810)),
    loading: () => null,
});
const DashboardPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(301), __webpack_require__.e(650)]).then(__webpack_require__.bind(__webpack_require__, 650)),
    loading: () => null,
});
const DownloadsPage = lib_default()({
    loader: () => Promise.all(/* import() */[__webpack_require__.e(598), __webpack_require__.e(758)]).then(__webpack_require__.bind(__webpack_require__, 7758)),
    loading: () => null,
});
const PreferencesPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 2).then(__webpack_require__.bind(__webpack_require__, 7002)),
    loading: () => null,
});
const ScanInstallLocationsPage = lib_default()({
    loader: () => __webpack_require__.e(/* import() */ 551).then(__webpack_require__.bind(__webpack_require__, 6551)),
    loading: () => null,
});
const ErrorDiv = styles/* default */.ZP.div `
  display: block;
  overflow: hidden;
  margin: 20px;
  width: 100%;
`;
const ErrorContents = styles/* default */.ZP.div `
  overflow-y: scroll;
  max-height: fill-available;
  padding: 20px 0;

  pre {
    font-family: monospace;
    font-size: 12px;
    line-height: 1.4;
  }
`;
const ErrorHeader = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const ErrorButtons = styles/* default */.ZP.div `
  margin: 20px 0;
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const ErrorSpacer = styles/* default */.ZP.div `
  height: 1px;
  width: 8px;
`;
class Meat extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.renderError = () => {
            const { error, info } = this.state;
            return (react.createElement(ErrorDiv, null,
                react.createElement(ErrorHeader, null,
                    react.createElement("h3", null, "itch has encountered a rendering error")),
                react.createElement(ErrorButtons, null,
                    react.createElement(Button/* default */.Z, { icon: "repeat", onClick: this.reloadMeat }, this.state.loading ? react.createElement(LoadingCircle/* default */.Z, { progress: -1 }) : "Reload"),
                    react.createElement(ErrorSpacer, null),
                    react.createElement(Button/* default */.Z, { icon: "bug", onClick: this.onReportIssue }, (0,t.T)(["menu.help.report_issue"]))),
                react.createElement("details", null,
                    react.createElement("summary", null, "View details for nerds"),
                    react.createElement(ErrorContents, null,
                        react.createElement("p", null,
                            react.createElement("pre", null, error
                                ? error.stack
                                    ? error.stack
                                    : String(error)
                                : "(no error)")),
                        react.createElement("p", null,
                            react.createElement("pre", null, info ? info.componentStack : "(no component stack)"))))));
        };
        this.reloadMeat = () => {
            this.setState({ loading: true });
            setTimeout(() => {
                this.setState({ hasError: false, loading: false });
            }, 400);
        };
        this.onReportIssue = () => {
            const { dispatch } = this.props;
            const e = this.state.error;
            dispatch(actions/* actions */.N.openModal(modals/* default */.Z.sendFeedback.make({
                wind: "root",
                title: (0,t._)("prompt.show_error.generic_message"),
                widgetParams: {
                    log: `While rendering ${this.props.url}, caught:\n${e.stack}`,
                },
            })));
        };
        this.state = {
            hasError: false,
            loading: false,
            lastURL: null,
        };
    }
    static getDerivedStateFromProps(props, state) {
        if (props.url !== state.lastURL) {
            return {
                hasError: false,
                loading: false,
                error: null,
                info: null,
                lastURL: props.url,
            };
        }
        return null;
    }
    componentDidCatch(error, info) {
        this.setState({
            hasError: true,
            loading: false,
            error,
            info,
        });
    }
    render() {
        if (this.state.hasError) {
            return this.renderError();
        }
        const ConcreteMeat = this.getConcrete();
        if (ConcreteMeat) {
            return (react.createElement(react.Fragment, null,
                react.createElement(ConcreteMeat, Object.assign({}, this.props))));
        }
        else {
            return (react.createElement(Page/* default */.Z, null,
                react.createElement(BrowserBar/* default */.Z, null),
                react.createElement("div", null,
                    "Invalid url: ",
                    JSON.stringify(this.props.url))));
        }
    }
    getConcrete() {
        const { isBrowser, internalPage, firstPathElement } = this.props;
        if (isBrowser) {
            return BrowserPage;
        }
        switch (internalPage) {
            case "library":
                switch (firstPathElement) {
                    case "owned":
                        return OwnedPage;
                    case "installed":
                        return InstalledPage;
                    default:
                        return LibraryPage;
                }
            case "games":
                return GamePage;
            case "caves":
                return CavePage;
            case "install":
                return InstallPage;
            case "featured":
                return FeaturedPage;
            case "collections":
                if (firstPathElement) {
                    return CollectionPage;
                }
                else {
                    return CollectionsPage;
                }
            case "locations":
                if (firstPathElement) {
                    return LocationPage;
                }
                else {
                    return LocationsPage;
                }
            case "dashboard":
                return DashboardPage;
            case "downloads":
                return DownloadsPage;
            case "preferences":
                return PreferencesPage;
            case "applog":
                return AppLogPage;
            case "crashy":
                return CrashyPage;
            case "new-tab":
                return NewTabPage;
            case "scan-install-locations":
                return ScanInstallLocationsPage;
            default:
                return null;
        }
    }
}
/* harmony default export */ const Meats_Meat = ((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(Meat)((map) => ({
    url: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.url),
    isBrowser: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.isBrowser),
    internalPage: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.internalPage),
    firstPathElement: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.firstPathElement),
}))(Meat)));

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Meats/index.tsx












const MeatContainer = styles/* default */.ZP.div `
  background: ${(props) => props.theme.meatBackground};
  overflow: hidden;
  display: flex;
  flex-direction: column;
  align-items: stretch;
  position: relative;

  flex-shrink: 1;
  flex-grow: 1;
`;
const MeatTab = styles/* default */.ZP.div `
  position: absolute;
  top: ${FiltersContainer/* filtersContainerHeight */.zR}px;
  right: 0;
  left: 0;
  bottom: 0;
  display: none;
  overflow: hidden;

  &.visible {
    display: flex;
  }
`;
class Meats extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (ev) => {
            if (ev.shiftKey && ev.ctrlKey) {
                const { tab, tabInstances, dispatch } = this.props;
                const tabInstance = tabInstances[tab];
                dispatch(actions/* actions */.N.openModal(modals/* default */.Z.exploreJson.make({
                    wind: (0,navigation/* ambientWind */.w)(),
                    title: "Tab information",
                    message: "",
                    widgetParams: {
                        data: { tab, tabInstance },
                    },
                    fullscreen: true,
                })));
            }
        };
    }
    render() {
        let { profile, openTabs, tabInstances, tab: currentId } = this.props;
        if (!profile) {
            return null;
        }
        return (react.createElement(MeatContainer, { onClick: this.onClick },
            react.createElement(TitleBar/* default */.Z, { tab: currentId }),
            (0,index_all/* map */.UI)(openTabs, (tab) => {
                const ti = tabInstances[tab];
                const visible = tab === currentId;
                return (react.createElement(withTab/* TabProvider */.sM, { key: tab, value: tab },
                    react.createElement(MeatTab, { key: tab, "data-id": tab, "data-url": ti.location.url, "data-resource": ti.resource ? ti.resource.value : null, className: classnames_default()("meat-tab", { visible }) },
                        react.createElement(Meats_Meat, { visible: visible, sequence: ti.sequence }))));
            })));
    }
}
/* harmony default export */ const HubScene_Meats = ((0,hook/* hook */.z)((map) => ({
    profile: map((rs) => rs.profile.profile),
    tab: map((rs) => (0,navigation/* ambientNavigation */.S5)(rs).tab),
    openTabs: map((rs) => (0,navigation/* ambientNavigation */.S5)(rs).openTabs),
    tabInstances: map((rs) => (0,navigation/* ambientWindState */.cq)(rs).tabInstances),
}))(Meats));

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/HubContent.tsx




const ContentContainer = styles/* default */.ZP.div `
  overflow: hidden;
  display: flex;
  flex-direction: column;
  flex-grow: 1;
`;
class HubContent extends react.PureComponent {
    render() {
        const { profile } = this.props;
        if (!profile) {
            return null;
        }
        return (react.createElement(ContentContainer, null,
            react.createElement(HubScene_Meats, null)));
    }
}
/* harmony default export */ const HubScene_HubContent = ((0,hook/* hook */.z)((map) => ({
    profile: map((rs) => rs.profile.profile),
}))(HubContent));

// EXTERNAL MODULE: ./node_modules/react-sortable-hoc/dist/react-sortable-hoc.esm.js + 19 modules
var react_sortable_hoc_esm = __webpack_require__(9963);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/Icon.tsx
var Icon = __webpack_require__(4198);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/common/helpers/secret-click.ts
var secret_click = __webpack_require__(4843);
;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Logo.tsx








const LogoDiv = styles/* default */.ZP.div `
  text-align: center;
  cursor: pointer;

  margin-top: 10px;
  height: 59px;

  img {
    width: 110px;
    margin: 10px 0;
  }
`;
class Logo extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if ((0,secret_click/* isSecretClick */.C)(e)) {
                const { dispatch } = this.props;
                dispatch(actions/* actions */.N.openModal(modals/* default */.Z.secretSettings.make({
                    wind: "root",
                    title: "Secret settings",
                    message: "",
                    widgetParams: {},
                })));
                return;
            }
            if (e.button === 0) {
                const { dispatch } = this.props;
                dispatch(actions/* actions */.N.openUserMenu({
                    wind: (0,navigation/* ambientWind */.w)(),
                    clientX: e.clientX,
                    clientY: e.clientY,
                }));
            }
        };
    }
    render() {
        const { appVersion } = this.props;
        return (react.createElement(LogoDiv, { title: appVersion, className: classnames_default()("logo-div"), onClick: this.onClick },
            react.createElement("img", { src: (__webpack_require__(7871)/* ["default"] */ .Z) })));
    }
}
/* harmony default export */ const Sidebar_Logo = ((0,hook/* hook */.z)((map) => ({
    appVersion: map((rs) => rs.system.appVersion),
}))(Logo));

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
;// CONCATENATED MODULE: ./src/common/constants/search-examples.ts
/* harmony default export */ const search_examples = ([
    "capsule",
    "race",
    "princess",
    "royals",
    "night",
    "garden",
    "tiger",
    "robot",
    "kenney",
    "quest",
    "simulator",
    "date",
    "lost",
    "tycoon",
    "grow",
    "fly",
    "basket",
    "legend",
    "drift",
    "galaxy",
    "rogue",
    "moon",
    "strategy",
    "shoot",
    "platform",
    "ghost",
    "tea",
    "parable",
    "sun",
    "market",
    "creator",
    "ville",
    "heart",
    "poem",
    "twine",
    "flower",
    "escape",
    "castle",
    "wild",
    "trouble",
    "purpose",
    "ludum dare",
    "challenge",
    "coop",
    "club",
    "dream",
    "midnight",
    "remix",
    "witch",
    "social",
    "hylics",
    "doggest",
    "crypt",
    "tower",
    "forest",
]);

// EXTERNAL MODULE: ./src/renderer/basics/Floater.tsx
var Floater = __webpack_require__(3537);
// EXTERNAL MODULE: ./src/renderer/butlerd/rcall.ts
var rcall = __webpack_require__(8472);
// EXTERNAL MODULE: ./src/renderer/helpers/doAsync.tsx
var doAsync = __webpack_require__(5969);
// EXTERNAL MODULE: ./src/renderer/hocs/watching.tsx
var watching = __webpack_require__(7538);
// EXTERNAL MODULE: ./src/common/constants/urls.ts
var urls = __webpack_require__(541);
// EXTERNAL MODULE: ./src/renderer/basics/Cover/index.tsx + 2 modules
var Cover = __webpack_require__(103);
// EXTERNAL MODULE: ./src/renderer/helpers/whenClickNavigates.ts
var whenClickNavigates = __webpack_require__(9698);
// EXTERNAL MODULE: ./node_modules/react-dom/index.js
var react_dom = __webpack_require__(3935);
;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/SearchResultsBar/GameSearchResult.tsx













const GameSearchResultDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: stretch;
  padding: 4px 8px;
  padding-left: 12px;

  flex-shrink: 0;

  border-left: 1px solid transparent;

  &.chosen {
    background-color: ${(props) => props.theme.sidebarEntryFocusedBackground};
    border-color: ${(props) => props.theme.accent};
    cursor: pointer;
  }

  &:hover {
    border-color: rgba(255, 255, 255, 0.5);
    cursor: pointer;
  }

  .cover-container {
    flex-shrink: 0;
    width: ${80 * 1}px;

    display: flex;
    flex-direction: row;
    align-items: flex-start;

    .cover {
      width: 100%;
    }
  }
`;
const SectionDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: column;
  align-items: stretch;

  overflow-x: hidden;
  ${styles/* singleLine */.U1};
  line-height: 1.4;
`;
const TitleDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const Title = styles/* default */.ZP.span `
  font-size: ${(props) => props.theme.fontSizes.smaller};
  ${styles/* singleLine */.U1};

  &.chosen {
    font-size: ${(props) => props.theme.fontSizes.larger};
  }
`;
const ShortText = styles/* default */.ZP.span `
  font-size: ${(props) => props.theme.fontSizes.smaller};
  color: ${(props) => props.theme.secondaryText};
  margin-right: 8px;
  overflow-x: hidden;
  text-overflow: ellipsis;
  word-wrap: break-all;
  white-space: normal;
`;
let GameSearchResult = class GameSearchResult extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (ev) => {
            (0,whenClickNavigates/* whenClickNavigates */.P)(ev, ({ background }) => {
                if (background) {
                    ev.preventDefault();
                }
                const { game, dispatch } = this.props;
                dispatch(actions/* actions */.N.navigate({
                    wind: (0,navigation/* ambientWind */.w)(),
                    url: (0,navigation/* urlForGame */.OH)(game.id),
                    background,
                }));
                dispatch(actions/* actions */.N.closeSearch({}));
            });
        };
        this.onEnter = (ev) => {
            this.props.setSearchHighlight(this.props.index);
        };
    }
    subscribe(watcher) {
        watcher.on(actions/* actions */.N.commandOk, async (store, action) => {
            if (this.props.chosen && this.props.active && !this.props.loading) {
                store.dispatch(this.getNavigateAction());
                store.dispatch(actions/* actions */.N.closeSearch({}));
            }
        });
    }
    componentDidUpdate() {
        if (this.props.chosen) {
            const node = (0,react_dom.findDOMNode)(this);
            if (node) {
                node.scrollIntoViewIfNeeded();
            }
        }
    }
    render() {
        const { game, chosen } = this.props;
        const { title, stillCoverUrl, coverUrl } = game;
        const resultClasses = classnames_default()("game-search-result", {
            chosen: chosen,
        });
        return (react.createElement(GameSearchResultDiv, { className: resultClasses, onMouseDown: this.onClick, onMouseEnter: this.onEnter, "data-game-id": game.id },
            react.createElement(SectionDiv, null,
                react.createElement(TitleDiv, null,
                    react.createElement(Title, { className: classnames_default()({ chosen }) }, title),
                    react.createElement(Filler/* default */.Z, null)),
                chosen ? (react.createElement(TitleDiv, null,
                    react.createElement(ShortText, null, game.shortText && game.shortText !== ""
                        ? game.shortText
                        : (0,t.T)(["search.results.game.no_description"])),
                    game.user ? (react.createElement(ShortText, null,
                        "By ",
                        game.user.displayName || game.user.username)) : null)) : null),
            chosen ? (react.createElement(react.Fragment, null,
                react.createElement(Filler/* default */.Z, null),
                react.createElement("div", { className: "cover-container" },
                    react.createElement(Cover/* default */.ZP, { hover: false, showGifMarker: false, className: "cover", gameId: game.id, coverUrl: coverUrl, stillCoverUrl: stillCoverUrl })))) : null));
    }
    getNavigateAction() {
        const { game } = this.props;
        return actions/* actions */.N.navigate({
            wind: (0,navigation/* ambientWind */.w)(),
            url: (0,navigation/* urlForGame */.OH)(game.id),
        });
    }
};
GameSearchResult = (0,tslib_es6/* __decorate */.gn)([
    watching/* default */.Z
], GameSearchResult);
/* harmony default export */ const SearchResultsBar_GameSearchResult = ((0,hook/* hook */.z)()(GameSearchResult));

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/SearchResultsBar/index.tsx












const ResultsContainer = styles/* default */.ZP.div `
  background: ${(props) => props.theme.sidebarBackground};
  z-index: 40;

  position: absolute;
  box-shadow: 0 0 30px ${(props) => props.theme.sidebarBackground};
  border-radius: 0 0 0 2px;

  display: flex;
  flex-direction: column;

  width: 500px;
  max-height: 400px;

  left: -10px;
  top: 0;
  border: 1px solid rgba(255, 255, 255, 0.1);
`;
const ResultList = styles/* default */.ZP.div `
  display: flex;
  flex-direction: column;
  overflow-x: hidden;
  overflow-y: auto;

  /* this scrolls, so we want it to have its own layer */
  will-change: transform;

  flex-grow: 1;

  font-size: ${(props) => props.theme.fontSizes.baseText};
`;
const NoResults = styles/* default */.ZP.p `
  font-size: ${(props) => props.theme.fontSizes.smaller};
  padding: 8px 12px;
`;
let SearchResultsBar = class SearchResultsBar extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onResultList = (el) => {
            this.resultList = el;
        };
        this.onOpenAsTab = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.closeSearch({}));
            dispatch(actions/* actions */.N.navigate({
                wind: (0,navigation/* ambientWind */.w)(),
                url: `${urls/* default */.Z.itchio}?${encodeURIComponent(this.props.query)}`,
            }));
        };
    }
    render() {
        const { open, games } = this.props;
        if (!open) {
            return null;
        }
        return (react.createElement(ResultsContainer, { className: classnames_default()("results-container", { open }) }, this.resultsGrid(games)));
    }
    subscribe(watcher) {
        watcher.on(actions/* actions */.N.searchFetched, async (store, action) => {
            if (this.resultList) {
                this.resultList.scrollTop = 0;
            }
        });
    }
    resultsGrid(games) {
        const { highlight, query, example, loading } = this.props;
        const active = this.props.open;
        const items = [];
        if ((0,index_all/* isEmpty */.xb)(games)) {
            items.push(react.createElement(NoResults, { key: "no-results" }, loading
                ? (0,t.T)(["sidebar.loading"])
                : query
                    ? (0,t.T)(["search.empty.no_results"])
                    : (0,t.T)(["search.empty.tagline", { example }])));
        }
        else {
            let index = 0;
            (0,index_all/* each */.S6)(games, (game) => {
                items.push(react.createElement(SearchResultsBar_GameSearchResult, { key: `game-${game.id}`, game: game, index: index, chosen: index === highlight, active: active, loading: loading, setSearchHighlight: this.props.setSearchHighlight }));
                index++;
            });
        }
        return react.createElement(ResultList, null, items);
    }
};
SearchResultsBar = (0,tslib_es6/* __decorate */.gn)([
    watching/* default */.Z
], SearchResultsBar);
/* harmony default export */ const Sidebar_SearchResultsBar = ((0,hook/* hook */.z)()(SearchResultsBar));

// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Search.tsx

















const SearchContainerContainer = styles/* default */.ZP.section `
  .relative-wrapper {
    position: relative;
    height: 0;
  }
`;
const SearchContainer = styles/* default */.ZP.div `
  position: relative;
  padding: 0px 8px;
  margin: 16px 10px;
  font-size: 14px;
  border: 1px solid rgba(255, 255, 255, 0.1);
  background: rgba(0, 0, 0, 0.3);

  transition: border-color 0.4s;
  &.open {
    border-color: rgba(255, 255, 255, 0.4);
  }

  input[type="search"] {
    ${styles/* searchInput */.eK} // mixin!
    width: 100%;
    margin-left: 4px;
    height: 32px;
    font-size: inherit;

    &:focus {
      outline: none;
    }
  }

  .search-icon {
    ${styles/* searchIcon */.RL};
    font-size: inherit;
  }

  .search-icon-loading {
    display: flex;
    align-items: center;
    justify-content: center;
    height: 100%;
    transition: opacity 0.2s;
    left: 8px;

    &.enter-pending {
      opacity: 0.5;
    }
  }
`;
let Search = class Search extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.trigger = (0,index_all/* debounce */.Ds)(() => {
            if (!this.input) {
                return;
            }
            const { profileId } = this.props;
            const query = this.input.value;
            if (query === this.state.query) {
                this.setState({ loading: false });
                return;
            }
            this.setState({ query });
            if (query == "") {
                this.setState({
                    games: [],
                    example: pickExample(),
                    loading: false,
                });
                return;
            }
            (0,doAsync/* doAsync */.R)(async () => {
                this.setState({ loading: true });
                try {
                    const { games } = await (0,rcall/* rcall */.v)(messages/* SearchGames */.lb, {
                        profileId,
                        query,
                    });
                    this.setState({ games });
                }
                catch (_a) {
                    this.setState({ games: [] });
                }
                finally {
                    this.setState({ loading: false, highlight: 0 });
                    if (query == this.state.query && this.state.enterPending) {
                        this.setState({ enterPending: false });
                        this.setOpened(false);
                        if (this.input) {
                            this.input.blur();
                        }
                        if (!(0,index_all/* isEmpty */.xb)(this.state.games)) {
                            const gameId = this.state.games[0].id;
                            this.props.dispatch(actions/* actions */.N.navigate({
                                wind: "root",
                                url: (0,navigation/* urlForGame */.OH)(gameId),
                            }));
                        }
                    }
                }
            });
        }, 100);
        this.onFocus = (e) => {
            this.setOpened(true);
        };
        this.onBlur = (e) => {
            this.setOpened(false);
        };
        this.onChange = (e) => {
            this.setState({ loading: true });
            this.trigger();
        };
        this.setSearchHighlight = (index) => {
            let msSinceLastHighlightSet = Date.now() - this.state.lastHighlightOffset;
            if (msSinceLastHighlightSet < 500) {
                // ignore
                return;
            }
            this.setState({ highlight: index });
        };
        this.onKeyDown = (e) => {
            const { key } = e;
            let passthrough = false;
            if (key === "Escape") {
                // default behavior is to clear - don't
            }
            else if (key === "ArrowDown") {
                this.searchHighlightOffset(1);
                // default behavior is to jump to end of input - don't
            }
            else if (key === "ArrowUp") {
                this.searchHighlightOffset(-1);
                // default behavior is to jump to start of input - don't
            }
            else {
                passthrough = true;
            }
            if (!passthrough) {
                e.preventDefault();
                e.stopPropagation();
                return false;
            }
            return true;
        };
        this.onKeyUp = (e) => {
            const { key } = e;
            if (key === "Escape") {
                return;
            }
            else if (key === "ArrowDown") {
                return;
            }
            else if (key === "ArrowUp") {
                return;
            }
            else if (key === "Enter") {
                if (this.state.loading) {
                    this.setState({ enterPending: true });
                }
                return;
            }
            this.trigger();
        };
        this.gotInput = (input) => {
            this.input = input;
        };
        this.state = {
            open: false,
            loading: false,
            highlight: 0,
            games: [],
            example: pickExample(),
            query: "",
            lastHighlightOffset: 0,
            enterPending: false,
        };
    }
    searchHighlightOffset(offset) {
        let highlight = this.state.highlight + offset;
        const numGames = (0,index_all/* size */.dp)(this.state.games);
        if (numGames == 0) {
            highlight = 0;
        }
        else {
            if (highlight >= (0,index_all/* size */.dp)(this.state.games)) {
                highlight = (0,index_all/* size */.dp)(this.state.games) - 1;
            }
            if (highlight < 0) {
                highlight = 0;
            }
        }
        this.setState({ highlight, lastHighlightOffset: Date.now() });
    }
    subscribe(watcher) {
        watcher.on(actions/* actions */.N.focusSearch, async (store, action) => {
            if (this.input) {
                this.input.focus();
                this.input.select();
            }
            this.setOpened(true);
        });
        watcher.on(actions/* actions */.N.commandBack, async (store, action) => {
            if (this.input) {
                this.input.blur();
            }
            this.setOpened(false);
        });
        watcher.on(actions/* actions */.N.closeSearch, async (store, action) => {
            if (this.input) {
                this.input.blur();
            }
            this.setOpened(false);
        });
    }
    render() {
        const { intl } = this.props;
        const { loading, open } = this.state;
        return (react.createElement(SearchContainerContainer, null,
            react.createElement(SearchContainer, { className: classnames_default()({ open }) },
                react.createElement("input", { id: "search", ref: this.gotInput, type: "search", placeholder: (0,t/* TString */.m)(intl, ["search.placeholder"]) + "...", onKeyDown: this.onKeyDown, onKeyUp: this.onKeyUp, onChange: this.onChange, onBlur: this.onBlur, onFocus: this.onFocus }),
                loading ? (react.createElement("div", { className: classnames_default()("search-icon search-icon-loading", {
                        "enter-pending": this.state.enterPending,
                    }) },
                    react.createElement(Floater/* default */.Z, { tiny: true }))) : (react.createElement("span", { className: "icon icon-search search-icon" })),
                react.createElement("div", { className: "relative-wrapper" },
                    react.createElement(Sidebar_SearchResultsBar, { example: this.state.example, games: this.state.games, loading: this.state.loading, open: this.state.open, query: this.state.query, highlight: this.state.highlight, setSearchHighlight: this.setSearchHighlight })))));
    }
    setOpened(open) {
        this.setState({ open });
        const { dispatch } = this.props;
        dispatch(actions/* actions */.N.searchVisibilityChanged({ open }));
    }
};
Search = (0,tslib_es6/* __decorate */.gn)([
    watching/* default */.Z
], Search);
function pickExample() {
    return (0,index_all/* sample */.UP)(search_examples);
}
/* harmony default export */ const Sidebar_Search = ((0,hook/* hook */.z)((map) => ({
    profileId: map((rs) => rs.profile.profile.id),
}))((0,injectIntl/* default */.ZP)(Search)));

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/styles.ts

const SidebarSection = styles/* default */.ZP.div `
  color: ${(props) => props.theme.ternaryText};

  padding-left: 14px;
  margin: 12px 0;

  display: flex;
  flex-shrink: 0;
  align-items: center;

  a {
    text-decoration: none;
    font-size: 16px;
    color: ${(props) => props.theme.secondaryText};
    &:hover {
      color: ${(props) => props.theme.secondaryTextHover};
    }

    &.active {
      color: ${(props) => props.theme.baseText};
      font-weight: 400;
    }

    display: flex;
    align-items: center;

    .icon {
      padding-right: 0.6em;
      font-size: 140%;
    }
  }
`;
const SidebarHeading = styles/* default */.ZP.span `
  text-transform: uppercase;
  font-weight: bold;
`;

// EXTERNAL MODULE: ./src/common/format/datetime.ts
var datetime = __webpack_require__(1061);
// EXTERNAL MODULE: ./src/main/reactors/downloads/getters.ts
var getters = __webpack_require__(9027);
// EXTERNAL MODULE: ./node_modules/polished/dist/polished.esm.js + 9 modules
var polished_esm = __webpack_require__(6538);
;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Item.tsx










const UnshrinkableIconButton = (0,styles/* default */.ZP)((0,IconButton/* default */.Z)) `
  flex-shrink: 0;
`;
const ItemHeading = styles/* default */.ZP.div `
  ${styles/* singleLine */.U1};
  padding: 0.2em 0;
`;
const ItemSection = styles/* default */.ZP.section `
  background: ${(props) => props.theme.sidebarBackground};
  font-size: 14px;
  border-radius: 0 4px 4px 0;
  word-break: break-word;

  flex-shrink: 0;
  display: flex;
  flex-direction: column;
  margin: 2px 0;
  margin-right: 0;
  padding-left: 8px;
  height: 32px;
  justify-content: center;

  position: relative;

  &.active {
    .icon-cross {
      opacity: 1;
      color: ${(props) => props.theme.secondaryText}

      &:hover {
        color: ${(props) => props.theme.secondaryTextHover}
      }
    }
    
    background: ${(props) => props.theme.sidebarEntryFocusedBackground}
  }

  &:hover {
    cursor: pointer;
    background: ${(props) => (0,polished_esm/* darken */._j)(0.02, props.theme.sidebarEntryFocusedBackground)};
    color: ${(props) => props.theme.baseText};

    .icon-cross {
      opacity: 1;
    }
  }
`;
const Row = styles/* default */.ZP.div `
  display: flex;
  flex-shrink: 0;
  flex-direction: row;
  align-items: center;
`;
const IconContainer = styles/* default */.ZP.div `
  width: 18px;
  height: 16px;
  margin-right: 4px;
  text-align: center;
  flex-shrink: 0;

  img {
    width: 14px;
    height: 14px;
    margin-right: 2px;
    border-radius: 2px;
  }
`;
const ProgressOuter = styles/* default */.ZP.div `
  ${styles/* progress */.YD};
  width: 60px;
  height: 4px;
  margin: 4px 0 2px 10px;

  &,
  .progress-inner {
    border-radius: 4px;
  }

  .progress-inner {
    background-color: white;
  }
`;
const Bubble = styles/* default */.ZP.span `
  font-size: 11px;
  background: white;
  border-radius: 2px;
  color: ${(props) => props.theme.sidebarBackground};
  font-weight: bold;
  padding: 1px 6px;
  margin-left: 8px;
  white-space: nowrap;
`;
class Item extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            if ((0,secret_click/* isSecretClick */.C)(e)) {
                const { onExplore, tab } = this.props;
                if (onExplore) {
                    onExplore(tab);
                    return;
                }
            }
            // left (normal) click
            const { onClick } = this.props;
            if (onClick) {
                onClick();
            }
        };
        this.onMouseUp = (e) => {
            if (e.button === 1) {
                // middle click
                const { onClose } = this.props;
                if (onClose) {
                    onClose();
                }
            }
        };
        this.onCloseClick = (e) => {
            e.stopPropagation();
            const { onClose } = this.props;
            if (onClose) {
                onClose();
            }
        };
    }
    render() {
        const { count, sublabel, progress, tab, label, active, url, resource, } = this.props;
        const { onClose } = this.props;
        const progressColor = "white";
        const progressStyle = {
            width: `${Math.max(0, Math.min(1, progress)) * 100}%`,
            backgroundColor: progressColor,
        };
        return (react.createElement(ItemSection, { className: classnames_default()({ active }), "data-rh-at": "right", "data-rh": sublabel ? JSON.stringify(sublabel) : null, onClick: this.onClick, onMouseUp: this.onMouseUp, "data-id": tab, "data-url": url, "data-resource": resource },
            react.createElement(Row, null,
                react.createElement(IconContainer, null, this.props.loading ? (react.createElement(LoadingCircle/* default */.Z, { progress: -1 })) : this.props.iconImage ? (react.createElement("img", { className: "icon-image", src: this.props.iconImage })) : (react.createElement(Icon/* default */.Z, { icon: this.props.icon || "tag" }))),
                react.createElement(ItemHeading, null, (0,t.T)(label)),
                count > 0 ? react.createElement(Bubble, null, count) : null,
                react.createElement(Filler/* default */.Z, null),
                progress !== null ? (react.createElement(ProgressOuter, null,
                    react.createElement("div", { className: "progress-inner", style: progressStyle }))) : null,
                onClose ? (react.createElement(UnshrinkableIconButton, { icon: "cross", onClick: this.onCloseClick })) : null)));
    }
}
/* harmony default export */ const Sidebar_Item = (Item);

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Tab.tsx











const SortableItem = (0,react_sortable_hoc_esm/* SortableElement */.W8)((props) => {
    return react.createElement(Sidebar_Item, Object.assign({}, props.props));
});
class Tab extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = () => {
            const { tab, dispatch } = this.props;
            dispatch(actions/* actions */.N.tabFocused({ wind: (0,navigation/* ambientWind */.w)(), tab }));
        };
        this.onClose = () => {
            const { tab, dispatch } = this.props;
            dispatch(actions/* actions */.N.closeTab({ wind: (0,navigation/* ambientWind */.w)(), tab }));
        };
        this.onExplore = (tab) => {
            const { dispatch, tabInstance } = this.props;
            dispatch(actions/* actions */.N.openModal(modals/* default */.Z.exploreJson.make({
                wind: (0,navigation/* ambientWind */.w)(),
                title: "Tab information",
                message: "",
                widgetParams: {
                    data: { tab, tabInstance },
                },
                fullscreen: true,
            })));
        };
    }
    render() {
        const { tab, index, sortable, tabInstance, active } = this.props;
        const { onExplore } = this;
        const { location, status } = tabInstance;
        let loading = tabInstance.loading;
        const url = location.url;
        const resource = tabInstance.resource ? tabInstance.resource.value : null;
        const label = status.lazyLabel;
        let icon = status.icon;
        let count = 0;
        let progress = null;
        let sublabel = null;
        if (tab === "itch://downloads") {
            const { downloads } = this.props;
            count = (0,index_all/* size */.dp)((0,getters/* getPendingDownloads */.g2)(downloads));
            const activeDownload = (0,getters/* getActiveDownload */.tp)(downloads);
            if (activeDownload) {
                const downloadProgress = downloads.progresses[activeDownload.id];
                if (downloads.paused) {
                    icon = "stopwatch";
                    sublabel = ["grid.item.downloads_paused"];
                }
                else if (downloadProgress && downloadProgress.eta) {
                    progress = downloadProgress.progress;
                    const title = activeDownload.game.title;
                    const { intl } = this.props;
                    const formatted = (0,datetime/* formatDurationAsMessage */.Lb)(downloadProgress.eta);
                    const humanDuration = intl.formatMessage({
                        id: formatted.id,
                    }, formatted.values);
                    sublabel = `${title} — ${humanDuration}`;
                }
            }
        }
        let gameOverride = null;
        let { onClick, onClose } = this;
        if (!sortable) {
            onClose = null;
        }
        const props = {
            tab,
            url,
            resource,
            tabInstance,
            label,
            icon,
            active,
            onClick,
            count,
            progress,
            onClose,
            onExplore,
            sublabel,
            gameOverride,
            loading,
        };
        if (sortable) {
            return react.createElement(SortableItem, { key: tab, index: index, props: props });
        }
        else {
            return react.createElement(Sidebar_Item, Object.assign({ key: tab }, props));
        }
    }
}
/* harmony default export */ const Sidebar_Tab = ((0,injectIntl/* default */.ZP)((0,hook/* hookWithProps */.h)(Tab)((map) => ({
    tabInstance: map((rs, p) => (0,navigation/* ambientWindState */.cq)(rs).tabInstances[p.tab]),
    downloads: map((rs, p) => p.tab === "itch://downloads" ? rs.downloads : null),
}))(Tab)));

// EXTERNAL MODULE: ./node_modules/react-fast-compare/index.js
var react_fast_compare = __webpack_require__(9590);
var react_fast_compare_default = /*#__PURE__*/__webpack_require__.n(react_fast_compare);
// EXTERNAL MODULE: ./src/common/util/lru-memoize.ts
var lru_memoize = __webpack_require__(2476);
;// CONCATENATED MODULE: ./src/main/reactors/tasks/getters.ts


const getActiveTask = (0,lru_memoize/* memoize */.H)(1, function (tasks) {
    return (0,index_all/* first */.Ps)(getRunningTasks(tasks));
});
const getRunningTasks = (0,lru_memoize/* memoize */.H)(1, function (tasks) {
    return (0,index_all/* values */.VO)(tasks.tasks);
});

// EXTERNAL MODULE: ./src/renderer/hocs/butlerCaller/index.tsx + 1 modules
var butlerCaller = __webpack_require__(5617);
// EXTERNAL MODULE: ./src/common/format/operation.ts
var operation = __webpack_require__(5414);
// EXTERNAL MODULE: ./src/renderer/basics/DownloadProgressSpan.tsx
var DownloadProgressSpan = __webpack_require__(830);
;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/PrimeDownload/GameTitle.tsx


const GameTitleDiv = styles/* default */.ZP.div `
  ${styles/* singleLine */.U1};
  max-width: 90%;
  text-align: center;
	font-weight: bold;
  font-size: ${(props) => props.theme.fontSizes.large};

  &.gt-17 {
    font-size: 14px;
  }

  &.gt-26 {
    font-size: 12px;
  }
`;
const GameTitle = (props) => {
    const { title } = props;
    let className = "";
    if (title.length > 26) {
        className = "gt-26";
    }
    else if (title.length > 17) {
        className = "gt-17";
    }
    return react.createElement(GameTitleDiv, { className: className }, title);
};

// EXTERNAL MODULE: ./src/renderer/basics/LastPlayed.tsx
var LastPlayed = __webpack_require__(2985);
// EXTERNAL MODULE: ./src/renderer/pages/common/StandardGameCover.tsx + 1 modules
var StandardGameCover = __webpack_require__(7792);
// EXTERNAL MODULE: ./src/common/butlerd/utils.ts
var utils = __webpack_require__(2325);
;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/PrimeDownload/PrimeDownloadContents.tsx



















const FetchCave = (0,butlerCaller/* default */.ZP)(messages/* FetchCave */.nD);
const CompactLastPlayed = (0,styles/* default */.ZP)((0,LastPlayed/* default */.Z)) `
  max-width: 90%;
  text-align: center;
  line-height: 1.2;
`;
const TitleBlock = styles/* default */.ZP.div `
  flex-shrink: 0;
  height: 40px;
  overflow: hidden;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
`;
const EnormousIcon = (0,styles/* default */.ZP)((0,Icon/* default */.Z)) `
  font-size: ${(props) => props.theme.fontSizes.enormous};
`;
const GameCover = (0,styles/* default */.ZP)((0,StandardGameCover/* default */.ZP)) `
  position: relative;
  pointer-events: none;

  overflow: hidden;
  box-shadow: 0 0 4px rgba(0, 0, 0, 0.4);
`;
const PrimeDownloadDiv = styles/* default */.ZP.div `
  ${styles/* clickable */.Zk};

  margin: 20px auto;
  padding-bottom: 1em;

  display: flex;
  flex-direction: column;
  align-items: center;
`;
const Overlay = styles/* default */.ZP.div `
  background: rgba(0, 0, 0, 0.8);
  position: absolute;

  left: 0;
  right: 0;
  bottom: 0;
  top: 0;

  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: space-between;
`;
const ProgressContainer = styles/* default */.ZP.div `
  height: 50px;
  margin: 16px 0;

  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
`;
class PrimeDownloadContents extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onMainClick = () => {
            (0,doAsync/* doAsync */.R)(async () => {
                const { dispatch, kind, game, taskName, caveId } = this.props;
                if (kind === "task") {
                    if (taskName === "launch") {
                        dispatch(actions/* actions */.N.forceCloseGameRequest({ game }));
                    }
                    return;
                }
                if (caveId) {
                    try {
                        const { cave } = await (0,rcall/* rcall */.v)(messages/* FetchCave */.nD, {
                            caveId,
                        });
                        dispatch(actions/* actions */.N.queueLaunch({ cave }));
                        return;
                    }
                    catch (e) { }
                }
                dispatch(actions/* actions */.N.navigate({
                    wind: (0,navigation/* ambientWind */.w)(),
                    url: "itch://downloads",
                }));
            });
        };
        this.renderLastPlayed = FetchCave.renderCallback(({ result }) => {
            if (result && result.cave) {
                const { cave } = result;
                const { game } = this.props;
                return react.createElement(CompactLastPlayed, { cave: (0,utils/* getCaveSummary */.CH)(cave), game: game });
            }
            return null;
        });
        this.onContextMenu = (ev) => {
            ev.preventDefault();
            const { clientX, clientY } = ev;
            const { game, dispatch } = this.props;
            dispatch(actions/* actions */.N.openGameContextMenu({
                wind: (0,navigation/* ambientWind */.w)(),
                game,
                clientX,
                clientY,
            }));
        };
    }
    render() {
        const { game } = this.props;
        return (react.createElement(PrimeDownloadDiv, { onClick: this.onMainClick, onContextMenu: this.onContextMenu },
            react.createElement(GameCover, { game: game, showGifMarker: false },
                react.createElement(Overlay, null,
                    react.createElement(TitleBlock, null,
                        react.createElement(GameTitle, { title: game.title })),
                    this.renderProgress()))));
    }
    renderProgress() {
        const { progress, downloadsPaused, caveId, taskName, game } = this.props;
        if (taskName) {
            return (react.createElement(react.Fragment, null,
                react.createElement(ProgressContainer, null,
                    react.createElement(EnormousIcon, { icon: (0,operation/* taskIcon */.yt)(taskName) })),
                react.createElement(TitleBlock, null, (0,t.T)((0,operation/* formatTask */.bU)(taskName)))));
        }
        if (!progress && !caveId) {
            return (react.createElement(react.Fragment, null,
                react.createElement(ProgressContainer, null,
                    react.createElement(EnormousIcon, { icon: "stopwatch" })),
                react.createElement(TitleBlock, null, (0,t.T)(["grid.item.queued"]))));
        }
        return (react.createElement(react.Fragment, null,
            react.createElement(ProgressContainer, null, caveId ? (react.createElement(IconButton/* default */.Z, { icon: "play2", enormous: true })) : (react.createElement(LoadingCircle/* default */.Z, { progress: progress.progress, huge: true }))),
            caveId ? (react.createElement(TitleBlock, null,
                react.createElement(FetchCave, { params: { caveId }, render: this.renderLastPlayed }))) : (react.createElement(TitleBlock, null,
                react.createElement(DownloadProgressSpan/* default */.Z, Object.assign({}, progress, { downloadsPaused: downloadsPaused }))))));
    }
}
/* harmony default export */ const PrimeDownload_PrimeDownloadContents = ((0,hook/* hook */.z)((map) => ({
    downloadsPaused: map((rs) => rs.downloads.paused),
}))(PrimeDownloadContents));

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/PrimeDownload/index.tsx








const FetchGame = (0,butlerCaller/* default */.ZP)(messages/* FetchGame */.dx);
const FetchCaves = (0,butlerCaller/* default */.ZP)(messages/* FetchCaves */.J1);
class PrimeDownload extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.renderGameForCave = FetchCaves.renderCallback(({ result }) => {
            if (result) {
                const { items } = result;
                const cave = (0,index_all/* first */.Ps)(items);
                if (cave) {
                    const { game } = cave;
                    return (react.createElement(PrimeDownload_PrimeDownloadContents, { game: game, caveId: cave.id, kind: "recent" }));
                }
            }
            return null;
        });
        this.renderGameForTask = FetchGame.renderCallback(({ result }) => {
            if (result) {
                const { game } = result;
                const { task } = this.props;
                return (react.createElement(PrimeDownload_PrimeDownloadContents, { game: game, kind: "task", caveId: task.caveId, taskName: task.name }));
            }
            return null;
        });
    }
    render() {
        const { task } = this.props;
        if (task) {
            if (task.name === "launch" || task.name === "uninstall") {
                return (react.createElement(FetchGame, { loadingHandled: true, errorsHandled: true, params: { gameId: task.gameId }, render: this.renderGameForTask }));
            }
        }
        const { download, progress } = this.props;
        if (download) {
            const { game } = download;
            let caveId;
            if (download.finishedAt) {
                caveId = download.caveId;
            }
            return (react.createElement(PrimeDownload_PrimeDownloadContents, { game: game, kind: "download", caveId: caveId, progress: progress }));
        }
        return (react.createElement(FetchCaves, { loadingHandled: true, errorsHandled: true, params: {
                limit: 1,
                sortBy: "lastTouched",
            }, render: this.renderGameForCave }));
    }
}
/* harmony default export */ const Sidebar_PrimeDownload = ((0,hook/* hook */.z)((map) => ({
    task: map((rs) => getActiveTask(rs.tasks)),
    download: map((rs) => (0,getters/* getActiveDownload */.tp)(rs.downloads)),
    progress: map((rs) => {
        const active = (0,getters/* getActiveDownload */.tp)(rs.downloads);
        if (active) {
            return rs.downloads.progresses[active.id];
        }
        return null;
    }),
}))(PrimeDownload));

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/Sidebar/Sidebar.tsx


















const SidebarDiv = styles/* default */.ZP.div `
  width: 240px;
  background: ${(props) => props.theme.sidebarBackground};
  font-size: ${styles/* fontSizes */.CH.sidebar};

  animation: ${styles/* animations */.sF.enterLeft} 0.2s;

  padding-bottom: 8px;

  height: 100%;
  flex-grow: 0;
  flex-shrink: 0;

  display: flex;
  align-items: stretch;
  flex-direction: column;
`;
const SidebarItems = styles/* default */.ZP.div `
  display: flex;
  align-items: stretch;
  flex-direction: column;

  overflow: hidden;

  &.no-shrink {
    flex-shrink: 0;
  }
`;
const SortableListContainer = styles/* default */.ZP.div `
  overflow-y: auto;
`;
const SortableList = (0,react_sortable_hoc_esm/* SortableContainer */.JN)((params) => {
    const { sidebarProps, items } = params;
    const currentTab = sidebarProps.tab;
    return (react.createElement(SortableListContainer, null, (0,index_all/* map */.UI)(items, (tab, index) => {
        const active = currentTab === tab;
        return (react.createElement(Sidebar_Tab, { key: tab, tab: tab, active: active, index: index, sortable: true }));
    })));
});
class Sidebar extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.closeAllTabs = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.closeAllTabs({
                wind: (0,navigation/* ambientWind */.w)(),
            }));
        };
        this.newTab = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.newTab({
                wind: (0,navigation/* ambientWind */.w)(),
            }));
        };
        this.onSortEnd = (params) => {
            const { oldIndex, newIndex } = params;
            this.setState({
                openTabs: (0,react_sortable_hoc_esm/* arrayMove */.Rp)(this.state.openTabs, oldIndex, newIndex),
            });
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.moveTab({
                wind: (0,navigation/* ambientWind */.w)(),
                before: oldIndex,
                after: newIndex,
            }));
        };
        this.state = {
            openTabs: props.openTabs,
        };
    }
    render() {
        const { enableTabs } = this.props;
        return (react.createElement(SidebarDiv, { id: "sidebar" },
            react.createElement(Sidebar_Logo, null),
            react.createElement(Sidebar_Search, null),
            enableTabs ? this.renderTabs() : this.renderShortcuts(),
            this.renderShortcutsRest()));
    }
    renderTabs() {
        return (react.createElement(react.Fragment, null,
            react.createElement(SidebarItems, null,
                react.createElement(SidebarSection, null,
                    react.createElement(SidebarHeading, null, (0,t.T)(["sidebar.category.tabs"])),
                    react.createElement(Filler/* default */.Z, null),
                    react.createElement(IconButton/* default */.Z, { icon: "delete", id: "sidebar-close-all-tabs", hint: (0,t._)("sidebar.close_all_tabs"), hintPosition: "left", onClick: this.closeAllTabs }),
                    react.createElement(IconButton/* default */.Z, { id: "new-tab-icon", icon: "plus", hint: (0,t._)("sidebar.new_tab"), hintPosition: "left", onClick: this.newTab })),
                react.createElement(SortableList, { items: this.state.openTabs, sidebarProps: this.props, onSortEnd: this.onSortEnd, distance: 5, lockAxis: "y" }))));
    }
    renderShortcuts() {
        return (react.createElement(react.Fragment, null,
            react.createElement(SidebarItems, null,
                this.renderLink("itch://featured", "earth", ["sidebar.explore"]),
                this.renderLink("itch://library", "heart-filled", [
                    "sidebar.library",
                ]),
                this.renderLink("itch://collections", "video_collection", [
                    "sidebar.collections",
                ]),
                this.renderLink("itch://dashboard", "archive", [
                    "sidebar.dashboard",
                ]))));
    }
    renderShortcutsRest() {
        return (react.createElement(react.Fragment, null,
            react.createElement("div", { style: { flexGrow: 1 } }),
            react.createElement(Sidebar_PrimeDownload, null),
            react.createElement(SidebarItems, { className: "no-shrink" },
                this.renderLink("itch://downloads", "download", [
                    "sidebar.downloads",
                ]),
                this.renderLink("itch://preferences", "cog", [
                    "sidebar.preferences",
                ]))));
    }
    renderLink(url, icon, label) {
        return (react.createElement(SidebarSection, null,
            react.createElement("a", { href: url, className: classnames_default()({ active: this.props.url.startsWith(url) }) },
                react.createElement(Icon/* default */.Z, { icon: icon }),
                " ",
                (0,t.T)(label))));
    }
    static getDerivedStateFromProps(props, state) {
        if (!react_fast_compare_default()(props.openTabs, state.openTabs)) {
            return {
                openTabs: props.openTabs,
            };
        }
        return null;
    }
}
/* harmony default export */ const Sidebar_Sidebar = ((0,hook/* hook */.z)((map) => ({
    me: map((rs) => rs.profile.profile.user),
    tab: map((rs) => (0,navigation/* ambientNavigation */.S5)(rs).tab),
    openTabs: map((rs) => (0,navigation/* ambientNavigation */.S5)(rs).openTabs),
    enableTabs: map((rs) => rs.preferences.enableTabs),
    url: map((rs) => {
        const ws = (0,navigation/* ambientWindState */.cq)(rs);
        const ti = ws.tabInstances[(0,navigation/* ambientNavigation */.S5)(rs).tab];
        return ti.history[ti.currentIndex].url;
    }),
}))(Sidebar));

;// CONCATENATED MODULE: ./src/renderer/scenes/HubScene/index.tsx




const HubSceneDiv = styles/* default */.ZP.div `
  overflow: hidden;
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  display: flex;
  flex-direction: row;
`;
class HubScene extends react.PureComponent {
    render() {
        const iw = window.windSpec;
        return (react.createElement(HubSceneDiv, null,
            iw.role == "main" ? react.createElement(Sidebar_Sidebar, null) : null,
            react.createElement(HubScene_HubContent, null)));
    }
}
/* harmony default export */ const scenes_HubScene = (HubScene);


/***/ }),

/***/ 3720:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   n: () => (/* binding */ getUserCoverURL)
/* harmony export */ });
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2968);

function getUserCoverURL(user) {
    const { coverUrl, stillCoverUrl } = user;
    return stillCoverUrl || coverUrl || getFrogCoverURL(user.id);
}
const frogs = [
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-cyan.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-red.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-gold.svg"),
    renderer_bridge__WEBPACK_IMPORTED_MODULE_0__/* .resources */ .Jb.getImageURL("avatars/frog-blue.svg"),
];
function getFrogCoverURL(userId) {
    return frogs[userId % frogs.length];
}


/***/ })

}]);
//# sourceMappingURL=63.chunk.js.map