"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[650],{

/***/ 650:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ pages_DashboardPage)
});

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/hocs/withProfile.tsx
var withProfile = __webpack_require__(953);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/pages/common/Filter.tsx
var Filter = __webpack_require__(9215);
// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__(9954);
// EXTERNAL MODULE: ./src/renderer/pages/common/SearchControl.tsx + 1 modules
var SearchControl = __webpack_require__(2315);
// EXTERNAL MODULE: ./src/renderer/pages/common/Sort.tsx
var Sort = __webpack_require__(1945);
// EXTERNAL MODULE: ./src/renderer/pages/common/SortsAndFilters.tsx
var SortsAndFilters = __webpack_require__(7128);
// EXTERNAL MODULE: ./src/renderer/pages/common/StandardMainAction.tsx
var StandardMainAction = __webpack_require__(771);
// EXTERNAL MODULE: ./node_modules/styled-components/dist/styled-components.browser.esm.js + 4 modules
var styled_components_browser_esm = __webpack_require__(9163);
;// CONCATENATED MODULE: ./src/renderer/pages/PageStyles/stats.tsx

const StatBox = styled_components_browser_esm["default"].div `
  padding: 0 4px;
  margin: 4px;
  margin-right: 16px;
  font-size: ${(props) => props.theme.fontSizes.baseText};
  color: ${(props) => props.theme.secondaryText};
  line-height: 1.4;
  font-weight: lighter;
  text-align: center;
`;
const StatNumber = styled_components_browser_esm["default"].div `
  font-size: ${(props) => props.theme.fontSizes.larger};
  color: ${(props) => props.theme.baseText};
  min-width: 3em;
`;

// EXTERNAL MODULE: ./node_modules/react-intl/lib/index.js + 1 modules
var lib = __webpack_require__(49);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
;// CONCATENATED MODULE: ./src/renderer/pages/DashboardPage/ProfileGameStats.tsx




//-----------------------------------
// Stats
//-----------------------------------
/* harmony default export */ const ProfileGameStats = (({ pg }) => (react.createElement(react.Fragment, null,
    react.createElement(StatBox, null,
        react.createElement(StatNumber, null,
            react.createElement(lib/* FormattedNumber */.BK, { value: pg.viewsCount })),
        " ",
        (0,t.T)(["dashboard.game_stats.views"])),
    react.createElement(StatBox, null,
        react.createElement(StatNumber, null,
            react.createElement(lib/* FormattedNumber */.BK, { value: pg.downloadsCount })),
        " ",
        (0,t.T)(["dashboard.game_stats.downloads"])),
    react.createElement(StatBox, null,
        react.createElement(StatNumber, null,
            react.createElement(lib/* FormattedNumber */.BK, { value: pg.purchasesCount })),
        " ",
        (0,t.T)(["dashboard.game_stats.purchases"])))));

// EXTERNAL MODULE: ./src/renderer/series/GameSeries.tsx
var GameSeries = __webpack_require__(4103);
;// CONCATENATED MODULE: ./src/renderer/pages/DashboardPage/index.tsx















const ProfileGameSeries = (0,GameSeries/* default */.Z)(messages/* FetchProfileGames */.VN);
class DashboardPage extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.getRecord = ProfileGameSeries.getRecordCallback((pg) => pg.game);
        this.renderMainFilters = () => react.createElement(SearchControl/* default */.Z, null);
        this.renderExtraFilters = () => (react.createElement(SortsAndFilters/* SortsAndFilters */.gY, null,
            react.createElement(SortsAndFilters/* FilterGroup */.e_, null,
                react.createElement(Sort/* SortOption */.Y, { sortBy: "title", label: (0,t._)("sort_by.games.title") }),
                react.createElement(Sort/* SortOption */.Y, { sortBy: "views", label: (0,t._)("sort_by.games.views") }),
                react.createElement(Sort/* SortOption */.Y, { sortBy: "downloads", label: (0,t._)("sort_by.games.downloads") }),
                react.createElement(Sort/* SortOption */.Y, { sortBy: "purchases", label: (0,t._)("sort_by.games.purchases") })),
            react.createElement(SortsAndFilters/* FilterSpacer */.dz, null),
            this.renderVisibilityFilter(),
            react.createElement(SortsAndFilters/* FilterSpacer */.dz, null),
            this.renderPaidStatusFilter()));
        this.renderItemExtras = ProfileGameSeries.renderItemExtrasCallback((pg) => (react.createElement(react.Fragment, null,
            react.createElement(ProfileGameStats, { pg: pg }),
            react.createElement(StandardMainAction/* default */.Z, { game: pg.game }))));
    }
    render() {
        const { profile, sortBy, sortDir, search, visibility, paidStatus, } = this.props;
        return (react.createElement(Page/* default */.Z, null,
            react.createElement(ProfileGameSeries, { label: (0,t._)("sidebar.dashboard"), params: {
                    profileId: profile.id,
                    sortBy,
                    reverse: sortDir === "reverse",
                    search,
                    filters: {
                        visibility,
                        paidStatus,
                    },
                }, getRecord: this.getRecord, renderMainFilters: this.renderMainFilters, renderExtraFilters: this.renderExtraFilters, renderItemExtras: this.renderItemExtras })));
    }
    renderPaidStatusFilter() {
        return (react.createElement(SortsAndFilters/* FilterGroup */.e_, null,
            react.createElement(Filter/* FilterOption */.f, { optionKey: "paidStatus", optionValue: "free", label: (0,t._)("filter_by.games.paid_status.free") }),
            react.createElement(Filter/* FilterOption */.f, { optionKey: "paidStatus", optionValue: "paid", label: (0,t._)("filter_by.games.paid_status.paid") })));
    }
    renderVisibilityFilter() {
        return (react.createElement(react.Fragment, null,
            react.createElement(SortsAndFilters/* FilterGroup */.e_, null,
                react.createElement(Filter/* FilterOption */.f, { optionKey: "visibility", optionValue: "published", label: (0,t._)("filter_by.games.visibility.published") }),
                react.createElement(Filter/* FilterOption */.f, { optionKey: "visibility", optionValue: "draft", label: (0,t._)("filter_by.games.visibility.draft") }))));
    }
}
/* harmony default export */ const pages_DashboardPage = ((0,withProfile/* withProfile */.Yh)((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(DashboardPage)((map) => ({
    sortBy: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.sortBy),
    sortDir: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.sortDir),
    search: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.search),
    visibility: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.visibility),
    paidStatus: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.paidStatus),
}))(DashboardPage))));


/***/ }),

/***/ 9215:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   f: () => (/* binding */ FilterOption)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(9471);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2263);
/* harmony import */ var renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2250);
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(2521);
/* harmony import */ var renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(7128);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(9080);








const base = (props) => {
    const { url, active, optionKey, optionValue, label } = props;
    let href;
    if (active) {
        href = (0,renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_3__/* .urlWithParams */ .Iq)(url, { [optionKey]: undefined });
    }
    else {
        href = (0,renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_3__/* .urlWithParams */ .Iq)(url, { [optionKey]: optionValue });
    }
    const baseClass = `filter--${optionKey}-${optionValue}--${active ? "disable" : "enable"}`;
    return (react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_5__/* .FilterOptionLink */ .zR, { target: "_replace", href: href, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(baseClass, { active }) },
        react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_pages_common_SortsAndFilters__WEBPACK_IMPORTED_MODULE_5__/* .FilterOptionIcon */ .Zk, { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ inactive: !active }), icon: active ? "checkbox-checked" : "filter" }),
        (0,renderer_t__WEBPACK_IMPORTED_MODULE_6__.T)(label)));
};
const hooked = (0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_2__/* .hookWithProps */ .h)(base)((map) => ({
    url: map((rs, props) => (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_7__/* .ambientTab */ .mB)(rs, props).location.url),
    active: map((rs, props) => (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_7__/* .ambientTab */ .mB)(rs, props).location.query[props.optionKey] ===
        props.optionValue),
}))(base);
const FilterOption = (0,renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_4__/* .withTab */ .D1)(hooked);


/***/ }),

/***/ 2315:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ common_SearchControl)
});

// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
;// CONCATENATED MODULE: ./src/renderer/pages/common/FilterInput.tsx


const StyledInput = styles/* default */.ZP.input `
  ${styles/* searchInput */.eK};
  width: 20em;
  padding-left: 10px;
  margin-left: 1.4em;
  border: 1px solid rgba(255, 255, 255, 0.1);
  background: rgba(0, 0, 0, 0.3);
`;
/* harmony default export */ const FilterInput = ((props) => react.createElement(StyledInput, Object.assign({ type: "search" }, props)));

// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
;// CONCATENATED MODULE: ./src/renderer/pages/common/SearchControl.tsx









class SearchControl extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onSearchChange = (e) => {
            this.setSearch(e.currentTarget.value);
        };
        this.setSearch = (0,index_all/* debounce */.Ds)((search) => {
            const { url } = this.props;
            (0,tab_utils/* dispatchTabEvolve */.vV)(this.props, {
                replace: true,
                url: (0,tab_utils/* urlWithParams */.Iq)(url, { search }),
            });
        }, 250);
    }
    render() {
        const { defaultValue } = this.props;
        return (react.createElement(FilterInput, { defaultValue: defaultValue, placeholder: (0,t/* TString */.m)(this.props.intl, ["grid.criterion.filter"]), onChange: this.onSearchChange }));
    }
}
/* harmony default export */ const common_SearchControl = ((0,withTab/* withTab */.D1)((0,injectIntl/* default */.ZP)((0,hook/* hookWithProps */.h)(SearchControl)((map) => ({
    url: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.url),
    defaultValue: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.search),
}))(SearchControl))));


/***/ }),

/***/ 49:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Ji: () => (/* binding */ FormattedDate),
  BK: () => (/* binding */ FormattedNumber),
  qN: () => (/* binding */ FormattedTime)
});

// UNUSED EXPORTS: FormattedDateParts, FormattedDateTimeRange, FormattedDisplayName, FormattedList, FormattedMessage, FormattedNumberParts, FormattedPlural, FormattedRelativeTime, FormattedTimeParts, IntlContext, IntlProvider, InvalidConfigError, MessageFormatError, MissingDataError, MissingTranslationError, RawIntlProvider, ReactIntlError, ReactIntlErrorCode, UnsupportedFormatterError, createIntl, createIntlCache, defineMessage, defineMessages, injectIntl, useIntl

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/utils.js
var utils = __webpack_require__(680);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
;// CONCATENATED MODULE: ./node_modules/react-intl/lib/src/components/createFormattedComponent.js




var DisplayName;
(function (DisplayName) {
    DisplayName["formatDate"] = "FormattedDate";
    DisplayName["formatTime"] = "FormattedTime";
    DisplayName["formatNumber"] = "FormattedNumber";
    DisplayName["formatList"] = "FormattedList";
    // Note that this DisplayName is the locale display name, not to be confused with
    // the name of the enum, which is for React component display name in dev tools.
    DisplayName["formatDisplayName"] = "FormattedDisplayName";
})(DisplayName || (DisplayName = {}));
var DisplayNameParts;
(function (DisplayNameParts) {
    DisplayNameParts["formatDate"] = "FormattedDateParts";
    DisplayNameParts["formatTime"] = "FormattedTimeParts";
    DisplayNameParts["formatNumber"] = "FormattedNumberParts";
    DisplayNameParts["formatList"] = "FormattedListParts";
})(DisplayNameParts || (DisplayNameParts = {}));
var FormattedNumberParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
    (0,utils/* invariantIntlContext */.lq)(intl);
    var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
    return children(intl.formatNumberToParts(value, formatProps));
})); };
FormattedNumberParts.displayName = 'FormattedNumberParts';
function createFormattedDateTimePartsComponent(name) {
    var ComponentParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        var date = typeof value === 'string' ? new Date(value || 0) : value;
        var formattedParts = name === 'formatDate'
            ? intl.formatDateToParts(date, formatProps)
            : intl.formatTimeToParts(date, formatProps);
        return children(formattedParts);
    })); };
    ComponentParts.displayName = DisplayNameParts[name];
    return ComponentParts;
}
function createFormattedComponent(name) {
    var Component = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        // TODO: fix TS type definition for localeMatcher upstream
        var formattedValue = intl[name](value, formatProps);
        if (typeof children === 'function') {
            return children(formattedValue);
        }
        var Text = intl.textComponent || react.Fragment;
        return react.createElement(Text, null, formattedValue);
    })); };
    Component.displayName = DisplayName[name];
    return Component;
}

;// CONCATENATED MODULE: ./node_modules/react-intl/lib/index.js


function defineMessages(msgs) {
    return msgs;
}
function defineMessage(msg) {
    return msg;
}



// IMPORTANT: Explicit here to prevent api-extractor from outputing `import('./src/types').CustomFormatConfig`
var FormattedDate = createFormattedComponent('formatDate');
var FormattedTime = createFormattedComponent('formatTime');
var FormattedNumber = createFormattedComponent('formatNumber');
var FormattedList = createFormattedComponent('formatList');
var FormattedDisplayName = createFormattedComponent('formatDisplayName');
var FormattedDateParts = createFormattedDateTimePartsComponent('formatDate');
var FormattedTimeParts = createFormattedDateTimePartsComponent('formatTime');







/***/ })

}]);
//# sourceMappingURL=650.chunk.js.map