"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[695],{

/***/ 7703:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .secondaryLink */ .CF};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_2__/* .__rest */ ._T)(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Link);
class Props {
}


/***/ }),

/***/ 485:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2448);
/* harmony import */ var common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(945);
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6025);
/* harmony import */ var renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(4198);
/* harmony import */ var renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5391);
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(6785);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(9080);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(2263);
/* harmony import */ var common_helpers_secret_click__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(4843);












class MainAction extends react__WEBPACK_IMPORTED_MODULE_4__.PureComponent {
    constructor() {
        super(...arguments);
        this.onClick = (e) => {
            e.stopPropagation();
            const { dispatch, game, status } = this.props;
            const { operation, update, cave, access } = status;
            if ((0,common_helpers_secret_click__WEBPACK_IMPORTED_MODULE_11__/* .isSecretClick */ .C)(e)) {
                if (cave) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.viewCaveDetails({ caveId: cave.id }));
                }
                return;
            }
            if (operation) {
                if (operation.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .OperationType */ .C8.Download) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.navigate({ wind: "root", url: "itch://downloads" }));
                }
                else if (operation.type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .OperationType */ .C8.Task) {
                    if (operation.name === "launch") {
                        dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.forceCloseGameRequest({ game }));
                    }
                }
            }
            else if (cave) {
                if (update) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.showGameUpdate({ update }));
                }
                else {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.queueGame({ game }));
                }
            }
            else {
                if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .Access */ .Nv.None) {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.initiatePurchase({ game }));
                }
                else {
                    dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.queueGame({ game }));
                }
            }
        };
    }
    render() {
        const { wide } = this.props;
        const { cave, access, operation, update } = this.props.status;
        let translucent = false;
        let iconComponent;
        let icon;
        let label;
        let primary = false;
        if (operation) {
            const { type, progress } = operation;
            translucent = true;
            if (operation.paused) {
                iconComponent = react__WEBPACK_IMPORTED_MODULE_4__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "stopwatch" });
            }
            else if (!operation.active) {
                iconComponent = react__WEBPACK_IMPORTED_MODULE_4__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: "stopwatch" });
            }
            else {
                iconComponent = (react__WEBPACK_IMPORTED_MODULE_4__.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .Z, { bare: true, wide: wide, progress: progress > 0 ? progress : 0.1 }));
            }
            if (type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .OperationType */ .C8.Download) {
                if (operation.paused) {
                    label = ["grid.item.downloads_paused"];
                }
                else if (operation.active) {
                    label = ["grid.item.installing"];
                }
                else {
                    label = ["grid.item.queued"];
                }
            }
            else if (type === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .OperationType */ .C8.Task) {
                const { name, stage } = operation;
                if (name === "launch") {
                    if (stage === "prepare") {
                        label = ["grid.item.running.prepare"];
                    }
                    else if (stage === "clean") {
                        label = ["grid.item.running.clean"];
                    }
                    else {
                        label = ["grid.item.running"];
                    }
                }
                else if (name === "uninstall") {
                    label = ["grid.item.uninstalling"];
                }
                else if (name === "install-queue") {
                    label = ["grid.item.queueing"];
                }
                else {
                    label = ["grid.item.installing"];
                }
            }
        }
        else if (cave) {
            if (update) {
                label = ["grid.item.update"];
                icon = "star";
            }
            else {
                const action = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_3__/* .actionForGame */ .x)(this.props.game, cave);
                label = [`grid.item.${action}`];
                if (action === "open") {
                    icon = "folder-open";
                }
                else {
                    icon = "play2";
                }
                primary = true;
            }
        }
        else {
            if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .Access */ .Nv.Demo || access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .Access */ .Nv.Press) {
                label = ["grid.item.review"];
                icon = "install";
            }
            else if (access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .Access */ .Nv.Pwyw ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .Access */ .Nv.Free ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .Access */ .Nv.Key ||
                access === common_helpers_get_game_status__WEBPACK_IMPORTED_MODULE_2__/* .Access */ .Nv.Edit) {
                label = ["grid.item.install"];
                icon = "install";
            }
            else {
                label = ["grid.item.buy_now"];
                icon = "shopping_cart";
            }
        }
        if (!label) {
            return null;
        }
        const { iconOnly, className } = this.props;
        if (iconOnly) {
            if (!iconComponent) {
                if (icon) {
                    iconComponent = react__WEBPACK_IMPORTED_MODULE_4__.createElement(renderer_basics_Icon__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { icon: icon });
                }
            }
            return (react__WEBPACK_IMPORTED_MODULE_4__.createElement(renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_7__/* ["default"] */ .Z, { onClick: this.onClick, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(className, "main-action"), "data-game-id": this.props.game.id, icon: iconComponent, hint: label, hintPosition: "left" }));
        }
        return (react__WEBPACK_IMPORTED_MODULE_4__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, { onClick: this.onClick, className: classnames__WEBPACK_IMPORTED_MODULE_0___default()(className, "main-action"), wide: wide, translucent: translucent, iconComponent: iconComponent, label: (0,renderer_t__WEBPACK_IMPORTED_MODULE_9__.T)(label), primary: primary, "data-game-id": this.props.game.id }));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_10__/* .hook */ .z)()(MainAction));


/***/ }),

/***/ 6055:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(9080);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2629);




class TotalPlaytime extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
    render() {
        const { game, cave, short = false } = this.props;
        let { secondsRun = 0 } = (cave || {});
        const classification = game.classification || "game";
        const classAction = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__/* .actionForGame */ .x)(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        if (secondsRun > 0 && classAction === "launch") {
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null,
                short ? null : (react__WEBPACK_IMPORTED_MODULE_1__.createElement("label", null,
                    (0,renderer_t__WEBPACK_IMPORTED_MODULE_2__.T)([`usage_stats.has_${xed}_for_duration`]),
                    " ")),
                react__WEBPACK_IMPORTED_MODULE_1__.createElement("span", { className: "total-playtime" },
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { secs: secondsRun }))));
        }
        return null;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (TotalPlaytime);


/***/ }),

/***/ 4695:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ pages_BrowserPage)
});

// EXTERNAL MODULE: ./src/renderer/bridge.ts
var bridge = __webpack_require__(2968);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
;// CONCATENATED MODULE: ./src/common/util/partition-for-user.ts
/**
 * Returns the Electron partition for a given itch.io user
 */
function partitionForUser(userId) {
    return `persist:itchio-${userId || "anonymous"}`;
}
function partitionForApp() {
    return `persist:itch-app`;
}

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/pages/BrowserPage/BrowserBar.tsx
var BrowserBar = __webpack_require__(9411);
// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
// EXTERNAL MODULE: ./src/renderer/hocs/butlerCaller/index.tsx + 1 modules
var butlerCaller = __webpack_require__(5617);
;// CONCATENATED MODULE: ./src/renderer/pages/BrowserPage/BrowserContext/BrowserContextConstants.tsx
const browserContextHeight = 110;

// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/helpers/get-game-status.ts + 1 modules
var get_game_status = __webpack_require__(945);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/common/constants/platform-data.ts
var platform_data = __webpack_require__(105);
;// CONCATENATED MODULE: ./src/common/format/price.ts
function formatPrice(currency, value) {
    if (currency === "CAD") {
        return `CAD $${(value / 100).toFixed(2)}`;
    }
    else if (currency === "AUD") {
        return `AUD $${(value / 100).toFixed(2)}`;
    }
    else if (currency === "GBP") {
        return `£${(value / 100).toFixed(2)}`;
    }
    else if (currency === "JPY") {
        return `¥${value.toFixed(2)}`;
    }
    else if (currency === "EUR") {
        return `${(value / 100).toFixed(2)} €`;
    }
    else {
        // default to dollarydoos
        return `$${(value / 100).toFixed(2)}`;
    }
}

// EXTERNAL MODULE: ./src/common/util/action-for-game.ts + 1 modules
var action_for_game = __webpack_require__(1829);
// EXTERNAL MODULE: ./src/renderer/basics/LastPlayed.tsx
var LastPlayed = __webpack_require__(2985);
// EXTERNAL MODULE: ./src/renderer/basics/PlatformIcons/index.tsx
var PlatformIcons = __webpack_require__(3043);
// EXTERNAL MODULE: ./src/renderer/basics/TimeAgo.tsx + 2 modules
var TimeAgo = __webpack_require__(8923);
// EXTERNAL MODULE: ./src/renderer/basics/TotalPlaytime.tsx
var TotalPlaytime = __webpack_require__(6055);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
;// CONCATENATED MODULE: ./src/renderer/basics/GameStats.tsx










const GameStatsDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: column;
  font-size: ${(props) => props.theme.fontSizes.baseText};
  color: ${(props) => props.theme.secondaryText};
  line-height: 1.8;
  justify-content: flex-end;

  div {
    margin-right: 12px;
  }

  label {
    color: #fff;

    .nice-ago {
      color: ${(props) => props.theme.secondaryText}; // sigh
    }

    &.original-price {
      text-decoration: line-through;
      color: inherit;
    }
  }

  .total-playtime--line {
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  .total-playtime,
  .last-playthrough {
    font-size: ${(props) => props.theme.fontSizes.baseText};
    margin-right: 5px;
  }
`;
const GameTitle = styles/* default */.ZP.div `
  font-weight: 700;
  line-height: 120%;
  overflow: hidden;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  white-space: normal;
`;
const SpacedPlatformIcons = (0,styles/* default */.ZP)((0,PlatformIcons/* default */.Z)) `
  margin-left: 4px;
`;
class GameStats extends react.PureComponent {
    render() {
        const { game, status } = this.props;
        const classification = game.classification || "game";
        const { cave, downloadKey } = status;
        const classAction = (0,action_for_game/* actionForGame */.x)(game, cave);
        if (cave) {
            return (react.createElement(GameStatsDiv, null,
                react.createElement(GameTitle, null, game.title),
                react.createElement(TotalPlaytime/* default */.Z, { game: game, cave: cave }),
                react.createElement(LastPlayed/* default */.Z, { game: game, cave: cave })));
        }
        else {
            const { minPrice } = game;
            const currency = "USD";
            const { sale } = game;
            const showPlatforms = classAction === "launch" && (0,platform_data/* hasPlatforms */.z)(game);
            // TODO: break down into components, or functions at the very least
            return (react.createElement(GameStatsDiv, null,
                react.createElement("div", { className: "total-playtime" },
                    react.createElement(GameTitle, null, game.title),
                    react.createElement("div", { className: "total-playtime--line game-summary" },
                        (0,t.T)([`usage_stats.description.${classification}`]),
                        showPlatforms ? (react.createElement("span", null,
                            " ",
                            (0,t.T)([
                                "usage_stats.description.platforms",
                                {
                                    platforms: (react.createElement(SpacedPlatformIcons, { className: "total-playtime--platforms", target: game })),
                                },
                            ]))) : null),
                    react.createElement("div", { className: "total-playtime--line" }, downloadKey
                        ? (0,t.T)([
                            "usage_stats.description.bought_time_ago",
                            {
                                time_ago: react.createElement(TimeAgo/* default */.Z, { date: downloadKey.createdAt }),
                            },
                        ])
                        : minPrice > 0
                            ? (0,t.T)([
                                "usage_stats.description.price",
                                {
                                    price: sale ? (react.createElement("span", null,
                                        react.createElement("label", { key: "original-price", className: "original-price" }, formatPrice(currency, minPrice)),
                                        react.createElement("label", { key: "discounted-price" },
                                            " ",
                                            formatPrice(currency, minPrice * (1 - sale.rate / 100))))) : (react.createElement("label", null, formatPrice(currency, minPrice))),
                                },
                            ])
                            : (0,t.T)(["usage_stats.description.free_download"])))));
        }
    }
}
/* harmony default export */ const basics_GameStats = (GameStats);

// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./src/renderer/basics/MainAction.tsx
var MainAction = __webpack_require__(485);
// EXTERNAL MODULE: ./src/renderer/pages/common/StandardGameCover.tsx + 1 modules
var StandardGameCover = __webpack_require__(7792);
;// CONCATENATED MODULE: ./src/renderer/pages/BrowserPage/BrowserContext/BrowserContextGame.tsx












const Spacer = styles/* default */.ZP.div `
  flex-basis: 16px;
  flex-shrink: 0;
`;
const coverFactor = browserContextHeight / StandardGameCover/* standardCoverHeight */.xb;
const SmallerGameCover = (0,styles/* default */.ZP)((0,StandardGameCover/* default */.ZP)) `
  flex-shrink: 0;

  width: ${StandardGameCover/* standardCoverWidth */.C2 * coverFactor}px;
  height: ${StandardGameCover/* standardCoverHeight */.xb * coverFactor}px;
`;
const BrowserContextDiv = styles/* default */.ZP.div `
  background: ${(props) => props.theme.sidebarBackground};

  display: flex;
  justify-content: center;
  flex-direction: row;

  padding-right: 16px;
  box-shadow: 0 0 18px rgba(0, 0, 0, 0.16);
  z-index: 50;
  align-items: center;
`;
class BrowserContextGame extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onContextMenu = (ev) => {
            ev.preventDefault();
            const { clientX, clientY } = ev;
            const { game, dispatch } = this.props;
            dispatch(actions/* actions */.N.openGameContextMenu({
                wind: (0,navigation/* ambientWind */.w)(),
                game,
                clientX,
                clientY,
            }));
        };
        this.onManage = () => {
            const { game, dispatch } = this.props;
            dispatch(actions/* actions */.N.manageGame({ game }));
        };
    }
    render() {
        const { game, status } = this.props;
        return (react.createElement(BrowserContextDiv, { onContextMenu: this.onContextMenu },
            react.createElement(SmallerGameCover, { game: game, showInfo: false }),
            react.createElement(Spacer, null),
            react.createElement(basics_GameStats, { game: game, status: status }),
            react.createElement(Filler/* default */.Z, null),
            react.createElement(MainAction/* default */.Z, { game: game, status: status, wide: true }),
            react.createElement(Spacer, null),
            react.createElement(IconButton/* default */.Z, { className: "manage-game", huge: true, emphasized: true, icon: "cog", onClick: this.onManage })));
    }
}
/* harmony default export */ const BrowserContext_BrowserContextGame = ((0,hook/* hookWithProps */.h)(BrowserContextGame)((map) => ({
    status: map((rs, props) => (0,get_game_status/* default */.ZP)(rs, props.game)),
}))(BrowserContextGame));

;// CONCATENATED MODULE: ./src/renderer/pages/BrowserPage/BrowserContext/index.tsx









const FetchGame = (0,butlerCaller/* default */.ZP)(messages/* FetchGame */.dx);
const BrowserContextContainer = styles/* default */.ZP.div `
  height: ${browserContextHeight}px;

  display: flex;
  flex-direction: column;
  justify-content: center;
`;
class BrowserContext extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.renderFetchContents = FetchGame.renderCallback(({ result }) => {
            return react.createElement(BrowserContext_BrowserContextGame, { game: result.game });
        });
    }
    render() {
        const { gameId, sequence } = this.props;
        if (!gameId) {
            return null;
        }
        return (react.createElement(BrowserContextContainer, null,
            react.createElement(FetchGame, { params: { gameId }, sequence: sequence, render: this.renderFetchContents })));
    }
}
/* harmony default export */ const BrowserPage_BrowserContext = ((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(BrowserContext)((map) => ({
    sequence: map((props, rs) => (0,navigation/* ambientTab */.mB)(props, rs).sequence),
    gameId: map((props, rs) => {
        const { resource } = (0,navigation/* ambientTab */.mB)(props, rs);
        if (resource && resource.prefix === "games") {
            return resource.numericId;
        }
        return null;
    }),
}))(BrowserContext)));

// EXTERNAL MODULE: ./src/renderer/basics/Link.tsx
var Link = __webpack_require__(7703);
;// CONCATENATED MODULE: ./src/renderer/pages/BrowserPage/DisabledBrowser.tsx






const DisabledBrowserContainer = styles/* default */.ZP.div `
  display: flex;
  width: 100%;
  height: 100%;
  align-items: center;
  overflow: hidden;

  background: ${(props) => props.theme.meatBackground};
`;
const DisabledBrowserDiv = styles/* default */.ZP.div `
  width: 100%;
  text-align: center;

  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: center;
`;
const DisabledBrowser_Spacer = styles/* default */.ZP.div `
  height: 1px;
  width: 10px;
`;
class DisabledBrowser extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onReenable = () => {
            const { dispatch } = this.props;
            dispatch(actions/* actions */.N.updatePreferences({ disableBrowser: false }));
        };
    }
    render() {
        return (react.createElement(DisabledBrowserContainer, null,
            react.createElement(DisabledBrowserDiv, null,
                (0,t.T)(["browser.disabled"]),
                react.createElement(DisabledBrowser_Spacer, null),
                react.createElement(Link/* default */.Z, { label: (0,t.T)(["browser.reenable"]), onClick: this.onReenable }))));
    }
}
/* harmony default export */ const BrowserPage_DisabledBrowser = ((0,hook/* hook */.z)()(DisabledBrowser));

;// CONCATENATED MODULE: ./src/renderer/pages/BrowserPage/index.tsx











const BrowserPageDiv = styles/* default */.ZP.div `
  ${styles/* meat */.pw};
`;
const BrowserMain = styles/* default */.ZP.div `
  flex-grow: 1;
  display: flex;
  flex-direction: row;
  position: relative;
`;
const WebviewShell = styles/* default */.ZP.div `
  background-color: ${(props) => props.theme.breadBackground};
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;

  webview {
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    background: white;
  }
`;
class BrowserPage extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.gotWebview = (wv) => {
            this.wv = wv;
            if (wv) {
                wv.addEventListener("dom-ready", this.wcDomReady);
            }
            else {
                (0,tab_utils/* dispatchTabLosingWebContents */.Vl)(this.props);
            }
        };
        this.wcDomReady = () => {
            if (this.wv) {
                this.wv.removeEventListener("dom-ready", this.wcDomReady);
                const webContentsId = this.wv.getWebContentsId();
                (0,tab_utils/* dispatchTabGotWebContents */.An)(this.props, webContentsId);
            }
        };
    }
    render() {
        const { sleepy, disableBrowser, visible, partition } = this.props;
        if (sleepy && !visible) {
            return null;
        }
        return (react.createElement(BrowserPageDiv, null,
            react.createElement(BrowserBar/* default */.Z, null),
            react.createElement(BrowserMain, null,
                react.createElement(WebviewShell, null, disableBrowser ? (react.createElement(BrowserPage_DisabledBrowser, null)) : (react.createElement("webview", { src: "about:blank", ref: this.gotWebview, partition: partition, useragent: bridge/* useragent */.qG.userAgent(), enableremotemodule: "false", webpreferences: "worldSafeExecuteJavaScript" })))),
            react.createElement(BrowserPage_BrowserContext, null)));
    }
    componentDidUpdate(prevProps, prevState) {
        if (!prevProps.disableBrowser && this.props.disableBrowser) {
            (0,tab_utils/* dispatchTabLoadingStateChanged */._H)(this.props, false);
        }
    }
    componentWillUnmount() {
        (0,tab_utils/* dispatchTabLosingWebContents */.Vl)(this.props);
    }
}
/* harmony default export */ const pages_BrowserPage = ((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(BrowserPage)((map) => ({
    url: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.url),
    sleepy: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).sleepy),
    loading: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).loading),
    proxy: map((rs) => rs.system.proxy),
    proxySource: map((rs) => rs.system.proxySource),
    disableBrowser: map((rs) => rs.preferences.disableBrowser),
    partition: map((rs, props) => partitionForUser(String(rs.profile.profile.id))),
}))(BrowserPage)));


/***/ })

}]);
//# sourceMappingURL=695.chunk.js.map