"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[810],{

/***/ 6817:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   b: () => (/* binding */ showInExplorerString)
/* harmony export */ });
/* provided dependency */ var process = __webpack_require__(4155);
function showInExplorerString() {
    switch (process.platform) {
        case "linux": {
            return ["grid.item.open_file_location.linux"];
        }
        case "darwin": {
            return ["grid.item.open_file_location.osx"];
        }
        case "win32":
        default: {
            return ["grid.item.open_file_location.windows"];
        }
    }
}


/***/ }),

/***/ 7703:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .secondaryLink */ .CF};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_2__/* .__rest */ ._T)(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Link);
class Props {
}


/***/ }),

/***/ 7426:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ AppLogPage_Log)
});

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/index.js + 1 modules
var lib = __webpack_require__(49);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
;// CONCATENATED MODULE: ./src/renderer/basics/SelectRow.tsx





const SelectRowDiv = styles/* default */.ZP.div `
  display: inline-block;
`;
const Select = styles/* default */.ZP.select `
  border: none;
  padding: 6px 8px;
  margin-left: 2px;
  background: ${(props) => props.theme.itemBackground};
  border: 1px solid rgba(255, 255, 255, 0.1);
  border-radius: 2px;
  color: ${(props) => props.theme.baseText};
  cursor: pointer;
  font-family: inherit;
  font-size: inherit;
`;
/**
 * A drop-down you can select from
 */
class SelectRow extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onChange = (event) => {
            const { onChange } = this.props;
            if (onChange) {
                onChange(event.currentTarget.value);
            }
        };
        this.gotElement = (element) => {
            this.element = element;
        };
    }
    render() {
        const { options, value, intl } = this.props;
        const optionTags = (0,index_all/* map */.UI)(options, (option, index) => (react.createElement("option", { key: index, value: option.value }, (0,t/* TString */.m)(intl, option.label))));
        return (react.createElement(SelectRowDiv, null,
            react.createElement(Select, { ref: this.gotElement, value: value, onChange: this.onChange }, optionTags)));
    }
    value() {
        if (this.element) {
            return this.element.value;
        }
        else {
            return null;
        }
    }
}
/* harmony default export */ const basics_SelectRow = ((0,injectIntl/* default */.ZP)(SelectRow));

// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__(6025);
;// CONCATENATED MODULE: ./src/renderer/pages/AppLogPage/Log.tsx









// time, module, message
const numColumns = 3;
const levels = {
    default: "user",
    "60": "fatal",
    "50": "error",
    "40": "warn",
    "30": "info",
    "20": "debug",
    "10": "trace",
};
const reverseLevels = {
    fatal: "60",
    error: "50",
    warn: "40",
    info: "30",
    debug: "20",
    trace: "10",
};
const LogContainer = styles/* default */.ZP.div `
  width: 100%;
  height: 100%;
`;
const LogControls = styles/* default */.ZP.div `
  padding-bottom: 1em;
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const LogTable = styles/* default */.ZP.table `
  background: ${(props) => props.theme.sidebarBackground};
  width: 100%;
  height: 100%;

  tbody {
    overflow-y: scroll;
    height: 100%;

    display: block;
    tr {
      display: table;
    }
  }

  td {
    padding: 0 0.5em;
    padding-left: 0;
    line-height: 1.4;
    color: ${(props) => props.theme.secondaryText};
    font-size: ${(props) => props.theme.fontSizes.smaller};

    &.fatal {
      background: #cd3131;
      color: white;
    }

    &.error {
      color: #c53030;
    }

    &.warn {
      color: #d3d310;
    }

    &.info {
      color: #138ba8;
    }

    &.debug {
      color: #357ac6;
    }

    &.timecol,
    &.modcol {
      white-space: nowrap;
    }

    &.msgcol {
      white-space: pre-wrap;
    }

    &.timecol {
      color: ${(props) => props.theme.ternaryText};
    }
  }
`;
const levelOptions = [
    { label: ["log.level.debug"], value: reverseLevels["debug"] },
    { label: ["log.level.info"], value: reverseLevels["info"] },
    { label: ["log.level.warning"], value: reverseLevels["warn"] },
    { label: ["log.level.error"], value: reverseLevels["error"] },
];
const linesPerPage = 250;
class Log extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onLoadMore = () => {
            this.setState((state) => ({
                maxLines: state.maxLines + linesPerPage,
            }));
        };
        this.gotBody = (tbody) => {
            this.tbody = tbody;
            this.scrollDown();
        };
        this.onChangeLevel = (value) => {
            this.setState({ level: value });
        };
        this.onJumpDown = () => {
            this.scrollDown();
        };
        this.state = {
            level: reverseLevels["info"],
            maxLines: linesPerPage,
        };
    }
    render() {
        const { maxLines } = this.state;
        let level = parseInt(this.state.level, 10);
        const { log, className, extraControls } = this.props;
        let lines = log.split("\n");
        let entries = lines.map((x) => {
            // TODO: use fast-json-parse instead ?
            try {
                const entry = JSON.parse(x);
                return entry.hasOwnProperty("msg") ? entry : x;
            }
            catch (e) {
                return x;
            }
        });
        entries = index_all/* default.filter */.ZP.filter(entries, (x) => (x.level ? x.level >= level : false));
        let hasMore = index_all/* default.size */.ZP.size(entries) > maxLines;
        entries = index_all/* default.last */.ZP.last(entries, maxLines);
        return (react.createElement(LogContainer, { className: className },
            react.createElement(LogControls, null,
                react.createElement("label", null,
                    (0,t.T)(["log.level"]),
                    ": ",
                    react.createElement(basics_SelectRow, { options: levelOptions, value: this.state.level, onChange: this.onChangeLevel })),
                extraControls,
                react.createElement(Filler/* default */.Z, null),
                react.createElement(IconButton/* default */.Z, { icon: "caret-down", onClick: this.onJumpDown })),
            react.createElement(LogTable, null,
                react.createElement("tbody", { ref: this.gotBody },
                    hasMore ? (react.createElement("div", { style: { margin: "20px" } },
                        react.createElement(Button/* default */.Z, { onClick: this.onLoadMore, label: "Load more..." }))) : null,
                    entries.map((x, i) => {
                        if (x.hasOwnProperty("msg")) {
                            let jumpElement;
                            let previousEntry = entries[i - 1];
                            if (x.time) {
                                const currDate = new Date(x.time);
                                const prevDate = previousEntry
                                    ? new Date(previousEntry.time)
                                    : null;
                                if (!previousEntry ||
                                    !previousEntry.time ||
                                    currDate.getUTCDate() != prevDate.getUTCDate() ||
                                    currDate.getUTCMonth() != prevDate.getUTCMonth() ||
                                    currDate.getUTCFullYear() != currDate.getUTCFullYear()) {
                                    jumpElement = (react.createElement("tr", { key: `${i}-jump` },
                                        react.createElement("td", { colSpan: 3 },
                                            react.createElement(lib/* FormattedDate */.Ji, { month: "long", year: "numeric", day: "numeric", value: x.time }))));
                                }
                            }
                            return (react.createElement(react.Fragment, null,
                                jumpElement,
                                react.createElement("tr", { key: i },
                                    react.createElement("td", { className: "timecol" },
                                        react.createElement(lib/* FormattedTime */.qN, { value: x.time })),
                                    react.createElement("td", { className: "modcol" }, x.name ? react.createElement("span", null, x.name) : null),
                                    react.createElement("td", { className: levels[x.level] + " msgcol" }, x.msg))));
                        }
                        else {
                            return (react.createElement("tr", { key: i },
                                react.createElement("td", { colSpan: numColumns }, x)));
                        }
                    })))));
    }
    scrollDown() {
        if (!this.tbody) {
            return;
        }
        this.tbody.scrollTop = this.tbody.scrollHeight;
    }
    scrollTop() {
        if (!this.tbody) {
            return;
        }
        this.tbody.scrollTop = 0;
    }
}
/* harmony default export */ const AppLogPage_Log = (Log);


/***/ }),

/***/ 8810:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(655);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_format_show_in_explorer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6817);
/* harmony import */ var common_util_navigation__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(9471);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3964);
/* harmony import */ var renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5391);
/* harmony import */ var renderer_basics_Link__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(7703);
/* harmony import */ var renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(6785);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(2263);
/* harmony import */ var renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(2250);
/* harmony import */ var renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2521);
/* harmony import */ var renderer_pages_AppLogPage_Log__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(7426);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(9080);
/* harmony import */ var renderer_hocs_watching__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(7538);
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(2968);

















const AppLogDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_11__/* ["default"] */ .ZP.div `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_11__/* .meat */ .pw};
`;
const Spacer = renderer_styles__WEBPACK_IMPORTED_MODULE_11__/* ["default"] */ .ZP.div `
  display: inline-block;
  height: 1px;
  width: 8px;
`;
const AppLogContentDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_11__/* ["default"] */ .ZP.div `
  overflow-y: hidden;
  padding: 1em;
  padding-bottom: 50px;
  height: 100%;
`;
const ControlsDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_11__/* ["default"] */ .ZP.div `
  display: flex;
  flex-direction: row;
  align-items: center;
`;
let AppLogPage = class AppLogPage extends react__WEBPACK_IMPORTED_MODULE_2__.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onContextMenu = (ev) => {
            ev.preventDefault();
            ev.stopPropagation();
            const { dispatch } = this.props;
            const { clientX, clientY } = ev;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.popupContextMenu({
                clientX,
                clientY,
                template: [
                    {
                        localizedLabel: "Open file...",
                        action: common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openLogFileRequest({}),
                    },
                ],
                wind: (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_15__/* .ambientWind */ .w)(),
            }));
        };
        this.queueFetch = () => {
            this.setState({ loading: true, error: null });
            this.doFetch()
                .catch((e) => {
                this.setState({ error: e });
            })
                .then(() => {
                this.setState({ loading: false });
            });
        };
        this.doFetch = async () => {
            let filePath = this.props.file;
            if (filePath) {
                console.log(`Reading external log`, filePath);
            }
            else {
                filePath = renderer_bridge__WEBPACK_IMPORTED_MODULE_14__/* .paths */ .Hb.mainLogPath();
            }
            const log = await renderer_bridge__WEBPACK_IMPORTED_MODULE_14__/* .promisedFs */ .Pq.readFile(filePath, { encoding: "utf8" });
            this.setState({ log, error: null });
        };
        this.onOpenAppLog = () => {
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openAppLog({}));
        };
        this.onReload = () => {
            (0,renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_8__/* .dispatchTabReloaded */ .hF)(this.props);
        };
        this.state = {
            log: null,
            loading: true,
            error: null,
        };
    }
    subscribe(watcher) {
        watcher.on(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openLogFileRequest, async () => {
            try {
                const { showOpenDialog } = renderer_bridge__WEBPACK_IMPORTED_MODULE_14__.electron;
                const filePaths = await showOpenDialog({ title: "Open log file" });
                if (filePaths && filePaths.length > 0) {
                    const filePath = filePaths[0];
                    console.log(`Opening external log`, filePath);
                    const { url } = this.props;
                    (0,renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_8__/* .dispatchTabEvolve */ .vV)(this.props, {
                        replace: true,
                        url: (0,renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_8__/* .urlWithParams */ .Iq)(url, { file: filePath }),
                    });
                }
            }
            catch (e) {
                console.error(e);
            }
        });
    }
    render() {
        const { loading, log, error } = this.state;
        return (react__WEBPACK_IMPORTED_MODULE_2__.createElement(AppLogDiv, null,
            react__WEBPACK_IMPORTED_MODULE_2__.createElement(AppLogContentDiv, null,
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_ErrorState__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { error: error }),
                log ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_pages_AppLogPage_Log__WEBPACK_IMPORTED_MODULE_10__/* ["default"] */ .Z, { log: log || "", extraControls: react__WEBPACK_IMPORTED_MODULE_2__.createElement(ControlsDiv, null,
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(Spacer, null),
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Link__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, { onContextMenu: this.onContextMenu, onClick: this.onOpenAppLog, label: (0,renderer_t__WEBPACK_IMPORTED_MODULE_12__.T)((0,common_format_show_in_explorer__WEBPACK_IMPORTED_MODULE_1__/* .showInExplorerString */ .b)()) }),
                        react__WEBPACK_IMPORTED_MODULE_2__.createElement(Spacer, null),
                        loading ? (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_LoadingCircle__WEBPACK_IMPORTED_MODULE_6__/* ["default"] */ .Z, { progress: -1 })) : (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_IconButton__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .Z, { icon: "repeat", onClick: this.onReload }))) })) : null)));
    }
    componentDidMount() {
        (0,renderer_hocs_tab_utils__WEBPACK_IMPORTED_MODULE_8__/* .dispatchTabPageUpdate */ .pq)(this.props, { label: ["sidebar.applog"] });
        this.queueFetch();
    }
    componentDidUpdate(prevProps) {
        if (prevProps.sequence != this.props.sequence ||
            prevProps.file !== this.props.file) {
            this.queueFetch();
        }
    }
};
AppLogPage = (0,tslib__WEBPACK_IMPORTED_MODULE_16__/* .__decorate */ .gn)([
    renderer_hocs_watching__WEBPACK_IMPORTED_MODULE_13__/* ["default"] */ .Z
], AppLogPage);
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_withTab__WEBPACK_IMPORTED_MODULE_9__/* .withTab */ .D1)((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_7__/* .hookWithProps */ .h)(AppLogPage)((map) => ({
    url: map((rs, props) => (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_15__/* .ambientTab */ .mB)(rs, props).location.url),
    file: map((rs, props) => (0,common_util_navigation__WEBPACK_IMPORTED_MODULE_15__/* .ambientTab */ .mB)(rs, props).location.query.file),
}))(AppLogPage)));


/***/ }),

/***/ 49:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Ji: () => (/* binding */ FormattedDate),
  BK: () => (/* binding */ FormattedNumber),
  qN: () => (/* binding */ FormattedTime)
});

// UNUSED EXPORTS: FormattedDateParts, FormattedDateTimeRange, FormattedDisplayName, FormattedList, FormattedMessage, FormattedNumberParts, FormattedPlural, FormattedRelativeTime, FormattedTimeParts, IntlContext, IntlProvider, InvalidConfigError, MessageFormatError, MissingDataError, MissingTranslationError, RawIntlProvider, ReactIntlError, ReactIntlErrorCode, UnsupportedFormatterError, createIntl, createIntlCache, defineMessage, defineMessages, injectIntl, useIntl

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/utils.js
var utils = __webpack_require__(680);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
;// CONCATENATED MODULE: ./node_modules/react-intl/lib/src/components/createFormattedComponent.js




var DisplayName;
(function (DisplayName) {
    DisplayName["formatDate"] = "FormattedDate";
    DisplayName["formatTime"] = "FormattedTime";
    DisplayName["formatNumber"] = "FormattedNumber";
    DisplayName["formatList"] = "FormattedList";
    // Note that this DisplayName is the locale display name, not to be confused with
    // the name of the enum, which is for React component display name in dev tools.
    DisplayName["formatDisplayName"] = "FormattedDisplayName";
})(DisplayName || (DisplayName = {}));
var DisplayNameParts;
(function (DisplayNameParts) {
    DisplayNameParts["formatDate"] = "FormattedDateParts";
    DisplayNameParts["formatTime"] = "FormattedTimeParts";
    DisplayNameParts["formatNumber"] = "FormattedNumberParts";
    DisplayNameParts["formatList"] = "FormattedListParts";
})(DisplayNameParts || (DisplayNameParts = {}));
var FormattedNumberParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
    (0,utils/* invariantIntlContext */.lq)(intl);
    var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
    return children(intl.formatNumberToParts(value, formatProps));
})); };
FormattedNumberParts.displayName = 'FormattedNumberParts';
function createFormattedDateTimePartsComponent(name) {
    var ComponentParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        var date = typeof value === 'string' ? new Date(value || 0) : value;
        var formattedParts = name === 'formatDate'
            ? intl.formatDateToParts(date, formatProps)
            : intl.formatTimeToParts(date, formatProps);
        return children(formattedParts);
    })); };
    ComponentParts.displayName = DisplayNameParts[name];
    return ComponentParts;
}
function createFormattedComponent(name) {
    var Component = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        // TODO: fix TS type definition for localeMatcher upstream
        var formattedValue = intl[name](value, formatProps);
        if (typeof children === 'function') {
            return children(formattedValue);
        }
        var Text = intl.textComponent || react.Fragment;
        return react.createElement(Text, null, formattedValue);
    })); };
    Component.displayName = DisplayName[name];
    return Component;
}

;// CONCATENATED MODULE: ./node_modules/react-intl/lib/index.js


function defineMessages(msgs) {
    return msgs;
}
function defineMessage(msg) {
    return msg;
}



// IMPORTANT: Explicit here to prevent api-extractor from outputing `import('./src/types').CustomFormatConfig`
var FormattedDate = createFormattedComponent('formatDate');
var FormattedTime = createFormattedComponent('formatTime');
var FormattedNumber = createFormattedComponent('formatNumber');
var FormattedList = createFormattedComponent('formatList');
var FormattedDisplayName = createFormattedComponent('formatDisplayName');
var FormattedDateParts = createFormattedDateTimePartsComponent('formatDate');
var FormattedTimeParts = createFormattedDateTimePartsComponent('formatTime');







/***/ })

}]);
//# sourceMappingURL=810.chunk.js.map