"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[857],{

/***/ 2325:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CH: () => (/* binding */ getCaveSummary)
/* harmony export */ });
/* unused harmony exports hookProgress, hookLogging, getErrorMessage */
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4713);

function hookProgress(convo, ctx) {
    convo.onNotification(messages.Progress, (params) => {
        ctx.emitProgress(params);
    });
}
function hookLogging(convo, logger) {
    convo.onNotification(messages.Log, async ({ level, message }) => {
        switch (level) {
            case "debug":
                logger.debug(message);
                break;
            case "info":
                logger.info(message);
                break;
            case "warning":
                logger.warn(message);
                break;
            case "error":
                logger.error(message);
                break;
            default:
                logger.info(`[${level}] ${message}`);
                break;
        }
    });
}
function getCaveSummary(cave) {
    return {
        id: cave.id,
        gameId: cave.game.id,
        lastTouchedAt: cave.stats.lastTouchedAt,
        secondsRun: cave.stats.secondsRun,
        installedSize: cave.installInfo.installedSize,
    };
}
function getErrorMessage(e) {
    if (!e) {
        return "Unknown error";
    }
    // TODO: this is a good place to do i18n on butlerd error codes!
    let errorMessage = e.message;
    const re = e.rpcError;
    if (re) {
        if (re.message) {
            // use just the json-rpc message if possible
            errorMessage = re.message;
        }
    }
    return errorMessage;
}


/***/ }),

/***/ 3961:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   kr: () => (/* binding */ onNotification),
/* harmony export */   mK: () => (/* binding */ hookLogging),
/* harmony export */   rN: () => (/* binding */ onRequest)
/* harmony export */ });
/* unused harmony export convertMessage */
/* harmony import */ var common_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(8976);
/* harmony import */ var common_butlerd_utils__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2325);
/* harmony import */ var butlerd_lib_support__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(8240);



const hookLogging = (logger) => {
    return { type: "HOOK_LOGGING", logger: logger };
};
const onNotification = (messageName, callback) => {
    return {
        type: "ON_NOTIFICATION",
        messageName: messageName,
        callback: callback,
    };
};
const onRequest = (messageName, callback) => {
    return { type: "ON_REQUEST", messageName: messageName, callback: callback };
};
const convertMessage = (message) => {
    if (message.type === "HOOK_LOGGING") {
        const logger = new Logger(message.logger.sink, message.logger.name);
        return (convo) => utils.hookLogging(convo, logger);
    }
    else if (message.type === "ON_NOTIFICATION") {
        const notification = createNotification(message.messageName);
        return (convo) => convo.onNotification(notification, message.callback);
    }
    else if (message.type === "ON_REQUEST") {
        const request = createRequest(message.messageName);
        return (convo) => convo.onRequest(request, message.callback);
    }
    else {
        return (convo) => null;
    }
};


/***/ }),

/***/ 8472:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   v: () => (/* binding */ rcall)
/* harmony export */ });
/* harmony import */ var renderer_store__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5784);
/* harmony import */ var renderer_logger__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5258);
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2968);



const logger = renderer_logger__WEBPACK_IMPORTED_MODULE_1__/* .rendererLogger */ .X.childWithName("rcall");
/**
 * Perform a butlerd call from the renderer process
 */
async function rcall(rc, params, setups) {
    return await renderer_bridge__WEBPACK_IMPORTED_MODULE_2__/* .butlerd */ .lB.rcall(renderer_store__WEBPACK_IMPORTED_MODULE_0__["default"], logger, rc.__method, params, setups);
}


/***/ }),

/***/ 5969:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   R: () => (/* binding */ doAsync)
/* harmony export */ });
function doAsync(f) {
    f().catch((e) => {
        console.error(e.stack);
    });
}


/***/ }),

/***/ 1857:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2448);
/* harmony import */ var common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4713);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6025);
/* harmony import */ var renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(8472);
/* harmony import */ var renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(5969);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2263);
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(5871);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5836);
/* harmony import */ var renderer_modals__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(9088);
/* harmony import */ var renderer_bridge__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(2968);
/* harmony import */ var common_helpers_bridge__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(3961);












const ControlsDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_7__/* ["default"] */ .ZP.div `
  display: flex;
  align-items: flex-start;
  flex-flow: row wrap;
  max-width: 600px;

  .control {
    margin: 8px;
  }

  label {
    padding: 8px;
    display: flex;
    flex-direction: row;
    align-items: center;
    border-left: 2px solid ${(props) => props.theme.prefBorder};
  }

  input[type="checkbox"] {
    margin-right: 0.4em;
  }
`;
class SecretSettings extends react__WEBPACK_IMPORTED_MODULE_2__.PureComponent {
    constructor() {
        super(...arguments);
        this.onReload = () => {
            window.location.reload();
        };
        this.onReloadLocales = () => {
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.reloadLocales({}));
        };
        this.onViewAppState = async () => {
            const chromeStore = (await Promise.resolve(/* import() */).then(__webpack_require__.bind(__webpack_require__, 5784))).default;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openModal(renderer_modals__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .Z.exploreJson.make({
                wind: "root",
                title: "Redux app state",
                widgetParams: {
                    data: chromeStore.getState(),
                },
                fullscreen: true,
            })));
        };
        this.onGPUFeatureStatus = async () => {
            const data = await renderer_bridge__WEBPACK_IMPORTED_MODULE_9__.electron.getGPUFeatureStatus();
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openModal(renderer_modals__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .Z.exploreJson.make({
                wind: "root",
                title: "GPU feature status",
                widgetParams: {
                    data,
                },
            })));
        };
        this.onBadButlerdCall = () => {
            const FakeRequest = renderer_bridge__WEBPACK_IMPORTED_MODULE_9__/* .butlerd */ .lB.createRequest("This.Is.Definitely.Not.A.Butlerd.Method");
            (0,renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_11__/* .doAsync */ .R)(async () => {
                let e;
                try {
                    await (0,renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_4__/* .rcall */ .v)(FakeRequest, {});
                }
                catch (ee) {
                    e = ee;
                }
                const { dispatch } = this.props;
                dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openModal(renderer_modals__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .Z.showError.make({
                    wind: "root",
                    title: "test butlerd internal error",
                    message: "This is a test butlerd error",
                    detail: "It's fun to snoop!",
                    widgetParams: {
                        rawError: e,
                        log: "no log",
                    },
                    buttons: [
                        {
                            label: ["prompt.action.continue"],
                        },
                    ],
                })));
            });
        };
        this.onDoubleTwice = () => {
            (0,renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_11__/* .doAsync */ .R)(async () => {
                // investigate
                await (0,renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_4__/* .rcall */ .v)(common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .TestDoubleTwice */ .aY, { number: 7 }, [
                    (0,common_helpers_bridge__WEBPACK_IMPORTED_MODULE_10__/* .onRequest */ .rN)(common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .TestDouble */ .Fi.__method, async ({ number }) => {
                        return { number: number * 2 };
                    }),
                ]);
            });
        };
        this.onExpireAll = () => {
            (0,renderer_helpers_doAsync__WEBPACK_IMPORTED_MODULE_11__/* .doAsync */ .R)(async () => {
                await (0,renderer_butlerd_rcall__WEBPACK_IMPORTED_MODULE_4__/* .rcall */ .v)(common_butlerd_messages__WEBPACK_IMPORTED_MODULE_1__/* .FetchExpireAll */ .Z9, {});
            });
        };
        this.onOpenCrashy = () => {
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.navigate({ wind: "root", url: "itch://crashy" }));
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({ wind: "root" }));
        };
        this.onRestartButler = async () => {
            const { dispatch } = this.props;
            const chromeStore = (await Promise.resolve(/* import() */).then(__webpack_require__.bind(__webpack_require__, 5784))).default;
            const butlerState = chromeStore.getState().broth.packages["butler"];
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.packageGotVersionPrefix({
                name: "butler",
                version: butlerState.version,
                versionPrefix: butlerState.versionPrefix,
            }));
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.closeModal({ wind: "root" }));
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.statusMessage({ message: "Butler restarted!" }));
        };
        this.toggleReduxLogging = () => {
            const enabled = !this.props.status.reduxLoggingEnabled;
            const { dispatch } = this.props;
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.setReduxLoggingEnabled({
                enabled,
            }));
            if (enabled) {
                dispatch(common_actions__WEBPACK_IMPORTED_MODULE_0__/* .actions */ .N.openDevTools({ wind: "root" }));
            }
        };
    }
    render() {
        const { status } = this.props;
        return (react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_6__/* .ModalWidgetDiv */ .U, null,
            react__WEBPACK_IMPORTED_MODULE_2__.createElement(ControlsDiv, null,
                react__WEBPACK_IMPORTED_MODULE_2__.createElement("label", { className: "control" },
                    react__WEBPACK_IMPORTED_MODULE_2__.createElement("input", { type: "checkbox", value: "Redux logging", checked: status.reduxLoggingEnabled, onChange: this.toggleReduxLogging }),
                    react__WEBPACK_IMPORTED_MODULE_2__.createElement("span", null, "Enable redux logging")),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "repeat", onClick: this.onReload, label: "Reload entire page" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "earth", onClick: this.onReloadLocales, label: "Reload locales" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "bug", onClick: this.onViewAppState, label: "View app state" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "palette", onClick: this.onGPUFeatureStatus, label: "View GPU feature status" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "bug", onClick: this.onBadButlerdCall, label: "Call non-existent butlerd endpoint" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "leaf", onClick: this.onDoubleTwice, label: "Double twice" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "close", onClick: this.onExpireAll, label: "Expire all data in local database" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "bug", onClick: this.onOpenCrashy, label: "Open crashy tab" }),
                react__WEBPACK_IMPORTED_MODULE_2__.createElement(renderer_basics_Button__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { className: "control", primary: true, icon: "checkbox-checked", onClick: this.onRestartButler, label: "Force butlerd restart" }))));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_5__/* .hook */ .z)((map) => ({
    status: map((rs) => rs.status),
}))(SecretSettings));


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ })

}]);
//# sourceMappingURL=857.chunk.js.map