"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[949],{

/***/ 6817:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   b: () => (/* binding */ showInExplorerString)
/* harmony export */ });
/* provided dependency */ var process = __webpack_require__(4155);
function showInExplorerString() {
    switch (process.platform) {
        case "linux": {
            return ["grid.item.open_file_location.linux"];
        }
        case "darwin": {
            return ["grid.item.open_file_location.osx"];
        }
        case "win32":
        default: {
            return ["grid.item.open_file_location.windows"];
        }
    }
}


/***/ }),

/***/ 5346:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   $O: () => (/* binding */ formatUploadTitle),
/* harmony export */   A6: () => (/* binding */ formatBuildVersionInfo),
/* harmony export */   Pn: () => (/* binding */ formatUploadTitleFancy)
/* harmony export */ });
function formatUploadTitle(u) {
    return u ? u.displayName || u.filename : "?";
}
function clean(s) {
    return s
        .replace(/\.[a-zA-Z0-9]+$/, "")
        .replace(/[_-]/g, " ")
        .replace(/\s+/, " ");
}
function formatUploadTitleFancy(u) {
    if (u.displayName) {
        return u.displayName;
    }
    if (u.filename) {
        return clean(u.filename);
    }
    return "?";
}
function formatBuildVersionInfo(b) {
    if (!b) {
        return null;
    }
    if (b.userVersion) {
        return `v${b.userVersion}`;
    }
    return `#${b.version}`;
}


/***/ }),

/***/ 7703:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .secondaryLink */ .CF};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_2__/* .__rest */ ._T)(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Link);
class Props {
}


/***/ }),

/***/ 6055:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1829);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7294);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(9080);
/* harmony import */ var renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2629);




class TotalPlaytime extends react__WEBPACK_IMPORTED_MODULE_1__.PureComponent {
    render() {
        const { game, cave, short = false } = this.props;
        let { secondsRun = 0 } = (cave || {});
        const classification = game.classification || "game";
        const classAction = (0,common_util_action_for_game__WEBPACK_IMPORTED_MODULE_0__/* .actionForGame */ .x)(game, cave);
        const xed = classAction === "open"
            ? "opened"
            : classification === "game"
                ? "played"
                : "used";
        if (secondsRun > 0 && classAction === "launch") {
            return (react__WEBPACK_IMPORTED_MODULE_1__.createElement("div", null,
                short ? null : (react__WEBPACK_IMPORTED_MODULE_1__.createElement("label", null,
                    (0,renderer_t__WEBPACK_IMPORTED_MODULE_2__.T)([`usage_stats.has_${xed}_for_duration`]),
                    " ")),
                react__WEBPACK_IMPORTED_MODULE_1__.createElement("span", { className: "total-playtime" },
                    react__WEBPACK_IMPORTED_MODULE_1__.createElement(renderer_basics_FormattedDuration__WEBPACK_IMPORTED_MODULE_3__/* ["default"] */ .Z, { secs: secondsRun }))));
        }
        return null;
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (TotalPlaytime);


/***/ }),

/***/ 1650:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "default": () => (/* binding */ pages_LocationPage)
});

// EXTERNAL MODULE: ./src/common/butlerd/messages.ts
var messages = __webpack_require__(4713);
// EXTERNAL MODULE: ./src/common/util/navigation.ts
var navigation = __webpack_require__(9471);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./src/renderer/hocs/butlerCaller/index.tsx + 1 modules
var butlerCaller = __webpack_require__(5617);
// EXTERNAL MODULE: ./src/renderer/hocs/hook.tsx
var hook = __webpack_require__(2263);
// EXTERNAL MODULE: ./src/renderer/hocs/tab-utils.tsx
var tab_utils = __webpack_require__(2250);
// EXTERNAL MODULE: ./src/renderer/hocs/withTab.tsx
var withTab = __webpack_require__(2521);
// EXTERNAL MODULE: ./src/renderer/pages/common/Page.tsx
var Page = __webpack_require__(9954);
// EXTERNAL MODULE: ./src/common/actions/index.ts
var actions = __webpack_require__(2448);
// EXTERNAL MODULE: ./src/common/format/filesize.ts
var filesize = __webpack_require__(5379);
// EXTERNAL MODULE: ./src/common/format/show-in-explorer.ts
var show_in_explorer = __webpack_require__(6817);
// EXTERNAL MODULE: ./src/renderer/basics/Link.tsx
var Link = __webpack_require__(7703);
// EXTERNAL MODULE: ./src/renderer/pages/common/Sort.tsx
var Sort = __webpack_require__(1945);
// EXTERNAL MODULE: ./src/renderer/pages/common/SortsAndFilters.tsx
var SortsAndFilters = __webpack_require__(7128);
// EXTERNAL MODULE: ./src/renderer/series/GameSeries.tsx
var GameSeries = __webpack_require__(4103);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/pages/common/StandardMainAction.tsx
var StandardMainAction = __webpack_require__(771);
// EXTERNAL MODULE: ./src/renderer/basics/TotalPlaytime.tsx
var TotalPlaytime = __webpack_require__(6055);
// EXTERNAL MODULE: ./src/renderer/basics/LastPlayed.tsx
var LastPlayed = __webpack_require__(2985);
// EXTERNAL MODULE: ./src/renderer/basics/GameStatusGetter.tsx
var GameStatusGetter = __webpack_require__(36);
// EXTERNAL MODULE: ./src/common/format/upload.ts
var upload = __webpack_require__(5346);
// EXTERNAL MODULE: ./src/common/format/truncate.ts
var truncate = __webpack_require__(1282);
;// CONCATENATED MODULE: ./src/renderer/pages/LocationPage/LocationItemExtras.tsx














const ExtrasDiv = styles/* default */.ZP.div `
  display: flex;
  flex-direction: column;
  flex-shrink: 0;
  align-items: flex-start;
`;
const SizeDiv = styles/* default */.ZP.div `
  white-space: nowrap;
  flex-shrink: 0;
  min-width: 260px;

  display: flex;
  flex-direction: row;
  align-items: center;
`;
class LocationItemExtras extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.renderPlayStats = (status) => {
            const { cave } = this.props;
            return (react.createElement(react.Fragment, null,
                react.createElement(TotalPlaytime/* default */.Z, { game: cave.game, cave: status.cave }),
                react.createElement(LastPlayed/* default */.Z, { game: cave.game, cave: status.cave })));
        };
        this.onManage = () => {
            const { dispatch, cave } = this.props;
            dispatch(actions/* actions */.N.manageCave({
                caveId: cave.id,
            }));
        };
    }
    render() {
        const { cave } = this.props;
        return (react.createElement(react.Fragment, null,
            react.createElement(ExtrasDiv, null,
                react.createElement(SortsAndFilters/* FilterSpacer */.dz, null),
                react.createElement("div", { title: (0,upload/* formatUploadTitle */.$O)(cave.upload) }, (0,truncate/* truncate */.$)((0,upload/* formatUploadTitle */.$O)(cave.upload), {
                    length: 20,
                })),
                react.createElement(GameStatusGetter/* default */.Z, { game: cave.game, caveId: cave.id, render: this.renderPlayStats }),
                react.createElement(SizeDiv, null,
                    (0,t.T)([
                        "install_location.property.size_on_disk",
                        { size: (0,filesize/* fileSize */.j)(cave.installInfo.installedSize) },
                    ]),
                    react.createElement(SortsAndFilters/* FilterSpacer */.dz, null),
                    react.createElement(Link/* default */.Z, { label: (0,t.T)(["grid.item.manage"]), onClick: this.onManage }))),
            react.createElement(StandardMainAction/* default */.Z, { game: cave.game })));
    }
}
/* harmony default export */ const LocationPage_LocationItemExtras = ((0,hook/* hook */.z)()(LocationItemExtras));

;// CONCATENATED MODULE: ./src/renderer/pages/LocationPage/LocationContents.tsx














const CaveGameSeries = (0,GameSeries/* default */.Z)(messages/* FetchCaves */.J1);
class LocationContents extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.getRecord = CaveGameSeries.getRecordCallback((cave) => cave.game);
        this.getKey = CaveGameSeries.getKeyCallback((cave) => cave.id);
        this.renderMainFilters = () => {
            const { location } = this.props;
            return (react.createElement(react.Fragment, null,
                this.renderLocationInfo(),
                "\u00A0 \u00A0",
                react.createElement(Link/* default */.Z, { label: (0,t.T)((0,show_in_explorer/* showInExplorerString */.b)()), onClick: this.onBrowse })));
        };
        this.renderExtraFilters = () => (react.createElement(SortsAndFilters/* SortsAndFilters */.gY, null,
            react.createElement(SortsAndFilters/* FilterGroup */.e_, null,
                react.createElement(Sort/* SortOption */.Y, { sortBy: "title", label: (0,t._)("sort_by.games.title") }),
                react.createElement(Sort/* SortOption */.Y, { sortBy: "lastTouched", label: (0,t._)("sort_by.games.last_touched") }),
                react.createElement(Sort/* SortOption */.Y, { sortBy: "playTime", label: (0,t._)("sort_by.games.play_time") }),
                react.createElement(Sort/* SortOption */.Y, { sortBy: "installedSize", label: (0,t._)("sort_by.games.size_on_disk") }),
                react.createElement(Sort/* SortOption */.Y, { sortBy: "installedAt", label: (0,t._)("sort_by.games.install_date") }))));
        this.renderItemExtras = CaveGameSeries.renderItemExtrasCallback((cave) => (react.createElement(LocationPage_LocationItemExtras, { cave: cave })));
        this.onBrowse = () => {
            const { dispatch, location } = this.props;
            dispatch(actions/* actions */.N.browseInstallLocation({
                id: location.id,
            }));
        };
    }
    render() {
        const { sortBy, sortDir, location } = this.props;
        if (!location) {
            return "Location not found";
        }
        return (react.createElement(CaveGameSeries, { params: {
                filters: { installLocationId: location.id },
                sortBy,
                reverse: sortDir === "reverse",
            }, getRecord: this.getRecord, getKey: this.getKey, renderMainFilters: this.renderMainFilters, renderExtraFilters: this.renderExtraFilters, renderItemExtras: this.renderItemExtras }));
    }
    renderLocationInfo() {
        const { location } = this.props;
        return (react.createElement("div", { className: "info" }, (0,t.T)([
            "install_location.property.size_on_disk",
            { size: (0,filesize/* fileSize */.j)(location.sizeInfo.installedSize) },
        ])));
    }
}
/* harmony default export */ const LocationPage_LocationContents = ((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(LocationContents)((map) => ({
    installLocationId: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.firstPathElement),
    sortBy: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.sortBy),
    sortDir: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.sortDir),
}))(LocationContents)));

;// CONCATENATED MODULE: ./src/renderer/pages/LocationPage/index.tsx









const InstallLocationsGetByID = (0,butlerCaller/* default */.ZP)(messages/* InstallLocationsGetByID */.i$);
class LocationPage extends react.PureComponent {
    constructor() {
        super(...arguments);
        this.onResult = InstallLocationsGetByID.onResultCallback((result) => {
            if (!(result && result.installLocation)) {
                return;
            }
            const loc = result.installLocation;
            (0,tab_utils/* dispatchTabPageUpdate */.pq)(this.props, { label: `${loc.path}` });
        });
        this.renderCallContents = InstallLocationsGetByID.renderCallback(({ result }) => {
            return (react.createElement(LocationPage_LocationContents, { location: result ? result.installLocation : null }));
        });
    }
    render() {
        const { installLocationId } = this.props;
        return (react.createElement(Page/* default */.Z, null,
            react.createElement(InstallLocationsGetByID, { params: { id: installLocationId }, onResult: this.onResult, loadingHandled: true, render: this.renderCallContents })));
    }
}
/* harmony default export */ const pages_LocationPage = ((0,withTab/* withTab */.D1)((0,hook/* hookWithProps */.h)(LocationPage)((map) => ({
    installLocationId: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.firstPathElement),
    sortBy: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.sortBy),
    sortDir: map((rs, props) => (0,navigation/* ambientTab */.mB)(rs, props).location.query.sortDir),
}))(LocationPage)));


/***/ })

}]);
//# sourceMappingURL=949.chunk.js.map