"use strict";
(self["webpackChunkLIB"] = self["webpackChunkLIB"] || []).push([[984],{

/***/ 992:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Nd: () => (/* binding */ getRpcErrorData),
/* harmony export */   SS: () => (/* binding */ isInternalError),
/* harmony export */   dt: () => (/* binding */ getErrorStack),
/* harmony export */   mg: () => (/* binding */ asRequestError)
/* harmony export */ });
/* unused harmony export mergeLogAndError */
/* harmony import */ var common_logger__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(8976);
/* harmony import */ var common_format_datetime__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1061);


function asRequestError(e) {
    const re = e;
    if (re.rpcError) {
        return e;
    }
    return null;
}
function getRpcErrorData(e) {
    const re = asRequestError(e);
    if (re && re.rpcError && re.rpcError.data) {
        return re.rpcError.data;
    }
    return null;
}
function isInternalError(e) {
    const re = asRequestError(e);
    if (!re) {
        return true;
    }
    if (re.rpcError.code < 0) {
        return true;
    }
    return false;
}
function getErrorStack(e) {
    if (!e) {
        return "Unknown error";
    }
    let errorStack = e.stack;
    const re = asRequestError(e);
    if (re) {
        const ed = getRpcErrorData(e);
        if (ed && ed.stack) {
            // use golang stack if available
            errorStack = ed.stack;
        }
        else if (re.message) {
            // or just message
            errorStack = re.message;
        }
    }
    return errorStack;
}
function mergeLogAndError(log, e) {
    let formattedLog = "";
    if (log) {
        let lines = log.split("\n");
        for (let line of lines) {
            line = line.trim();
            let fallback = false;
            try {
                const obj = JSON.parse(line);
                if (obj.msg) {
                    let date = formatDate(new Date(obj.time), "en-US", DATE_FORMAT);
                    let level = levels[obj.level];
                    let { msg } = obj;
                    formattedLog += `${date} [${level}] ${msg}\n`;
                }
                else {
                    fallback = true;
                }
            }
            catch (e) {
                fallback = true;
            }
            if (fallback) {
                formattedLog += `${line}\n`;
            }
        }
    }
    return `${formattedLog}\n\nError stack:\n${getErrorStack(e)}\n`;
}


/***/ }),

/***/ 7703:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Z: () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(655);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7294);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5836);



const LinkSpan = renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* ["default"] */ .ZP.span `
  ${renderer_styles__WEBPACK_IMPORTED_MODULE_1__/* .secondaryLink */ .CF};

  transition: color 0.4s;
  flex-shrink: 0.1;
  overflow-x: hidden;
  text-overflow: ellipsis;
`;
class Link extends react__WEBPACK_IMPORTED_MODULE_0__.PureComponent {
    render() {
        const _a = this.props, { label, children } = _a, restProps = (0,tslib__WEBPACK_IMPORTED_MODULE_2__/* .__rest */ ._T)(_a, ["label", "children"]);
        return (react__WEBPACK_IMPORTED_MODULE_0__.createElement(LinkSpan, Object.assign({}, restProps),
            label,
            children));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (Link);
class Props {
}


/***/ }),

/***/ 3984:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(4184);
/* harmony import */ var classnames__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(classnames__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var common_actions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2448);
/* harmony import */ var common_butlerd_errors__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(992);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(7294);
/* harmony import */ var renderer_basics_Cover__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(103);
/* harmony import */ var renderer_basics_Link__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(7703);
/* harmony import */ var renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(2263);
/* harmony import */ var renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(5871);
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(5836);
/* harmony import */ var renderer_t__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(9080);
/* harmony import */ var underscore__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(9050);
/* harmony import */ var renderer_pages_AppLogPage_Log__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(7426);












const StyledLog = (0,renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP)((0,renderer_pages_AppLogPage_Log__WEBPACK_IMPORTED_MODULE_11__/* ["default"] */ .Z)) `
  table,
  tbody {
    min-height: 180px;
  }

  padding-bottom: 1em;
`;
const Pre = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.pre `
  max-height: 10em;
  overflow-y: scroll;
  background: ${(props) => props.theme.sidebarBackground};
  padding: 1em;
  line-height: 1.4;
  margin-bottom: 1em;
  white-space: pre-wrap;
`;
const ContainerDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.div `
  details {
    padding-left: 1em;

    summary {
      color: ${(props) => props.theme.secondaryText};
      margin-left: -1em;
      margin-bottom: 1em;
      padding: 0.2m;

      &:active,
      &:focus {
        outline: 0;
      }

      &:hover {
        cursor: pointer;
      }
    }
  }

  p.butler-version {
    color: ${(props) => props.theme.secondaryText};
  }
`;
const ReportLabel = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.label `
  display: flex;
  flex-direction: row;
  align-items: center;

  input[type="checkbox"] {
    display: block;
    margin-left: 0;
    margin-right: 6px;
  }

  &:hover {
    cursor: pointer;
  }

  transition: color 0.4s;
  color: ${(props) => props.theme.secondaryText};

  &:not(.enabled) {
    opacity: 0.8;
  }
`;
const GameRow = renderer_styles__WEBPACK_IMPORTED_MODULE_8__/* ["default"] */ .ZP.div `
  margin: 5px 20px;
  padding: 8px;
  display: flex;
  flex-direction: row;
  align-items: center;
  border-radius: 4px;

  background: rgba(0, 0, 0, 0.2);

  .cover-container {
    width: 32px;
    margin-right: 10px;
  }
`;
class ShowError extends react__WEBPACK_IMPORTED_MODULE_3__.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onClickGame = () => {
            const { dispatch } = this.props;
            const { game } = this.props.modal.widgetParams;
            if (!game) {
                return;
            }
            dispatch(common_actions__WEBPACK_IMPORTED_MODULE_1__/* .actions */ .N.openInExternalBrowser({ url: game.url }));
        };
        this.onSendReportChange = (ev) => {
            let state = {
                sendReport: ev.currentTarget.checked,
            };
            this.setState(state);
            this.props.updatePayload({
                sendReport: state.sendReport,
            });
        };
        const { showSendReport } = props.modal.widgetParams;
        this.state = {
            sendReport: showSendReport,
        };
        props.updatePayload({
            sendReport: this.state.sendReport,
        });
    }
    render() {
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(react__WEBPACK_IMPORTED_MODULE_3__.Fragment, null,
            this.renderGameStuff(),
            this.renderErrorStuff()));
    }
    renderGameStuff() {
        const { game } = this.props.modal.widgetParams;
        if (!game) {
            return null;
        }
        const { stillCoverUrl, coverUrl, id, title } = game;
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(GameRow, null,
            react__WEBPACK_IMPORTED_MODULE_3__.createElement("div", { className: "cover-container" },
                react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Cover__WEBPACK_IMPORTED_MODULE_4__/* ["default"] */ .ZP, { hover: false, showGifMarker: false, stillCoverUrl: stillCoverUrl, coverUrl: coverUrl, gameId: id })),
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_basics_Link__WEBPACK_IMPORTED_MODULE_5__/* ["default"] */ .Z, { onClick: this.onClickGame, label: title })));
    }
    renderErrorStuff() {
        const { rawError, log, forceDetails, showSendReport, } = this.props.modal.widgetParams;
        const internal = (0,common_butlerd_errors__WEBPACK_IMPORTED_MODULE_2__/* .isInternalError */ .SS)(rawError);
        if (!internal && !forceDetails) {
            return null;
        }
        const ed = (0,common_butlerd_errors__WEBPACK_IMPORTED_MODULE_2__/* .getRpcErrorData */ .Nd)(rawError);
        const errorStack = (0,common_butlerd_errors__WEBPACK_IMPORTED_MODULE_2__/* .getErrorStack */ .dt)(rawError);
        const errorLines = (errorStack || "Unknown error").split("\n");
        return (react__WEBPACK_IMPORTED_MODULE_3__.createElement(renderer_modal_widgets_styles__WEBPACK_IMPORTED_MODULE_7__/* .ModalWidgetDiv */ .U, null,
            react__WEBPACK_IMPORTED_MODULE_3__.createElement(ContainerDiv, null,
                react__WEBPACK_IMPORTED_MODULE_3__.createElement("details", null,
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement("summary", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_9__.T)(["prompt.show_error.details_for_nerds"])),
                    react__WEBPACK_IMPORTED_MODULE_3__.createElement("details", { open: true },
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement("summary", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_9__.T)(["prompt.show_error.details_for_nerds.event_log"])),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(StyledLog, { log: log }),
                        ed && ed.butlerVersion ? (react__WEBPACK_IMPORTED_MODULE_3__.createElement("p", { className: "butler-version" },
                            "butler version: ",
                            ed.butlerVersion)) : null),
                    (0,underscore__WEBPACK_IMPORTED_MODULE_10__/* .size */ .dp)(errorLines) == 1 ? null : (react__WEBPACK_IMPORTED_MODULE_3__.createElement("details", null,
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement("summary", null, (0,renderer_t__WEBPACK_IMPORTED_MODULE_9__.T)(["prompt.show_error.details_for_nerds.stack_trace"])),
                        react__WEBPACK_IMPORTED_MODULE_3__.createElement(Pre, null,
                            ed && ed.butlerVersion ? `For: ${ed.butlerVersion}\n` : "",
                            errorLines.slice(1).join("\n")))))),
            showSendReport ? (react__WEBPACK_IMPORTED_MODULE_3__.createElement(ReportLabel, { className: classnames__WEBPACK_IMPORTED_MODULE_0___default()({ enabled: this.state.sendReport }) },
                react__WEBPACK_IMPORTED_MODULE_3__.createElement("input", { type: "checkbox", checked: this.state.sendReport, onChange: this.onSendReportChange }),
                (0,renderer_t__WEBPACK_IMPORTED_MODULE_9__.T)(["prompt.show_error.send_report"]))) : null));
    }
}
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = ((0,renderer_hocs_hook__WEBPACK_IMPORTED_MODULE_6__/* .hook */ .z)()(ShowError));


/***/ }),

/***/ 5871:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   U: () => (/* binding */ ModalWidgetDiv)
/* harmony export */ });
/* harmony import */ var renderer_styles__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5836);

const ModalWidgetDiv = renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* ["default"] */ .ZP.div `
  padding: 20px;
  flex-grow: 1;
  overflow-y: auto;

  input[type="number"],
  input[type="text"],
  input[type="password"] {
    ${renderer_styles__WEBPACK_IMPORTED_MODULE_0__/* .heavyInput */ .C1};
    width: 100%;
  }

  input[type="number"] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  strong {
    font-weight: bold;
  }

  p {
    line-height: 1.4;
    margin: 8px 0;
  }
`;


/***/ }),

/***/ 7426:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Z: () => (/* binding */ AppLogPage_Log)
});

// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/index.js + 1 modules
var lib = __webpack_require__(49);
// EXTERNAL MODULE: ./src/renderer/basics/Filler.tsx
var Filler = __webpack_require__(4333);
// EXTERNAL MODULE: ./src/renderer/basics/IconButton.tsx
var IconButton = __webpack_require__(5391);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
// EXTERNAL MODULE: ./src/renderer/styles.ts
var styles = __webpack_require__(5836);
// EXTERNAL MODULE: ./src/renderer/t.tsx + 2 modules
var t = __webpack_require__(9080);
// EXTERNAL MODULE: ./node_modules/underscore/modules/index-all.js + 160 modules
var index_all = __webpack_require__(9050);
;// CONCATENATED MODULE: ./src/renderer/basics/SelectRow.tsx





const SelectRowDiv = styles/* default */.ZP.div `
  display: inline-block;
`;
const Select = styles/* default */.ZP.select `
  border: none;
  padding: 6px 8px;
  margin-left: 2px;
  background: ${(props) => props.theme.itemBackground};
  border: 1px solid rgba(255, 255, 255, 0.1);
  border-radius: 2px;
  color: ${(props) => props.theme.baseText};
  cursor: pointer;
  font-family: inherit;
  font-size: inherit;
`;
/**
 * A drop-down you can select from
 */
class SelectRow extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onChange = (event) => {
            const { onChange } = this.props;
            if (onChange) {
                onChange(event.currentTarget.value);
            }
        };
        this.gotElement = (element) => {
            this.element = element;
        };
    }
    render() {
        const { options, value, intl } = this.props;
        const optionTags = (0,index_all/* map */.UI)(options, (option, index) => (react.createElement("option", { key: index, value: option.value }, (0,t/* TString */.m)(intl, option.label))));
        return (react.createElement(SelectRowDiv, null,
            react.createElement(Select, { ref: this.gotElement, value: value, onChange: this.onChange }, optionTags)));
    }
    value() {
        if (this.element) {
            return this.element.value;
        }
        else {
            return null;
        }
    }
}
/* harmony default export */ const basics_SelectRow = ((0,injectIntl/* default */.ZP)(SelectRow));

// EXTERNAL MODULE: ./src/renderer/basics/Button.tsx
var Button = __webpack_require__(6025);
;// CONCATENATED MODULE: ./src/renderer/pages/AppLogPage/Log.tsx









// time, module, message
const numColumns = 3;
const levels = {
    default: "user",
    "60": "fatal",
    "50": "error",
    "40": "warn",
    "30": "info",
    "20": "debug",
    "10": "trace",
};
const reverseLevels = {
    fatal: "60",
    error: "50",
    warn: "40",
    info: "30",
    debug: "20",
    trace: "10",
};
const LogContainer = styles/* default */.ZP.div `
  width: 100%;
  height: 100%;
`;
const LogControls = styles/* default */.ZP.div `
  padding-bottom: 1em;
  display: flex;
  flex-direction: row;
  align-items: center;
`;
const LogTable = styles/* default */.ZP.table `
  background: ${(props) => props.theme.sidebarBackground};
  width: 100%;
  height: 100%;

  tbody {
    overflow-y: scroll;
    height: 100%;

    display: block;
    tr {
      display: table;
    }
  }

  td {
    padding: 0 0.5em;
    padding-left: 0;
    line-height: 1.4;
    color: ${(props) => props.theme.secondaryText};
    font-size: ${(props) => props.theme.fontSizes.smaller};

    &.fatal {
      background: #cd3131;
      color: white;
    }

    &.error {
      color: #c53030;
    }

    &.warn {
      color: #d3d310;
    }

    &.info {
      color: #138ba8;
    }

    &.debug {
      color: #357ac6;
    }

    &.timecol,
    &.modcol {
      white-space: nowrap;
    }

    &.msgcol {
      white-space: pre-wrap;
    }

    &.timecol {
      color: ${(props) => props.theme.ternaryText};
    }
  }
`;
const levelOptions = [
    { label: ["log.level.debug"], value: reverseLevels["debug"] },
    { label: ["log.level.info"], value: reverseLevels["info"] },
    { label: ["log.level.warning"], value: reverseLevels["warn"] },
    { label: ["log.level.error"], value: reverseLevels["error"] },
];
const linesPerPage = 250;
class Log extends react.PureComponent {
    constructor(props, context) {
        super(props, context);
        this.onLoadMore = () => {
            this.setState((state) => ({
                maxLines: state.maxLines + linesPerPage,
            }));
        };
        this.gotBody = (tbody) => {
            this.tbody = tbody;
            this.scrollDown();
        };
        this.onChangeLevel = (value) => {
            this.setState({ level: value });
        };
        this.onJumpDown = () => {
            this.scrollDown();
        };
        this.state = {
            level: reverseLevels["info"],
            maxLines: linesPerPage,
        };
    }
    render() {
        const { maxLines } = this.state;
        let level = parseInt(this.state.level, 10);
        const { log, className, extraControls } = this.props;
        let lines = log.split("\n");
        let entries = lines.map((x) => {
            // TODO: use fast-json-parse instead ?
            try {
                const entry = JSON.parse(x);
                return entry.hasOwnProperty("msg") ? entry : x;
            }
            catch (e) {
                return x;
            }
        });
        entries = index_all/* default.filter */.ZP.filter(entries, (x) => (x.level ? x.level >= level : false));
        let hasMore = index_all/* default.size */.ZP.size(entries) > maxLines;
        entries = index_all/* default.last */.ZP.last(entries, maxLines);
        return (react.createElement(LogContainer, { className: className },
            react.createElement(LogControls, null,
                react.createElement("label", null,
                    (0,t.T)(["log.level"]),
                    ": ",
                    react.createElement(basics_SelectRow, { options: levelOptions, value: this.state.level, onChange: this.onChangeLevel })),
                extraControls,
                react.createElement(Filler/* default */.Z, null),
                react.createElement(IconButton/* default */.Z, { icon: "caret-down", onClick: this.onJumpDown })),
            react.createElement(LogTable, null,
                react.createElement("tbody", { ref: this.gotBody },
                    hasMore ? (react.createElement("div", { style: { margin: "20px" } },
                        react.createElement(Button/* default */.Z, { onClick: this.onLoadMore, label: "Load more..." }))) : null,
                    entries.map((x, i) => {
                        if (x.hasOwnProperty("msg")) {
                            let jumpElement;
                            let previousEntry = entries[i - 1];
                            if (x.time) {
                                const currDate = new Date(x.time);
                                const prevDate = previousEntry
                                    ? new Date(previousEntry.time)
                                    : null;
                                if (!previousEntry ||
                                    !previousEntry.time ||
                                    currDate.getUTCDate() != prevDate.getUTCDate() ||
                                    currDate.getUTCMonth() != prevDate.getUTCMonth() ||
                                    currDate.getUTCFullYear() != currDate.getUTCFullYear()) {
                                    jumpElement = (react.createElement("tr", { key: `${i}-jump` },
                                        react.createElement("td", { colSpan: 3 },
                                            react.createElement(lib/* FormattedDate */.Ji, { month: "long", year: "numeric", day: "numeric", value: x.time }))));
                                }
                            }
                            return (react.createElement(react.Fragment, null,
                                jumpElement,
                                react.createElement("tr", { key: i },
                                    react.createElement("td", { className: "timecol" },
                                        react.createElement(lib/* FormattedTime */.qN, { value: x.time })),
                                    react.createElement("td", { className: "modcol" }, x.name ? react.createElement("span", null, x.name) : null),
                                    react.createElement("td", { className: levels[x.level] + " msgcol" }, x.msg))));
                        }
                        else {
                            return (react.createElement("tr", { key: i },
                                react.createElement("td", { colSpan: numColumns }, x)));
                        }
                    })))));
    }
    scrollDown() {
        if (!this.tbody) {
            return;
        }
        this.tbody.scrollTop = this.tbody.scrollHeight;
    }
    scrollTop() {
        if (!this.tbody) {
            return;
        }
        this.tbody.scrollTop = 0;
    }
}
/* harmony default export */ const AppLogPage_Log = (Log);


/***/ }),

/***/ 49:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {


// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  Ji: () => (/* binding */ FormattedDate),
  BK: () => (/* binding */ FormattedNumber),
  qN: () => (/* binding */ FormattedTime)
});

// UNUSED EXPORTS: FormattedDateParts, FormattedDateTimeRange, FormattedDisplayName, FormattedList, FormattedMessage, FormattedNumberParts, FormattedPlural, FormattedRelativeTime, FormattedTimeParts, IntlContext, IntlProvider, InvalidConfigError, MessageFormatError, MissingDataError, MissingTranslationError, RawIntlProvider, ReactIntlError, ReactIntlErrorCode, UnsupportedFormatterError, createIntl, createIntlCache, defineMessage, defineMessages, injectIntl, useIntl

// EXTERNAL MODULE: ./node_modules/tslib/tslib.es6.js
var tslib_es6 = __webpack_require__(655);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/utils.js
var utils = __webpack_require__(680);
// EXTERNAL MODULE: ./node_modules/react-intl/lib/src/components/injectIntl.js
var injectIntl = __webpack_require__(4806);
;// CONCATENATED MODULE: ./node_modules/react-intl/lib/src/components/createFormattedComponent.js




var DisplayName;
(function (DisplayName) {
    DisplayName["formatDate"] = "FormattedDate";
    DisplayName["formatTime"] = "FormattedTime";
    DisplayName["formatNumber"] = "FormattedNumber";
    DisplayName["formatList"] = "FormattedList";
    // Note that this DisplayName is the locale display name, not to be confused with
    // the name of the enum, which is for React component display name in dev tools.
    DisplayName["formatDisplayName"] = "FormattedDisplayName";
})(DisplayName || (DisplayName = {}));
var DisplayNameParts;
(function (DisplayNameParts) {
    DisplayNameParts["formatDate"] = "FormattedDateParts";
    DisplayNameParts["formatTime"] = "FormattedTimeParts";
    DisplayNameParts["formatNumber"] = "FormattedNumberParts";
    DisplayNameParts["formatList"] = "FormattedListParts";
})(DisplayNameParts || (DisplayNameParts = {}));
var FormattedNumberParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
    (0,utils/* invariantIntlContext */.lq)(intl);
    var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
    return children(intl.formatNumberToParts(value, formatProps));
})); };
FormattedNumberParts.displayName = 'FormattedNumberParts';
function createFormattedDateTimePartsComponent(name) {
    var ComponentParts = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        var date = typeof value === 'string' ? new Date(value || 0) : value;
        var formattedParts = name === 'formatDate'
            ? intl.formatDateToParts(date, formatProps)
            : intl.formatTimeToParts(date, formatProps);
        return children(formattedParts);
    })); };
    ComponentParts.displayName = DisplayNameParts[name];
    return ComponentParts;
}
function createFormattedComponent(name) {
    var Component = function (props) { return (react.createElement(injectIntl/* Context */._y.Consumer, null, function (intl) {
        (0,utils/* invariantIntlContext */.lq)(intl);
        var value = props.value, children = props.children, formatProps = (0,tslib_es6/* __rest */._T)(props, ["value", "children"]);
        // TODO: fix TS type definition for localeMatcher upstream
        var formattedValue = intl[name](value, formatProps);
        if (typeof children === 'function') {
            return children(formattedValue);
        }
        var Text = intl.textComponent || react.Fragment;
        return react.createElement(Text, null, formattedValue);
    })); };
    Component.displayName = DisplayName[name];
    return Component;
}

;// CONCATENATED MODULE: ./node_modules/react-intl/lib/index.js


function defineMessages(msgs) {
    return msgs;
}
function defineMessage(msg) {
    return msg;
}



// IMPORTANT: Explicit here to prevent api-extractor from outputing `import('./src/types').CustomFormatConfig`
var FormattedDate = createFormattedComponent('formatDate');
var FormattedTime = createFormattedComponent('formatTime');
var FormattedNumber = createFormattedComponent('formatNumber');
var FormattedList = createFormattedComponent('formatList');
var FormattedDisplayName = createFormattedComponent('formatDisplayName');
var FormattedDateParts = createFormattedDateTimePartsComponent('formatDate');
var FormattedTimeParts = createFormattedDateTimePartsComponent('formatTime');







/***/ })

}]);
//# sourceMappingURL=984.chunk.js.map