"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isString = exports.isPlainObject = void 0;
function isPlainObject(value) {
    if (!(typeof value === 'object' && value !== null) || {}.toString.call(value) !== '[object Object]') {
        return false;
    }
    if (Object.getPrototypeOf(value) === null) {
        return true;
    }
    let proto = value;
    while (Object.getPrototypeOf(proto) !== null) {
        proto = Object.getPrototypeOf(proto);
    }
    return Object.getPrototypeOf(value) === proto;
}
exports.isPlainObject = isPlainObject;
function isString(value) {
    const type = typeof value;
    return (type === 'string' ||
        (type === 'object' && value != null && !Array.isArray(value) && {}.toString.call(value) === '[object String]'));
}
exports.isString = isString;
