export interface FluxStandardAction<Type extends string = string, Payload = undefined, Meta = undefined> {
    type: Type;
    error?: boolean;
    payload?: Payload;
    meta?: Meta;
}
export declare type GenericFluxAction = FluxStandardAction<string, unknown, {
    scope?: 'local' | string;
}>;
/**
 * Determines if an action has an appropriate shape that is safe for forwarding
 */
export declare const isFSA: (action: any) => action is GenericFluxAction;
/**
 * stopForwarding allows you to give it an action, and it will return an
 * equivalent action that will only play in the current process
 */
export declare const stopForwarding: (action: GenericFluxAction) => GenericFluxAction;
/**
 * validateAction ensures that the action meets the right format and isn't scoped locally
 */
export declare const validateAction: (action: unknown) => action is GenericFluxAction;
