"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateAction = exports.stopForwarding = exports.isFSA = void 0;
const _ = __importStar(require("./_"));
// Certain actions that we should never replay across stores
const blacklist = [/^@@/, /^redux-form/];
const validActionKeys = ['type', 'payload', 'error', 'meta'];
/**
 * Determines if an action has an appropriate shape that is safe for forwarding
 */
const isFSA = (action) => _.isPlainObject(action) &&
    _.isString(action['type']) &&
    Object.keys(action).every((key) => validActionKeys.includes(key));
exports.isFSA = isFSA;
/**
 * stopForwarding allows you to give it an action, and it will return an
 * equivalent action that will only play in the current process
 */
const stopForwarding = (action) => ({
    ...action,
    meta: {
        ...action.meta,
        scope: 'local',
    },
});
exports.stopForwarding = stopForwarding;
/**
 * validateAction ensures that the action meets the right format and isn't scoped locally
 */
const validateAction = (action) => { var _a; return exports.isFSA(action) && ((_a = action.meta) === null || _a === void 0 ? void 0 : _a.scope) !== 'local' && blacklist.every((rule) => !rule.test(action.type)); };
exports.validateAction = validateAction;
