"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const support_1 = require("../support");
/**
 * Ask butler to listen for a new connection, so commands can
 * be sent to it.
 */
exports.ConnectionNew = support_1.createRequest("Connection.New");
/**
 * Retrieves the version of the butler instance the client
 * is connected to.
 *
 * This endpoint is meant to gather information when reporting
 * issues, rather than feature sniffing. Conforming clients should
 * automatically download new versions of butler, see the **Updating** section.
 */
exports.VersionGet = support_1.createRequest("Version.Get");
/**
 * Test request: asks butler to double a number twice.
 * First by calling @@TestDoubleParams, then by
 * returning the result of that call doubled.
 *
 * Use that to try out your JSON-RPC 2.0 over TCP implementation.
 */
exports.TestDoubleTwice = support_1.createRequest("Test.DoubleTwice");
/**
 * Test request: return a number, doubled. Implement that to
 * use @@TestDoubleTwiceParams in your testing.
 */
exports.TestDouble = support_1.createRequest("Test.Double");
exports.Progress = support_1.createNotification("Progress");
